class MatesWidget():
    """
    An enumerated class to represent all possible widget types within the BBM ecosystem

    Attributes
    ----------
    MATES_LED - int
        - corresponds to LED widget

    MATES_RULER_GAUGE - int
        - corresponds to Ruler Gauge widget

    MATES_ANGULAR_METER - int
        - corresponds to Angular Meter widget

    MATES_GAUGE_A - int
        - corresponds to Gauge A widget

    MATES_GAUGE_B - int
        - corresponds to Gauge B widget

    MATES_LED_DIGITS - int
        - corresponds to LED Digits widget

    MATES_LABELS - int
        - corresponds to Label widget

    MATES_BUTTON_A - int
        - corresponds to Button A widget

    MATES_SWITCH_A - int
        - corresponds to Switch A widget

    MATES_SLIDER_B - int
        - corresponds to Slider B widget

    MATES_KNOB - int
        - corresponds to Knob widget

    MATES_MEDIA_LED - int
        - corresponds to Media LED widget

    MATES_MEDIA_COLOR_LED - int
        - corresponds to Color LED widget

    MATES_GAUGE_C - int
        - corresponds to Gauge C widget

    MATES_GAUGE_D - int
        - corresponds to Gauge D widget

    MATES_GAUGE_E - int
        - corresponds to Gauge E widget

    MATES_GAUGE_F - int
        - corresponds to Gauge F widget

    MATES_MEDIA_GAUGE_A - int
        - corresponds to Media Gauge A widget

    MATES_MEDIA_GAUGE_B - int
        - corresponds to Media Gauge B widget

    MATES_MEDIA_GAUGE_C - int
        - corresponds to Media Gauge C widget

    MATES_MEDIA_GAUGE_D - int
        - corresponds to Media Gauge D widget

    MATES_MEDIA_THERMOMETER - int
        - corresponds to Media Thermometer widget

    MATES_LED_SPECTRUM - int
        - corresponds to LED Spectrum widget

    MATES_MEDIA_SPECTRUM - int
        - corresponds to Media Spectrum widget

    MATES_SCOPE - int
        - corresponds to Scope widget

    MATES_SYMBOLS - int
        - corresponds to Symbols widget

    MATES_ROTARY_GAUGE - int
        - corresponds to Rotary Gauge widget

    MATES_BUTTON_B - int
        - corresponds to Button B widget

    MATES_SWITCH_B - int
        - corresponds to Switch B widget

    MATES_MEDIA_BUTTON - int
        - corresponds to Media Button widget

    MATES_SLIDER_A - int
        - corresponds to Slider A widget

    MATES_SLIDER_C - int
        - corresponds to Slider C widget

    MATES_SLIDER_D - int
        - corresponds to Slider D widget

    MATES_SLIDER_E - int
        - corresponds to Slider E widget

    MATES_SLIDER_F - int
        - corresponds to Slider F widget

    MATES_MEDIA_SLIDER - int
        - corresponds to Media Slider widget

    MATES_MEDIA_ROTARY - int
        - corresponds to Media Rotary widget

    MATES_SLIDE_SHOW - int
        - corresponds to Slideshow widget

    MATES_ANIMATION - int
        - corresponds to Animation widget

    MATES_FANCY_LED_A - int
        - corresponds to Fancy LED A widget

    MATES_FANCY_LED_B - int
        - corresponds to Fancy LED B widget

    MATES_FANCY_BUTTON_A - int
        - corresponds to Fancy Button A widget

    MATES_FANCY_BUTTON_B - int
        - corresponds to Fancy Button B widget

    """
    MATES_LED = 0
    MATES_RULER_GAUGE = 1
    MATES_ANGULAR_METER = 2
    MATES_GAUGE_A = 3
    MATES_GAUGE_B = 4
    MATES_LED_DIGITS = 5
    MATES_LABELS = 6
    MATES_BUTTON_A = 32
    MATES_SWITCH_A = 33
    MATES_SLIDER_B = 34
    MATES_KNOB = 35
    MATES_MEDIA_LED = 64
    MATES_MEDIA_COLOR_LED = 65
    MATES_GAUGE_C = 66
    MATES_GAUGE_D = 67
    MATES_GAUGE_E = 68
    MATES_GAUGE_F = 69
    MATES_MEDIA_GAUGE_A = 70
    MATES_MEDIA_GAUGE_B = 71
    MATES_MEDIA_GAUGE_C = 72
    MATES_MEDIA_GAUGE_D = 73
    MATES_MEDIA_THERMOMETER = 74
    MATES_LED_SPECTRUM = 75
    MATES_MEDIA_SPECTRUM = 76
    MATES_SCOPE = 77
    MATES_SYMBOLS = 78
    MATES_ROTARY_GAUGE = 79
    MATES_BUTTON_B = 96
    MATES_SWITCH_B = 97
    MATES_MEDIA_BUTTON = 98
    MATES_SLIDER_A = 99
    MATES_SLIDER_C = 100
    MATES_SLIDER_D = 101
    MATES_SLIDER_E = 102
    MATES_SLIDER_F = 103
    MATES_MEDIA_SLIDER = 104
    MATES_MEDIA_ROTARY = 105
    MATES_SLIDE_SHOW = 128
    MATES_ANIMATION = 129
    MATES_FANCY_LED_A = 130
    MATES_FANCY_LED_B = 131
    MATES_FANCY_BUTTON_A = 160
    MATES_FANCY_BUTTON_B = 161

class MatesError():
    """
    An enumerated class representing all possible error states of the
    Python Mates Serial controller.

    Attributes
    ----------
    MATES_ERROR_NONE: int
        - indicates no error state.

    MATES_ERROR_COMMAND_FAILED: int
        - indicates requested command failed.

    MATES_ERROR_COMMAND_TIMEOUT: int
        - indicates requested command timed out without a response.

    MATES_ERROR_RESPONSE_TIMEOUT: int
        - indicates response requested from controller timed out.
    """
    MATES_ERROR_NONE = 0
    MATES_ERROR_COMMAND_FAILED = 1
    MATES_ERROR_COMMAND_TIMEOUT = 2
    MATES_ERROR_RESPONSE_TIMEOUT = 3

class MatesResetMode():
    """
    An enumerated class representing hardware reset configurations
    for the device upon which the Python Mates Serial Controller
    is deployed.

    Attributes
    ----------
    RESET_LOW: str
        - indicates a pin should be driven to logic level low to
        hard reset the controller.

    RESET_HIGH: str
        - indicates a pin should be driven to logic level high to
        hard reset the controller.

    """
    RESET_LOW = 'LOW'
    RESET_HIGH = 'HIGH'

class MatesSwipeConsts():
    """
    An enumerated class representing the possible swipe event checks

    Attributes
    ----------
    MATES_SWIPE_NORTH: int
        - A flag that can be used to check if a swipe is 
        from bottom to top 

    MATES_SWIPE_SOUTH: int
        - A flag that can be used to check if a swipe is 
        from top to bottom 

    MATES_SWIPE_EAST: int
        - A flag that can be used to check if a swipe is 
        from left to right 

    MATES_SWIPE_WEST: int
        - A flag that can be used to check if a swipe is 
        from right to left 

    MATES_SWIPE_VERT: int
        - A flag that can be used to check if a swipe is 
        only done vertically 

    MATES_SWIPE_HORZ: int
        - A flag that can be used to check if a swipe is 
        only done horizontally 

    MATES_SWIPE_TLBR: int
        - A flag that can be used to check if a swipe is 
        from top left to bottom right

    MATES_SWIPE_TRBL: int
        - A flag that can be used to check if a swipe is 
        from top right to bottom left

    MATES_SWIPE_BLTR: int
        - A flag that can be used to check if a swipe is 
        from bottom left to top right

    MATES_SWIPE_BRTL: int
        - A flag that can be used to check if a swipe is 
        from bottom right to top left

    """
    MATES_SWIPE_NORTH = 0b0001
    MATES_SWIPE_SOUTH = 0b0010
    MATES_SWIPE_EAST = 0b0100
    MATES_SWIPE_WEST = 0b1000
    MATES_SWIPE_VERT = 0b0011
    MATES_SWIPE_HORZ = 0b1100
    MATES_SWIPE_TLBR = 0b0110
    MATES_SWIPE_TRBL = 0b1010
    MATES_SWIPE_BLTR = 0b0101
    MATES_SWIPE_BRTL = 0b1001

class MatesColorConsts():
    ALICEBLUE = 0xF7DF
    ANTIQUEWHITE = 0xFF5A
    AQUA = 0x07FF
    AQUAMARINE = 0x7FFA
    AZURE = 0xF7FF
    BEIGE = 0xF7BB
    BISQUE = 0xFF38
    BLACK = 0x0000
    BLANCHEDALMOND = 0xFF59
    BLUE = 0x001F
    BLUEVIOLET = 0x895C
    BROWN = 0xA145
    BURLYWOOD = 0xDDD0
    CADETBLUE = 0x5CF4
    CHARTREUSE = 0x7FE0
    CHOCOLATE = 0xD343
    CORAL = 0xFBEA
    CORNFLOWERBLUE = 0x64BD
    CORNSILK = 0xFFDB
    CRIMSON = 0xD8A7
    CYAN = 0x07FF
    DARKBLUE = 0x0011
    DARKCYAN = 0x0451
    DARKGOLDENROD = 0xBC21
    DARKGRAY = 0xAD55
    DARKGREEN = 0x0320
    DARKKHAKI = 0xBDAD
    DARKMAGENTA = 0x8811
    DARKOLIVEGREEN = 0x5345
    DARKORANGE = 0xFC60
    DARKORCHID = 0x9999
    DARKRED = 0x8800
    DARKSALMON = 0xECAF
    DARKSEAGREEN = 0x8DF1
    DARKSLATEBLUE = 0x49F1
    DARKSLATEGRAY = 0x2A69
    DARKTURQUOISE = 0x067A
    DARKVIOLET = 0x901A
    DEEPPINK = 0xF8B2
    DEEPSKYBLUE = 0x05FF
    DIMGRAY = 0x6B4D
    DODGERBLUE = 0x1C9F
    FIREBRICK = 0xB104
    FLORALWHITE = 0xFFDE
    FORESTGREEN = 0x2444
    FUCHSIA = 0xF81F
    GAINSBORO = 0xDEFB
    GHOSTWHITE = 0xFFDF
    GOLD = 0xFEA0
    GOLDENROD = 0xDD24
    GRAY = 0x8410
    GREEN = 0x0400
    GREENYELLOW = 0xAFE5
    HONEYDEW = 0xF7FE
    HOTPINK = 0xFB56
    INDIANRED = 0xCAEB
    INDIGO = 0x4810
    IVORY = 0xFFFE
    KHAKI = 0xF731
    LAVENDER = 0xE73F
    LAVENDERBLUSH = 0xFF9E
    LAWNGREEN = 0x7FE0
    LEMONCHIFFON = 0xFFD9
    LIGHTBLUE = 0xAEDC
    LIGHTCORAL = 0xF410
    LIGHTCYAN = 0xE7FF
    LIGHTGOLD = 0xFFDA
    LIGHTGREEN = 0x9772
    LIGHTGREY = 0xD69A
    LIGHTPINK = 0xFDB8
    LIGHTSALMON = 0xFD0F
    LIGHTSEAGREEN = 0x2595
    LIGHTSKYBLUE = 0x867F
    LIGHTSLATEGRAY = 0x7453
    LIGHTSTEELBLUE = 0xB63B
    LIGHTYELLOW = 0xFFFC
    LIME = 0x07E0
    LIMEGREEN = 0x3666
    LINEN = 0xFF9C
    MAGENTA = 0xF81F
    MAROON = 0x8000
    MEDIUMAQUAMARINE = 0x6675
    MEDIUMBLUE = 0x0019
    MEDIUMORCHID = 0xBABA
    MEDIUMPURPLE = 0x939B
    MEDIUMSEAGREEN = 0x3D8E
    MEDIUMSLATEBLUE = 0x7B5D
    MEDIUMSPRINGGREEN = 0x07D3
    MEDIUMTURQUOISE = 0x4E99
    MEDIUMVIOLETRED = 0xC0B0
    MIDNIGHTBLUE = 0x18CE
    MINTCREAM = 0xF7FF
    MISTYROSE = 0xFF3C
    MOCCASIN = 0xFF36
    NAVAJOWHITE = 0xFEF5
    NAVY = 0x0010
    OLDLACE = 0xFFBC
    OLIVE = 0x8400
    OLIVEDRAB = 0x6C64
    ORANGE = 0xFD20
    ORANGERED = 0xFA20
    ORCHID = 0xDB9A
    PALEGOLDENROD = 0xEF55
    PALEGREEN = 0x9FD3
    PALETURQUOISE = 0xAF7D
    PALEVIOLETRED = 0xDB92
    PAPAYAWHIP = 0xFF7A
    PEACHPUFF = 0xFED7
    PERU = 0xCC27
    PINK = 0xFE19
    PLUM = 0xDD1B
    POWDERBLUE = 0xB71C
    PURPLE = 0x8010
    RED = 0xF800
    ROSYBROWN = 0xBC71
    ROYALBLUE = 0x435C
    SADDLEBROWN = 0x8A22
    SALMON = 0xFC0E
    SANDYBROWN = 0xF52C
    SEAGREEN = 0x2C4A
    SEASHELL = 0xFFBD
    SIENNA = 0xA285
    SILVER = 0xC618
    SKYBLUE = 0x867D
    SLATEBLUE = 0x6AD9
    SLATEGRAY = 0x7412
    SNOW = 0xFFDF
    SPRINGGREEN = 0x07EF
    STEELBLUE = 0x4416
    TAN = 0xD5B1
    TEAL = 0x0410
    THISTLE = 0xDDFB
    TOMATO = 0xFB08
    TURQUOISE = 0x471A
    VIOLET = 0xEC1D
    WHEAT = 0xF6F6
    WHITE = 0xFFFF
    WHITESMOKE = 0xF7BE
    YELLOW = 0xFFE0
    YELLOWGREEN = 0x9E66

class MatesParamsLed():
    MATES_LED_BEZEL_COLOR_A = 4
    MATES_LED_BEZEL_COLOR_B = 5
    MATES_LED_LED_COLOR_ON = 7
    MATES_LED_LED_COLOR_OFF = 8
    MATES_LED_SHINE_COLOR = 6

class MatesParamRulerGauge():
    MATES_RULER_GAUGE_BACKGROUND_COLOR = 11
    MATES_RULER_GAUGE_PARTITION_1_COLOR = 12
    MATES_RULER_GAUGE_PARTITION_2_COLOR = 13
    MATES_RULER_GAUGE_PARTITION_3_COLOR = 14
    MATES_RULER_GAUGE_TICK_COLOR = 15

class MatesParamAngularMeter():
    MATES_ANGULAR_METER_BACKGROUND_COLOR = 11
    MATES_ANGULAR_METER_SCALE_SECTION_1_COLOR = 12
    MATES_ANGULAR_METER_SCALE_SECTION_2_COLOR = 13
    MATES_ANGULAR_METER_SCALE_SECTION_3_COLOR = 14
    MATES_ANGULAR_METER_TICK_COLOR = 9
    MATES_ANGULAR_METER_LABEL_COLOR = 18
    MATES_ANGULAR_METER_NEEDLE_COLOR = 43
    MATES_ANGULAR_METER_NEEDLE_PIN_COLOR = 45
    MATES_ANGULAR_METER_NEEDLE_PIN_DOT_COLOR = 47
    MATES_ANGULAR_METER_CAPTION_COLOR = 23

class MatesParamGaugeA():
    MATES_GAUGE_A_BASE_COLOR = 9
    MATES_GAUGE_A_PARTITION_1_INACTIVE_COLOR = 10
    MATES_GAUGE_A_PARTITION_1_ACTIVE_COLOR = 11
    MATES_GAUGE_A_PARTITION_2_INACTIVE_COLOR = 12
    MATES_GAUGE_A_PARTITION_2_ACTIVE_COLOR = 13
    MATES_GAUGE_A_PARTITION_3_INACTIVE_COLOR = 14
    MATES_GAUGE_A_PARTITION_3_ACTIVE_COLOR = 15

class MatesParamGaugeB():
    MATES_GAUGE_B_BACKGROUND_COLOR = 7
    MATES_GAUGE_B_TRACK_FILL_COLOR_A = 9
    MATES_GAUGE_B_TRACK_FILL_COLOR_B = 8
    MATES_GAUGE_B_MAJOR_TICK_COLOR = 15
    MATES_GAUGE_B_MINOR_TICK_COLOR = 15
    MATES_GAUGE_B_FONT_COLOR = 17

class MatesParamLedDigits():
    MATES_LED_DIGITS_SEGMENT_COLOR_ON = 8
    MATES_LED_DIGITS_SEGMENT_COLOR_OFF = 9

class MatesParamLabels():
    MATES_LABELS_FOREGROUND_COLOR = 5
    MATES_LABELS_BACKGROUND_COLOR = 6

class MatesParamButtonA():
    MATES_BUTTON_A_BASE_COLOR_A = 3
    MATES_BUTTON_A_BASE_COLOR_B = 4
    MATES_BUTTON_A_RING_COLOR_OFF = 6
    MATES_BUTTON_A_RING_COLOR_ON = 7
    MATES_BUTTON_A_BUTTON_COLOR_A = 8
    MATES_BUTTON_A_BUTTON_COLOR_B = 9
    MATES_BUTTON_A_FACE_COLOR = 12
    MATES_BUTTON_A_CAPTION_COLOR_OFF = 14
    MATES_BUTTON_A_CAPTION_COLOR_ON = 15
    MATES_BUTTON_A_DOT_COLOR_A = 14
    MATES_BUTTON_A_DOT_COLOR_B = 15

class MatesParamSwitchA():
    MATES_SWITCH_A_BEVEL_MAIN_COLOR = 5
    MATES_SWITCH_A_BEVEL_SHADOW_COLOR = 6
    MATES_SWITCH_A_TRACK_COLOR_ON = 9
    MATES_SWITCH_A_TRACK_COLOR_OFF = 10
    MATES_SWITCH_A_LABEL_COLOR_ON = 15
    MATES_SWITCH_A_LABEL_COLOR_OFF = 16

class MatesParamSliderB():
    MATES_SLIDER_B_BACKGROUND_COLOR = 7
    MATES_SLIDER_B_TRACK_FILL_COLOR_A = 9
    MATES_SLIDER_B_TRACK_FILL_COLOR_B = 8
    MATES_SLIDER_B_MAJOR_TICK_COLOR = 15
    MATES_SLIDER_B_MINOR_TICK_COLOR = 17
    MATES_SLIDER_B_FONT_COLOR = 19
    MATES_SLIDER_B_KNOB_OUTLINE_COLOR_A = 20
    MATES_SLIDER_B_KNOB_OUTLINE_COLOR_B = 21
    MATES_SLIDER_B_KNOB_FACE_COLOR_A = 23
    MATES_SLIDER_B_KNOB_FACE_COLOR_B = 24

class MatesParamKnob():
    MATES_KNOB_BACKGROUND_COLOR = 11
    MATES_KNOB_KNOB_COLOR = 12
    MATES_KNOB_BEVEL_COLOR_LEFT = 15
    MATES_KNOB_BEVEL_COLOR_RIGHT = 14
    MATES_KNOB_PARTITION_1_INACTIVE_COLOR = 18
    MATES_KNOB_PARTITION_1_ACTIVE_COLOR = 21
    MATES_KNOB_PARTITION_2_INACTIVE_COLOR = 19
    MATES_KNOB_PARTITION_2_ACTIVE_COLOR = 22
    MATES_KNOB_PARTITION_3_INACTIVE_COLOR = 20
    MATES_KNOB_PARTITION_3_ACTIVE_COLOR = 23
    MATES_KNOB_LABEL_COLOR = 30
    MATES_KNOB_CAPTION_COLOR = 36
    MATES_KNOB_POINTER_COLOR = 27

class MatesParamMediaLed():
    MATES_MEDIA_LED_BACKGROUND_COLOR = 8
    MATES_MEDIA_LED_BEVEL_COLOR = 6
    MATES_MEDIA_LED_FACE_COLOR = 7
    MATES_MEDIA_LED_LED_COLOR_ON = 10
    MATES_MEDIA_LED_LED_COLOR_OFF = 9
    MATES_MEDIA_LED_SYMBOL_COLOR = 12

class MatesParamMediaColorLed():
    MATES_MEDIA_COLOR_LED_OUTER_COLOR = 4
    MATES_MEDIA_COLOR_LED_INNER_COLOR = 5

class MatesParamGaugeC():
    MATES_GAUGE_C_BACKGROUND_COLOR = 7
    MATES_GAUGE_C_TRACK_FILL_COLOR_A = 10
    MATES_GAUGE_C_TRACK_FILL_COLOR_B = 9
    MATES_GAUGE_C_TICK_COLOR = 11
    MATES_GAUGE_C_FONT_COLOR = 13

class MatesParamGaugeD():
    MATES_GAUGE_D_BACKGROUND_COLOR = 7
    MATES_GAUGE_D_TRACK_FILL_COLOR_A = 10
    MATES_GAUGE_D_TRACK_FILL_COLOR_B = 9
    MATES_GAUGE_D_TICK_COLOR = 11
    MATES_GAUGE_D_FONT_COLOR = 13

class MatesParamGaugeE():
    MATES_GAUGE_E_BEVEL_COLOR = 7
    MATES_GAUGE_E_TRACK_FILL_COLOR_A = 6
    MATES_GAUGE_E_TRACK_FILL_COLOR_B = 8

class MatesParamGaugeF():
    MATES_GAUGE_F_OUTER_BEVEL_COLOR_A = 6
    MATES_GAUGE_F_OUTER_BEVEL_COLOR_B = 7
    MATES_GAUGE_F_INNER_BEVEL_COLOR_A = 9
    MATES_GAUGE_F_INNER_BEVEL_COLOR_B = 10
    MATES_GAUGE_F_TRACK_FILL_COLOR_A = 13
    MATES_GAUGE_F_TRACK_FILL_COLOR_B = 12

class MatesParamMediaGaugeA():
    MATES_MEDIA_GAUGE_A_BACKGROUND_COLOR = 10
    MATES_MEDIA_GAUGE_A_SCALE_BEVEL_COLOR = 9
    MATES_MEDIA_GAUGE_A_SCALE_BOTTOM_LEFT_FILL_COLOR = 7
    MATES_MEDIA_GAUGE_A_SCALE_TOP_RIGHT_FILL_COLOR = 8

class MatesParamMediaGaugeB():
    MATES_MEDIA_GAUGE_B_NEEDLE_COLOR = 12
    MATES_MEDIA_GAUGE_B_OUTER_BEZEL_COLOR = 4
    MATES_MEDIA_GAUGE_B_INNER_BEZEL_COLOR = 5
    MATES_MEDIA_GAUGE_B_DIAL_COLOR = 6
    MATES_MEDIA_GAUGE_B_SCALE_LOW_COLOR = 13
    MATES_MEDIA_GAUGE_B_SCALE_MEDIUM_COLOR = 14
    MATES_MEDIA_GAUGE_B_SCALE_HIGH_COLOR = 15
    MATES_MEDIA_GAUGE_B_TICK_COLOR = 7
    MATES_MEDIA_GAUGE_B_FONT_COLOR = 8

class MatesParamMediaGaugeC():
    MATES_MEDIA_GAUGE_C_ON_COLOR = 4
    MATES_MEDIA_GAUGE_C_OFF_COLOR = 5

class MatesParamMediaGaugeD():
    MATES_MEDIA_GAUGE_D_ACTIVE_START_COLOR = 4
    MATES_MEDIA_GAUGE_D_ACTIVE_END_COLOR = 5
    MATES_MEDIA_GAUGE_D_INACTIVE_COLOR = 6

class MatesParamMediaThermometer():
    MATES_MEDIA_THERMOMETER_BASE_COLOR = 6
    MATES_MEDIA_THERMOMETER_BULB_COLOR = 7
    MATES_MEDIA_THERMOMETER_FONT_COLOR = 9
    MATES_MEDIA_THERMOMETER_SCALE_TICK_COLOR = 8

class MatesParamLedSpectrum():
    MATES_LED_SPECTRUM_BASE_COLOR = 11
    MATES_LED_SPECTRUM_PARTITION_1_INACTIVE_COLOR = 12
    MATES_LED_SPECTRUM_PARTITION_1_ACTIVE_COLOR = 13
    MATES_LED_SPECTRUM_PARTITION_2_INACTIVE_COLOR = 14
    MATES_LED_SPECTRUM_PARTITION_2_ACTIVE_COLOR = 15
    MATES_LED_SPECTRUM_PARTITION_3_INACTIVE_COLOR = 16
    MATES_LED_SPECTRUM_PARTITION_3_ACTIVE_COLOR = 17

class MatesParamMediaSpectrum():
    MATES_MEDIA_SPECTRUM_ACTIVE_START_COLOR = 6
    MATES_MEDIA_SPECTRUM_ACTIVE_END_COLOR = 7
    MATES_MEDIA_SPECTRUM_INACTIVE_COLOR = 8

class MatesParamButtonB():
    MATES_BUTTON_B_BEVEL_COLOR_A = 5
    MATES_BUTTON_B_BEVEL_COLOR_B = 6
    MATES_BUTTON_B_FACE_ON_COLOR = 9
    MATES_BUTTON_B_FACE_OFF_COLOR_A = 10
    MATES_BUTTON_B_FACE_OFF_COLOR_B = 11
    MATES_BUTTON_B_TEXT_ON_COLOR = 17
    MATES_BUTTON_B_TEXT_OFF_COLOR = 18
    MATES_BUTTON_B_SHINE_COLOR = 13

class MatesParamSwitchB():
    MATES_SWITCH_B_BEVEL_MAIN_COLOR = 5
    MATES_SWITCH_B_BEVEL_SHADOW_COLOR = 10
    MATES_SWITCH_B_LABEL_COLOR_ON = 15
    MATES_SWITCH_B_LABEL_COLOR_OFF = 16

class MatesParamMediaButton():
    MATES_MEDIA_BUTTON_BACKGROUND_COLOR = 8
    MATES_MEDIA_BUTTON_BEVEL_COLOR = 6
    MATES_MEDIA_BUTTON_FACE_COLOR = 7
    MATES_MEDIA_BUTTON_LED_COLOR_ON = 10
    MATES_MEDIA_BUTTON_LED_COLOR_OFF = 9
    MATES_MEDIA_BUTTON_SYMBOL_COLOR = 12

class MatesParamSliderA():
    MATES_SLIDER_A_BACKGROUND_COLOR = 7
    MATES_SLIDER_A_BORDER_COLOR = 8
    MATES_SLIDER_A_LED_OUTLINE_COLOR_A = 15
    MATES_SLIDER_A_LED_OUTLINE_COLOR_B = 16
    MATES_SLIDER_A_LED_ACTIVE_COLOR = 21
    MATES_SLIDER_A_LED_INACTIVE_COLOR_A = 17
    MATES_SLIDER_A_LED_INACTIVE_COLOR_B = 18
    MATES_SLIDER_A_TRACK_OUTLINE_COLOR_A = 9
    MATES_SLIDER_A_TRACK_OUTLINE_COLOR_B = 10
    MATES_SLIDER_A_TRACK_FILL_COLOR_A = 11
    MATES_SLIDER_A_TRACK_FILL_COLOR_B = 12
    MATES_SLIDER_A_KNOB_COLOR_A = 22
    MATES_SLIDER_A_KNOB_COLOR_B = 23
    MATES_SLIDER_A_FONT_COLOR = 26

class MatesParamSliderC():
    MATES_SLIDER_C_BACKGROUND_COLOR = 7
    MATES_SLIDER_C_KNOB_COLOR = 8
    MATES_SLIDER_C_TRACK_FILL_COLOR_A = 10
    MATES_SLIDER_C_TRACK_FILL_COLOR_B = 9
    MATES_SLIDER_C_TICK_COLOR = 11
    MATES_SLIDER_C_FONT_COLOR = 13

class MatesParamSliderD():
    MATES_SLIDER_D_BACKGROUND_COLOR = 7
    MATES_SLIDER_D_KNOB_COLOR = 8
    MATES_SLIDER_D_TRACK_FILL_COLOR_A = 10
    MATES_SLIDER_D_TRACK_FILL_COLOR_B = 9
    MATES_SLIDER_D_TICK_COLOR = 11
    MATES_SLIDER_D_FONT_COLOR = 13

class MatesParamSliderE():
    MATES_SLIDER_E_BEVEL_COLOR = 7
    MATES_SLIDER_E_TRACK_FILL_COLOR_A = 6
    MATES_SLIDER_E_TRACK_FILL_COLOR_B = 8
    MATES_SLIDER_E_KNOB_COLOR = 9

class MatesParamSliderF():
    MATES_SLIDER_F_OUTER_BEVEL_COLOR_A = 6
    MATES_SLIDER_F_OUTER_BEVEL_COLOR_B = 7
    MATES_SLIDER_F_INNER_BEVEL_COLOR_A = 9
    MATES_SLIDER_F_INNER_BEVEL_COLOR_B = 10
    MATES_SLIDER_F_TRACK_FILL_COLOR_A = 13
    MATES_SLIDER_F_TRACK_FILL_COLOR_B = 12
    MATES_SLIDER_F_KNOB_OUTLINE_COLOR_A = 14
    MATES_SLIDER_F_KNOB_OUTLINE_COLOR_B = 15
    MATES_SLIDER_F_KNOB_FACE_COLOR_A = 17
    MATES_SLIDER_F_KNOB_FACE_COLOR_B = 18
    MATES_SLIDER_F_KNOB_DOT_COLOR = 20

class MatesParamMediaSlider():
    MATES_MEDIA_SLIDER_BACKGROUND_COLOR = 10
    MATES_MEDIA_SLIDER_SCALE_BEVEL_COLOR = 9
    MATES_MEDIA_SLIDER_SCALE_BOTTOM_LEFT_FILL_COLOR = 7
    MATES_MEDIA_SLIDER_SCALE_TOP_RIGHT_FILL_COLOR = 8
    MATES_MEDIA_SLIDER_KNOB_BEVEL_COLOR = 6
    MATES_MEDIA_SLIDER_KNOB_CENTER_COLOR = 5

class MatesParamMediaRotary():
    MATES_MEDIA_ROTARY_OUTER_EDGE_COLOR = 5
    MATES_MEDIA_ROTARY_OUTER_RADIUS_COLOR = 6
    MATES_MEDIA_ROTARY_INNER_EDGE_COLOR = 7
    MATES_MEDIA_ROTARY_INNER_RADIUS_COLOR = 8
    MATES_MEDIA_ROTARY_INDICATOR_OUTER_COLOR = 9
    MATES_MEDIA_ROTARY_INDICATOR_INNER_COLOR = 10

# Here are predefined IDs for widgets
class MatesWidgetId():
    # Led List
    Led0 = 0x0000
    Led1 = 0x0001
    Led2 = 0x0002
    Led3 = 0x0003
    Led4 = 0x0004
    Led5 = 0x0005
    Led6 = 0x0006
    Led7 = 0x0007
    Led8 = 0x0008
    Led9 = 0x0009
    Led10 = 0x000A
    Led11 = 0x000B
    Led12 = 0x000C
    Led13 = 0x000D
    Led14 = 0x000E
    Led15 = 0x000F
    Led16 = 0x0010
    Led17 = 0x0011
    Led18 = 0x0012
    Led19 = 0x0013
    Led20 = 0x0014
    Led21 = 0x0015
    Led22 = 0x0016
    Led23 = 0x0017
    Led24 = 0x0018
    Led25 = 0x0019
    Led26 = 0x001A
    Led27 = 0x001B
    Led28 = 0x001C
    Led29 = 0x001D
    Led30 = 0x001E
    Led31 = 0x001F
    Led32 = 0x0020
    Led33 = 0x0021
    Led34 = 0x0022
    Led35 = 0x0023
    Led36 = 0x0024
    Led37 = 0x0025
    Led38 = 0x0026
    Led39 = 0x0027
    Led40 = 0x0028
    Led41 = 0x0029
    Led42 = 0x002A
    Led43 = 0x002B
    Led44 = 0x002C
    Led45 = 0x002D
    Led46 = 0x002E
    Led47 = 0x002F
    Led48 = 0x0030
    Led49 = 0x0031
    Led50 = 0x0032
    Led51 = 0x0033
    Led52 = 0x0034
    Led53 = 0x0035
    Led54 = 0x0036
    Led55 = 0x0037
    Led56 = 0x0038
    Led57 = 0x0039
    Led58 = 0x003A
    Led59 = 0x003B
    Led60 = 0x003C
    Led61 = 0x003D
    Led62 = 0x003E
    Led63 = 0x003F
    Led64 = 0x0040
    Led65 = 0x0041
    Led66 = 0x0042
    Led67 = 0x0043
    Led68 = 0x0044
    Led69 = 0x0045
    Led70 = 0x0046
    Led71 = 0x0047
    Led72 = 0x0048
    Led73 = 0x0049
    Led74 = 0x004A
    Led75 = 0x004B
    Led76 = 0x004C
    Led77 = 0x004D
    Led78 = 0x004E
    Led79 = 0x004F
    Led80 = 0x0050
    Led81 = 0x0051
    Led82 = 0x0052
    Led83 = 0x0053
    Led84 = 0x0054
    Led85 = 0x0055
    Led86 = 0x0056
    Led87 = 0x0057
    Led88 = 0x0058
    Led89 = 0x0059
    Led90 = 0x005A
    Led91 = 0x005B
    Led92 = 0x005C
    Led93 = 0x005D
    Led94 = 0x005E
    Led95 = 0x005F
    Led96 = 0x0060
    Led97 = 0x0061
    Led98 = 0x0062
    Led99 = 0x0063
    Led100 = 0x0064
    Led101 = 0x0065
    Led102 = 0x0066
    Led103 = 0x0067
    Led104 = 0x0068
    Led105 = 0x0069
    Led106 = 0x006A
    Led107 = 0x006B
    Led108 = 0x006C
    Led109 = 0x006D
    Led110 = 0x006E
    Led111 = 0x006F
    Led112 = 0x0070
    Led113 = 0x0071
    Led114 = 0x0072
    Led115 = 0x0073
    Led116 = 0x0074
    Led117 = 0x0075
    Led118 = 0x0076
    Led119 = 0x0077
    Led120 = 0x0078
    Led121 = 0x0079
    Led122 = 0x007A
    Led123 = 0x007B
    Led124 = 0x007C
    Led125 = 0x007D
    Led126 = 0x007E
    Led127 = 0x007F
    Led128 = 0x0080
    Led129 = 0x0081
    Led130 = 0x0082
    Led131 = 0x0083
    Led132 = 0x0084
    Led133 = 0x0085
    Led134 = 0x0086
    Led135 = 0x0087
    Led136 = 0x0088
    Led137 = 0x0089
    Led138 = 0x008A
    Led139 = 0x008B
    Led140 = 0x008C
    Led141 = 0x008D
    Led142 = 0x008E
    Led143 = 0x008F
    Led144 = 0x0090
    Led145 = 0x0091
    Led146 = 0x0092
    Led147 = 0x0093
    Led148 = 0x0094
    Led149 = 0x0095
    Led150 = 0x0096
    Led151 = 0x0097
    Led152 = 0x0098
    Led153 = 0x0099
    Led154 = 0x009A
    Led155 = 0x009B
    Led156 = 0x009C
    Led157 = 0x009D
    Led158 = 0x009E
    Led159 = 0x009F
    Led160 = 0x00A0
    Led161 = 0x00A1
    Led162 = 0x00A2
    Led163 = 0x00A3
    Led164 = 0x00A4
    Led165 = 0x00A5
    Led166 = 0x00A6
    Led167 = 0x00A7
    Led168 = 0x00A8
    Led169 = 0x00A9
    Led170 = 0x00AA
    Led171 = 0x00AB
    Led172 = 0x00AC
    Led173 = 0x00AD
    Led174 = 0x00AE
    Led175 = 0x00AF
    Led176 = 0x00B0
    Led177 = 0x00B1
    Led178 = 0x00B2
    Led179 = 0x00B3
    Led180 = 0x00B4
    Led181 = 0x00B5
    Led182 = 0x00B6
    Led183 = 0x00B7
    Led184 = 0x00B8
    Led185 = 0x00B9
    Led186 = 0x00BA
    Led187 = 0x00BB
    Led188 = 0x00BC
    Led189 = 0x00BD
    Led190 = 0x00BE
    Led191 = 0x00BF
    Led192 = 0x00C0
    Led193 = 0x00C1
    Led194 = 0x00C2
    Led195 = 0x00C3
    Led196 = 0x00C4
    Led197 = 0x00C5
    Led198 = 0x00C6
    Led199 = 0x00C7
    Led200 = 0x00C8
    Led201 = 0x00C9
    Led202 = 0x00CA
    Led203 = 0x00CB
    Led204 = 0x00CC
    Led205 = 0x00CD
    Led206 = 0x00CE
    Led207 = 0x00CF
    Led208 = 0x00D0
    Led209 = 0x00D1
    Led210 = 0x00D2
    Led211 = 0x00D3
    Led212 = 0x00D4
    Led213 = 0x00D5
    Led214 = 0x00D6
    Led215 = 0x00D7
    Led216 = 0x00D8
    Led217 = 0x00D9
    Led218 = 0x00DA
    Led219 = 0x00DB
    Led220 = 0x00DC
    Led221 = 0x00DD
    Led222 = 0x00DE
    Led223 = 0x00DF
    Led224 = 0x00E0
    Led225 = 0x00E1
    Led226 = 0x00E2
    Led227 = 0x00E3
    Led228 = 0x00E4
    Led229 = 0x00E5
    Led230 = 0x00E6
    Led231 = 0x00E7
    Led232 = 0x00E8
    Led233 = 0x00E9
    Led234 = 0x00EA
    Led235 = 0x00EB
    Led236 = 0x00EC
    Led237 = 0x00ED
    Led238 = 0x00EE
    Led239 = 0x00EF
    Led240 = 0x00F0
    Led241 = 0x00F1
    Led242 = 0x00F2
    Led243 = 0x00F3
    Led244 = 0x00F4
    Led245 = 0x00F5
    Led246 = 0x00F6
    Led247 = 0x00F7
    Led248 = 0x00F8
    Led249 = 0x00F9
    Led250 = 0x00FA
    Led251 = 0x00FB
    Led252 = 0x00FC
    Led253 = 0x00FD
    Led254 = 0x00FE
    Led255 = 0x00FF
    # RulerGauge List
    RulerGauge0 = 0x0100
    RulerGauge1 = 0x0101
    RulerGauge2 = 0x0102
    RulerGauge3 = 0x0103
    RulerGauge4 = 0x0104
    RulerGauge5 = 0x0105
    RulerGauge6 = 0x0106
    RulerGauge7 = 0x0107
    RulerGauge8 = 0x0108
    RulerGauge9 = 0x0109
    RulerGauge10 = 0x010A
    RulerGauge11 = 0x010B
    RulerGauge12 = 0x010C
    RulerGauge13 = 0x010D
    RulerGauge14 = 0x010E
    RulerGauge15 = 0x010F
    RulerGauge16 = 0x0110
    RulerGauge17 = 0x0111
    RulerGauge18 = 0x0112
    RulerGauge19 = 0x0113
    RulerGauge20 = 0x0114
    RulerGauge21 = 0x0115
    RulerGauge22 = 0x0116
    RulerGauge23 = 0x0117
    RulerGauge24 = 0x0118
    RulerGauge25 = 0x0119
    RulerGauge26 = 0x011A
    RulerGauge27 = 0x011B
    RulerGauge28 = 0x011C
    RulerGauge29 = 0x011D
    RulerGauge30 = 0x011E
    RulerGauge31 = 0x011F
    RulerGauge32 = 0x0120
    RulerGauge33 = 0x0121
    RulerGauge34 = 0x0122
    RulerGauge35 = 0x0123
    RulerGauge36 = 0x0124
    RulerGauge37 = 0x0125
    RulerGauge38 = 0x0126
    RulerGauge39 = 0x0127
    RulerGauge40 = 0x0128
    RulerGauge41 = 0x0129
    RulerGauge42 = 0x012A
    RulerGauge43 = 0x012B
    RulerGauge44 = 0x012C
    RulerGauge45 = 0x012D
    RulerGauge46 = 0x012E
    RulerGauge47 = 0x012F
    RulerGauge48 = 0x0130
    RulerGauge49 = 0x0131
    RulerGauge50 = 0x0132
    RulerGauge51 = 0x0133
    RulerGauge52 = 0x0134
    RulerGauge53 = 0x0135
    RulerGauge54 = 0x0136
    RulerGauge55 = 0x0137
    RulerGauge56 = 0x0138
    RulerGauge57 = 0x0139
    RulerGauge58 = 0x013A
    RulerGauge59 = 0x013B
    RulerGauge60 = 0x013C
    RulerGauge61 = 0x013D
    RulerGauge62 = 0x013E
    RulerGauge63 = 0x013F
    RulerGauge64 = 0x0140
    RulerGauge65 = 0x0141
    RulerGauge66 = 0x0142
    RulerGauge67 = 0x0143
    RulerGauge68 = 0x0144
    RulerGauge69 = 0x0145
    RulerGauge70 = 0x0146
    RulerGauge71 = 0x0147
    RulerGauge72 = 0x0148
    RulerGauge73 = 0x0149
    RulerGauge74 = 0x014A
    RulerGauge75 = 0x014B
    RulerGauge76 = 0x014C
    RulerGauge77 = 0x014D
    RulerGauge78 = 0x014E
    RulerGauge79 = 0x014F
    RulerGauge80 = 0x0150
    RulerGauge81 = 0x0151
    RulerGauge82 = 0x0152
    RulerGauge83 = 0x0153
    RulerGauge84 = 0x0154
    RulerGauge85 = 0x0155
    RulerGauge86 = 0x0156
    RulerGauge87 = 0x0157
    RulerGauge88 = 0x0158
    RulerGauge89 = 0x0159
    RulerGauge90 = 0x015A
    RulerGauge91 = 0x015B
    RulerGauge92 = 0x015C
    RulerGauge93 = 0x015D
    RulerGauge94 = 0x015E
    RulerGauge95 = 0x015F
    RulerGauge96 = 0x0160
    RulerGauge97 = 0x0161
    RulerGauge98 = 0x0162
    RulerGauge99 = 0x0163
    RulerGauge100 = 0x0164
    RulerGauge101 = 0x0165
    RulerGauge102 = 0x0166
    RulerGauge103 = 0x0167
    RulerGauge104 = 0x0168
    RulerGauge105 = 0x0169
    RulerGauge106 = 0x016A
    RulerGauge107 = 0x016B
    RulerGauge108 = 0x016C
    RulerGauge109 = 0x016D
    RulerGauge110 = 0x016E
    RulerGauge111 = 0x016F
    RulerGauge112 = 0x0170
    RulerGauge113 = 0x0171
    RulerGauge114 = 0x0172
    RulerGauge115 = 0x0173
    RulerGauge116 = 0x0174
    RulerGauge117 = 0x0175
    RulerGauge118 = 0x0176
    RulerGauge119 = 0x0177
    RulerGauge120 = 0x0178
    RulerGauge121 = 0x0179
    RulerGauge122 = 0x017A
    RulerGauge123 = 0x017B
    RulerGauge124 = 0x017C
    RulerGauge125 = 0x017D
    RulerGauge126 = 0x017E
    RulerGauge127 = 0x017F
    RulerGauge128 = 0x0180
    RulerGauge129 = 0x0181
    RulerGauge130 = 0x0182
    RulerGauge131 = 0x0183
    RulerGauge132 = 0x0184
    RulerGauge133 = 0x0185
    RulerGauge134 = 0x0186
    RulerGauge135 = 0x0187
    RulerGauge136 = 0x0188
    RulerGauge137 = 0x0189
    RulerGauge138 = 0x018A
    RulerGauge139 = 0x018B
    RulerGauge140 = 0x018C
    RulerGauge141 = 0x018D
    RulerGauge142 = 0x018E
    RulerGauge143 = 0x018F
    RulerGauge144 = 0x0190
    RulerGauge145 = 0x0191
    RulerGauge146 = 0x0192
    RulerGauge147 = 0x0193
    RulerGauge148 = 0x0194
    RulerGauge149 = 0x0195
    RulerGauge150 = 0x0196
    RulerGauge151 = 0x0197
    RulerGauge152 = 0x0198
    RulerGauge153 = 0x0199
    RulerGauge154 = 0x019A
    RulerGauge155 = 0x019B
    RulerGauge156 = 0x019C
    RulerGauge157 = 0x019D
    RulerGauge158 = 0x019E
    RulerGauge159 = 0x019F
    RulerGauge160 = 0x01A0
    RulerGauge161 = 0x01A1
    RulerGauge162 = 0x01A2
    RulerGauge163 = 0x01A3
    RulerGauge164 = 0x01A4
    RulerGauge165 = 0x01A5
    RulerGauge166 = 0x01A6
    RulerGauge167 = 0x01A7
    RulerGauge168 = 0x01A8
    RulerGauge169 = 0x01A9
    RulerGauge170 = 0x01AA
    RulerGauge171 = 0x01AB
    RulerGauge172 = 0x01AC
    RulerGauge173 = 0x01AD
    RulerGauge174 = 0x01AE
    RulerGauge175 = 0x01AF
    RulerGauge176 = 0x01B0
    RulerGauge177 = 0x01B1
    RulerGauge178 = 0x01B2
    RulerGauge179 = 0x01B3
    RulerGauge180 = 0x01B4
    RulerGauge181 = 0x01B5
    RulerGauge182 = 0x01B6
    RulerGauge183 = 0x01B7
    RulerGauge184 = 0x01B8
    RulerGauge185 = 0x01B9
    RulerGauge186 = 0x01BA
    RulerGauge187 = 0x01BB
    RulerGauge188 = 0x01BC
    RulerGauge189 = 0x01BD
    RulerGauge190 = 0x01BE
    RulerGauge191 = 0x01BF
    RulerGauge192 = 0x01C0
    RulerGauge193 = 0x01C1
    RulerGauge194 = 0x01C2
    RulerGauge195 = 0x01C3
    RulerGauge196 = 0x01C4
    RulerGauge197 = 0x01C5
    RulerGauge198 = 0x01C6
    RulerGauge199 = 0x01C7
    RulerGauge200 = 0x01C8
    RulerGauge201 = 0x01C9
    RulerGauge202 = 0x01CA
    RulerGauge203 = 0x01CB
    RulerGauge204 = 0x01CC
    RulerGauge205 = 0x01CD
    RulerGauge206 = 0x01CE
    RulerGauge207 = 0x01CF
    RulerGauge208 = 0x01D0
    RulerGauge209 = 0x01D1
    RulerGauge210 = 0x01D2
    RulerGauge211 = 0x01D3
    RulerGauge212 = 0x01D4
    RulerGauge213 = 0x01D5
    RulerGauge214 = 0x01D6
    RulerGauge215 = 0x01D7
    RulerGauge216 = 0x01D8
    RulerGauge217 = 0x01D9
    RulerGauge218 = 0x01DA
    RulerGauge219 = 0x01DB
    RulerGauge220 = 0x01DC
    RulerGauge221 = 0x01DD
    RulerGauge222 = 0x01DE
    RulerGauge223 = 0x01DF
    RulerGauge224 = 0x01E0
    RulerGauge225 = 0x01E1
    RulerGauge226 = 0x01E2
    RulerGauge227 = 0x01E3
    RulerGauge228 = 0x01E4
    RulerGauge229 = 0x01E5
    RulerGauge230 = 0x01E6
    RulerGauge231 = 0x01E7
    RulerGauge232 = 0x01E8
    RulerGauge233 = 0x01E9
    RulerGauge234 = 0x01EA
    RulerGauge235 = 0x01EB
    RulerGauge236 = 0x01EC
    RulerGauge237 = 0x01ED
    RulerGauge238 = 0x01EE
    RulerGauge239 = 0x01EF
    RulerGauge240 = 0x01F0
    RulerGauge241 = 0x01F1
    RulerGauge242 = 0x01F2
    RulerGauge243 = 0x01F3
    RulerGauge244 = 0x01F4
    RulerGauge245 = 0x01F5
    RulerGauge246 = 0x01F6
    RulerGauge247 = 0x01F7
    RulerGauge248 = 0x01F8
    RulerGauge249 = 0x01F9
    RulerGauge250 = 0x01FA
    RulerGauge251 = 0x01FB
    RulerGauge252 = 0x01FC
    RulerGauge253 = 0x01FD
    RulerGauge254 = 0x01FE
    RulerGauge255 = 0x01FF
    # AngularMeter List
    AngularMeter0 = 0x0200
    AngularMeter1 = 0x0201
    AngularMeter2 = 0x0202
    AngularMeter3 = 0x0203
    AngularMeter4 = 0x0204
    AngularMeter5 = 0x0205
    AngularMeter6 = 0x0206
    AngularMeter7 = 0x0207
    AngularMeter8 = 0x0208
    AngularMeter9 = 0x0209
    AngularMeter10 = 0x020A
    AngularMeter11 = 0x020B
    AngularMeter12 = 0x020C
    AngularMeter13 = 0x020D
    AngularMeter14 = 0x020E
    AngularMeter15 = 0x020F
    AngularMeter16 = 0x0210
    AngularMeter17 = 0x0211
    AngularMeter18 = 0x0212
    AngularMeter19 = 0x0213
    AngularMeter20 = 0x0214
    AngularMeter21 = 0x0215
    AngularMeter22 = 0x0216
    AngularMeter23 = 0x0217
    AngularMeter24 = 0x0218
    AngularMeter25 = 0x0219
    AngularMeter26 = 0x021A
    AngularMeter27 = 0x021B
    AngularMeter28 = 0x021C
    AngularMeter29 = 0x021D
    AngularMeter30 = 0x021E
    AngularMeter31 = 0x021F
    AngularMeter32 = 0x0220
    AngularMeter33 = 0x0221
    AngularMeter34 = 0x0222
    AngularMeter35 = 0x0223
    AngularMeter36 = 0x0224
    AngularMeter37 = 0x0225
    AngularMeter38 = 0x0226
    AngularMeter39 = 0x0227
    AngularMeter40 = 0x0228
    AngularMeter41 = 0x0229
    AngularMeter42 = 0x022A
    AngularMeter43 = 0x022B
    AngularMeter44 = 0x022C
    AngularMeter45 = 0x022D
    AngularMeter46 = 0x022E
    AngularMeter47 = 0x022F
    AngularMeter48 = 0x0230
    AngularMeter49 = 0x0231
    AngularMeter50 = 0x0232
    AngularMeter51 = 0x0233
    AngularMeter52 = 0x0234
    AngularMeter53 = 0x0235
    AngularMeter54 = 0x0236
    AngularMeter55 = 0x0237
    AngularMeter56 = 0x0238
    AngularMeter57 = 0x0239
    AngularMeter58 = 0x023A
    AngularMeter59 = 0x023B
    AngularMeter60 = 0x023C
    AngularMeter61 = 0x023D
    AngularMeter62 = 0x023E
    AngularMeter63 = 0x023F
    AngularMeter64 = 0x0240
    AngularMeter65 = 0x0241
    AngularMeter66 = 0x0242
    AngularMeter67 = 0x0243
    AngularMeter68 = 0x0244
    AngularMeter69 = 0x0245
    AngularMeter70 = 0x0246
    AngularMeter71 = 0x0247
    AngularMeter72 = 0x0248
    AngularMeter73 = 0x0249
    AngularMeter74 = 0x024A
    AngularMeter75 = 0x024B
    AngularMeter76 = 0x024C
    AngularMeter77 = 0x024D
    AngularMeter78 = 0x024E
    AngularMeter79 = 0x024F
    AngularMeter80 = 0x0250
    AngularMeter81 = 0x0251
    AngularMeter82 = 0x0252
    AngularMeter83 = 0x0253
    AngularMeter84 = 0x0254
    AngularMeter85 = 0x0255
    AngularMeter86 = 0x0256
    AngularMeter87 = 0x0257
    AngularMeter88 = 0x0258
    AngularMeter89 = 0x0259
    AngularMeter90 = 0x025A
    AngularMeter91 = 0x025B
    AngularMeter92 = 0x025C
    AngularMeter93 = 0x025D
    AngularMeter94 = 0x025E
    AngularMeter95 = 0x025F
    AngularMeter96 = 0x0260
    AngularMeter97 = 0x0261
    AngularMeter98 = 0x0262
    AngularMeter99 = 0x0263
    AngularMeter100 = 0x0264
    AngularMeter101 = 0x0265
    AngularMeter102 = 0x0266
    AngularMeter103 = 0x0267
    AngularMeter104 = 0x0268
    AngularMeter105 = 0x0269
    AngularMeter106 = 0x026A
    AngularMeter107 = 0x026B
    AngularMeter108 = 0x026C
    AngularMeter109 = 0x026D
    AngularMeter110 = 0x026E
    AngularMeter111 = 0x026F
    AngularMeter112 = 0x0270
    AngularMeter113 = 0x0271
    AngularMeter114 = 0x0272
    AngularMeter115 = 0x0273
    AngularMeter116 = 0x0274
    AngularMeter117 = 0x0275
    AngularMeter118 = 0x0276
    AngularMeter119 = 0x0277
    AngularMeter120 = 0x0278
    AngularMeter121 = 0x0279
    AngularMeter122 = 0x027A
    AngularMeter123 = 0x027B
    AngularMeter124 = 0x027C
    AngularMeter125 = 0x027D
    AngularMeter126 = 0x027E
    AngularMeter127 = 0x027F
    AngularMeter128 = 0x0280
    AngularMeter129 = 0x0281
    AngularMeter130 = 0x0282
    AngularMeter131 = 0x0283
    AngularMeter132 = 0x0284
    AngularMeter133 = 0x0285
    AngularMeter134 = 0x0286
    AngularMeter135 = 0x0287
    AngularMeter136 = 0x0288
    AngularMeter137 = 0x0289
    AngularMeter138 = 0x028A
    AngularMeter139 = 0x028B
    AngularMeter140 = 0x028C
    AngularMeter141 = 0x028D
    AngularMeter142 = 0x028E
    AngularMeter143 = 0x028F
    AngularMeter144 = 0x0290
    AngularMeter145 = 0x0291
    AngularMeter146 = 0x0292
    AngularMeter147 = 0x0293
    AngularMeter148 = 0x0294
    AngularMeter149 = 0x0295
    AngularMeter150 = 0x0296
    AngularMeter151 = 0x0297
    AngularMeter152 = 0x0298
    AngularMeter153 = 0x0299
    AngularMeter154 = 0x029A
    AngularMeter155 = 0x029B
    AngularMeter156 = 0x029C
    AngularMeter157 = 0x029D
    AngularMeter158 = 0x029E
    AngularMeter159 = 0x029F
    AngularMeter160 = 0x02A0
    AngularMeter161 = 0x02A1
    AngularMeter162 = 0x02A2
    AngularMeter163 = 0x02A3
    AngularMeter164 = 0x02A4
    AngularMeter165 = 0x02A5
    AngularMeter166 = 0x02A6
    AngularMeter167 = 0x02A7
    AngularMeter168 = 0x02A8
    AngularMeter169 = 0x02A9
    AngularMeter170 = 0x02AA
    AngularMeter171 = 0x02AB
    AngularMeter172 = 0x02AC
    AngularMeter173 = 0x02AD
    AngularMeter174 = 0x02AE
    AngularMeter175 = 0x02AF
    AngularMeter176 = 0x02B0
    AngularMeter177 = 0x02B1
    AngularMeter178 = 0x02B2
    AngularMeter179 = 0x02B3
    AngularMeter180 = 0x02B4
    AngularMeter181 = 0x02B5
    AngularMeter182 = 0x02B6
    AngularMeter183 = 0x02B7
    AngularMeter184 = 0x02B8
    AngularMeter185 = 0x02B9
    AngularMeter186 = 0x02BA
    AngularMeter187 = 0x02BB
    AngularMeter188 = 0x02BC
    AngularMeter189 = 0x02BD
    AngularMeter190 = 0x02BE
    AngularMeter191 = 0x02BF
    AngularMeter192 = 0x02C0
    AngularMeter193 = 0x02C1
    AngularMeter194 = 0x02C2
    AngularMeter195 = 0x02C3
    AngularMeter196 = 0x02C4
    AngularMeter197 = 0x02C5
    AngularMeter198 = 0x02C6
    AngularMeter199 = 0x02C7
    AngularMeter200 = 0x02C8
    AngularMeter201 = 0x02C9
    AngularMeter202 = 0x02CA
    AngularMeter203 = 0x02CB
    AngularMeter204 = 0x02CC
    AngularMeter205 = 0x02CD
    AngularMeter206 = 0x02CE
    AngularMeter207 = 0x02CF
    AngularMeter208 = 0x02D0
    AngularMeter209 = 0x02D1
    AngularMeter210 = 0x02D2
    AngularMeter211 = 0x02D3
    AngularMeter212 = 0x02D4
    AngularMeter213 = 0x02D5
    AngularMeter214 = 0x02D6
    AngularMeter215 = 0x02D7
    AngularMeter216 = 0x02D8
    AngularMeter217 = 0x02D9
    AngularMeter218 = 0x02DA
    AngularMeter219 = 0x02DB
    AngularMeter220 = 0x02DC
    AngularMeter221 = 0x02DD
    AngularMeter222 = 0x02DE
    AngularMeter223 = 0x02DF
    AngularMeter224 = 0x02E0
    AngularMeter225 = 0x02E1
    AngularMeter226 = 0x02E2
    AngularMeter227 = 0x02E3
    AngularMeter228 = 0x02E4
    AngularMeter229 = 0x02E5
    AngularMeter230 = 0x02E6
    AngularMeter231 = 0x02E7
    AngularMeter232 = 0x02E8
    AngularMeter233 = 0x02E9
    AngularMeter234 = 0x02EA
    AngularMeter235 = 0x02EB
    AngularMeter236 = 0x02EC
    AngularMeter237 = 0x02ED
    AngularMeter238 = 0x02EE
    AngularMeter239 = 0x02EF
    AngularMeter240 = 0x02F0
    AngularMeter241 = 0x02F1
    AngularMeter242 = 0x02F2
    AngularMeter243 = 0x02F3
    AngularMeter244 = 0x02F4
    AngularMeter245 = 0x02F5
    AngularMeter246 = 0x02F6
    AngularMeter247 = 0x02F7
    AngularMeter248 = 0x02F8
    AngularMeter249 = 0x02F9
    AngularMeter250 = 0x02FA
    AngularMeter251 = 0x02FB
    AngularMeter252 = 0x02FC
    AngularMeter253 = 0x02FD
    AngularMeter254 = 0x02FE
    AngularMeter255 = 0x02FF
    # GaugeA List
    GaugeA0 = 0x0300
    GaugeA1 = 0x0301
    GaugeA2 = 0x0302
    GaugeA3 = 0x0303
    GaugeA4 = 0x0304
    GaugeA5 = 0x0305
    GaugeA6 = 0x0306
    GaugeA7 = 0x0307
    GaugeA8 = 0x0308
    GaugeA9 = 0x0309
    GaugeA10 = 0x030A
    GaugeA11 = 0x030B
    GaugeA12 = 0x030C
    GaugeA13 = 0x030D
    GaugeA14 = 0x030E
    GaugeA15 = 0x030F
    GaugeA16 = 0x0310
    GaugeA17 = 0x0311
    GaugeA18 = 0x0312
    GaugeA19 = 0x0313
    GaugeA20 = 0x0314
    GaugeA21 = 0x0315
    GaugeA22 = 0x0316
    GaugeA23 = 0x0317
    GaugeA24 = 0x0318
    GaugeA25 = 0x0319
    GaugeA26 = 0x031A
    GaugeA27 = 0x031B
    GaugeA28 = 0x031C
    GaugeA29 = 0x031D
    GaugeA30 = 0x031E
    GaugeA31 = 0x031F
    GaugeA32 = 0x0320
    GaugeA33 = 0x0321
    GaugeA34 = 0x0322
    GaugeA35 = 0x0323
    GaugeA36 = 0x0324
    GaugeA37 = 0x0325
    GaugeA38 = 0x0326
    GaugeA39 = 0x0327
    GaugeA40 = 0x0328
    GaugeA41 = 0x0329
    GaugeA42 = 0x032A
    GaugeA43 = 0x032B
    GaugeA44 = 0x032C
    GaugeA45 = 0x032D
    GaugeA46 = 0x032E
    GaugeA47 = 0x032F
    GaugeA48 = 0x0330
    GaugeA49 = 0x0331
    GaugeA50 = 0x0332
    GaugeA51 = 0x0333
    GaugeA52 = 0x0334
    GaugeA53 = 0x0335
    GaugeA54 = 0x0336
    GaugeA55 = 0x0337
    GaugeA56 = 0x0338
    GaugeA57 = 0x0339
    GaugeA58 = 0x033A
    GaugeA59 = 0x033B
    GaugeA60 = 0x033C
    GaugeA61 = 0x033D
    GaugeA62 = 0x033E
    GaugeA63 = 0x033F
    GaugeA64 = 0x0340
    GaugeA65 = 0x0341
    GaugeA66 = 0x0342
    GaugeA67 = 0x0343
    GaugeA68 = 0x0344
    GaugeA69 = 0x0345
    GaugeA70 = 0x0346
    GaugeA71 = 0x0347
    GaugeA72 = 0x0348
    GaugeA73 = 0x0349
    GaugeA74 = 0x034A
    GaugeA75 = 0x034B
    GaugeA76 = 0x034C
    GaugeA77 = 0x034D
    GaugeA78 = 0x034E
    GaugeA79 = 0x034F
    GaugeA80 = 0x0350
    GaugeA81 = 0x0351
    GaugeA82 = 0x0352
    GaugeA83 = 0x0353
    GaugeA84 = 0x0354
    GaugeA85 = 0x0355
    GaugeA86 = 0x0356
    GaugeA87 = 0x0357
    GaugeA88 = 0x0358
    GaugeA89 = 0x0359
    GaugeA90 = 0x035A
    GaugeA91 = 0x035B
    GaugeA92 = 0x035C
    GaugeA93 = 0x035D
    GaugeA94 = 0x035E
    GaugeA95 = 0x035F
    GaugeA96 = 0x0360
    GaugeA97 = 0x0361
    GaugeA98 = 0x0362
    GaugeA99 = 0x0363
    GaugeA100 = 0x0364
    GaugeA101 = 0x0365
    GaugeA102 = 0x0366
    GaugeA103 = 0x0367
    GaugeA104 = 0x0368
    GaugeA105 = 0x0369
    GaugeA106 = 0x036A
    GaugeA107 = 0x036B
    GaugeA108 = 0x036C
    GaugeA109 = 0x036D
    GaugeA110 = 0x036E
    GaugeA111 = 0x036F
    GaugeA112 = 0x0370
    GaugeA113 = 0x0371
    GaugeA114 = 0x0372
    GaugeA115 = 0x0373
    GaugeA116 = 0x0374
    GaugeA117 = 0x0375
    GaugeA118 = 0x0376
    GaugeA119 = 0x0377
    GaugeA120 = 0x0378
    GaugeA121 = 0x0379
    GaugeA122 = 0x037A
    GaugeA123 = 0x037B
    GaugeA124 = 0x037C
    GaugeA125 = 0x037D
    GaugeA126 = 0x037E
    GaugeA127 = 0x037F
    GaugeA128 = 0x0380
    GaugeA129 = 0x0381
    GaugeA130 = 0x0382
    GaugeA131 = 0x0383
    GaugeA132 = 0x0384
    GaugeA133 = 0x0385
    GaugeA134 = 0x0386
    GaugeA135 = 0x0387
    GaugeA136 = 0x0388
    GaugeA137 = 0x0389
    GaugeA138 = 0x038A
    GaugeA139 = 0x038B
    GaugeA140 = 0x038C
    GaugeA141 = 0x038D
    GaugeA142 = 0x038E
    GaugeA143 = 0x038F
    GaugeA144 = 0x0390
    GaugeA145 = 0x0391
    GaugeA146 = 0x0392
    GaugeA147 = 0x0393
    GaugeA148 = 0x0394
    GaugeA149 = 0x0395
    GaugeA150 = 0x0396
    GaugeA151 = 0x0397
    GaugeA152 = 0x0398
    GaugeA153 = 0x0399
    GaugeA154 = 0x039A
    GaugeA155 = 0x039B
    GaugeA156 = 0x039C
    GaugeA157 = 0x039D
    GaugeA158 = 0x039E
    GaugeA159 = 0x039F
    GaugeA160 = 0x03A0
    GaugeA161 = 0x03A1
    GaugeA162 = 0x03A2
    GaugeA163 = 0x03A3
    GaugeA164 = 0x03A4
    GaugeA165 = 0x03A5
    GaugeA166 = 0x03A6
    GaugeA167 = 0x03A7
    GaugeA168 = 0x03A8
    GaugeA169 = 0x03A9
    GaugeA170 = 0x03AA
    GaugeA171 = 0x03AB
    GaugeA172 = 0x03AC
    GaugeA173 = 0x03AD
    GaugeA174 = 0x03AE
    GaugeA175 = 0x03AF
    GaugeA176 = 0x03B0
    GaugeA177 = 0x03B1
    GaugeA178 = 0x03B2
    GaugeA179 = 0x03B3
    GaugeA180 = 0x03B4
    GaugeA181 = 0x03B5
    GaugeA182 = 0x03B6
    GaugeA183 = 0x03B7
    GaugeA184 = 0x03B8
    GaugeA185 = 0x03B9
    GaugeA186 = 0x03BA
    GaugeA187 = 0x03BB
    GaugeA188 = 0x03BC
    GaugeA189 = 0x03BD
    GaugeA190 = 0x03BE
    GaugeA191 = 0x03BF
    GaugeA192 = 0x03C0
    GaugeA193 = 0x03C1
    GaugeA194 = 0x03C2
    GaugeA195 = 0x03C3
    GaugeA196 = 0x03C4
    GaugeA197 = 0x03C5
    GaugeA198 = 0x03C6
    GaugeA199 = 0x03C7
    GaugeA200 = 0x03C8
    GaugeA201 = 0x03C9
    GaugeA202 = 0x03CA
    GaugeA203 = 0x03CB
    GaugeA204 = 0x03CC
    GaugeA205 = 0x03CD
    GaugeA206 = 0x03CE
    GaugeA207 = 0x03CF
    GaugeA208 = 0x03D0
    GaugeA209 = 0x03D1
    GaugeA210 = 0x03D2
    GaugeA211 = 0x03D3
    GaugeA212 = 0x03D4
    GaugeA213 = 0x03D5
    GaugeA214 = 0x03D6
    GaugeA215 = 0x03D7
    GaugeA216 = 0x03D8
    GaugeA217 = 0x03D9
    GaugeA218 = 0x03DA
    GaugeA219 = 0x03DB
    GaugeA220 = 0x03DC
    GaugeA221 = 0x03DD
    GaugeA222 = 0x03DE
    GaugeA223 = 0x03DF
    GaugeA224 = 0x03E0
    GaugeA225 = 0x03E1
    GaugeA226 = 0x03E2
    GaugeA227 = 0x03E3
    GaugeA228 = 0x03E4
    GaugeA229 = 0x03E5
    GaugeA230 = 0x03E6
    GaugeA231 = 0x03E7
    GaugeA232 = 0x03E8
    GaugeA233 = 0x03E9
    GaugeA234 = 0x03EA
    GaugeA235 = 0x03EB
    GaugeA236 = 0x03EC
    GaugeA237 = 0x03ED
    GaugeA238 = 0x03EE
    GaugeA239 = 0x03EF
    GaugeA240 = 0x03F0
    GaugeA241 = 0x03F1
    GaugeA242 = 0x03F2
    GaugeA243 = 0x03F3
    GaugeA244 = 0x03F4
    GaugeA245 = 0x03F5
    GaugeA246 = 0x03F6
    GaugeA247 = 0x03F7
    GaugeA248 = 0x03F8
    GaugeA249 = 0x03F9
    GaugeA250 = 0x03FA
    GaugeA251 = 0x03FB
    GaugeA252 = 0x03FC
    GaugeA253 = 0x03FD
    GaugeA254 = 0x03FE
    GaugeA255 = 0x03FF
    # GaugeB List
    GaugeB0 = 0x0400
    GaugeB1 = 0x0401
    GaugeB2 = 0x0402
    GaugeB3 = 0x0403
    GaugeB4 = 0x0404
    GaugeB5 = 0x0405
    GaugeB6 = 0x0406
    GaugeB7 = 0x0407
    GaugeB8 = 0x0408
    GaugeB9 = 0x0409
    GaugeB10 = 0x040A
    GaugeB11 = 0x040B
    GaugeB12 = 0x040C
    GaugeB13 = 0x040D
    GaugeB14 = 0x040E
    GaugeB15 = 0x040F
    GaugeB16 = 0x0410
    GaugeB17 = 0x0411
    GaugeB18 = 0x0412
    GaugeB19 = 0x0413
    GaugeB20 = 0x0414
    GaugeB21 = 0x0415
    GaugeB22 = 0x0416
    GaugeB23 = 0x0417
    GaugeB24 = 0x0418
    GaugeB25 = 0x0419
    GaugeB26 = 0x041A
    GaugeB27 = 0x041B
    GaugeB28 = 0x041C
    GaugeB29 = 0x041D
    GaugeB30 = 0x041E
    GaugeB31 = 0x041F
    GaugeB32 = 0x0420
    GaugeB33 = 0x0421
    GaugeB34 = 0x0422
    GaugeB35 = 0x0423
    GaugeB36 = 0x0424
    GaugeB37 = 0x0425
    GaugeB38 = 0x0426
    GaugeB39 = 0x0427
    GaugeB40 = 0x0428
    GaugeB41 = 0x0429
    GaugeB42 = 0x042A
    GaugeB43 = 0x042B
    GaugeB44 = 0x042C
    GaugeB45 = 0x042D
    GaugeB46 = 0x042E
    GaugeB47 = 0x042F
    GaugeB48 = 0x0430
    GaugeB49 = 0x0431
    GaugeB50 = 0x0432
    GaugeB51 = 0x0433
    GaugeB52 = 0x0434
    GaugeB53 = 0x0435
    GaugeB54 = 0x0436
    GaugeB55 = 0x0437
    GaugeB56 = 0x0438
    GaugeB57 = 0x0439
    GaugeB58 = 0x043A
    GaugeB59 = 0x043B
    GaugeB60 = 0x043C
    GaugeB61 = 0x043D
    GaugeB62 = 0x043E
    GaugeB63 = 0x043F
    GaugeB64 = 0x0440
    GaugeB65 = 0x0441
    GaugeB66 = 0x0442
    GaugeB67 = 0x0443
    GaugeB68 = 0x0444
    GaugeB69 = 0x0445
    GaugeB70 = 0x0446
    GaugeB71 = 0x0447
    GaugeB72 = 0x0448
    GaugeB73 = 0x0449
    GaugeB74 = 0x044A
    GaugeB75 = 0x044B
    GaugeB76 = 0x044C
    GaugeB77 = 0x044D
    GaugeB78 = 0x044E
    GaugeB79 = 0x044F
    GaugeB80 = 0x0450
    GaugeB81 = 0x0451
    GaugeB82 = 0x0452
    GaugeB83 = 0x0453
    GaugeB84 = 0x0454
    GaugeB85 = 0x0455
    GaugeB86 = 0x0456
    GaugeB87 = 0x0457
    GaugeB88 = 0x0458
    GaugeB89 = 0x0459
    GaugeB90 = 0x045A
    GaugeB91 = 0x045B
    GaugeB92 = 0x045C
    GaugeB93 = 0x045D
    GaugeB94 = 0x045E
    GaugeB95 = 0x045F
    GaugeB96 = 0x0460
    GaugeB97 = 0x0461
    GaugeB98 = 0x0462
    GaugeB99 = 0x0463
    GaugeB100 = 0x0464
    GaugeB101 = 0x0465
    GaugeB102 = 0x0466
    GaugeB103 = 0x0467
    GaugeB104 = 0x0468
    GaugeB105 = 0x0469
    GaugeB106 = 0x046A
    GaugeB107 = 0x046B
    GaugeB108 = 0x046C
    GaugeB109 = 0x046D
    GaugeB110 = 0x046E
    GaugeB111 = 0x046F
    GaugeB112 = 0x0470
    GaugeB113 = 0x0471
    GaugeB114 = 0x0472
    GaugeB115 = 0x0473
    GaugeB116 = 0x0474
    GaugeB117 = 0x0475
    GaugeB118 = 0x0476
    GaugeB119 = 0x0477
    GaugeB120 = 0x0478
    GaugeB121 = 0x0479
    GaugeB122 = 0x047A
    GaugeB123 = 0x047B
    GaugeB124 = 0x047C
    GaugeB125 = 0x047D
    GaugeB126 = 0x047E
    GaugeB127 = 0x047F
    GaugeB128 = 0x0480
    GaugeB129 = 0x0481
    GaugeB130 = 0x0482
    GaugeB131 = 0x0483
    GaugeB132 = 0x0484
    GaugeB133 = 0x0485
    GaugeB134 = 0x0486
    GaugeB135 = 0x0487
    GaugeB136 = 0x0488
    GaugeB137 = 0x0489
    GaugeB138 = 0x048A
    GaugeB139 = 0x048B
    GaugeB140 = 0x048C
    GaugeB141 = 0x048D
    GaugeB142 = 0x048E
    GaugeB143 = 0x048F
    GaugeB144 = 0x0490
    GaugeB145 = 0x0491
    GaugeB146 = 0x0492
    GaugeB147 = 0x0493
    GaugeB148 = 0x0494
    GaugeB149 = 0x0495
    GaugeB150 = 0x0496
    GaugeB151 = 0x0497
    GaugeB152 = 0x0498
    GaugeB153 = 0x0499
    GaugeB154 = 0x049A
    GaugeB155 = 0x049B
    GaugeB156 = 0x049C
    GaugeB157 = 0x049D
    GaugeB158 = 0x049E
    GaugeB159 = 0x049F
    GaugeB160 = 0x04A0
    GaugeB161 = 0x04A1
    GaugeB162 = 0x04A2
    GaugeB163 = 0x04A3
    GaugeB164 = 0x04A4
    GaugeB165 = 0x04A5
    GaugeB166 = 0x04A6
    GaugeB167 = 0x04A7
    GaugeB168 = 0x04A8
    GaugeB169 = 0x04A9
    GaugeB170 = 0x04AA
    GaugeB171 = 0x04AB
    GaugeB172 = 0x04AC
    GaugeB173 = 0x04AD
    GaugeB174 = 0x04AE
    GaugeB175 = 0x04AF
    GaugeB176 = 0x04B0
    GaugeB177 = 0x04B1
    GaugeB178 = 0x04B2
    GaugeB179 = 0x04B3
    GaugeB180 = 0x04B4
    GaugeB181 = 0x04B5
    GaugeB182 = 0x04B6
    GaugeB183 = 0x04B7
    GaugeB184 = 0x04B8
    GaugeB185 = 0x04B9
    GaugeB186 = 0x04BA
    GaugeB187 = 0x04BB
    GaugeB188 = 0x04BC
    GaugeB189 = 0x04BD
    GaugeB190 = 0x04BE
    GaugeB191 = 0x04BF
    GaugeB192 = 0x04C0
    GaugeB193 = 0x04C1
    GaugeB194 = 0x04C2
    GaugeB195 = 0x04C3
    GaugeB196 = 0x04C4
    GaugeB197 = 0x04C5
    GaugeB198 = 0x04C6
    GaugeB199 = 0x04C7
    GaugeB200 = 0x04C8
    GaugeB201 = 0x04C9
    GaugeB202 = 0x04CA
    GaugeB203 = 0x04CB
    GaugeB204 = 0x04CC
    GaugeB205 = 0x04CD
    GaugeB206 = 0x04CE
    GaugeB207 = 0x04CF
    GaugeB208 = 0x04D0
    GaugeB209 = 0x04D1
    GaugeB210 = 0x04D2
    GaugeB211 = 0x04D3
    GaugeB212 = 0x04D4
    GaugeB213 = 0x04D5
    GaugeB214 = 0x04D6
    GaugeB215 = 0x04D7
    GaugeB216 = 0x04D8
    GaugeB217 = 0x04D9
    GaugeB218 = 0x04DA
    GaugeB219 = 0x04DB
    GaugeB220 = 0x04DC
    GaugeB221 = 0x04DD
    GaugeB222 = 0x04DE
    GaugeB223 = 0x04DF
    GaugeB224 = 0x04E0
    GaugeB225 = 0x04E1
    GaugeB226 = 0x04E2
    GaugeB227 = 0x04E3
    GaugeB228 = 0x04E4
    GaugeB229 = 0x04E5
    GaugeB230 = 0x04E6
    GaugeB231 = 0x04E7
    GaugeB232 = 0x04E8
    GaugeB233 = 0x04E9
    GaugeB234 = 0x04EA
    GaugeB235 = 0x04EB
    GaugeB236 = 0x04EC
    GaugeB237 = 0x04ED
    GaugeB238 = 0x04EE
    GaugeB239 = 0x04EF
    GaugeB240 = 0x04F0
    GaugeB241 = 0x04F1
    GaugeB242 = 0x04F2
    GaugeB243 = 0x04F3
    GaugeB244 = 0x04F4
    GaugeB245 = 0x04F5
    GaugeB246 = 0x04F6
    GaugeB247 = 0x04F7
    GaugeB248 = 0x04F8
    GaugeB249 = 0x04F9
    GaugeB250 = 0x04FA
    GaugeB251 = 0x04FB
    GaugeB252 = 0x04FC
    GaugeB253 = 0x04FD
    GaugeB254 = 0x04FE
    GaugeB255 = 0x04FF
    # LedDigits List
    LedDigits0 = 0x0500
    LedDigits1 = 0x0501
    LedDigits2 = 0x0502
    LedDigits3 = 0x0503
    LedDigits4 = 0x0504
    LedDigits5 = 0x0505
    LedDigits6 = 0x0506
    LedDigits7 = 0x0507
    LedDigits8 = 0x0508
    LedDigits9 = 0x0509
    LedDigits10 = 0x050A
    LedDigits11 = 0x050B
    LedDigits12 = 0x050C
    LedDigits13 = 0x050D
    LedDigits14 = 0x050E
    LedDigits15 = 0x050F
    LedDigits16 = 0x0510
    LedDigits17 = 0x0511
    LedDigits18 = 0x0512
    LedDigits19 = 0x0513
    LedDigits20 = 0x0514
    LedDigits21 = 0x0515
    LedDigits22 = 0x0516
    LedDigits23 = 0x0517
    LedDigits24 = 0x0518
    LedDigits25 = 0x0519
    LedDigits26 = 0x051A
    LedDigits27 = 0x051B
    LedDigits28 = 0x051C
    LedDigits29 = 0x051D
    LedDigits30 = 0x051E
    LedDigits31 = 0x051F
    LedDigits32 = 0x0520
    LedDigits33 = 0x0521
    LedDigits34 = 0x0522
    LedDigits35 = 0x0523
    LedDigits36 = 0x0524
    LedDigits37 = 0x0525
    LedDigits38 = 0x0526
    LedDigits39 = 0x0527
    LedDigits40 = 0x0528
    LedDigits41 = 0x0529
    LedDigits42 = 0x052A
    LedDigits43 = 0x052B
    LedDigits44 = 0x052C
    LedDigits45 = 0x052D
    LedDigits46 = 0x052E
    LedDigits47 = 0x052F
    LedDigits48 = 0x0530
    LedDigits49 = 0x0531
    LedDigits50 = 0x0532
    LedDigits51 = 0x0533
    LedDigits52 = 0x0534
    LedDigits53 = 0x0535
    LedDigits54 = 0x0536
    LedDigits55 = 0x0537
    LedDigits56 = 0x0538
    LedDigits57 = 0x0539
    LedDigits58 = 0x053A
    LedDigits59 = 0x053B
    LedDigits60 = 0x053C
    LedDigits61 = 0x053D
    LedDigits62 = 0x053E
    LedDigits63 = 0x053F
    LedDigits64 = 0x0540
    LedDigits65 = 0x0541
    LedDigits66 = 0x0542
    LedDigits67 = 0x0543
    LedDigits68 = 0x0544
    LedDigits69 = 0x0545
    LedDigits70 = 0x0546
    LedDigits71 = 0x0547
    LedDigits72 = 0x0548
    LedDigits73 = 0x0549
    LedDigits74 = 0x054A
    LedDigits75 = 0x054B
    LedDigits76 = 0x054C
    LedDigits77 = 0x054D
    LedDigits78 = 0x054E
    LedDigits79 = 0x054F
    LedDigits80 = 0x0550
    LedDigits81 = 0x0551
    LedDigits82 = 0x0552
    LedDigits83 = 0x0553
    LedDigits84 = 0x0554
    LedDigits85 = 0x0555
    LedDigits86 = 0x0556
    LedDigits87 = 0x0557
    LedDigits88 = 0x0558
    LedDigits89 = 0x0559
    LedDigits90 = 0x055A
    LedDigits91 = 0x055B
    LedDigits92 = 0x055C
    LedDigits93 = 0x055D
    LedDigits94 = 0x055E
    LedDigits95 = 0x055F
    LedDigits96 = 0x0560
    LedDigits97 = 0x0561
    LedDigits98 = 0x0562
    LedDigits99 = 0x0563
    LedDigits100 = 0x0564
    LedDigits101 = 0x0565
    LedDigits102 = 0x0566
    LedDigits103 = 0x0567
    LedDigits104 = 0x0568
    LedDigits105 = 0x0569
    LedDigits106 = 0x056A
    LedDigits107 = 0x056B
    LedDigits108 = 0x056C
    LedDigits109 = 0x056D
    LedDigits110 = 0x056E
    LedDigits111 = 0x056F
    LedDigits112 = 0x0570
    LedDigits113 = 0x0571
    LedDigits114 = 0x0572
    LedDigits115 = 0x0573
    LedDigits116 = 0x0574
    LedDigits117 = 0x0575
    LedDigits118 = 0x0576
    LedDigits119 = 0x0577
    LedDigits120 = 0x0578
    LedDigits121 = 0x0579
    LedDigits122 = 0x057A
    LedDigits123 = 0x057B
    LedDigits124 = 0x057C
    LedDigits125 = 0x057D
    LedDigits126 = 0x057E
    LedDigits127 = 0x057F
    LedDigits128 = 0x0580
    LedDigits129 = 0x0581
    LedDigits130 = 0x0582
    LedDigits131 = 0x0583
    LedDigits132 = 0x0584
    LedDigits133 = 0x0585
    LedDigits134 = 0x0586
    LedDigits135 = 0x0587
    LedDigits136 = 0x0588
    LedDigits137 = 0x0589
    LedDigits138 = 0x058A
    LedDigits139 = 0x058B
    LedDigits140 = 0x058C
    LedDigits141 = 0x058D
    LedDigits142 = 0x058E
    LedDigits143 = 0x058F
    LedDigits144 = 0x0590
    LedDigits145 = 0x0591
    LedDigits146 = 0x0592
    LedDigits147 = 0x0593
    LedDigits148 = 0x0594
    LedDigits149 = 0x0595
    LedDigits150 = 0x0596
    LedDigits151 = 0x0597
    LedDigits152 = 0x0598
    LedDigits153 = 0x0599
    LedDigits154 = 0x059A
    LedDigits155 = 0x059B
    LedDigits156 = 0x059C
    LedDigits157 = 0x059D
    LedDigits158 = 0x059E
    LedDigits159 = 0x059F
    LedDigits160 = 0x05A0
    LedDigits161 = 0x05A1
    LedDigits162 = 0x05A2
    LedDigits163 = 0x05A3
    LedDigits164 = 0x05A4
    LedDigits165 = 0x05A5
    LedDigits166 = 0x05A6
    LedDigits167 = 0x05A7
    LedDigits168 = 0x05A8
    LedDigits169 = 0x05A9
    LedDigits170 = 0x05AA
    LedDigits171 = 0x05AB
    LedDigits172 = 0x05AC
    LedDigits173 = 0x05AD
    LedDigits174 = 0x05AE
    LedDigits175 = 0x05AF
    LedDigits176 = 0x05B0
    LedDigits177 = 0x05B1
    LedDigits178 = 0x05B2
    LedDigits179 = 0x05B3
    LedDigits180 = 0x05B4
    LedDigits181 = 0x05B5
    LedDigits182 = 0x05B6
    LedDigits183 = 0x05B7
    LedDigits184 = 0x05B8
    LedDigits185 = 0x05B9
    LedDigits186 = 0x05BA
    LedDigits187 = 0x05BB
    LedDigits188 = 0x05BC
    LedDigits189 = 0x05BD
    LedDigits190 = 0x05BE
    LedDigits191 = 0x05BF
    LedDigits192 = 0x05C0
    LedDigits193 = 0x05C1
    LedDigits194 = 0x05C2
    LedDigits195 = 0x05C3
    LedDigits196 = 0x05C4
    LedDigits197 = 0x05C5
    LedDigits198 = 0x05C6
    LedDigits199 = 0x05C7
    LedDigits200 = 0x05C8
    LedDigits201 = 0x05C9
    LedDigits202 = 0x05CA
    LedDigits203 = 0x05CB
    LedDigits204 = 0x05CC
    LedDigits205 = 0x05CD
    LedDigits206 = 0x05CE
    LedDigits207 = 0x05CF
    LedDigits208 = 0x05D0
    LedDigits209 = 0x05D1
    LedDigits210 = 0x05D2
    LedDigits211 = 0x05D3
    LedDigits212 = 0x05D4
    LedDigits213 = 0x05D5
    LedDigits214 = 0x05D6
    LedDigits215 = 0x05D7
    LedDigits216 = 0x05D8
    LedDigits217 = 0x05D9
    LedDigits218 = 0x05DA
    LedDigits219 = 0x05DB
    LedDigits220 = 0x05DC
    LedDigits221 = 0x05DD
    LedDigits222 = 0x05DE
    LedDigits223 = 0x05DF
    LedDigits224 = 0x05E0
    LedDigits225 = 0x05E1
    LedDigits226 = 0x05E2
    LedDigits227 = 0x05E3
    LedDigits228 = 0x05E4
    LedDigits229 = 0x05E5
    LedDigits230 = 0x05E6
    LedDigits231 = 0x05E7
    LedDigits232 = 0x05E8
    LedDigits233 = 0x05E9
    LedDigits234 = 0x05EA
    LedDigits235 = 0x05EB
    LedDigits236 = 0x05EC
    LedDigits237 = 0x05ED
    LedDigits238 = 0x05EE
    LedDigits239 = 0x05EF
    LedDigits240 = 0x05F0
    LedDigits241 = 0x05F1
    LedDigits242 = 0x05F2
    LedDigits243 = 0x05F3
    LedDigits244 = 0x05F4
    LedDigits245 = 0x05F5
    LedDigits246 = 0x05F6
    LedDigits247 = 0x05F7
    LedDigits248 = 0x05F8
    LedDigits249 = 0x05F9
    LedDigits250 = 0x05FA
    LedDigits251 = 0x05FB
    LedDigits252 = 0x05FC
    LedDigits253 = 0x05FD
    LedDigits254 = 0x05FE
    LedDigits255 = 0x05FF
    # Labels List
    Labels0 = 0x0600
    Labels1 = 0x0601
    Labels2 = 0x0602
    Labels3 = 0x0603
    Labels4 = 0x0604
    Labels5 = 0x0605
    Labels6 = 0x0606
    Labels7 = 0x0607
    Labels8 = 0x0608
    Labels9 = 0x0609
    Labels10 = 0x060A
    Labels11 = 0x060B
    Labels12 = 0x060C
    Labels13 = 0x060D
    Labels14 = 0x060E
    Labels15 = 0x060F
    Labels16 = 0x0610
    Labels17 = 0x0611
    Labels18 = 0x0612
    Labels19 = 0x0613
    Labels20 = 0x0614
    Labels21 = 0x0615
    Labels22 = 0x0616
    Labels23 = 0x0617
    Labels24 = 0x0618
    Labels25 = 0x0619
    Labels26 = 0x061A
    Labels27 = 0x061B
    Labels28 = 0x061C
    Labels29 = 0x061D
    Labels30 = 0x061E
    Labels31 = 0x061F
    Labels32 = 0x0620
    Labels33 = 0x0621
    Labels34 = 0x0622
    Labels35 = 0x0623
    Labels36 = 0x0624
    Labels37 = 0x0625
    Labels38 = 0x0626
    Labels39 = 0x0627
    Labels40 = 0x0628
    Labels41 = 0x0629
    Labels42 = 0x062A
    Labels43 = 0x062B
    Labels44 = 0x062C
    Labels45 = 0x062D
    Labels46 = 0x062E
    Labels47 = 0x062F
    Labels48 = 0x0630
    Labels49 = 0x0631
    Labels50 = 0x0632
    Labels51 = 0x0633
    Labels52 = 0x0634
    Labels53 = 0x0635
    Labels54 = 0x0636
    Labels55 = 0x0637
    Labels56 = 0x0638
    Labels57 = 0x0639
    Labels58 = 0x063A
    Labels59 = 0x063B
    Labels60 = 0x063C
    Labels61 = 0x063D
    Labels62 = 0x063E
    Labels63 = 0x063F
    Labels64 = 0x0640
    Labels65 = 0x0641
    Labels66 = 0x0642
    Labels67 = 0x0643
    Labels68 = 0x0644
    Labels69 = 0x0645
    Labels70 = 0x0646
    Labels71 = 0x0647
    Labels72 = 0x0648
    Labels73 = 0x0649
    Labels74 = 0x064A
    Labels75 = 0x064B
    Labels76 = 0x064C
    Labels77 = 0x064D
    Labels78 = 0x064E
    Labels79 = 0x064F
    Labels80 = 0x0650
    Labels81 = 0x0651
    Labels82 = 0x0652
    Labels83 = 0x0653
    Labels84 = 0x0654
    Labels85 = 0x0655
    Labels86 = 0x0656
    Labels87 = 0x0657
    Labels88 = 0x0658
    Labels89 = 0x0659
    Labels90 = 0x065A
    Labels91 = 0x065B
    Labels92 = 0x065C
    Labels93 = 0x065D
    Labels94 = 0x065E
    Labels95 = 0x065F
    Labels96 = 0x0660
    Labels97 = 0x0661
    Labels98 = 0x0662
    Labels99 = 0x0663
    Labels100 = 0x0664
    Labels101 = 0x0665
    Labels102 = 0x0666
    Labels103 = 0x0667
    Labels104 = 0x0668
    Labels105 = 0x0669
    Labels106 = 0x066A
    Labels107 = 0x066B
    Labels108 = 0x066C
    Labels109 = 0x066D
    Labels110 = 0x066E
    Labels111 = 0x066F
    Labels112 = 0x0670
    Labels113 = 0x0671
    Labels114 = 0x0672
    Labels115 = 0x0673
    Labels116 = 0x0674
    Labels117 = 0x0675
    Labels118 = 0x0676
    Labels119 = 0x0677
    Labels120 = 0x0678
    Labels121 = 0x0679
    Labels122 = 0x067A
    Labels123 = 0x067B
    Labels124 = 0x067C
    Labels125 = 0x067D
    Labels126 = 0x067E
    Labels127 = 0x067F
    Labels128 = 0x0680
    Labels129 = 0x0681
    Labels130 = 0x0682
    Labels131 = 0x0683
    Labels132 = 0x0684
    Labels133 = 0x0685
    Labels134 = 0x0686
    Labels135 = 0x0687
    Labels136 = 0x0688
    Labels137 = 0x0689
    Labels138 = 0x068A
    Labels139 = 0x068B
    Labels140 = 0x068C
    Labels141 = 0x068D
    Labels142 = 0x068E
    Labels143 = 0x068F
    Labels144 = 0x0690
    Labels145 = 0x0691
    Labels146 = 0x0692
    Labels147 = 0x0693
    Labels148 = 0x0694
    Labels149 = 0x0695
    Labels150 = 0x0696
    Labels151 = 0x0697
    Labels152 = 0x0698
    Labels153 = 0x0699
    Labels154 = 0x069A
    Labels155 = 0x069B
    Labels156 = 0x069C
    Labels157 = 0x069D
    Labels158 = 0x069E
    Labels159 = 0x069F
    Labels160 = 0x06A0
    Labels161 = 0x06A1
    Labels162 = 0x06A2
    Labels163 = 0x06A3
    Labels164 = 0x06A4
    Labels165 = 0x06A5
    Labels166 = 0x06A6
    Labels167 = 0x06A7
    Labels168 = 0x06A8
    Labels169 = 0x06A9
    Labels170 = 0x06AA
    Labels171 = 0x06AB
    Labels172 = 0x06AC
    Labels173 = 0x06AD
    Labels174 = 0x06AE
    Labels175 = 0x06AF
    Labels176 = 0x06B0
    Labels177 = 0x06B1
    Labels178 = 0x06B2
    Labels179 = 0x06B3
    Labels180 = 0x06B4
    Labels181 = 0x06B5
    Labels182 = 0x06B6
    Labels183 = 0x06B7
    Labels184 = 0x06B8
    Labels185 = 0x06B9
    Labels186 = 0x06BA
    Labels187 = 0x06BB
    Labels188 = 0x06BC
    Labels189 = 0x06BD
    Labels190 = 0x06BE
    Labels191 = 0x06BF
    Labels192 = 0x06C0
    Labels193 = 0x06C1
    Labels194 = 0x06C2
    Labels195 = 0x06C3
    Labels196 = 0x06C4
    Labels197 = 0x06C5
    Labels198 = 0x06C6
    Labels199 = 0x06C7
    Labels200 = 0x06C8
    Labels201 = 0x06C9
    Labels202 = 0x06CA
    Labels203 = 0x06CB
    Labels204 = 0x06CC
    Labels205 = 0x06CD
    Labels206 = 0x06CE
    Labels207 = 0x06CF
    Labels208 = 0x06D0
    Labels209 = 0x06D1
    Labels210 = 0x06D2
    Labels211 = 0x06D3
    Labels212 = 0x06D4
    Labels213 = 0x06D5
    Labels214 = 0x06D6
    Labels215 = 0x06D7
    Labels216 = 0x06D8
    Labels217 = 0x06D9
    Labels218 = 0x06DA
    Labels219 = 0x06DB
    Labels220 = 0x06DC
    Labels221 = 0x06DD
    Labels222 = 0x06DE
    Labels223 = 0x06DF
    Labels224 = 0x06E0
    Labels225 = 0x06E1
    Labels226 = 0x06E2
    Labels227 = 0x06E3
    Labels228 = 0x06E4
    Labels229 = 0x06E5
    Labels230 = 0x06E6
    Labels231 = 0x06E7
    Labels232 = 0x06E8
    Labels233 = 0x06E9
    Labels234 = 0x06EA
    Labels235 = 0x06EB
    Labels236 = 0x06EC
    Labels237 = 0x06ED
    Labels238 = 0x06EE
    Labels239 = 0x06EF
    Labels240 = 0x06F0
    Labels241 = 0x06F1
    Labels242 = 0x06F2
    Labels243 = 0x06F3
    Labels244 = 0x06F4
    Labels245 = 0x06F5
    Labels246 = 0x06F6
    Labels247 = 0x06F7
    Labels248 = 0x06F8
    Labels249 = 0x06F9
    Labels250 = 0x06FA
    Labels251 = 0x06FB
    Labels252 = 0x06FC
    Labels253 = 0x06FD
    Labels254 = 0x06FE
    Labels255 = 0x06FF
    # ButtonA List
    ButtonA0 = 0x2000
    ButtonA1 = 0x2001
    ButtonA2 = 0x2002
    ButtonA3 = 0x2003
    ButtonA4 = 0x2004
    ButtonA5 = 0x2005
    ButtonA6 = 0x2006
    ButtonA7 = 0x2007
    ButtonA8 = 0x2008
    ButtonA9 = 0x2009
    ButtonA10 = 0x200A
    ButtonA11 = 0x200B
    ButtonA12 = 0x200C
    ButtonA13 = 0x200D
    ButtonA14 = 0x200E
    ButtonA15 = 0x200F
    ButtonA16 = 0x2010
    ButtonA17 = 0x2011
    ButtonA18 = 0x2012
    ButtonA19 = 0x2013
    ButtonA20 = 0x2014
    ButtonA21 = 0x2015
    ButtonA22 = 0x2016
    ButtonA23 = 0x2017
    ButtonA24 = 0x2018
    ButtonA25 = 0x2019
    ButtonA26 = 0x201A
    ButtonA27 = 0x201B
    ButtonA28 = 0x201C
    ButtonA29 = 0x201D
    ButtonA30 = 0x201E
    ButtonA31 = 0x201F
    ButtonA32 = 0x2020
    ButtonA33 = 0x2021
    ButtonA34 = 0x2022
    ButtonA35 = 0x2023
    ButtonA36 = 0x2024
    ButtonA37 = 0x2025
    ButtonA38 = 0x2026
    ButtonA39 = 0x2027
    ButtonA40 = 0x2028
    ButtonA41 = 0x2029
    ButtonA42 = 0x202A
    ButtonA43 = 0x202B
    ButtonA44 = 0x202C
    ButtonA45 = 0x202D
    ButtonA46 = 0x202E
    ButtonA47 = 0x202F
    ButtonA48 = 0x2030
    ButtonA49 = 0x2031
    ButtonA50 = 0x2032
    ButtonA51 = 0x2033
    ButtonA52 = 0x2034
    ButtonA53 = 0x2035
    ButtonA54 = 0x2036
    ButtonA55 = 0x2037
    ButtonA56 = 0x2038
    ButtonA57 = 0x2039
    ButtonA58 = 0x203A
    ButtonA59 = 0x203B
    ButtonA60 = 0x203C
    ButtonA61 = 0x203D
    ButtonA62 = 0x203E
    ButtonA63 = 0x203F
    ButtonA64 = 0x2040
    ButtonA65 = 0x2041
    ButtonA66 = 0x2042
    ButtonA67 = 0x2043
    ButtonA68 = 0x2044
    ButtonA69 = 0x2045
    ButtonA70 = 0x2046
    ButtonA71 = 0x2047
    ButtonA72 = 0x2048
    ButtonA73 = 0x2049
    ButtonA74 = 0x204A
    ButtonA75 = 0x204B
    ButtonA76 = 0x204C
    ButtonA77 = 0x204D
    ButtonA78 = 0x204E
    ButtonA79 = 0x204F
    ButtonA80 = 0x2050
    ButtonA81 = 0x2051
    ButtonA82 = 0x2052
    ButtonA83 = 0x2053
    ButtonA84 = 0x2054
    ButtonA85 = 0x2055
    ButtonA86 = 0x2056
    ButtonA87 = 0x2057
    ButtonA88 = 0x2058
    ButtonA89 = 0x2059
    ButtonA90 = 0x205A
    ButtonA91 = 0x205B
    ButtonA92 = 0x205C
    ButtonA93 = 0x205D
    ButtonA94 = 0x205E
    ButtonA95 = 0x205F
    ButtonA96 = 0x2060
    ButtonA97 = 0x2061
    ButtonA98 = 0x2062
    ButtonA99 = 0x2063
    ButtonA100 = 0x2064
    ButtonA101 = 0x2065
    ButtonA102 = 0x2066
    ButtonA103 = 0x2067
    ButtonA104 = 0x2068
    ButtonA105 = 0x2069
    ButtonA106 = 0x206A
    ButtonA107 = 0x206B
    ButtonA108 = 0x206C
    ButtonA109 = 0x206D
    ButtonA110 = 0x206E
    ButtonA111 = 0x206F
    ButtonA112 = 0x2070
    ButtonA113 = 0x2071
    ButtonA114 = 0x2072
    ButtonA115 = 0x2073
    ButtonA116 = 0x2074
    ButtonA117 = 0x2075
    ButtonA118 = 0x2076
    ButtonA119 = 0x2077
    ButtonA120 = 0x2078
    ButtonA121 = 0x2079
    ButtonA122 = 0x207A
    ButtonA123 = 0x207B
    ButtonA124 = 0x207C
    ButtonA125 = 0x207D
    ButtonA126 = 0x207E
    ButtonA127 = 0x207F
    ButtonA128 = 0x2080
    ButtonA129 = 0x2081
    ButtonA130 = 0x2082
    ButtonA131 = 0x2083
    ButtonA132 = 0x2084
    ButtonA133 = 0x2085
    ButtonA134 = 0x2086
    ButtonA135 = 0x2087
    ButtonA136 = 0x2088
    ButtonA137 = 0x2089
    ButtonA138 = 0x208A
    ButtonA139 = 0x208B
    ButtonA140 = 0x208C
    ButtonA141 = 0x208D
    ButtonA142 = 0x208E
    ButtonA143 = 0x208F
    ButtonA144 = 0x2090
    ButtonA145 = 0x2091
    ButtonA146 = 0x2092
    ButtonA147 = 0x2093
    ButtonA148 = 0x2094
    ButtonA149 = 0x2095
    ButtonA150 = 0x2096
    ButtonA151 = 0x2097
    ButtonA152 = 0x2098
    ButtonA153 = 0x2099
    ButtonA154 = 0x209A
    ButtonA155 = 0x209B
    ButtonA156 = 0x209C
    ButtonA157 = 0x209D
    ButtonA158 = 0x209E
    ButtonA159 = 0x209F
    ButtonA160 = 0x20A0
    ButtonA161 = 0x20A1
    ButtonA162 = 0x20A2
    ButtonA163 = 0x20A3
    ButtonA164 = 0x20A4
    ButtonA165 = 0x20A5
    ButtonA166 = 0x20A6
    ButtonA167 = 0x20A7
    ButtonA168 = 0x20A8
    ButtonA169 = 0x20A9
    ButtonA170 = 0x20AA
    ButtonA171 = 0x20AB
    ButtonA172 = 0x20AC
    ButtonA173 = 0x20AD
    ButtonA174 = 0x20AE
    ButtonA175 = 0x20AF
    ButtonA176 = 0x20B0
    ButtonA177 = 0x20B1
    ButtonA178 = 0x20B2
    ButtonA179 = 0x20B3
    ButtonA180 = 0x20B4
    ButtonA181 = 0x20B5
    ButtonA182 = 0x20B6
    ButtonA183 = 0x20B7
    ButtonA184 = 0x20B8
    ButtonA185 = 0x20B9
    ButtonA186 = 0x20BA
    ButtonA187 = 0x20BB
    ButtonA188 = 0x20BC
    ButtonA189 = 0x20BD
    ButtonA190 = 0x20BE
    ButtonA191 = 0x20BF
    ButtonA192 = 0x20C0
    ButtonA193 = 0x20C1
    ButtonA194 = 0x20C2
    ButtonA195 = 0x20C3
    ButtonA196 = 0x20C4
    ButtonA197 = 0x20C5
    ButtonA198 = 0x20C6
    ButtonA199 = 0x20C7
    ButtonA200 = 0x20C8
    ButtonA201 = 0x20C9
    ButtonA202 = 0x20CA
    ButtonA203 = 0x20CB
    ButtonA204 = 0x20CC
    ButtonA205 = 0x20CD
    ButtonA206 = 0x20CE
    ButtonA207 = 0x20CF
    ButtonA208 = 0x20D0
    ButtonA209 = 0x20D1
    ButtonA210 = 0x20D2
    ButtonA211 = 0x20D3
    ButtonA212 = 0x20D4
    ButtonA213 = 0x20D5
    ButtonA214 = 0x20D6
    ButtonA215 = 0x20D7
    ButtonA216 = 0x20D8
    ButtonA217 = 0x20D9
    ButtonA218 = 0x20DA
    ButtonA219 = 0x20DB
    ButtonA220 = 0x20DC
    ButtonA221 = 0x20DD
    ButtonA222 = 0x20DE
    ButtonA223 = 0x20DF
    ButtonA224 = 0x20E0
    ButtonA225 = 0x20E1
    ButtonA226 = 0x20E2
    ButtonA227 = 0x20E3
    ButtonA228 = 0x20E4
    ButtonA229 = 0x20E5
    ButtonA230 = 0x20E6
    ButtonA231 = 0x20E7
    ButtonA232 = 0x20E8
    ButtonA233 = 0x20E9
    ButtonA234 = 0x20EA
    ButtonA235 = 0x20EB
    ButtonA236 = 0x20EC
    ButtonA237 = 0x20ED
    ButtonA238 = 0x20EE
    ButtonA239 = 0x20EF
    ButtonA240 = 0x20F0
    ButtonA241 = 0x20F1
    ButtonA242 = 0x20F2
    ButtonA243 = 0x20F3
    ButtonA244 = 0x20F4
    ButtonA245 = 0x20F5
    ButtonA246 = 0x20F6
    ButtonA247 = 0x20F7
    ButtonA248 = 0x20F8
    ButtonA249 = 0x20F9
    ButtonA250 = 0x20FA
    ButtonA251 = 0x20FB
    ButtonA252 = 0x20FC
    ButtonA253 = 0x20FD
    ButtonA254 = 0x20FE
    ButtonA255 = 0x20FF
    # SwitchA List
    SwitchA0 = 0x2100
    SwitchA1 = 0x2101
    SwitchA2 = 0x2102
    SwitchA3 = 0x2103
    SwitchA4 = 0x2104
    SwitchA5 = 0x2105
    SwitchA6 = 0x2106
    SwitchA7 = 0x2107
    SwitchA8 = 0x2108
    SwitchA9 = 0x2109
    SwitchA10 = 0x210A
    SwitchA11 = 0x210B
    SwitchA12 = 0x210C
    SwitchA13 = 0x210D
    SwitchA14 = 0x210E
    SwitchA15 = 0x210F
    SwitchA16 = 0x2110
    SwitchA17 = 0x2111
    SwitchA18 = 0x2112
    SwitchA19 = 0x2113
    SwitchA20 = 0x2114
    SwitchA21 = 0x2115
    SwitchA22 = 0x2116
    SwitchA23 = 0x2117
    SwitchA24 = 0x2118
    SwitchA25 = 0x2119
    SwitchA26 = 0x211A
    SwitchA27 = 0x211B
    SwitchA28 = 0x211C
    SwitchA29 = 0x211D
    SwitchA30 = 0x211E
    SwitchA31 = 0x211F
    SwitchA32 = 0x2120
    SwitchA33 = 0x2121
    SwitchA34 = 0x2122
    SwitchA35 = 0x2123
    SwitchA36 = 0x2124
    SwitchA37 = 0x2125
    SwitchA38 = 0x2126
    SwitchA39 = 0x2127
    SwitchA40 = 0x2128
    SwitchA41 = 0x2129
    SwitchA42 = 0x212A
    SwitchA43 = 0x212B
    SwitchA44 = 0x212C
    SwitchA45 = 0x212D
    SwitchA46 = 0x212E
    SwitchA47 = 0x212F
    SwitchA48 = 0x2130
    SwitchA49 = 0x2131
    SwitchA50 = 0x2132
    SwitchA51 = 0x2133
    SwitchA52 = 0x2134
    SwitchA53 = 0x2135
    SwitchA54 = 0x2136
    SwitchA55 = 0x2137
    SwitchA56 = 0x2138
    SwitchA57 = 0x2139
    SwitchA58 = 0x213A
    SwitchA59 = 0x213B
    SwitchA60 = 0x213C
    SwitchA61 = 0x213D
    SwitchA62 = 0x213E
    SwitchA63 = 0x213F
    SwitchA64 = 0x2140
    SwitchA65 = 0x2141
    SwitchA66 = 0x2142
    SwitchA67 = 0x2143
    SwitchA68 = 0x2144
    SwitchA69 = 0x2145
    SwitchA70 = 0x2146
    SwitchA71 = 0x2147
    SwitchA72 = 0x2148
    SwitchA73 = 0x2149
    SwitchA74 = 0x214A
    SwitchA75 = 0x214B
    SwitchA76 = 0x214C
    SwitchA77 = 0x214D
    SwitchA78 = 0x214E
    SwitchA79 = 0x214F
    SwitchA80 = 0x2150
    SwitchA81 = 0x2151
    SwitchA82 = 0x2152
    SwitchA83 = 0x2153
    SwitchA84 = 0x2154
    SwitchA85 = 0x2155
    SwitchA86 = 0x2156
    SwitchA87 = 0x2157
    SwitchA88 = 0x2158
    SwitchA89 = 0x2159
    SwitchA90 = 0x215A
    SwitchA91 = 0x215B
    SwitchA92 = 0x215C
    SwitchA93 = 0x215D
    SwitchA94 = 0x215E
    SwitchA95 = 0x215F
    SwitchA96 = 0x2160
    SwitchA97 = 0x2161
    SwitchA98 = 0x2162
    SwitchA99 = 0x2163
    SwitchA100 = 0x2164
    SwitchA101 = 0x2165
    SwitchA102 = 0x2166
    SwitchA103 = 0x2167
    SwitchA104 = 0x2168
    SwitchA105 = 0x2169
    SwitchA106 = 0x216A
    SwitchA107 = 0x216B
    SwitchA108 = 0x216C
    SwitchA109 = 0x216D
    SwitchA110 = 0x216E
    SwitchA111 = 0x216F
    SwitchA112 = 0x2170
    SwitchA113 = 0x2171
    SwitchA114 = 0x2172
    SwitchA115 = 0x2173
    SwitchA116 = 0x2174
    SwitchA117 = 0x2175
    SwitchA118 = 0x2176
    SwitchA119 = 0x2177
    SwitchA120 = 0x2178
    SwitchA121 = 0x2179
    SwitchA122 = 0x217A
    SwitchA123 = 0x217B
    SwitchA124 = 0x217C
    SwitchA125 = 0x217D
    SwitchA126 = 0x217E
    SwitchA127 = 0x217F
    SwitchA128 = 0x2180
    SwitchA129 = 0x2181
    SwitchA130 = 0x2182
    SwitchA131 = 0x2183
    SwitchA132 = 0x2184
    SwitchA133 = 0x2185
    SwitchA134 = 0x2186
    SwitchA135 = 0x2187
    SwitchA136 = 0x2188
    SwitchA137 = 0x2189
    SwitchA138 = 0x218A
    SwitchA139 = 0x218B
    SwitchA140 = 0x218C
    SwitchA141 = 0x218D
    SwitchA142 = 0x218E
    SwitchA143 = 0x218F
    SwitchA144 = 0x2190
    SwitchA145 = 0x2191
    SwitchA146 = 0x2192
    SwitchA147 = 0x2193
    SwitchA148 = 0x2194
    SwitchA149 = 0x2195
    SwitchA150 = 0x2196
    SwitchA151 = 0x2197
    SwitchA152 = 0x2198
    SwitchA153 = 0x2199
    SwitchA154 = 0x219A
    SwitchA155 = 0x219B
    SwitchA156 = 0x219C
    SwitchA157 = 0x219D
    SwitchA158 = 0x219E
    SwitchA159 = 0x219F
    SwitchA160 = 0x21A0
    SwitchA161 = 0x21A1
    SwitchA162 = 0x21A2
    SwitchA163 = 0x21A3
    SwitchA164 = 0x21A4
    SwitchA165 = 0x21A5
    SwitchA166 = 0x21A6
    SwitchA167 = 0x21A7
    SwitchA168 = 0x21A8
    SwitchA169 = 0x21A9
    SwitchA170 = 0x21AA
    SwitchA171 = 0x21AB
    SwitchA172 = 0x21AC
    SwitchA173 = 0x21AD
    SwitchA174 = 0x21AE
    SwitchA175 = 0x21AF
    SwitchA176 = 0x21B0
    SwitchA177 = 0x21B1
    SwitchA178 = 0x21B2
    SwitchA179 = 0x21B3
    SwitchA180 = 0x21B4
    SwitchA181 = 0x21B5
    SwitchA182 = 0x21B6
    SwitchA183 = 0x21B7
    SwitchA184 = 0x21B8
    SwitchA185 = 0x21B9
    SwitchA186 = 0x21BA
    SwitchA187 = 0x21BB
    SwitchA188 = 0x21BC
    SwitchA189 = 0x21BD
    SwitchA190 = 0x21BE
    SwitchA191 = 0x21BF
    SwitchA192 = 0x21C0
    SwitchA193 = 0x21C1
    SwitchA194 = 0x21C2
    SwitchA195 = 0x21C3
    SwitchA196 = 0x21C4
    SwitchA197 = 0x21C5
    SwitchA198 = 0x21C6
    SwitchA199 = 0x21C7
    SwitchA200 = 0x21C8
    SwitchA201 = 0x21C9
    SwitchA202 = 0x21CA
    SwitchA203 = 0x21CB
    SwitchA204 = 0x21CC
    SwitchA205 = 0x21CD
    SwitchA206 = 0x21CE
    SwitchA207 = 0x21CF
    SwitchA208 = 0x21D0
    SwitchA209 = 0x21D1
    SwitchA210 = 0x21D2
    SwitchA211 = 0x21D3
    SwitchA212 = 0x21D4
    SwitchA213 = 0x21D5
    SwitchA214 = 0x21D6
    SwitchA215 = 0x21D7
    SwitchA216 = 0x21D8
    SwitchA217 = 0x21D9
    SwitchA218 = 0x21DA
    SwitchA219 = 0x21DB
    SwitchA220 = 0x21DC
    SwitchA221 = 0x21DD
    SwitchA222 = 0x21DE
    SwitchA223 = 0x21DF
    SwitchA224 = 0x21E0
    SwitchA225 = 0x21E1
    SwitchA226 = 0x21E2
    SwitchA227 = 0x21E3
    SwitchA228 = 0x21E4
    SwitchA229 = 0x21E5
    SwitchA230 = 0x21E6
    SwitchA231 = 0x21E7
    SwitchA232 = 0x21E8
    SwitchA233 = 0x21E9
    SwitchA234 = 0x21EA
    SwitchA235 = 0x21EB
    SwitchA236 = 0x21EC
    SwitchA237 = 0x21ED
    SwitchA238 = 0x21EE
    SwitchA239 = 0x21EF
    SwitchA240 = 0x21F0
    SwitchA241 = 0x21F1
    SwitchA242 = 0x21F2
    SwitchA243 = 0x21F3
    SwitchA244 = 0x21F4
    SwitchA245 = 0x21F5
    SwitchA246 = 0x21F6
    SwitchA247 = 0x21F7
    SwitchA248 = 0x21F8
    SwitchA249 = 0x21F9
    SwitchA250 = 0x21FA
    SwitchA251 = 0x21FB
    SwitchA252 = 0x21FC
    SwitchA253 = 0x21FD
    SwitchA254 = 0x21FE
    SwitchA255 = 0x21FF
    # SliderB List
    SliderB0 = 0x2200
    SliderB1 = 0x2201
    SliderB2 = 0x2202
    SliderB3 = 0x2203
    SliderB4 = 0x2204
    SliderB5 = 0x2205
    SliderB6 = 0x2206
    SliderB7 = 0x2207
    SliderB8 = 0x2208
    SliderB9 = 0x2209
    SliderB10 = 0x220A
    SliderB11 = 0x220B
    SliderB12 = 0x220C
    SliderB13 = 0x220D
    SliderB14 = 0x220E
    SliderB15 = 0x220F
    SliderB16 = 0x2210
    SliderB17 = 0x2211
    SliderB18 = 0x2212
    SliderB19 = 0x2213
    SliderB20 = 0x2214
    SliderB21 = 0x2215
    SliderB22 = 0x2216
    SliderB23 = 0x2217
    SliderB24 = 0x2218
    SliderB25 = 0x2219
    SliderB26 = 0x221A
    SliderB27 = 0x221B
    SliderB28 = 0x221C
    SliderB29 = 0x221D
    SliderB30 = 0x221E
    SliderB31 = 0x221F
    SliderB32 = 0x2220
    SliderB33 = 0x2221
    SliderB34 = 0x2222
    SliderB35 = 0x2223
    SliderB36 = 0x2224
    SliderB37 = 0x2225
    SliderB38 = 0x2226
    SliderB39 = 0x2227
    SliderB40 = 0x2228
    SliderB41 = 0x2229
    SliderB42 = 0x222A
    SliderB43 = 0x222B
    SliderB44 = 0x222C
    SliderB45 = 0x222D
    SliderB46 = 0x222E
    SliderB47 = 0x222F
    SliderB48 = 0x2230
    SliderB49 = 0x2231
    SliderB50 = 0x2232
    SliderB51 = 0x2233
    SliderB52 = 0x2234
    SliderB53 = 0x2235
    SliderB54 = 0x2236
    SliderB55 = 0x2237
    SliderB56 = 0x2238
    SliderB57 = 0x2239
    SliderB58 = 0x223A
    SliderB59 = 0x223B
    SliderB60 = 0x223C
    SliderB61 = 0x223D
    SliderB62 = 0x223E
    SliderB63 = 0x223F
    SliderB64 = 0x2240
    SliderB65 = 0x2241
    SliderB66 = 0x2242
    SliderB67 = 0x2243
    SliderB68 = 0x2244
    SliderB69 = 0x2245
    SliderB70 = 0x2246
    SliderB71 = 0x2247
    SliderB72 = 0x2248
    SliderB73 = 0x2249
    SliderB74 = 0x224A
    SliderB75 = 0x224B
    SliderB76 = 0x224C
    SliderB77 = 0x224D
    SliderB78 = 0x224E
    SliderB79 = 0x224F
    SliderB80 = 0x2250
    SliderB81 = 0x2251
    SliderB82 = 0x2252
    SliderB83 = 0x2253
    SliderB84 = 0x2254
    SliderB85 = 0x2255
    SliderB86 = 0x2256
    SliderB87 = 0x2257
    SliderB88 = 0x2258
    SliderB89 = 0x2259
    SliderB90 = 0x225A
    SliderB91 = 0x225B
    SliderB92 = 0x225C
    SliderB93 = 0x225D
    SliderB94 = 0x225E
    SliderB95 = 0x225F
    SliderB96 = 0x2260
    SliderB97 = 0x2261
    SliderB98 = 0x2262
    SliderB99 = 0x2263
    SliderB100 = 0x2264
    SliderB101 = 0x2265
    SliderB102 = 0x2266
    SliderB103 = 0x2267
    SliderB104 = 0x2268
    SliderB105 = 0x2269
    SliderB106 = 0x226A
    SliderB107 = 0x226B
    SliderB108 = 0x226C
    SliderB109 = 0x226D
    SliderB110 = 0x226E
    SliderB111 = 0x226F
    SliderB112 = 0x2270
    SliderB113 = 0x2271
    SliderB114 = 0x2272
    SliderB115 = 0x2273
    SliderB116 = 0x2274
    SliderB117 = 0x2275
    SliderB118 = 0x2276
    SliderB119 = 0x2277
    SliderB120 = 0x2278
    SliderB121 = 0x2279
    SliderB122 = 0x227A
    SliderB123 = 0x227B
    SliderB124 = 0x227C
    SliderB125 = 0x227D
    SliderB126 = 0x227E
    SliderB127 = 0x227F
    SliderB128 = 0x2280
    SliderB129 = 0x2281
    SliderB130 = 0x2282
    SliderB131 = 0x2283
    SliderB132 = 0x2284
    SliderB133 = 0x2285
    SliderB134 = 0x2286
    SliderB135 = 0x2287
    SliderB136 = 0x2288
    SliderB137 = 0x2289
    SliderB138 = 0x228A
    SliderB139 = 0x228B
    SliderB140 = 0x228C
    SliderB141 = 0x228D
    SliderB142 = 0x228E
    SliderB143 = 0x228F
    SliderB144 = 0x2290
    SliderB145 = 0x2291
    SliderB146 = 0x2292
    SliderB147 = 0x2293
    SliderB148 = 0x2294
    SliderB149 = 0x2295
    SliderB150 = 0x2296
    SliderB151 = 0x2297
    SliderB152 = 0x2298
    SliderB153 = 0x2299
    SliderB154 = 0x229A
    SliderB155 = 0x229B
    SliderB156 = 0x229C
    SliderB157 = 0x229D
    SliderB158 = 0x229E
    SliderB159 = 0x229F
    SliderB160 = 0x22A0
    SliderB161 = 0x22A1
    SliderB162 = 0x22A2
    SliderB163 = 0x22A3
    SliderB164 = 0x22A4
    SliderB165 = 0x22A5
    SliderB166 = 0x22A6
    SliderB167 = 0x22A7
    SliderB168 = 0x22A8
    SliderB169 = 0x22A9
    SliderB170 = 0x22AA
    SliderB171 = 0x22AB
    SliderB172 = 0x22AC
    SliderB173 = 0x22AD
    SliderB174 = 0x22AE
    SliderB175 = 0x22AF
    SliderB176 = 0x22B0
    SliderB177 = 0x22B1
    SliderB178 = 0x22B2
    SliderB179 = 0x22B3
    SliderB180 = 0x22B4
    SliderB181 = 0x22B5
    SliderB182 = 0x22B6
    SliderB183 = 0x22B7
    SliderB184 = 0x22B8
    SliderB185 = 0x22B9
    SliderB186 = 0x22BA
    SliderB187 = 0x22BB
    SliderB188 = 0x22BC
    SliderB189 = 0x22BD
    SliderB190 = 0x22BE
    SliderB191 = 0x22BF
    SliderB192 = 0x22C0
    SliderB193 = 0x22C1
    SliderB194 = 0x22C2
    SliderB195 = 0x22C3
    SliderB196 = 0x22C4
    SliderB197 = 0x22C5
    SliderB198 = 0x22C6
    SliderB199 = 0x22C7
    SliderB200 = 0x22C8
    SliderB201 = 0x22C9
    SliderB202 = 0x22CA
    SliderB203 = 0x22CB
    SliderB204 = 0x22CC
    SliderB205 = 0x22CD
    SliderB206 = 0x22CE
    SliderB207 = 0x22CF
    SliderB208 = 0x22D0
    SliderB209 = 0x22D1
    SliderB210 = 0x22D2
    SliderB211 = 0x22D3
    SliderB212 = 0x22D4
    SliderB213 = 0x22D5
    SliderB214 = 0x22D6
    SliderB215 = 0x22D7
    SliderB216 = 0x22D8
    SliderB217 = 0x22D9
    SliderB218 = 0x22DA
    SliderB219 = 0x22DB
    SliderB220 = 0x22DC
    SliderB221 = 0x22DD
    SliderB222 = 0x22DE
    SliderB223 = 0x22DF
    SliderB224 = 0x22E0
    SliderB225 = 0x22E1
    SliderB226 = 0x22E2
    SliderB227 = 0x22E3
    SliderB228 = 0x22E4
    SliderB229 = 0x22E5
    SliderB230 = 0x22E6
    SliderB231 = 0x22E7
    SliderB232 = 0x22E8
    SliderB233 = 0x22E9
    SliderB234 = 0x22EA
    SliderB235 = 0x22EB
    SliderB236 = 0x22EC
    SliderB237 = 0x22ED
    SliderB238 = 0x22EE
    SliderB239 = 0x22EF
    SliderB240 = 0x22F0
    SliderB241 = 0x22F1
    SliderB242 = 0x22F2
    SliderB243 = 0x22F3
    SliderB244 = 0x22F4
    SliderB245 = 0x22F5
    SliderB246 = 0x22F6
    SliderB247 = 0x22F7
    SliderB248 = 0x22F8
    SliderB249 = 0x22F9
    SliderB250 = 0x22FA
    SliderB251 = 0x22FB
    SliderB252 = 0x22FC
    SliderB253 = 0x22FD
    SliderB254 = 0x22FE
    SliderB255 = 0x22FF
    # Knob List
    Knob0 = 0x2300
    Knob1 = 0x2301
    Knob2 = 0x2302
    Knob3 = 0x2303
    Knob4 = 0x2304
    Knob5 = 0x2305
    Knob6 = 0x2306
    Knob7 = 0x2307
    Knob8 = 0x2308
    Knob9 = 0x2309
    Knob10 = 0x230A
    Knob11 = 0x230B
    Knob12 = 0x230C
    Knob13 = 0x230D
    Knob14 = 0x230E
    Knob15 = 0x230F
    Knob16 = 0x2310
    Knob17 = 0x2311
    Knob18 = 0x2312
    Knob19 = 0x2313
    Knob20 = 0x2314
    Knob21 = 0x2315
    Knob22 = 0x2316
    Knob23 = 0x2317
    Knob24 = 0x2318
    Knob25 = 0x2319
    Knob26 = 0x231A
    Knob27 = 0x231B
    Knob28 = 0x231C
    Knob29 = 0x231D
    Knob30 = 0x231E
    Knob31 = 0x231F
    Knob32 = 0x2320
    Knob33 = 0x2321
    Knob34 = 0x2322
    Knob35 = 0x2323
    Knob36 = 0x2324
    Knob37 = 0x2325
    Knob38 = 0x2326
    Knob39 = 0x2327
    Knob40 = 0x2328
    Knob41 = 0x2329
    Knob42 = 0x232A
    Knob43 = 0x232B
    Knob44 = 0x232C
    Knob45 = 0x232D
    Knob46 = 0x232E
    Knob47 = 0x232F
    Knob48 = 0x2330
    Knob49 = 0x2331
    Knob50 = 0x2332
    Knob51 = 0x2333
    Knob52 = 0x2334
    Knob53 = 0x2335
    Knob54 = 0x2336
    Knob55 = 0x2337
    Knob56 = 0x2338
    Knob57 = 0x2339
    Knob58 = 0x233A
    Knob59 = 0x233B
    Knob60 = 0x233C
    Knob61 = 0x233D
    Knob62 = 0x233E
    Knob63 = 0x233F
    Knob64 = 0x2340
    Knob65 = 0x2341
    Knob66 = 0x2342
    Knob67 = 0x2343
    Knob68 = 0x2344
    Knob69 = 0x2345
    Knob70 = 0x2346
    Knob71 = 0x2347
    Knob72 = 0x2348
    Knob73 = 0x2349
    Knob74 = 0x234A
    Knob75 = 0x234B
    Knob76 = 0x234C
    Knob77 = 0x234D
    Knob78 = 0x234E
    Knob79 = 0x234F
    Knob80 = 0x2350
    Knob81 = 0x2351
    Knob82 = 0x2352
    Knob83 = 0x2353
    Knob84 = 0x2354
    Knob85 = 0x2355
    Knob86 = 0x2356
    Knob87 = 0x2357
    Knob88 = 0x2358
    Knob89 = 0x2359
    Knob90 = 0x235A
    Knob91 = 0x235B
    Knob92 = 0x235C
    Knob93 = 0x235D
    Knob94 = 0x235E
    Knob95 = 0x235F
    Knob96 = 0x2360
    Knob97 = 0x2361
    Knob98 = 0x2362
    Knob99 = 0x2363
    Knob100 = 0x2364
    Knob101 = 0x2365
    Knob102 = 0x2366
    Knob103 = 0x2367
    Knob104 = 0x2368
    Knob105 = 0x2369
    Knob106 = 0x236A
    Knob107 = 0x236B
    Knob108 = 0x236C
    Knob109 = 0x236D
    Knob110 = 0x236E
    Knob111 = 0x236F
    Knob112 = 0x2370
    Knob113 = 0x2371
    Knob114 = 0x2372
    Knob115 = 0x2373
    Knob116 = 0x2374
    Knob117 = 0x2375
    Knob118 = 0x2376
    Knob119 = 0x2377
    Knob120 = 0x2378
    Knob121 = 0x2379
    Knob122 = 0x237A
    Knob123 = 0x237B
    Knob124 = 0x237C
    Knob125 = 0x237D
    Knob126 = 0x237E
    Knob127 = 0x237F
    Knob128 = 0x2380
    Knob129 = 0x2381
    Knob130 = 0x2382
    Knob131 = 0x2383
    Knob132 = 0x2384
    Knob133 = 0x2385
    Knob134 = 0x2386
    Knob135 = 0x2387
    Knob136 = 0x2388
    Knob137 = 0x2389
    Knob138 = 0x238A
    Knob139 = 0x238B
    Knob140 = 0x238C
    Knob141 = 0x238D
    Knob142 = 0x238E
    Knob143 = 0x238F
    Knob144 = 0x2390
    Knob145 = 0x2391
    Knob146 = 0x2392
    Knob147 = 0x2393
    Knob148 = 0x2394
    Knob149 = 0x2395
    Knob150 = 0x2396
    Knob151 = 0x2397
    Knob152 = 0x2398
    Knob153 = 0x2399
    Knob154 = 0x239A
    Knob155 = 0x239B
    Knob156 = 0x239C
    Knob157 = 0x239D
    Knob158 = 0x239E
    Knob159 = 0x239F
    Knob160 = 0x23A0
    Knob161 = 0x23A1
    Knob162 = 0x23A2
    Knob163 = 0x23A3
    Knob164 = 0x23A4
    Knob165 = 0x23A5
    Knob166 = 0x23A6
    Knob167 = 0x23A7
    Knob168 = 0x23A8
    Knob169 = 0x23A9
    Knob170 = 0x23AA
    Knob171 = 0x23AB
    Knob172 = 0x23AC
    Knob173 = 0x23AD
    Knob174 = 0x23AE
    Knob175 = 0x23AF
    Knob176 = 0x23B0
    Knob177 = 0x23B1
    Knob178 = 0x23B2
    Knob179 = 0x23B3
    Knob180 = 0x23B4
    Knob181 = 0x23B5
    Knob182 = 0x23B6
    Knob183 = 0x23B7
    Knob184 = 0x23B8
    Knob185 = 0x23B9
    Knob186 = 0x23BA
    Knob187 = 0x23BB
    Knob188 = 0x23BC
    Knob189 = 0x23BD
    Knob190 = 0x23BE
    Knob191 = 0x23BF
    Knob192 = 0x23C0
    Knob193 = 0x23C1
    Knob194 = 0x23C2
    Knob195 = 0x23C3
    Knob196 = 0x23C4
    Knob197 = 0x23C5
    Knob198 = 0x23C6
    Knob199 = 0x23C7
    Knob200 = 0x23C8
    Knob201 = 0x23C9
    Knob202 = 0x23CA
    Knob203 = 0x23CB
    Knob204 = 0x23CC
    Knob205 = 0x23CD
    Knob206 = 0x23CE
    Knob207 = 0x23CF
    Knob208 = 0x23D0
    Knob209 = 0x23D1
    Knob210 = 0x23D2
    Knob211 = 0x23D3
    Knob212 = 0x23D4
    Knob213 = 0x23D5
    Knob214 = 0x23D6
    Knob215 = 0x23D7
    Knob216 = 0x23D8
    Knob217 = 0x23D9
    Knob218 = 0x23DA
    Knob219 = 0x23DB
    Knob220 = 0x23DC
    Knob221 = 0x23DD
    Knob222 = 0x23DE
    Knob223 = 0x23DF
    Knob224 = 0x23E0
    Knob225 = 0x23E1
    Knob226 = 0x23E2
    Knob227 = 0x23E3
    Knob228 = 0x23E4
    Knob229 = 0x23E5
    Knob230 = 0x23E6
    Knob231 = 0x23E7
    Knob232 = 0x23E8
    Knob233 = 0x23E9
    Knob234 = 0x23EA
    Knob235 = 0x23EB
    Knob236 = 0x23EC
    Knob237 = 0x23ED
    Knob238 = 0x23EE
    Knob239 = 0x23EF
    Knob240 = 0x23F0
    Knob241 = 0x23F1
    Knob242 = 0x23F2
    Knob243 = 0x23F3
    Knob244 = 0x23F4
    Knob245 = 0x23F5
    Knob246 = 0x23F6
    Knob247 = 0x23F7
    Knob248 = 0x23F8
    Knob249 = 0x23F9
    Knob250 = 0x23FA
    Knob251 = 0x23FB
    Knob252 = 0x23FC
    Knob253 = 0x23FD
    Knob254 = 0x23FE
    Knob255 = 0x23FF
    # MediaLed List
    MediaLed0 = 0x4000
    MediaLed1 = 0x4001
    MediaLed2 = 0x4002
    MediaLed3 = 0x4003
    MediaLed4 = 0x4004
    MediaLed5 = 0x4005
    MediaLed6 = 0x4006
    MediaLed7 = 0x4007
    MediaLed8 = 0x4008
    MediaLed9 = 0x4009
    MediaLed10 = 0x400A
    MediaLed11 = 0x400B
    MediaLed12 = 0x400C
    MediaLed13 = 0x400D
    MediaLed14 = 0x400E
    MediaLed15 = 0x400F
    MediaLed16 = 0x4010
    MediaLed17 = 0x4011
    MediaLed18 = 0x4012
    MediaLed19 = 0x4013
    MediaLed20 = 0x4014
    MediaLed21 = 0x4015
    MediaLed22 = 0x4016
    MediaLed23 = 0x4017
    MediaLed24 = 0x4018
    MediaLed25 = 0x4019
    MediaLed26 = 0x401A
    MediaLed27 = 0x401B
    MediaLed28 = 0x401C
    MediaLed29 = 0x401D
    MediaLed30 = 0x401E
    MediaLed31 = 0x401F
    MediaLed32 = 0x4020
    MediaLed33 = 0x4021
    MediaLed34 = 0x4022
    MediaLed35 = 0x4023
    MediaLed36 = 0x4024
    MediaLed37 = 0x4025
    MediaLed38 = 0x4026
    MediaLed39 = 0x4027
    MediaLed40 = 0x4028
    MediaLed41 = 0x4029
    MediaLed42 = 0x402A
    MediaLed43 = 0x402B
    MediaLed44 = 0x402C
    MediaLed45 = 0x402D
    MediaLed46 = 0x402E
    MediaLed47 = 0x402F
    MediaLed48 = 0x4030
    MediaLed49 = 0x4031
    MediaLed50 = 0x4032
    MediaLed51 = 0x4033
    MediaLed52 = 0x4034
    MediaLed53 = 0x4035
    MediaLed54 = 0x4036
    MediaLed55 = 0x4037
    MediaLed56 = 0x4038
    MediaLed57 = 0x4039
    MediaLed58 = 0x403A
    MediaLed59 = 0x403B
    MediaLed60 = 0x403C
    MediaLed61 = 0x403D
    MediaLed62 = 0x403E
    MediaLed63 = 0x403F
    MediaLed64 = 0x4040
    MediaLed65 = 0x4041
    MediaLed66 = 0x4042
    MediaLed67 = 0x4043
    MediaLed68 = 0x4044
    MediaLed69 = 0x4045
    MediaLed70 = 0x4046
    MediaLed71 = 0x4047
    MediaLed72 = 0x4048
    MediaLed73 = 0x4049
    MediaLed74 = 0x404A
    MediaLed75 = 0x404B
    MediaLed76 = 0x404C
    MediaLed77 = 0x404D
    MediaLed78 = 0x404E
    MediaLed79 = 0x404F
    MediaLed80 = 0x4050
    MediaLed81 = 0x4051
    MediaLed82 = 0x4052
    MediaLed83 = 0x4053
    MediaLed84 = 0x4054
    MediaLed85 = 0x4055
    MediaLed86 = 0x4056
    MediaLed87 = 0x4057
    MediaLed88 = 0x4058
    MediaLed89 = 0x4059
    MediaLed90 = 0x405A
    MediaLed91 = 0x405B
    MediaLed92 = 0x405C
    MediaLed93 = 0x405D
    MediaLed94 = 0x405E
    MediaLed95 = 0x405F
    MediaLed96 = 0x4060
    MediaLed97 = 0x4061
    MediaLed98 = 0x4062
    MediaLed99 = 0x4063
    MediaLed100 = 0x4064
    MediaLed101 = 0x4065
    MediaLed102 = 0x4066
    MediaLed103 = 0x4067
    MediaLed104 = 0x4068
    MediaLed105 = 0x4069
    MediaLed106 = 0x406A
    MediaLed107 = 0x406B
    MediaLed108 = 0x406C
    MediaLed109 = 0x406D
    MediaLed110 = 0x406E
    MediaLed111 = 0x406F
    MediaLed112 = 0x4070
    MediaLed113 = 0x4071
    MediaLed114 = 0x4072
    MediaLed115 = 0x4073
    MediaLed116 = 0x4074
    MediaLed117 = 0x4075
    MediaLed118 = 0x4076
    MediaLed119 = 0x4077
    MediaLed120 = 0x4078
    MediaLed121 = 0x4079
    MediaLed122 = 0x407A
    MediaLed123 = 0x407B
    MediaLed124 = 0x407C
    MediaLed125 = 0x407D
    MediaLed126 = 0x407E
    MediaLed127 = 0x407F
    MediaLed128 = 0x4080
    MediaLed129 = 0x4081
    MediaLed130 = 0x4082
    MediaLed131 = 0x4083
    MediaLed132 = 0x4084
    MediaLed133 = 0x4085
    MediaLed134 = 0x4086
    MediaLed135 = 0x4087
    MediaLed136 = 0x4088
    MediaLed137 = 0x4089
    MediaLed138 = 0x408A
    MediaLed139 = 0x408B
    MediaLed140 = 0x408C
    MediaLed141 = 0x408D
    MediaLed142 = 0x408E
    MediaLed143 = 0x408F
    MediaLed144 = 0x4090
    MediaLed145 = 0x4091
    MediaLed146 = 0x4092
    MediaLed147 = 0x4093
    MediaLed148 = 0x4094
    MediaLed149 = 0x4095
    MediaLed150 = 0x4096
    MediaLed151 = 0x4097
    MediaLed152 = 0x4098
    MediaLed153 = 0x4099
    MediaLed154 = 0x409A
    MediaLed155 = 0x409B
    MediaLed156 = 0x409C
    MediaLed157 = 0x409D
    MediaLed158 = 0x409E
    MediaLed159 = 0x409F
    MediaLed160 = 0x40A0
    MediaLed161 = 0x40A1
    MediaLed162 = 0x40A2
    MediaLed163 = 0x40A3
    MediaLed164 = 0x40A4
    MediaLed165 = 0x40A5
    MediaLed166 = 0x40A6
    MediaLed167 = 0x40A7
    MediaLed168 = 0x40A8
    MediaLed169 = 0x40A9
    MediaLed170 = 0x40AA
    MediaLed171 = 0x40AB
    MediaLed172 = 0x40AC
    MediaLed173 = 0x40AD
    MediaLed174 = 0x40AE
    MediaLed175 = 0x40AF
    MediaLed176 = 0x40B0
    MediaLed177 = 0x40B1
    MediaLed178 = 0x40B2
    MediaLed179 = 0x40B3
    MediaLed180 = 0x40B4
    MediaLed181 = 0x40B5
    MediaLed182 = 0x40B6
    MediaLed183 = 0x40B7
    MediaLed184 = 0x40B8
    MediaLed185 = 0x40B9
    MediaLed186 = 0x40BA
    MediaLed187 = 0x40BB
    MediaLed188 = 0x40BC
    MediaLed189 = 0x40BD
    MediaLed190 = 0x40BE
    MediaLed191 = 0x40BF
    MediaLed192 = 0x40C0
    MediaLed193 = 0x40C1
    MediaLed194 = 0x40C2
    MediaLed195 = 0x40C3
    MediaLed196 = 0x40C4
    MediaLed197 = 0x40C5
    MediaLed198 = 0x40C6
    MediaLed199 = 0x40C7
    MediaLed200 = 0x40C8
    MediaLed201 = 0x40C9
    MediaLed202 = 0x40CA
    MediaLed203 = 0x40CB
    MediaLed204 = 0x40CC
    MediaLed205 = 0x40CD
    MediaLed206 = 0x40CE
    MediaLed207 = 0x40CF
    MediaLed208 = 0x40D0
    MediaLed209 = 0x40D1
    MediaLed210 = 0x40D2
    MediaLed211 = 0x40D3
    MediaLed212 = 0x40D4
    MediaLed213 = 0x40D5
    MediaLed214 = 0x40D6
    MediaLed215 = 0x40D7
    MediaLed216 = 0x40D8
    MediaLed217 = 0x40D9
    MediaLed218 = 0x40DA
    MediaLed219 = 0x40DB
    MediaLed220 = 0x40DC
    MediaLed221 = 0x40DD
    MediaLed222 = 0x40DE
    MediaLed223 = 0x40DF
    MediaLed224 = 0x40E0
    MediaLed225 = 0x40E1
    MediaLed226 = 0x40E2
    MediaLed227 = 0x40E3
    MediaLed228 = 0x40E4
    MediaLed229 = 0x40E5
    MediaLed230 = 0x40E6
    MediaLed231 = 0x40E7
    MediaLed232 = 0x40E8
    MediaLed233 = 0x40E9
    MediaLed234 = 0x40EA
    MediaLed235 = 0x40EB
    MediaLed236 = 0x40EC
    MediaLed237 = 0x40ED
    MediaLed238 = 0x40EE
    MediaLed239 = 0x40EF
    MediaLed240 = 0x40F0
    MediaLed241 = 0x40F1
    MediaLed242 = 0x40F2
    MediaLed243 = 0x40F3
    MediaLed244 = 0x40F4
    MediaLed245 = 0x40F5
    MediaLed246 = 0x40F6
    MediaLed247 = 0x40F7
    MediaLed248 = 0x40F8
    MediaLed249 = 0x40F9
    MediaLed250 = 0x40FA
    MediaLed251 = 0x40FB
    MediaLed252 = 0x40FC
    MediaLed253 = 0x40FD
    MediaLed254 = 0x40FE
    MediaLed255 = 0x40FF
    # MediaColorLed List
    MediaColorLed0 = 0x4100
    MediaColorLed1 = 0x4101
    MediaColorLed2 = 0x4102
    MediaColorLed3 = 0x4103
    MediaColorLed4 = 0x4104
    MediaColorLed5 = 0x4105
    MediaColorLed6 = 0x4106
    MediaColorLed7 = 0x4107
    MediaColorLed8 = 0x4108
    MediaColorLed9 = 0x4109
    MediaColorLed10 = 0x410A
    MediaColorLed11 = 0x410B
    MediaColorLed12 = 0x410C
    MediaColorLed13 = 0x410D
    MediaColorLed14 = 0x410E
    MediaColorLed15 = 0x410F
    MediaColorLed16 = 0x4110
    MediaColorLed17 = 0x4111
    MediaColorLed18 = 0x4112
    MediaColorLed19 = 0x4113
    MediaColorLed20 = 0x4114
    MediaColorLed21 = 0x4115
    MediaColorLed22 = 0x4116
    MediaColorLed23 = 0x4117
    MediaColorLed24 = 0x4118
    MediaColorLed25 = 0x4119
    MediaColorLed26 = 0x411A
    MediaColorLed27 = 0x411B
    MediaColorLed28 = 0x411C
    MediaColorLed29 = 0x411D
    MediaColorLed30 = 0x411E
    MediaColorLed31 = 0x411F
    MediaColorLed32 = 0x4120
    MediaColorLed33 = 0x4121
    MediaColorLed34 = 0x4122
    MediaColorLed35 = 0x4123
    MediaColorLed36 = 0x4124
    MediaColorLed37 = 0x4125
    MediaColorLed38 = 0x4126
    MediaColorLed39 = 0x4127
    MediaColorLed40 = 0x4128
    MediaColorLed41 = 0x4129
    MediaColorLed42 = 0x412A
    MediaColorLed43 = 0x412B
    MediaColorLed44 = 0x412C
    MediaColorLed45 = 0x412D
    MediaColorLed46 = 0x412E
    MediaColorLed47 = 0x412F
    MediaColorLed48 = 0x4130
    MediaColorLed49 = 0x4131
    MediaColorLed50 = 0x4132
    MediaColorLed51 = 0x4133
    MediaColorLed52 = 0x4134
    MediaColorLed53 = 0x4135
    MediaColorLed54 = 0x4136
    MediaColorLed55 = 0x4137
    MediaColorLed56 = 0x4138
    MediaColorLed57 = 0x4139
    MediaColorLed58 = 0x413A
    MediaColorLed59 = 0x413B
    MediaColorLed60 = 0x413C
    MediaColorLed61 = 0x413D
    MediaColorLed62 = 0x413E
    MediaColorLed63 = 0x413F
    MediaColorLed64 = 0x4140
    MediaColorLed65 = 0x4141
    MediaColorLed66 = 0x4142
    MediaColorLed67 = 0x4143
    MediaColorLed68 = 0x4144
    MediaColorLed69 = 0x4145
    MediaColorLed70 = 0x4146
    MediaColorLed71 = 0x4147
    MediaColorLed72 = 0x4148
    MediaColorLed73 = 0x4149
    MediaColorLed74 = 0x414A
    MediaColorLed75 = 0x414B
    MediaColorLed76 = 0x414C
    MediaColorLed77 = 0x414D
    MediaColorLed78 = 0x414E
    MediaColorLed79 = 0x414F
    MediaColorLed80 = 0x4150
    MediaColorLed81 = 0x4151
    MediaColorLed82 = 0x4152
    MediaColorLed83 = 0x4153
    MediaColorLed84 = 0x4154
    MediaColorLed85 = 0x4155
    MediaColorLed86 = 0x4156
    MediaColorLed87 = 0x4157
    MediaColorLed88 = 0x4158
    MediaColorLed89 = 0x4159
    MediaColorLed90 = 0x415A
    MediaColorLed91 = 0x415B
    MediaColorLed92 = 0x415C
    MediaColorLed93 = 0x415D
    MediaColorLed94 = 0x415E
    MediaColorLed95 = 0x415F
    MediaColorLed96 = 0x4160
    MediaColorLed97 = 0x4161
    MediaColorLed98 = 0x4162
    MediaColorLed99 = 0x4163
    MediaColorLed100 = 0x4164
    MediaColorLed101 = 0x4165
    MediaColorLed102 = 0x4166
    MediaColorLed103 = 0x4167
    MediaColorLed104 = 0x4168
    MediaColorLed105 = 0x4169
    MediaColorLed106 = 0x416A
    MediaColorLed107 = 0x416B
    MediaColorLed108 = 0x416C
    MediaColorLed109 = 0x416D
    MediaColorLed110 = 0x416E
    MediaColorLed111 = 0x416F
    MediaColorLed112 = 0x4170
    MediaColorLed113 = 0x4171
    MediaColorLed114 = 0x4172
    MediaColorLed115 = 0x4173
    MediaColorLed116 = 0x4174
    MediaColorLed117 = 0x4175
    MediaColorLed118 = 0x4176
    MediaColorLed119 = 0x4177
    MediaColorLed120 = 0x4178
    MediaColorLed121 = 0x4179
    MediaColorLed122 = 0x417A
    MediaColorLed123 = 0x417B
    MediaColorLed124 = 0x417C
    MediaColorLed125 = 0x417D
    MediaColorLed126 = 0x417E
    MediaColorLed127 = 0x417F
    MediaColorLed128 = 0x4180
    MediaColorLed129 = 0x4181
    MediaColorLed130 = 0x4182
    MediaColorLed131 = 0x4183
    MediaColorLed132 = 0x4184
    MediaColorLed133 = 0x4185
    MediaColorLed134 = 0x4186
    MediaColorLed135 = 0x4187
    MediaColorLed136 = 0x4188
    MediaColorLed137 = 0x4189
    MediaColorLed138 = 0x418A
    MediaColorLed139 = 0x418B
    MediaColorLed140 = 0x418C
    MediaColorLed141 = 0x418D
    MediaColorLed142 = 0x418E
    MediaColorLed143 = 0x418F
    MediaColorLed144 = 0x4190
    MediaColorLed145 = 0x4191
    MediaColorLed146 = 0x4192
    MediaColorLed147 = 0x4193
    MediaColorLed148 = 0x4194
    MediaColorLed149 = 0x4195
    MediaColorLed150 = 0x4196
    MediaColorLed151 = 0x4197
    MediaColorLed152 = 0x4198
    MediaColorLed153 = 0x4199
    MediaColorLed154 = 0x419A
    MediaColorLed155 = 0x419B
    MediaColorLed156 = 0x419C
    MediaColorLed157 = 0x419D
    MediaColorLed158 = 0x419E
    MediaColorLed159 = 0x419F
    MediaColorLed160 = 0x41A0
    MediaColorLed161 = 0x41A1
    MediaColorLed162 = 0x41A2
    MediaColorLed163 = 0x41A3
    MediaColorLed164 = 0x41A4
    MediaColorLed165 = 0x41A5
    MediaColorLed166 = 0x41A6
    MediaColorLed167 = 0x41A7
    MediaColorLed168 = 0x41A8
    MediaColorLed169 = 0x41A9
    MediaColorLed170 = 0x41AA
    MediaColorLed171 = 0x41AB
    MediaColorLed172 = 0x41AC
    MediaColorLed173 = 0x41AD
    MediaColorLed174 = 0x41AE
    MediaColorLed175 = 0x41AF
    MediaColorLed176 = 0x41B0
    MediaColorLed177 = 0x41B1
    MediaColorLed178 = 0x41B2
    MediaColorLed179 = 0x41B3
    MediaColorLed180 = 0x41B4
    MediaColorLed181 = 0x41B5
    MediaColorLed182 = 0x41B6
    MediaColorLed183 = 0x41B7
    MediaColorLed184 = 0x41B8
    MediaColorLed185 = 0x41B9
    MediaColorLed186 = 0x41BA
    MediaColorLed187 = 0x41BB
    MediaColorLed188 = 0x41BC
    MediaColorLed189 = 0x41BD
    MediaColorLed190 = 0x41BE
    MediaColorLed191 = 0x41BF
    MediaColorLed192 = 0x41C0
    MediaColorLed193 = 0x41C1
    MediaColorLed194 = 0x41C2
    MediaColorLed195 = 0x41C3
    MediaColorLed196 = 0x41C4
    MediaColorLed197 = 0x41C5
    MediaColorLed198 = 0x41C6
    MediaColorLed199 = 0x41C7
    MediaColorLed200 = 0x41C8
    MediaColorLed201 = 0x41C9
    MediaColorLed202 = 0x41CA
    MediaColorLed203 = 0x41CB
    MediaColorLed204 = 0x41CC
    MediaColorLed205 = 0x41CD
    MediaColorLed206 = 0x41CE
    MediaColorLed207 = 0x41CF
    MediaColorLed208 = 0x41D0
    MediaColorLed209 = 0x41D1
    MediaColorLed210 = 0x41D2
    MediaColorLed211 = 0x41D3
    MediaColorLed212 = 0x41D4
    MediaColorLed213 = 0x41D5
    MediaColorLed214 = 0x41D6
    MediaColorLed215 = 0x41D7
    MediaColorLed216 = 0x41D8
    MediaColorLed217 = 0x41D9
    MediaColorLed218 = 0x41DA
    MediaColorLed219 = 0x41DB
    MediaColorLed220 = 0x41DC
    MediaColorLed221 = 0x41DD
    MediaColorLed222 = 0x41DE
    MediaColorLed223 = 0x41DF
    MediaColorLed224 = 0x41E0
    MediaColorLed225 = 0x41E1
    MediaColorLed226 = 0x41E2
    MediaColorLed227 = 0x41E3
    MediaColorLed228 = 0x41E4
    MediaColorLed229 = 0x41E5
    MediaColorLed230 = 0x41E6
    MediaColorLed231 = 0x41E7
    MediaColorLed232 = 0x41E8
    MediaColorLed233 = 0x41E9
    MediaColorLed234 = 0x41EA
    MediaColorLed235 = 0x41EB
    MediaColorLed236 = 0x41EC
    MediaColorLed237 = 0x41ED
    MediaColorLed238 = 0x41EE
    MediaColorLed239 = 0x41EF
    MediaColorLed240 = 0x41F0
    MediaColorLed241 = 0x41F1
    MediaColorLed242 = 0x41F2
    MediaColorLed243 = 0x41F3
    MediaColorLed244 = 0x41F4
    MediaColorLed245 = 0x41F5
    MediaColorLed246 = 0x41F6
    MediaColorLed247 = 0x41F7
    MediaColorLed248 = 0x41F8
    MediaColorLed249 = 0x41F9
    MediaColorLed250 = 0x41FA
    MediaColorLed251 = 0x41FB
    MediaColorLed252 = 0x41FC
    MediaColorLed253 = 0x41FD
    MediaColorLed254 = 0x41FE
    MediaColorLed255 = 0x41FF
    # GaugeC List
    GaugeC0 = 0x4200
    GaugeC1 = 0x4201
    GaugeC2 = 0x4202
    GaugeC3 = 0x4203
    GaugeC4 = 0x4204
    GaugeC5 = 0x4205
    GaugeC6 = 0x4206
    GaugeC7 = 0x4207
    GaugeC8 = 0x4208
    GaugeC9 = 0x4209
    GaugeC10 = 0x420A
    GaugeC11 = 0x420B
    GaugeC12 = 0x420C
    GaugeC13 = 0x420D
    GaugeC14 = 0x420E
    GaugeC15 = 0x420F
    GaugeC16 = 0x4210
    GaugeC17 = 0x4211
    GaugeC18 = 0x4212
    GaugeC19 = 0x4213
    GaugeC20 = 0x4214
    GaugeC21 = 0x4215
    GaugeC22 = 0x4216
    GaugeC23 = 0x4217
    GaugeC24 = 0x4218
    GaugeC25 = 0x4219
    GaugeC26 = 0x421A
    GaugeC27 = 0x421B
    GaugeC28 = 0x421C
    GaugeC29 = 0x421D
    GaugeC30 = 0x421E
    GaugeC31 = 0x421F
    GaugeC32 = 0x4220
    GaugeC33 = 0x4221
    GaugeC34 = 0x4222
    GaugeC35 = 0x4223
    GaugeC36 = 0x4224
    GaugeC37 = 0x4225
    GaugeC38 = 0x4226
    GaugeC39 = 0x4227
    GaugeC40 = 0x4228
    GaugeC41 = 0x4229
    GaugeC42 = 0x422A
    GaugeC43 = 0x422B
    GaugeC44 = 0x422C
    GaugeC45 = 0x422D
    GaugeC46 = 0x422E
    GaugeC47 = 0x422F
    GaugeC48 = 0x4230
    GaugeC49 = 0x4231
    GaugeC50 = 0x4232
    GaugeC51 = 0x4233
    GaugeC52 = 0x4234
    GaugeC53 = 0x4235
    GaugeC54 = 0x4236
    GaugeC55 = 0x4237
    GaugeC56 = 0x4238
    GaugeC57 = 0x4239
    GaugeC58 = 0x423A
    GaugeC59 = 0x423B
    GaugeC60 = 0x423C
    GaugeC61 = 0x423D
    GaugeC62 = 0x423E
    GaugeC63 = 0x423F
    GaugeC64 = 0x4240
    GaugeC65 = 0x4241
    GaugeC66 = 0x4242
    GaugeC67 = 0x4243
    GaugeC68 = 0x4244
    GaugeC69 = 0x4245
    GaugeC70 = 0x4246
    GaugeC71 = 0x4247
    GaugeC72 = 0x4248
    GaugeC73 = 0x4249
    GaugeC74 = 0x424A
    GaugeC75 = 0x424B
    GaugeC76 = 0x424C
    GaugeC77 = 0x424D
    GaugeC78 = 0x424E
    GaugeC79 = 0x424F
    GaugeC80 = 0x4250
    GaugeC81 = 0x4251
    GaugeC82 = 0x4252
    GaugeC83 = 0x4253
    GaugeC84 = 0x4254
    GaugeC85 = 0x4255
    GaugeC86 = 0x4256
    GaugeC87 = 0x4257
    GaugeC88 = 0x4258
    GaugeC89 = 0x4259
    GaugeC90 = 0x425A
    GaugeC91 = 0x425B
    GaugeC92 = 0x425C
    GaugeC93 = 0x425D
    GaugeC94 = 0x425E
    GaugeC95 = 0x425F
    GaugeC96 = 0x4260
    GaugeC97 = 0x4261
    GaugeC98 = 0x4262
    GaugeC99 = 0x4263
    GaugeC100 = 0x4264
    GaugeC101 = 0x4265
    GaugeC102 = 0x4266
    GaugeC103 = 0x4267
    GaugeC104 = 0x4268
    GaugeC105 = 0x4269
    GaugeC106 = 0x426A
    GaugeC107 = 0x426B
    GaugeC108 = 0x426C
    GaugeC109 = 0x426D
    GaugeC110 = 0x426E
    GaugeC111 = 0x426F
    GaugeC112 = 0x4270
    GaugeC113 = 0x4271
    GaugeC114 = 0x4272
    GaugeC115 = 0x4273
    GaugeC116 = 0x4274
    GaugeC117 = 0x4275
    GaugeC118 = 0x4276
    GaugeC119 = 0x4277
    GaugeC120 = 0x4278
    GaugeC121 = 0x4279
    GaugeC122 = 0x427A
    GaugeC123 = 0x427B
    GaugeC124 = 0x427C
    GaugeC125 = 0x427D
    GaugeC126 = 0x427E
    GaugeC127 = 0x427F
    GaugeC128 = 0x4280
    GaugeC129 = 0x4281
    GaugeC130 = 0x4282
    GaugeC131 = 0x4283
    GaugeC132 = 0x4284
    GaugeC133 = 0x4285
    GaugeC134 = 0x4286
    GaugeC135 = 0x4287
    GaugeC136 = 0x4288
    GaugeC137 = 0x4289
    GaugeC138 = 0x428A
    GaugeC139 = 0x428B
    GaugeC140 = 0x428C
    GaugeC141 = 0x428D
    GaugeC142 = 0x428E
    GaugeC143 = 0x428F
    GaugeC144 = 0x4290
    GaugeC145 = 0x4291
    GaugeC146 = 0x4292
    GaugeC147 = 0x4293
    GaugeC148 = 0x4294
    GaugeC149 = 0x4295
    GaugeC150 = 0x4296
    GaugeC151 = 0x4297
    GaugeC152 = 0x4298
    GaugeC153 = 0x4299
    GaugeC154 = 0x429A
    GaugeC155 = 0x429B
    GaugeC156 = 0x429C
    GaugeC157 = 0x429D
    GaugeC158 = 0x429E
    GaugeC159 = 0x429F
    GaugeC160 = 0x42A0
    GaugeC161 = 0x42A1
    GaugeC162 = 0x42A2
    GaugeC163 = 0x42A3
    GaugeC164 = 0x42A4
    GaugeC165 = 0x42A5
    GaugeC166 = 0x42A6
    GaugeC167 = 0x42A7
    GaugeC168 = 0x42A8
    GaugeC169 = 0x42A9
    GaugeC170 = 0x42AA
    GaugeC171 = 0x42AB
    GaugeC172 = 0x42AC
    GaugeC173 = 0x42AD
    GaugeC174 = 0x42AE
    GaugeC175 = 0x42AF
    GaugeC176 = 0x42B0
    GaugeC177 = 0x42B1
    GaugeC178 = 0x42B2
    GaugeC179 = 0x42B3
    GaugeC180 = 0x42B4
    GaugeC181 = 0x42B5
    GaugeC182 = 0x42B6
    GaugeC183 = 0x42B7
    GaugeC184 = 0x42B8
    GaugeC185 = 0x42B9
    GaugeC186 = 0x42BA
    GaugeC187 = 0x42BB
    GaugeC188 = 0x42BC
    GaugeC189 = 0x42BD
    GaugeC190 = 0x42BE
    GaugeC191 = 0x42BF
    GaugeC192 = 0x42C0
    GaugeC193 = 0x42C1
    GaugeC194 = 0x42C2
    GaugeC195 = 0x42C3
    GaugeC196 = 0x42C4
    GaugeC197 = 0x42C5
    GaugeC198 = 0x42C6
    GaugeC199 = 0x42C7
    GaugeC200 = 0x42C8
    GaugeC201 = 0x42C9
    GaugeC202 = 0x42CA
    GaugeC203 = 0x42CB
    GaugeC204 = 0x42CC
    GaugeC205 = 0x42CD
    GaugeC206 = 0x42CE
    GaugeC207 = 0x42CF
    GaugeC208 = 0x42D0
    GaugeC209 = 0x42D1
    GaugeC210 = 0x42D2
    GaugeC211 = 0x42D3
    GaugeC212 = 0x42D4
    GaugeC213 = 0x42D5
    GaugeC214 = 0x42D6
    GaugeC215 = 0x42D7
    GaugeC216 = 0x42D8
    GaugeC217 = 0x42D9
    GaugeC218 = 0x42DA
    GaugeC219 = 0x42DB
    GaugeC220 = 0x42DC
    GaugeC221 = 0x42DD
    GaugeC222 = 0x42DE
    GaugeC223 = 0x42DF
    GaugeC224 = 0x42E0
    GaugeC225 = 0x42E1
    GaugeC226 = 0x42E2
    GaugeC227 = 0x42E3
    GaugeC228 = 0x42E4
    GaugeC229 = 0x42E5
    GaugeC230 = 0x42E6
    GaugeC231 = 0x42E7
    GaugeC232 = 0x42E8
    GaugeC233 = 0x42E9
    GaugeC234 = 0x42EA
    GaugeC235 = 0x42EB
    GaugeC236 = 0x42EC
    GaugeC237 = 0x42ED
    GaugeC238 = 0x42EE
    GaugeC239 = 0x42EF
    GaugeC240 = 0x42F0
    GaugeC241 = 0x42F1
    GaugeC242 = 0x42F2
    GaugeC243 = 0x42F3
    GaugeC244 = 0x42F4
    GaugeC245 = 0x42F5
    GaugeC246 = 0x42F6
    GaugeC247 = 0x42F7
    GaugeC248 = 0x42F8
    GaugeC249 = 0x42F9
    GaugeC250 = 0x42FA
    GaugeC251 = 0x42FB
    GaugeC252 = 0x42FC
    GaugeC253 = 0x42FD
    GaugeC254 = 0x42FE
    GaugeC255 = 0x42FF
    # GaugeD List
    GaugeD0 = 0x4300
    GaugeD1 = 0x4301
    GaugeD2 = 0x4302
    GaugeD3 = 0x4303
    GaugeD4 = 0x4304
    GaugeD5 = 0x4305
    GaugeD6 = 0x4306
    GaugeD7 = 0x4307
    GaugeD8 = 0x4308
    GaugeD9 = 0x4309
    GaugeD10 = 0x430A
    GaugeD11 = 0x430B
    GaugeD12 = 0x430C
    GaugeD13 = 0x430D
    GaugeD14 = 0x430E
    GaugeD15 = 0x430F
    GaugeD16 = 0x4310
    GaugeD17 = 0x4311
    GaugeD18 = 0x4312
    GaugeD19 = 0x4313
    GaugeD20 = 0x4314
    GaugeD21 = 0x4315
    GaugeD22 = 0x4316
    GaugeD23 = 0x4317
    GaugeD24 = 0x4318
    GaugeD25 = 0x4319
    GaugeD26 = 0x431A
    GaugeD27 = 0x431B
    GaugeD28 = 0x431C
    GaugeD29 = 0x431D
    GaugeD30 = 0x431E
    GaugeD31 = 0x431F
    GaugeD32 = 0x4320
    GaugeD33 = 0x4321
    GaugeD34 = 0x4322
    GaugeD35 = 0x4323
    GaugeD36 = 0x4324
    GaugeD37 = 0x4325
    GaugeD38 = 0x4326
    GaugeD39 = 0x4327
    GaugeD40 = 0x4328
    GaugeD41 = 0x4329
    GaugeD42 = 0x432A
    GaugeD43 = 0x432B
    GaugeD44 = 0x432C
    GaugeD45 = 0x432D
    GaugeD46 = 0x432E
    GaugeD47 = 0x432F
    GaugeD48 = 0x4330
    GaugeD49 = 0x4331
    GaugeD50 = 0x4332
    GaugeD51 = 0x4333
    GaugeD52 = 0x4334
    GaugeD53 = 0x4335
    GaugeD54 = 0x4336
    GaugeD55 = 0x4337
    GaugeD56 = 0x4338
    GaugeD57 = 0x4339
    GaugeD58 = 0x433A
    GaugeD59 = 0x433B
    GaugeD60 = 0x433C
    GaugeD61 = 0x433D
    GaugeD62 = 0x433E
    GaugeD63 = 0x433F
    GaugeD64 = 0x4340
    GaugeD65 = 0x4341
    GaugeD66 = 0x4342
    GaugeD67 = 0x4343
    GaugeD68 = 0x4344
    GaugeD69 = 0x4345
    GaugeD70 = 0x4346
    GaugeD71 = 0x4347
    GaugeD72 = 0x4348
    GaugeD73 = 0x4349
    GaugeD74 = 0x434A
    GaugeD75 = 0x434B
    GaugeD76 = 0x434C
    GaugeD77 = 0x434D
    GaugeD78 = 0x434E
    GaugeD79 = 0x434F
    GaugeD80 = 0x4350
    GaugeD81 = 0x4351
    GaugeD82 = 0x4352
    GaugeD83 = 0x4353
    GaugeD84 = 0x4354
    GaugeD85 = 0x4355
    GaugeD86 = 0x4356
    GaugeD87 = 0x4357
    GaugeD88 = 0x4358
    GaugeD89 = 0x4359
    GaugeD90 = 0x435A
    GaugeD91 = 0x435B
    GaugeD92 = 0x435C
    GaugeD93 = 0x435D
    GaugeD94 = 0x435E
    GaugeD95 = 0x435F
    GaugeD96 = 0x4360
    GaugeD97 = 0x4361
    GaugeD98 = 0x4362
    GaugeD99 = 0x4363
    GaugeD100 = 0x4364
    GaugeD101 = 0x4365
    GaugeD102 = 0x4366
    GaugeD103 = 0x4367
    GaugeD104 = 0x4368
    GaugeD105 = 0x4369
    GaugeD106 = 0x436A
    GaugeD107 = 0x436B
    GaugeD108 = 0x436C
    GaugeD109 = 0x436D
    GaugeD110 = 0x436E
    GaugeD111 = 0x436F
    GaugeD112 = 0x4370
    GaugeD113 = 0x4371
    GaugeD114 = 0x4372
    GaugeD115 = 0x4373
    GaugeD116 = 0x4374
    GaugeD117 = 0x4375
    GaugeD118 = 0x4376
    GaugeD119 = 0x4377
    GaugeD120 = 0x4378
    GaugeD121 = 0x4379
    GaugeD122 = 0x437A
    GaugeD123 = 0x437B
    GaugeD124 = 0x437C
    GaugeD125 = 0x437D
    GaugeD126 = 0x437E
    GaugeD127 = 0x437F
    GaugeD128 = 0x4380
    GaugeD129 = 0x4381
    GaugeD130 = 0x4382
    GaugeD131 = 0x4383
    GaugeD132 = 0x4384
    GaugeD133 = 0x4385
    GaugeD134 = 0x4386
    GaugeD135 = 0x4387
    GaugeD136 = 0x4388
    GaugeD137 = 0x4389
    GaugeD138 = 0x438A
    GaugeD139 = 0x438B
    GaugeD140 = 0x438C
    GaugeD141 = 0x438D
    GaugeD142 = 0x438E
    GaugeD143 = 0x438F
    GaugeD144 = 0x4390
    GaugeD145 = 0x4391
    GaugeD146 = 0x4392
    GaugeD147 = 0x4393
    GaugeD148 = 0x4394
    GaugeD149 = 0x4395
    GaugeD150 = 0x4396
    GaugeD151 = 0x4397
    GaugeD152 = 0x4398
    GaugeD153 = 0x4399
    GaugeD154 = 0x439A
    GaugeD155 = 0x439B
    GaugeD156 = 0x439C
    GaugeD157 = 0x439D
    GaugeD158 = 0x439E
    GaugeD159 = 0x439F
    GaugeD160 = 0x43A0
    GaugeD161 = 0x43A1
    GaugeD162 = 0x43A2
    GaugeD163 = 0x43A3
    GaugeD164 = 0x43A4
    GaugeD165 = 0x43A5
    GaugeD166 = 0x43A6
    GaugeD167 = 0x43A7
    GaugeD168 = 0x43A8
    GaugeD169 = 0x43A9
    GaugeD170 = 0x43AA
    GaugeD171 = 0x43AB
    GaugeD172 = 0x43AC
    GaugeD173 = 0x43AD
    GaugeD174 = 0x43AE
    GaugeD175 = 0x43AF
    GaugeD176 = 0x43B0
    GaugeD177 = 0x43B1
    GaugeD178 = 0x43B2
    GaugeD179 = 0x43B3
    GaugeD180 = 0x43B4
    GaugeD181 = 0x43B5
    GaugeD182 = 0x43B6
    GaugeD183 = 0x43B7
    GaugeD184 = 0x43B8
    GaugeD185 = 0x43B9
    GaugeD186 = 0x43BA
    GaugeD187 = 0x43BB
    GaugeD188 = 0x43BC
    GaugeD189 = 0x43BD
    GaugeD190 = 0x43BE
    GaugeD191 = 0x43BF
    GaugeD192 = 0x43C0
    GaugeD193 = 0x43C1
    GaugeD194 = 0x43C2
    GaugeD195 = 0x43C3
    GaugeD196 = 0x43C4
    GaugeD197 = 0x43C5
    GaugeD198 = 0x43C6
    GaugeD199 = 0x43C7
    GaugeD200 = 0x43C8
    GaugeD201 = 0x43C9
    GaugeD202 = 0x43CA
    GaugeD203 = 0x43CB
    GaugeD204 = 0x43CC
    GaugeD205 = 0x43CD
    GaugeD206 = 0x43CE
    GaugeD207 = 0x43CF
    GaugeD208 = 0x43D0
    GaugeD209 = 0x43D1
    GaugeD210 = 0x43D2
    GaugeD211 = 0x43D3
    GaugeD212 = 0x43D4
    GaugeD213 = 0x43D5
    GaugeD214 = 0x43D6
    GaugeD215 = 0x43D7
    GaugeD216 = 0x43D8
    GaugeD217 = 0x43D9
    GaugeD218 = 0x43DA
    GaugeD219 = 0x43DB
    GaugeD220 = 0x43DC
    GaugeD221 = 0x43DD
    GaugeD222 = 0x43DE
    GaugeD223 = 0x43DF
    GaugeD224 = 0x43E0
    GaugeD225 = 0x43E1
    GaugeD226 = 0x43E2
    GaugeD227 = 0x43E3
    GaugeD228 = 0x43E4
    GaugeD229 = 0x43E5
    GaugeD230 = 0x43E6
    GaugeD231 = 0x43E7
    GaugeD232 = 0x43E8
    GaugeD233 = 0x43E9
    GaugeD234 = 0x43EA
    GaugeD235 = 0x43EB
    GaugeD236 = 0x43EC
    GaugeD237 = 0x43ED
    GaugeD238 = 0x43EE
    GaugeD239 = 0x43EF
    GaugeD240 = 0x43F0
    GaugeD241 = 0x43F1
    GaugeD242 = 0x43F2
    GaugeD243 = 0x43F3
    GaugeD244 = 0x43F4
    GaugeD245 = 0x43F5
    GaugeD246 = 0x43F6
    GaugeD247 = 0x43F7
    GaugeD248 = 0x43F8
    GaugeD249 = 0x43F9
    GaugeD250 = 0x43FA
    GaugeD251 = 0x43FB
    GaugeD252 = 0x43FC
    GaugeD253 = 0x43FD
    GaugeD254 = 0x43FE
    GaugeD255 = 0x43FF
    # GaugeE List
    GaugeE0 = 0x4400
    GaugeE1 = 0x4401
    GaugeE2 = 0x4402
    GaugeE3 = 0x4403
    GaugeE4 = 0x4404
    GaugeE5 = 0x4405
    GaugeE6 = 0x4406
    GaugeE7 = 0x4407
    GaugeE8 = 0x4408
    GaugeE9 = 0x4409
    GaugeE10 = 0x440A
    GaugeE11 = 0x440B
    GaugeE12 = 0x440C
    GaugeE13 = 0x440D
    GaugeE14 = 0x440E
    GaugeE15 = 0x440F
    GaugeE16 = 0x4410
    GaugeE17 = 0x4411
    GaugeE18 = 0x4412
    GaugeE19 = 0x4413
    GaugeE20 = 0x4414
    GaugeE21 = 0x4415
    GaugeE22 = 0x4416
    GaugeE23 = 0x4417
    GaugeE24 = 0x4418
    GaugeE25 = 0x4419
    GaugeE26 = 0x441A
    GaugeE27 = 0x441B
    GaugeE28 = 0x441C
    GaugeE29 = 0x441D
    GaugeE30 = 0x441E
    GaugeE31 = 0x441F
    GaugeE32 = 0x4420
    GaugeE33 = 0x4421
    GaugeE34 = 0x4422
    GaugeE35 = 0x4423
    GaugeE36 = 0x4424
    GaugeE37 = 0x4425
    GaugeE38 = 0x4426
    GaugeE39 = 0x4427
    GaugeE40 = 0x4428
    GaugeE41 = 0x4429
    GaugeE42 = 0x442A
    GaugeE43 = 0x442B
    GaugeE44 = 0x442C
    GaugeE45 = 0x442D
    GaugeE46 = 0x442E
    GaugeE47 = 0x442F
    GaugeE48 = 0x4430
    GaugeE49 = 0x4431
    GaugeE50 = 0x4432
    GaugeE51 = 0x4433
    GaugeE52 = 0x4434
    GaugeE53 = 0x4435
    GaugeE54 = 0x4436
    GaugeE55 = 0x4437
    GaugeE56 = 0x4438
    GaugeE57 = 0x4439
    GaugeE58 = 0x443A
    GaugeE59 = 0x443B
    GaugeE60 = 0x443C
    GaugeE61 = 0x443D
    GaugeE62 = 0x443E
    GaugeE63 = 0x443F
    GaugeE64 = 0x4440
    GaugeE65 = 0x4441
    GaugeE66 = 0x4442
    GaugeE67 = 0x4443
    GaugeE68 = 0x4444
    GaugeE69 = 0x4445
    GaugeE70 = 0x4446
    GaugeE71 = 0x4447
    GaugeE72 = 0x4448
    GaugeE73 = 0x4449
    GaugeE74 = 0x444A
    GaugeE75 = 0x444B
    GaugeE76 = 0x444C
    GaugeE77 = 0x444D
    GaugeE78 = 0x444E
    GaugeE79 = 0x444F
    GaugeE80 = 0x4450
    GaugeE81 = 0x4451
    GaugeE82 = 0x4452
    GaugeE83 = 0x4453
    GaugeE84 = 0x4454
    GaugeE85 = 0x4455
    GaugeE86 = 0x4456
    GaugeE87 = 0x4457
    GaugeE88 = 0x4458
    GaugeE89 = 0x4459
    GaugeE90 = 0x445A
    GaugeE91 = 0x445B
    GaugeE92 = 0x445C
    GaugeE93 = 0x445D
    GaugeE94 = 0x445E
    GaugeE95 = 0x445F
    GaugeE96 = 0x4460
    GaugeE97 = 0x4461
    GaugeE98 = 0x4462
    GaugeE99 = 0x4463
    GaugeE100 = 0x4464
    GaugeE101 = 0x4465
    GaugeE102 = 0x4466
    GaugeE103 = 0x4467
    GaugeE104 = 0x4468
    GaugeE105 = 0x4469
    GaugeE106 = 0x446A
    GaugeE107 = 0x446B
    GaugeE108 = 0x446C
    GaugeE109 = 0x446D
    GaugeE110 = 0x446E
    GaugeE111 = 0x446F
    GaugeE112 = 0x4470
    GaugeE113 = 0x4471
    GaugeE114 = 0x4472
    GaugeE115 = 0x4473
    GaugeE116 = 0x4474
    GaugeE117 = 0x4475
    GaugeE118 = 0x4476
    GaugeE119 = 0x4477
    GaugeE120 = 0x4478
    GaugeE121 = 0x4479
    GaugeE122 = 0x447A
    GaugeE123 = 0x447B
    GaugeE124 = 0x447C
    GaugeE125 = 0x447D
    GaugeE126 = 0x447E
    GaugeE127 = 0x447F
    GaugeE128 = 0x4480
    GaugeE129 = 0x4481
    GaugeE130 = 0x4482
    GaugeE131 = 0x4483
    GaugeE132 = 0x4484
    GaugeE133 = 0x4485
    GaugeE134 = 0x4486
    GaugeE135 = 0x4487
    GaugeE136 = 0x4488
    GaugeE137 = 0x4489
    GaugeE138 = 0x448A
    GaugeE139 = 0x448B
    GaugeE140 = 0x448C
    GaugeE141 = 0x448D
    GaugeE142 = 0x448E
    GaugeE143 = 0x448F
    GaugeE144 = 0x4490
    GaugeE145 = 0x4491
    GaugeE146 = 0x4492
    GaugeE147 = 0x4493
    GaugeE148 = 0x4494
    GaugeE149 = 0x4495
    GaugeE150 = 0x4496
    GaugeE151 = 0x4497
    GaugeE152 = 0x4498
    GaugeE153 = 0x4499
    GaugeE154 = 0x449A
    GaugeE155 = 0x449B
    GaugeE156 = 0x449C
    GaugeE157 = 0x449D
    GaugeE158 = 0x449E
    GaugeE159 = 0x449F
    GaugeE160 = 0x44A0
    GaugeE161 = 0x44A1
    GaugeE162 = 0x44A2
    GaugeE163 = 0x44A3
    GaugeE164 = 0x44A4
    GaugeE165 = 0x44A5
    GaugeE166 = 0x44A6
    GaugeE167 = 0x44A7
    GaugeE168 = 0x44A8
    GaugeE169 = 0x44A9
    GaugeE170 = 0x44AA
    GaugeE171 = 0x44AB
    GaugeE172 = 0x44AC
    GaugeE173 = 0x44AD
    GaugeE174 = 0x44AE
    GaugeE175 = 0x44AF
    GaugeE176 = 0x44B0
    GaugeE177 = 0x44B1
    GaugeE178 = 0x44B2
    GaugeE179 = 0x44B3
    GaugeE180 = 0x44B4
    GaugeE181 = 0x44B5
    GaugeE182 = 0x44B6
    GaugeE183 = 0x44B7
    GaugeE184 = 0x44B8
    GaugeE185 = 0x44B9
    GaugeE186 = 0x44BA
    GaugeE187 = 0x44BB
    GaugeE188 = 0x44BC
    GaugeE189 = 0x44BD
    GaugeE190 = 0x44BE
    GaugeE191 = 0x44BF
    GaugeE192 = 0x44C0
    GaugeE193 = 0x44C1
    GaugeE194 = 0x44C2
    GaugeE195 = 0x44C3
    GaugeE196 = 0x44C4
    GaugeE197 = 0x44C5
    GaugeE198 = 0x44C6
    GaugeE199 = 0x44C7
    GaugeE200 = 0x44C8
    GaugeE201 = 0x44C9
    GaugeE202 = 0x44CA
    GaugeE203 = 0x44CB
    GaugeE204 = 0x44CC
    GaugeE205 = 0x44CD
    GaugeE206 = 0x44CE
    GaugeE207 = 0x44CF
    GaugeE208 = 0x44D0
    GaugeE209 = 0x44D1
    GaugeE210 = 0x44D2
    GaugeE211 = 0x44D3
    GaugeE212 = 0x44D4
    GaugeE213 = 0x44D5
    GaugeE214 = 0x44D6
    GaugeE215 = 0x44D7
    GaugeE216 = 0x44D8
    GaugeE217 = 0x44D9
    GaugeE218 = 0x44DA
    GaugeE219 = 0x44DB
    GaugeE220 = 0x44DC
    GaugeE221 = 0x44DD
    GaugeE222 = 0x44DE
    GaugeE223 = 0x44DF
    GaugeE224 = 0x44E0
    GaugeE225 = 0x44E1
    GaugeE226 = 0x44E2
    GaugeE227 = 0x44E3
    GaugeE228 = 0x44E4
    GaugeE229 = 0x44E5
    GaugeE230 = 0x44E6
    GaugeE231 = 0x44E7
    GaugeE232 = 0x44E8
    GaugeE233 = 0x44E9
    GaugeE234 = 0x44EA
    GaugeE235 = 0x44EB
    GaugeE236 = 0x44EC
    GaugeE237 = 0x44ED
    GaugeE238 = 0x44EE
    GaugeE239 = 0x44EF
    GaugeE240 = 0x44F0
    GaugeE241 = 0x44F1
    GaugeE242 = 0x44F2
    GaugeE243 = 0x44F3
    GaugeE244 = 0x44F4
    GaugeE245 = 0x44F5
    GaugeE246 = 0x44F6
    GaugeE247 = 0x44F7
    GaugeE248 = 0x44F8
    GaugeE249 = 0x44F9
    GaugeE250 = 0x44FA
    GaugeE251 = 0x44FB
    GaugeE252 = 0x44FC
    GaugeE253 = 0x44FD
    GaugeE254 = 0x44FE
    GaugeE255 = 0x44FF
    # GaugeF List
    GaugeF0 = 0x4500
    GaugeF1 = 0x4501
    GaugeF2 = 0x4502
    GaugeF3 = 0x4503
    GaugeF4 = 0x4504
    GaugeF5 = 0x4505
    GaugeF6 = 0x4506
    GaugeF7 = 0x4507
    GaugeF8 = 0x4508
    GaugeF9 = 0x4509
    GaugeF10 = 0x450A
    GaugeF11 = 0x450B
    GaugeF12 = 0x450C
    GaugeF13 = 0x450D
    GaugeF14 = 0x450E
    GaugeF15 = 0x450F
    GaugeF16 = 0x4510
    GaugeF17 = 0x4511
    GaugeF18 = 0x4512
    GaugeF19 = 0x4513
    GaugeF20 = 0x4514
    GaugeF21 = 0x4515
    GaugeF22 = 0x4516
    GaugeF23 = 0x4517
    GaugeF24 = 0x4518
    GaugeF25 = 0x4519
    GaugeF26 = 0x451A
    GaugeF27 = 0x451B
    GaugeF28 = 0x451C
    GaugeF29 = 0x451D
    GaugeF30 = 0x451E
    GaugeF31 = 0x451F
    GaugeF32 = 0x4520
    GaugeF33 = 0x4521
    GaugeF34 = 0x4522
    GaugeF35 = 0x4523
    GaugeF36 = 0x4524
    GaugeF37 = 0x4525
    GaugeF38 = 0x4526
    GaugeF39 = 0x4527
    GaugeF40 = 0x4528
    GaugeF41 = 0x4529
    GaugeF42 = 0x452A
    GaugeF43 = 0x452B
    GaugeF44 = 0x452C
    GaugeF45 = 0x452D
    GaugeF46 = 0x452E
    GaugeF47 = 0x452F
    GaugeF48 = 0x4530
    GaugeF49 = 0x4531
    GaugeF50 = 0x4532
    GaugeF51 = 0x4533
    GaugeF52 = 0x4534
    GaugeF53 = 0x4535
    GaugeF54 = 0x4536
    GaugeF55 = 0x4537
    GaugeF56 = 0x4538
    GaugeF57 = 0x4539
    GaugeF58 = 0x453A
    GaugeF59 = 0x453B
    GaugeF60 = 0x453C
    GaugeF61 = 0x453D
    GaugeF62 = 0x453E
    GaugeF63 = 0x453F
    GaugeF64 = 0x4540
    GaugeF65 = 0x4541
    GaugeF66 = 0x4542
    GaugeF67 = 0x4543
    GaugeF68 = 0x4544
    GaugeF69 = 0x4545
    GaugeF70 = 0x4546
    GaugeF71 = 0x4547
    GaugeF72 = 0x4548
    GaugeF73 = 0x4549
    GaugeF74 = 0x454A
    GaugeF75 = 0x454B
    GaugeF76 = 0x454C
    GaugeF77 = 0x454D
    GaugeF78 = 0x454E
    GaugeF79 = 0x454F
    GaugeF80 = 0x4550
    GaugeF81 = 0x4551
    GaugeF82 = 0x4552
    GaugeF83 = 0x4553
    GaugeF84 = 0x4554
    GaugeF85 = 0x4555
    GaugeF86 = 0x4556
    GaugeF87 = 0x4557
    GaugeF88 = 0x4558
    GaugeF89 = 0x4559
    GaugeF90 = 0x455A
    GaugeF91 = 0x455B
    GaugeF92 = 0x455C
    GaugeF93 = 0x455D
    GaugeF94 = 0x455E
    GaugeF95 = 0x455F
    GaugeF96 = 0x4560
    GaugeF97 = 0x4561
    GaugeF98 = 0x4562
    GaugeF99 = 0x4563
    GaugeF100 = 0x4564
    GaugeF101 = 0x4565
    GaugeF102 = 0x4566
    GaugeF103 = 0x4567
    GaugeF104 = 0x4568
    GaugeF105 = 0x4569
    GaugeF106 = 0x456A
    GaugeF107 = 0x456B
    GaugeF108 = 0x456C
    GaugeF109 = 0x456D
    GaugeF110 = 0x456E
    GaugeF111 = 0x456F
    GaugeF112 = 0x4570
    GaugeF113 = 0x4571
    GaugeF114 = 0x4572
    GaugeF115 = 0x4573
    GaugeF116 = 0x4574
    GaugeF117 = 0x4575
    GaugeF118 = 0x4576
    GaugeF119 = 0x4577
    GaugeF120 = 0x4578
    GaugeF121 = 0x4579
    GaugeF122 = 0x457A
    GaugeF123 = 0x457B
    GaugeF124 = 0x457C
    GaugeF125 = 0x457D
    GaugeF126 = 0x457E
    GaugeF127 = 0x457F
    GaugeF128 = 0x4580
    GaugeF129 = 0x4581
    GaugeF130 = 0x4582
    GaugeF131 = 0x4583
    GaugeF132 = 0x4584
    GaugeF133 = 0x4585
    GaugeF134 = 0x4586
    GaugeF135 = 0x4587
    GaugeF136 = 0x4588
    GaugeF137 = 0x4589
    GaugeF138 = 0x458A
    GaugeF139 = 0x458B
    GaugeF140 = 0x458C
    GaugeF141 = 0x458D
    GaugeF142 = 0x458E
    GaugeF143 = 0x458F
    GaugeF144 = 0x4590
    GaugeF145 = 0x4591
    GaugeF146 = 0x4592
    GaugeF147 = 0x4593
    GaugeF148 = 0x4594
    GaugeF149 = 0x4595
    GaugeF150 = 0x4596
    GaugeF151 = 0x4597
    GaugeF152 = 0x4598
    GaugeF153 = 0x4599
    GaugeF154 = 0x459A
    GaugeF155 = 0x459B
    GaugeF156 = 0x459C
    GaugeF157 = 0x459D
    GaugeF158 = 0x459E
    GaugeF159 = 0x459F
    GaugeF160 = 0x45A0
    GaugeF161 = 0x45A1
    GaugeF162 = 0x45A2
    GaugeF163 = 0x45A3
    GaugeF164 = 0x45A4
    GaugeF165 = 0x45A5
    GaugeF166 = 0x45A6
    GaugeF167 = 0x45A7
    GaugeF168 = 0x45A8
    GaugeF169 = 0x45A9
    GaugeF170 = 0x45AA
    GaugeF171 = 0x45AB
    GaugeF172 = 0x45AC
    GaugeF173 = 0x45AD
    GaugeF174 = 0x45AE
    GaugeF175 = 0x45AF
    GaugeF176 = 0x45B0
    GaugeF177 = 0x45B1
    GaugeF178 = 0x45B2
    GaugeF179 = 0x45B3
    GaugeF180 = 0x45B4
    GaugeF181 = 0x45B5
    GaugeF182 = 0x45B6
    GaugeF183 = 0x45B7
    GaugeF184 = 0x45B8
    GaugeF185 = 0x45B9
    GaugeF186 = 0x45BA
    GaugeF187 = 0x45BB
    GaugeF188 = 0x45BC
    GaugeF189 = 0x45BD
    GaugeF190 = 0x45BE
    GaugeF191 = 0x45BF
    GaugeF192 = 0x45C0
    GaugeF193 = 0x45C1
    GaugeF194 = 0x45C2
    GaugeF195 = 0x45C3
    GaugeF196 = 0x45C4
    GaugeF197 = 0x45C5
    GaugeF198 = 0x45C6
    GaugeF199 = 0x45C7
    GaugeF200 = 0x45C8
    GaugeF201 = 0x45C9
    GaugeF202 = 0x45CA
    GaugeF203 = 0x45CB
    GaugeF204 = 0x45CC
    GaugeF205 = 0x45CD
    GaugeF206 = 0x45CE
    GaugeF207 = 0x45CF
    GaugeF208 = 0x45D0
    GaugeF209 = 0x45D1
    GaugeF210 = 0x45D2
    GaugeF211 = 0x45D3
    GaugeF212 = 0x45D4
    GaugeF213 = 0x45D5
    GaugeF214 = 0x45D6
    GaugeF215 = 0x45D7
    GaugeF216 = 0x45D8
    GaugeF217 = 0x45D9
    GaugeF218 = 0x45DA
    GaugeF219 = 0x45DB
    GaugeF220 = 0x45DC
    GaugeF221 = 0x45DD
    GaugeF222 = 0x45DE
    GaugeF223 = 0x45DF
    GaugeF224 = 0x45E0
    GaugeF225 = 0x45E1
    GaugeF226 = 0x45E2
    GaugeF227 = 0x45E3
    GaugeF228 = 0x45E4
    GaugeF229 = 0x45E5
    GaugeF230 = 0x45E6
    GaugeF231 = 0x45E7
    GaugeF232 = 0x45E8
    GaugeF233 = 0x45E9
    GaugeF234 = 0x45EA
    GaugeF235 = 0x45EB
    GaugeF236 = 0x45EC
    GaugeF237 = 0x45ED
    GaugeF238 = 0x45EE
    GaugeF239 = 0x45EF
    GaugeF240 = 0x45F0
    GaugeF241 = 0x45F1
    GaugeF242 = 0x45F2
    GaugeF243 = 0x45F3
    GaugeF244 = 0x45F4
    GaugeF245 = 0x45F5
    GaugeF246 = 0x45F6
    GaugeF247 = 0x45F7
    GaugeF248 = 0x45F8
    GaugeF249 = 0x45F9
    GaugeF250 = 0x45FA
    GaugeF251 = 0x45FB
    GaugeF252 = 0x45FC
    GaugeF253 = 0x45FD
    GaugeF254 = 0x45FE
    GaugeF255 = 0x45FF
    # MediaGaugeA List
    MediaGaugeA0 = 0x4600
    MediaGaugeA1 = 0x4601
    MediaGaugeA2 = 0x4602
    MediaGaugeA3 = 0x4603
    MediaGaugeA4 = 0x4604
    MediaGaugeA5 = 0x4605
    MediaGaugeA6 = 0x4606
    MediaGaugeA7 = 0x4607
    MediaGaugeA8 = 0x4608
    MediaGaugeA9 = 0x4609
    MediaGaugeA10 = 0x460A
    MediaGaugeA11 = 0x460B
    MediaGaugeA12 = 0x460C
    MediaGaugeA13 = 0x460D
    MediaGaugeA14 = 0x460E
    MediaGaugeA15 = 0x460F
    MediaGaugeA16 = 0x4610
    MediaGaugeA17 = 0x4611
    MediaGaugeA18 = 0x4612
    MediaGaugeA19 = 0x4613
    MediaGaugeA20 = 0x4614
    MediaGaugeA21 = 0x4615
    MediaGaugeA22 = 0x4616
    MediaGaugeA23 = 0x4617
    MediaGaugeA24 = 0x4618
    MediaGaugeA25 = 0x4619
    MediaGaugeA26 = 0x461A
    MediaGaugeA27 = 0x461B
    MediaGaugeA28 = 0x461C
    MediaGaugeA29 = 0x461D
    MediaGaugeA30 = 0x461E
    MediaGaugeA31 = 0x461F
    MediaGaugeA32 = 0x4620
    MediaGaugeA33 = 0x4621
    MediaGaugeA34 = 0x4622
    MediaGaugeA35 = 0x4623
    MediaGaugeA36 = 0x4624
    MediaGaugeA37 = 0x4625
    MediaGaugeA38 = 0x4626
    MediaGaugeA39 = 0x4627
    MediaGaugeA40 = 0x4628
    MediaGaugeA41 = 0x4629
    MediaGaugeA42 = 0x462A
    MediaGaugeA43 = 0x462B
    MediaGaugeA44 = 0x462C
    MediaGaugeA45 = 0x462D
    MediaGaugeA46 = 0x462E
    MediaGaugeA47 = 0x462F
    MediaGaugeA48 = 0x4630
    MediaGaugeA49 = 0x4631
    MediaGaugeA50 = 0x4632
    MediaGaugeA51 = 0x4633
    MediaGaugeA52 = 0x4634
    MediaGaugeA53 = 0x4635
    MediaGaugeA54 = 0x4636
    MediaGaugeA55 = 0x4637
    MediaGaugeA56 = 0x4638
    MediaGaugeA57 = 0x4639
    MediaGaugeA58 = 0x463A
    MediaGaugeA59 = 0x463B
    MediaGaugeA60 = 0x463C
    MediaGaugeA61 = 0x463D
    MediaGaugeA62 = 0x463E
    MediaGaugeA63 = 0x463F
    MediaGaugeA64 = 0x4640
    MediaGaugeA65 = 0x4641
    MediaGaugeA66 = 0x4642
    MediaGaugeA67 = 0x4643
    MediaGaugeA68 = 0x4644
    MediaGaugeA69 = 0x4645
    MediaGaugeA70 = 0x4646
    MediaGaugeA71 = 0x4647
    MediaGaugeA72 = 0x4648
    MediaGaugeA73 = 0x4649
    MediaGaugeA74 = 0x464A
    MediaGaugeA75 = 0x464B
    MediaGaugeA76 = 0x464C
    MediaGaugeA77 = 0x464D
    MediaGaugeA78 = 0x464E
    MediaGaugeA79 = 0x464F
    MediaGaugeA80 = 0x4650
    MediaGaugeA81 = 0x4651
    MediaGaugeA82 = 0x4652
    MediaGaugeA83 = 0x4653
    MediaGaugeA84 = 0x4654
    MediaGaugeA85 = 0x4655
    MediaGaugeA86 = 0x4656
    MediaGaugeA87 = 0x4657
    MediaGaugeA88 = 0x4658
    MediaGaugeA89 = 0x4659
    MediaGaugeA90 = 0x465A
    MediaGaugeA91 = 0x465B
    MediaGaugeA92 = 0x465C
    MediaGaugeA93 = 0x465D
    MediaGaugeA94 = 0x465E
    MediaGaugeA95 = 0x465F
    MediaGaugeA96 = 0x4660
    MediaGaugeA97 = 0x4661
    MediaGaugeA98 = 0x4662
    MediaGaugeA99 = 0x4663
    MediaGaugeA100 = 0x4664
    MediaGaugeA101 = 0x4665
    MediaGaugeA102 = 0x4666
    MediaGaugeA103 = 0x4667
    MediaGaugeA104 = 0x4668
    MediaGaugeA105 = 0x4669
    MediaGaugeA106 = 0x466A
    MediaGaugeA107 = 0x466B
    MediaGaugeA108 = 0x466C
    MediaGaugeA109 = 0x466D
    MediaGaugeA110 = 0x466E
    MediaGaugeA111 = 0x466F
    MediaGaugeA112 = 0x4670
    MediaGaugeA113 = 0x4671
    MediaGaugeA114 = 0x4672
    MediaGaugeA115 = 0x4673
    MediaGaugeA116 = 0x4674
    MediaGaugeA117 = 0x4675
    MediaGaugeA118 = 0x4676
    MediaGaugeA119 = 0x4677
    MediaGaugeA120 = 0x4678
    MediaGaugeA121 = 0x4679
    MediaGaugeA122 = 0x467A
    MediaGaugeA123 = 0x467B
    MediaGaugeA124 = 0x467C
    MediaGaugeA125 = 0x467D
    MediaGaugeA126 = 0x467E
    MediaGaugeA127 = 0x467F
    MediaGaugeA128 = 0x4680
    MediaGaugeA129 = 0x4681
    MediaGaugeA130 = 0x4682
    MediaGaugeA131 = 0x4683
    MediaGaugeA132 = 0x4684
    MediaGaugeA133 = 0x4685
    MediaGaugeA134 = 0x4686
    MediaGaugeA135 = 0x4687
    MediaGaugeA136 = 0x4688
    MediaGaugeA137 = 0x4689
    MediaGaugeA138 = 0x468A
    MediaGaugeA139 = 0x468B
    MediaGaugeA140 = 0x468C
    MediaGaugeA141 = 0x468D
    MediaGaugeA142 = 0x468E
    MediaGaugeA143 = 0x468F
    MediaGaugeA144 = 0x4690
    MediaGaugeA145 = 0x4691
    MediaGaugeA146 = 0x4692
    MediaGaugeA147 = 0x4693
    MediaGaugeA148 = 0x4694
    MediaGaugeA149 = 0x4695
    MediaGaugeA150 = 0x4696
    MediaGaugeA151 = 0x4697
    MediaGaugeA152 = 0x4698
    MediaGaugeA153 = 0x4699
    MediaGaugeA154 = 0x469A
    MediaGaugeA155 = 0x469B
    MediaGaugeA156 = 0x469C
    MediaGaugeA157 = 0x469D
    MediaGaugeA158 = 0x469E
    MediaGaugeA159 = 0x469F
    MediaGaugeA160 = 0x46A0
    MediaGaugeA161 = 0x46A1
    MediaGaugeA162 = 0x46A2
    MediaGaugeA163 = 0x46A3
    MediaGaugeA164 = 0x46A4
    MediaGaugeA165 = 0x46A5
    MediaGaugeA166 = 0x46A6
    MediaGaugeA167 = 0x46A7
    MediaGaugeA168 = 0x46A8
    MediaGaugeA169 = 0x46A9
    MediaGaugeA170 = 0x46AA
    MediaGaugeA171 = 0x46AB
    MediaGaugeA172 = 0x46AC
    MediaGaugeA173 = 0x46AD
    MediaGaugeA174 = 0x46AE
    MediaGaugeA175 = 0x46AF
    MediaGaugeA176 = 0x46B0
    MediaGaugeA177 = 0x46B1
    MediaGaugeA178 = 0x46B2
    MediaGaugeA179 = 0x46B3
    MediaGaugeA180 = 0x46B4
    MediaGaugeA181 = 0x46B5
    MediaGaugeA182 = 0x46B6
    MediaGaugeA183 = 0x46B7
    MediaGaugeA184 = 0x46B8
    MediaGaugeA185 = 0x46B9
    MediaGaugeA186 = 0x46BA
    MediaGaugeA187 = 0x46BB
    MediaGaugeA188 = 0x46BC
    MediaGaugeA189 = 0x46BD
    MediaGaugeA190 = 0x46BE
    MediaGaugeA191 = 0x46BF
    MediaGaugeA192 = 0x46C0
    MediaGaugeA193 = 0x46C1
    MediaGaugeA194 = 0x46C2
    MediaGaugeA195 = 0x46C3
    MediaGaugeA196 = 0x46C4
    MediaGaugeA197 = 0x46C5
    MediaGaugeA198 = 0x46C6
    MediaGaugeA199 = 0x46C7
    MediaGaugeA200 = 0x46C8
    MediaGaugeA201 = 0x46C9
    MediaGaugeA202 = 0x46CA
    MediaGaugeA203 = 0x46CB
    MediaGaugeA204 = 0x46CC
    MediaGaugeA205 = 0x46CD
    MediaGaugeA206 = 0x46CE
    MediaGaugeA207 = 0x46CF
    MediaGaugeA208 = 0x46D0
    MediaGaugeA209 = 0x46D1
    MediaGaugeA210 = 0x46D2
    MediaGaugeA211 = 0x46D3
    MediaGaugeA212 = 0x46D4
    MediaGaugeA213 = 0x46D5
    MediaGaugeA214 = 0x46D6
    MediaGaugeA215 = 0x46D7
    MediaGaugeA216 = 0x46D8
    MediaGaugeA217 = 0x46D9
    MediaGaugeA218 = 0x46DA
    MediaGaugeA219 = 0x46DB
    MediaGaugeA220 = 0x46DC
    MediaGaugeA221 = 0x46DD
    MediaGaugeA222 = 0x46DE
    MediaGaugeA223 = 0x46DF
    MediaGaugeA224 = 0x46E0
    MediaGaugeA225 = 0x46E1
    MediaGaugeA226 = 0x46E2
    MediaGaugeA227 = 0x46E3
    MediaGaugeA228 = 0x46E4
    MediaGaugeA229 = 0x46E5
    MediaGaugeA230 = 0x46E6
    MediaGaugeA231 = 0x46E7
    MediaGaugeA232 = 0x46E8
    MediaGaugeA233 = 0x46E9
    MediaGaugeA234 = 0x46EA
    MediaGaugeA235 = 0x46EB
    MediaGaugeA236 = 0x46EC
    MediaGaugeA237 = 0x46ED
    MediaGaugeA238 = 0x46EE
    MediaGaugeA239 = 0x46EF
    MediaGaugeA240 = 0x46F0
    MediaGaugeA241 = 0x46F1
    MediaGaugeA242 = 0x46F2
    MediaGaugeA243 = 0x46F3
    MediaGaugeA244 = 0x46F4
    MediaGaugeA245 = 0x46F5
    MediaGaugeA246 = 0x46F6
    MediaGaugeA247 = 0x46F7
    MediaGaugeA248 = 0x46F8
    MediaGaugeA249 = 0x46F9
    MediaGaugeA250 = 0x46FA
    MediaGaugeA251 = 0x46FB
    MediaGaugeA252 = 0x46FC
    MediaGaugeA253 = 0x46FD
    MediaGaugeA254 = 0x46FE
    MediaGaugeA255 = 0x46FF
    # MediaGaugeB List
    MediaGaugeB0 = 0x4700
    MediaGaugeB1 = 0x4701
    MediaGaugeB2 = 0x4702
    MediaGaugeB3 = 0x4703
    MediaGaugeB4 = 0x4704
    MediaGaugeB5 = 0x4705
    MediaGaugeB6 = 0x4706
    MediaGaugeB7 = 0x4707
    MediaGaugeB8 = 0x4708
    MediaGaugeB9 = 0x4709
    MediaGaugeB10 = 0x470A
    MediaGaugeB11 = 0x470B
    MediaGaugeB12 = 0x470C
    MediaGaugeB13 = 0x470D
    MediaGaugeB14 = 0x470E
    MediaGaugeB15 = 0x470F
    MediaGaugeB16 = 0x4710
    MediaGaugeB17 = 0x4711
    MediaGaugeB18 = 0x4712
    MediaGaugeB19 = 0x4713
    MediaGaugeB20 = 0x4714
    MediaGaugeB21 = 0x4715
    MediaGaugeB22 = 0x4716
    MediaGaugeB23 = 0x4717
    MediaGaugeB24 = 0x4718
    MediaGaugeB25 = 0x4719
    MediaGaugeB26 = 0x471A
    MediaGaugeB27 = 0x471B
    MediaGaugeB28 = 0x471C
    MediaGaugeB29 = 0x471D
    MediaGaugeB30 = 0x471E
    MediaGaugeB31 = 0x471F
    MediaGaugeB32 = 0x4720
    MediaGaugeB33 = 0x4721
    MediaGaugeB34 = 0x4722
    MediaGaugeB35 = 0x4723
    MediaGaugeB36 = 0x4724
    MediaGaugeB37 = 0x4725
    MediaGaugeB38 = 0x4726
    MediaGaugeB39 = 0x4727
    MediaGaugeB40 = 0x4728
    MediaGaugeB41 = 0x4729
    MediaGaugeB42 = 0x472A
    MediaGaugeB43 = 0x472B
    MediaGaugeB44 = 0x472C
    MediaGaugeB45 = 0x472D
    MediaGaugeB46 = 0x472E
    MediaGaugeB47 = 0x472F
    MediaGaugeB48 = 0x4730
    MediaGaugeB49 = 0x4731
    MediaGaugeB50 = 0x4732
    MediaGaugeB51 = 0x4733
    MediaGaugeB52 = 0x4734
    MediaGaugeB53 = 0x4735
    MediaGaugeB54 = 0x4736
    MediaGaugeB55 = 0x4737
    MediaGaugeB56 = 0x4738
    MediaGaugeB57 = 0x4739
    MediaGaugeB58 = 0x473A
    MediaGaugeB59 = 0x473B
    MediaGaugeB60 = 0x473C
    MediaGaugeB61 = 0x473D
    MediaGaugeB62 = 0x473E
    MediaGaugeB63 = 0x473F
    MediaGaugeB64 = 0x4740
    MediaGaugeB65 = 0x4741
    MediaGaugeB66 = 0x4742
    MediaGaugeB67 = 0x4743
    MediaGaugeB68 = 0x4744
    MediaGaugeB69 = 0x4745
    MediaGaugeB70 = 0x4746
    MediaGaugeB71 = 0x4747
    MediaGaugeB72 = 0x4748
    MediaGaugeB73 = 0x4749
    MediaGaugeB74 = 0x474A
    MediaGaugeB75 = 0x474B
    MediaGaugeB76 = 0x474C
    MediaGaugeB77 = 0x474D
    MediaGaugeB78 = 0x474E
    MediaGaugeB79 = 0x474F
    MediaGaugeB80 = 0x4750
    MediaGaugeB81 = 0x4751
    MediaGaugeB82 = 0x4752
    MediaGaugeB83 = 0x4753
    MediaGaugeB84 = 0x4754
    MediaGaugeB85 = 0x4755
    MediaGaugeB86 = 0x4756
    MediaGaugeB87 = 0x4757
    MediaGaugeB88 = 0x4758
    MediaGaugeB89 = 0x4759
    MediaGaugeB90 = 0x475A
    MediaGaugeB91 = 0x475B
    MediaGaugeB92 = 0x475C
    MediaGaugeB93 = 0x475D
    MediaGaugeB94 = 0x475E
    MediaGaugeB95 = 0x475F
    MediaGaugeB96 = 0x4760
    MediaGaugeB97 = 0x4761
    MediaGaugeB98 = 0x4762
    MediaGaugeB99 = 0x4763
    MediaGaugeB100 = 0x4764
    MediaGaugeB101 = 0x4765
    MediaGaugeB102 = 0x4766
    MediaGaugeB103 = 0x4767
    MediaGaugeB104 = 0x4768
    MediaGaugeB105 = 0x4769
    MediaGaugeB106 = 0x476A
    MediaGaugeB107 = 0x476B
    MediaGaugeB108 = 0x476C
    MediaGaugeB109 = 0x476D
    MediaGaugeB110 = 0x476E
    MediaGaugeB111 = 0x476F
    MediaGaugeB112 = 0x4770
    MediaGaugeB113 = 0x4771
    MediaGaugeB114 = 0x4772
    MediaGaugeB115 = 0x4773
    MediaGaugeB116 = 0x4774
    MediaGaugeB117 = 0x4775
    MediaGaugeB118 = 0x4776
    MediaGaugeB119 = 0x4777
    MediaGaugeB120 = 0x4778
    MediaGaugeB121 = 0x4779
    MediaGaugeB122 = 0x477A
    MediaGaugeB123 = 0x477B
    MediaGaugeB124 = 0x477C
    MediaGaugeB125 = 0x477D
    MediaGaugeB126 = 0x477E
    MediaGaugeB127 = 0x477F
    MediaGaugeB128 = 0x4780
    MediaGaugeB129 = 0x4781
    MediaGaugeB130 = 0x4782
    MediaGaugeB131 = 0x4783
    MediaGaugeB132 = 0x4784
    MediaGaugeB133 = 0x4785
    MediaGaugeB134 = 0x4786
    MediaGaugeB135 = 0x4787
    MediaGaugeB136 = 0x4788
    MediaGaugeB137 = 0x4789
    MediaGaugeB138 = 0x478A
    MediaGaugeB139 = 0x478B
    MediaGaugeB140 = 0x478C
    MediaGaugeB141 = 0x478D
    MediaGaugeB142 = 0x478E
    MediaGaugeB143 = 0x478F
    MediaGaugeB144 = 0x4790
    MediaGaugeB145 = 0x4791
    MediaGaugeB146 = 0x4792
    MediaGaugeB147 = 0x4793
    MediaGaugeB148 = 0x4794
    MediaGaugeB149 = 0x4795
    MediaGaugeB150 = 0x4796
    MediaGaugeB151 = 0x4797
    MediaGaugeB152 = 0x4798
    MediaGaugeB153 = 0x4799
    MediaGaugeB154 = 0x479A
    MediaGaugeB155 = 0x479B
    MediaGaugeB156 = 0x479C
    MediaGaugeB157 = 0x479D
    MediaGaugeB158 = 0x479E
    MediaGaugeB159 = 0x479F
    MediaGaugeB160 = 0x47A0
    MediaGaugeB161 = 0x47A1
    MediaGaugeB162 = 0x47A2
    MediaGaugeB163 = 0x47A3
    MediaGaugeB164 = 0x47A4
    MediaGaugeB165 = 0x47A5
    MediaGaugeB166 = 0x47A6
    MediaGaugeB167 = 0x47A7
    MediaGaugeB168 = 0x47A8
    MediaGaugeB169 = 0x47A9
    MediaGaugeB170 = 0x47AA
    MediaGaugeB171 = 0x47AB
    MediaGaugeB172 = 0x47AC
    MediaGaugeB173 = 0x47AD
    MediaGaugeB174 = 0x47AE
    MediaGaugeB175 = 0x47AF
    MediaGaugeB176 = 0x47B0
    MediaGaugeB177 = 0x47B1
    MediaGaugeB178 = 0x47B2
    MediaGaugeB179 = 0x47B3
    MediaGaugeB180 = 0x47B4
    MediaGaugeB181 = 0x47B5
    MediaGaugeB182 = 0x47B6
    MediaGaugeB183 = 0x47B7
    MediaGaugeB184 = 0x47B8
    MediaGaugeB185 = 0x47B9
    MediaGaugeB186 = 0x47BA
    MediaGaugeB187 = 0x47BB
    MediaGaugeB188 = 0x47BC
    MediaGaugeB189 = 0x47BD
    MediaGaugeB190 = 0x47BE
    MediaGaugeB191 = 0x47BF
    MediaGaugeB192 = 0x47C0
    MediaGaugeB193 = 0x47C1
    MediaGaugeB194 = 0x47C2
    MediaGaugeB195 = 0x47C3
    MediaGaugeB196 = 0x47C4
    MediaGaugeB197 = 0x47C5
    MediaGaugeB198 = 0x47C6
    MediaGaugeB199 = 0x47C7
    MediaGaugeB200 = 0x47C8
    MediaGaugeB201 = 0x47C9
    MediaGaugeB202 = 0x47CA
    MediaGaugeB203 = 0x47CB
    MediaGaugeB204 = 0x47CC
    MediaGaugeB205 = 0x47CD
    MediaGaugeB206 = 0x47CE
    MediaGaugeB207 = 0x47CF
    MediaGaugeB208 = 0x47D0
    MediaGaugeB209 = 0x47D1
    MediaGaugeB210 = 0x47D2
    MediaGaugeB211 = 0x47D3
    MediaGaugeB212 = 0x47D4
    MediaGaugeB213 = 0x47D5
    MediaGaugeB214 = 0x47D6
    MediaGaugeB215 = 0x47D7
    MediaGaugeB216 = 0x47D8
    MediaGaugeB217 = 0x47D9
    MediaGaugeB218 = 0x47DA
    MediaGaugeB219 = 0x47DB
    MediaGaugeB220 = 0x47DC
    MediaGaugeB221 = 0x47DD
    MediaGaugeB222 = 0x47DE
    MediaGaugeB223 = 0x47DF
    MediaGaugeB224 = 0x47E0
    MediaGaugeB225 = 0x47E1
    MediaGaugeB226 = 0x47E2
    MediaGaugeB227 = 0x47E3
    MediaGaugeB228 = 0x47E4
    MediaGaugeB229 = 0x47E5
    MediaGaugeB230 = 0x47E6
    MediaGaugeB231 = 0x47E7
    MediaGaugeB232 = 0x47E8
    MediaGaugeB233 = 0x47E9
    MediaGaugeB234 = 0x47EA
    MediaGaugeB235 = 0x47EB
    MediaGaugeB236 = 0x47EC
    MediaGaugeB237 = 0x47ED
    MediaGaugeB238 = 0x47EE
    MediaGaugeB239 = 0x47EF
    MediaGaugeB240 = 0x47F0
    MediaGaugeB241 = 0x47F1
    MediaGaugeB242 = 0x47F2
    MediaGaugeB243 = 0x47F3
    MediaGaugeB244 = 0x47F4
    MediaGaugeB245 = 0x47F5
    MediaGaugeB246 = 0x47F6
    MediaGaugeB247 = 0x47F7
    MediaGaugeB248 = 0x47F8
    MediaGaugeB249 = 0x47F9
    MediaGaugeB250 = 0x47FA
    MediaGaugeB251 = 0x47FB
    MediaGaugeB252 = 0x47FC
    MediaGaugeB253 = 0x47FD
    MediaGaugeB254 = 0x47FE
    MediaGaugeB255 = 0x47FF
    # MediaGaugeC List
    MediaGaugeC0 = 0x4800
    MediaGaugeC1 = 0x4801
    MediaGaugeC2 = 0x4802
    MediaGaugeC3 = 0x4803
    MediaGaugeC4 = 0x4804
    MediaGaugeC5 = 0x4805
    MediaGaugeC6 = 0x4806
    MediaGaugeC7 = 0x4807
    MediaGaugeC8 = 0x4808
    MediaGaugeC9 = 0x4809
    MediaGaugeC10 = 0x480A
    MediaGaugeC11 = 0x480B
    MediaGaugeC12 = 0x480C
    MediaGaugeC13 = 0x480D
    MediaGaugeC14 = 0x480E
    MediaGaugeC15 = 0x480F
    MediaGaugeC16 = 0x4810
    MediaGaugeC17 = 0x4811
    MediaGaugeC18 = 0x4812
    MediaGaugeC19 = 0x4813
    MediaGaugeC20 = 0x4814
    MediaGaugeC21 = 0x4815
    MediaGaugeC22 = 0x4816
    MediaGaugeC23 = 0x4817
    MediaGaugeC24 = 0x4818
    MediaGaugeC25 = 0x4819
    MediaGaugeC26 = 0x481A
    MediaGaugeC27 = 0x481B
    MediaGaugeC28 = 0x481C
    MediaGaugeC29 = 0x481D
    MediaGaugeC30 = 0x481E
    MediaGaugeC31 = 0x481F
    MediaGaugeC32 = 0x4820
    MediaGaugeC33 = 0x4821
    MediaGaugeC34 = 0x4822
    MediaGaugeC35 = 0x4823
    MediaGaugeC36 = 0x4824
    MediaGaugeC37 = 0x4825
    MediaGaugeC38 = 0x4826
    MediaGaugeC39 = 0x4827
    MediaGaugeC40 = 0x4828
    MediaGaugeC41 = 0x4829
    MediaGaugeC42 = 0x482A
    MediaGaugeC43 = 0x482B
    MediaGaugeC44 = 0x482C
    MediaGaugeC45 = 0x482D
    MediaGaugeC46 = 0x482E
    MediaGaugeC47 = 0x482F
    MediaGaugeC48 = 0x4830
    MediaGaugeC49 = 0x4831
    MediaGaugeC50 = 0x4832
    MediaGaugeC51 = 0x4833
    MediaGaugeC52 = 0x4834
    MediaGaugeC53 = 0x4835
    MediaGaugeC54 = 0x4836
    MediaGaugeC55 = 0x4837
    MediaGaugeC56 = 0x4838
    MediaGaugeC57 = 0x4839
    MediaGaugeC58 = 0x483A
    MediaGaugeC59 = 0x483B
    MediaGaugeC60 = 0x483C
    MediaGaugeC61 = 0x483D
    MediaGaugeC62 = 0x483E
    MediaGaugeC63 = 0x483F
    MediaGaugeC64 = 0x4840
    MediaGaugeC65 = 0x4841
    MediaGaugeC66 = 0x4842
    MediaGaugeC67 = 0x4843
    MediaGaugeC68 = 0x4844
    MediaGaugeC69 = 0x4845
    MediaGaugeC70 = 0x4846
    MediaGaugeC71 = 0x4847
    MediaGaugeC72 = 0x4848
    MediaGaugeC73 = 0x4849
    MediaGaugeC74 = 0x484A
    MediaGaugeC75 = 0x484B
    MediaGaugeC76 = 0x484C
    MediaGaugeC77 = 0x484D
    MediaGaugeC78 = 0x484E
    MediaGaugeC79 = 0x484F
    MediaGaugeC80 = 0x4850
    MediaGaugeC81 = 0x4851
    MediaGaugeC82 = 0x4852
    MediaGaugeC83 = 0x4853
    MediaGaugeC84 = 0x4854
    MediaGaugeC85 = 0x4855
    MediaGaugeC86 = 0x4856
    MediaGaugeC87 = 0x4857
    MediaGaugeC88 = 0x4858
    MediaGaugeC89 = 0x4859
    MediaGaugeC90 = 0x485A
    MediaGaugeC91 = 0x485B
    MediaGaugeC92 = 0x485C
    MediaGaugeC93 = 0x485D
    MediaGaugeC94 = 0x485E
    MediaGaugeC95 = 0x485F
    MediaGaugeC96 = 0x4860
    MediaGaugeC97 = 0x4861
    MediaGaugeC98 = 0x4862
    MediaGaugeC99 = 0x4863
    MediaGaugeC100 = 0x4864
    MediaGaugeC101 = 0x4865
    MediaGaugeC102 = 0x4866
    MediaGaugeC103 = 0x4867
    MediaGaugeC104 = 0x4868
    MediaGaugeC105 = 0x4869
    MediaGaugeC106 = 0x486A
    MediaGaugeC107 = 0x486B
    MediaGaugeC108 = 0x486C
    MediaGaugeC109 = 0x486D
    MediaGaugeC110 = 0x486E
    MediaGaugeC111 = 0x486F
    MediaGaugeC112 = 0x4870
    MediaGaugeC113 = 0x4871
    MediaGaugeC114 = 0x4872
    MediaGaugeC115 = 0x4873
    MediaGaugeC116 = 0x4874
    MediaGaugeC117 = 0x4875
    MediaGaugeC118 = 0x4876
    MediaGaugeC119 = 0x4877
    MediaGaugeC120 = 0x4878
    MediaGaugeC121 = 0x4879
    MediaGaugeC122 = 0x487A
    MediaGaugeC123 = 0x487B
    MediaGaugeC124 = 0x487C
    MediaGaugeC125 = 0x487D
    MediaGaugeC126 = 0x487E
    MediaGaugeC127 = 0x487F
    MediaGaugeC128 = 0x4880
    MediaGaugeC129 = 0x4881
    MediaGaugeC130 = 0x4882
    MediaGaugeC131 = 0x4883
    MediaGaugeC132 = 0x4884
    MediaGaugeC133 = 0x4885
    MediaGaugeC134 = 0x4886
    MediaGaugeC135 = 0x4887
    MediaGaugeC136 = 0x4888
    MediaGaugeC137 = 0x4889
    MediaGaugeC138 = 0x488A
    MediaGaugeC139 = 0x488B
    MediaGaugeC140 = 0x488C
    MediaGaugeC141 = 0x488D
    MediaGaugeC142 = 0x488E
    MediaGaugeC143 = 0x488F
    MediaGaugeC144 = 0x4890
    MediaGaugeC145 = 0x4891
    MediaGaugeC146 = 0x4892
    MediaGaugeC147 = 0x4893
    MediaGaugeC148 = 0x4894
    MediaGaugeC149 = 0x4895
    MediaGaugeC150 = 0x4896
    MediaGaugeC151 = 0x4897
    MediaGaugeC152 = 0x4898
    MediaGaugeC153 = 0x4899
    MediaGaugeC154 = 0x489A
    MediaGaugeC155 = 0x489B
    MediaGaugeC156 = 0x489C
    MediaGaugeC157 = 0x489D
    MediaGaugeC158 = 0x489E
    MediaGaugeC159 = 0x489F
    MediaGaugeC160 = 0x48A0
    MediaGaugeC161 = 0x48A1
    MediaGaugeC162 = 0x48A2
    MediaGaugeC163 = 0x48A3
    MediaGaugeC164 = 0x48A4
    MediaGaugeC165 = 0x48A5
    MediaGaugeC166 = 0x48A6
    MediaGaugeC167 = 0x48A7
    MediaGaugeC168 = 0x48A8
    MediaGaugeC169 = 0x48A9
    MediaGaugeC170 = 0x48AA
    MediaGaugeC171 = 0x48AB
    MediaGaugeC172 = 0x48AC
    MediaGaugeC173 = 0x48AD
    MediaGaugeC174 = 0x48AE
    MediaGaugeC175 = 0x48AF
    MediaGaugeC176 = 0x48B0
    MediaGaugeC177 = 0x48B1
    MediaGaugeC178 = 0x48B2
    MediaGaugeC179 = 0x48B3
    MediaGaugeC180 = 0x48B4
    MediaGaugeC181 = 0x48B5
    MediaGaugeC182 = 0x48B6
    MediaGaugeC183 = 0x48B7
    MediaGaugeC184 = 0x48B8
    MediaGaugeC185 = 0x48B9
    MediaGaugeC186 = 0x48BA
    MediaGaugeC187 = 0x48BB
    MediaGaugeC188 = 0x48BC
    MediaGaugeC189 = 0x48BD
    MediaGaugeC190 = 0x48BE
    MediaGaugeC191 = 0x48BF
    MediaGaugeC192 = 0x48C0
    MediaGaugeC193 = 0x48C1
    MediaGaugeC194 = 0x48C2
    MediaGaugeC195 = 0x48C3
    MediaGaugeC196 = 0x48C4
    MediaGaugeC197 = 0x48C5
    MediaGaugeC198 = 0x48C6
    MediaGaugeC199 = 0x48C7
    MediaGaugeC200 = 0x48C8
    MediaGaugeC201 = 0x48C9
    MediaGaugeC202 = 0x48CA
    MediaGaugeC203 = 0x48CB
    MediaGaugeC204 = 0x48CC
    MediaGaugeC205 = 0x48CD
    MediaGaugeC206 = 0x48CE
    MediaGaugeC207 = 0x48CF
    MediaGaugeC208 = 0x48D0
    MediaGaugeC209 = 0x48D1
    MediaGaugeC210 = 0x48D2
    MediaGaugeC211 = 0x48D3
    MediaGaugeC212 = 0x48D4
    MediaGaugeC213 = 0x48D5
    MediaGaugeC214 = 0x48D6
    MediaGaugeC215 = 0x48D7
    MediaGaugeC216 = 0x48D8
    MediaGaugeC217 = 0x48D9
    MediaGaugeC218 = 0x48DA
    MediaGaugeC219 = 0x48DB
    MediaGaugeC220 = 0x48DC
    MediaGaugeC221 = 0x48DD
    MediaGaugeC222 = 0x48DE
    MediaGaugeC223 = 0x48DF
    MediaGaugeC224 = 0x48E0
    MediaGaugeC225 = 0x48E1
    MediaGaugeC226 = 0x48E2
    MediaGaugeC227 = 0x48E3
    MediaGaugeC228 = 0x48E4
    MediaGaugeC229 = 0x48E5
    MediaGaugeC230 = 0x48E6
    MediaGaugeC231 = 0x48E7
    MediaGaugeC232 = 0x48E8
    MediaGaugeC233 = 0x48E9
    MediaGaugeC234 = 0x48EA
    MediaGaugeC235 = 0x48EB
    MediaGaugeC236 = 0x48EC
    MediaGaugeC237 = 0x48ED
    MediaGaugeC238 = 0x48EE
    MediaGaugeC239 = 0x48EF
    MediaGaugeC240 = 0x48F0
    MediaGaugeC241 = 0x48F1
    MediaGaugeC242 = 0x48F2
    MediaGaugeC243 = 0x48F3
    MediaGaugeC244 = 0x48F4
    MediaGaugeC245 = 0x48F5
    MediaGaugeC246 = 0x48F6
    MediaGaugeC247 = 0x48F7
    MediaGaugeC248 = 0x48F8
    MediaGaugeC249 = 0x48F9
    MediaGaugeC250 = 0x48FA
    MediaGaugeC251 = 0x48FB
    MediaGaugeC252 = 0x48FC
    MediaGaugeC253 = 0x48FD
    MediaGaugeC254 = 0x48FE
    MediaGaugeC255 = 0x48FF
    # MediaGaugeD List
    MediaGaugeD0 = 0x4900
    MediaGaugeD1 = 0x4901
    MediaGaugeD2 = 0x4902
    MediaGaugeD3 = 0x4903
    MediaGaugeD4 = 0x4904
    MediaGaugeD5 = 0x4905
    MediaGaugeD6 = 0x4906
    MediaGaugeD7 = 0x4907
    MediaGaugeD8 = 0x4908
    MediaGaugeD9 = 0x4909
    MediaGaugeD10 = 0x490A
    MediaGaugeD11 = 0x490B
    MediaGaugeD12 = 0x490C
    MediaGaugeD13 = 0x490D
    MediaGaugeD14 = 0x490E
    MediaGaugeD15 = 0x490F
    MediaGaugeD16 = 0x4910
    MediaGaugeD17 = 0x4911
    MediaGaugeD18 = 0x4912
    MediaGaugeD19 = 0x4913
    MediaGaugeD20 = 0x4914
    MediaGaugeD21 = 0x4915
    MediaGaugeD22 = 0x4916
    MediaGaugeD23 = 0x4917
    MediaGaugeD24 = 0x4918
    MediaGaugeD25 = 0x4919
    MediaGaugeD26 = 0x491A
    MediaGaugeD27 = 0x491B
    MediaGaugeD28 = 0x491C
    MediaGaugeD29 = 0x491D
    MediaGaugeD30 = 0x491E
    MediaGaugeD31 = 0x491F
    MediaGaugeD32 = 0x4920
    MediaGaugeD33 = 0x4921
    MediaGaugeD34 = 0x4922
    MediaGaugeD35 = 0x4923
    MediaGaugeD36 = 0x4924
    MediaGaugeD37 = 0x4925
    MediaGaugeD38 = 0x4926
    MediaGaugeD39 = 0x4927
    MediaGaugeD40 = 0x4928
    MediaGaugeD41 = 0x4929
    MediaGaugeD42 = 0x492A
    MediaGaugeD43 = 0x492B
    MediaGaugeD44 = 0x492C
    MediaGaugeD45 = 0x492D
    MediaGaugeD46 = 0x492E
    MediaGaugeD47 = 0x492F
    MediaGaugeD48 = 0x4930
    MediaGaugeD49 = 0x4931
    MediaGaugeD50 = 0x4932
    MediaGaugeD51 = 0x4933
    MediaGaugeD52 = 0x4934
    MediaGaugeD53 = 0x4935
    MediaGaugeD54 = 0x4936
    MediaGaugeD55 = 0x4937
    MediaGaugeD56 = 0x4938
    MediaGaugeD57 = 0x4939
    MediaGaugeD58 = 0x493A
    MediaGaugeD59 = 0x493B
    MediaGaugeD60 = 0x493C
    MediaGaugeD61 = 0x493D
    MediaGaugeD62 = 0x493E
    MediaGaugeD63 = 0x493F
    MediaGaugeD64 = 0x4940
    MediaGaugeD65 = 0x4941
    MediaGaugeD66 = 0x4942
    MediaGaugeD67 = 0x4943
    MediaGaugeD68 = 0x4944
    MediaGaugeD69 = 0x4945
    MediaGaugeD70 = 0x4946
    MediaGaugeD71 = 0x4947
    MediaGaugeD72 = 0x4948
    MediaGaugeD73 = 0x4949
    MediaGaugeD74 = 0x494A
    MediaGaugeD75 = 0x494B
    MediaGaugeD76 = 0x494C
    MediaGaugeD77 = 0x494D
    MediaGaugeD78 = 0x494E
    MediaGaugeD79 = 0x494F
    MediaGaugeD80 = 0x4950
    MediaGaugeD81 = 0x4951
    MediaGaugeD82 = 0x4952
    MediaGaugeD83 = 0x4953
    MediaGaugeD84 = 0x4954
    MediaGaugeD85 = 0x4955
    MediaGaugeD86 = 0x4956
    MediaGaugeD87 = 0x4957
    MediaGaugeD88 = 0x4958
    MediaGaugeD89 = 0x4959
    MediaGaugeD90 = 0x495A
    MediaGaugeD91 = 0x495B
    MediaGaugeD92 = 0x495C
    MediaGaugeD93 = 0x495D
    MediaGaugeD94 = 0x495E
    MediaGaugeD95 = 0x495F
    MediaGaugeD96 = 0x4960
    MediaGaugeD97 = 0x4961
    MediaGaugeD98 = 0x4962
    MediaGaugeD99 = 0x4963
    MediaGaugeD100 = 0x4964
    MediaGaugeD101 = 0x4965
    MediaGaugeD102 = 0x4966
    MediaGaugeD103 = 0x4967
    MediaGaugeD104 = 0x4968
    MediaGaugeD105 = 0x4969
    MediaGaugeD106 = 0x496A
    MediaGaugeD107 = 0x496B
    MediaGaugeD108 = 0x496C
    MediaGaugeD109 = 0x496D
    MediaGaugeD110 = 0x496E
    MediaGaugeD111 = 0x496F
    MediaGaugeD112 = 0x4970
    MediaGaugeD113 = 0x4971
    MediaGaugeD114 = 0x4972
    MediaGaugeD115 = 0x4973
    MediaGaugeD116 = 0x4974
    MediaGaugeD117 = 0x4975
    MediaGaugeD118 = 0x4976
    MediaGaugeD119 = 0x4977
    MediaGaugeD120 = 0x4978
    MediaGaugeD121 = 0x4979
    MediaGaugeD122 = 0x497A
    MediaGaugeD123 = 0x497B
    MediaGaugeD124 = 0x497C
    MediaGaugeD125 = 0x497D
    MediaGaugeD126 = 0x497E
    MediaGaugeD127 = 0x497F
    MediaGaugeD128 = 0x4980
    MediaGaugeD129 = 0x4981
    MediaGaugeD130 = 0x4982
    MediaGaugeD131 = 0x4983
    MediaGaugeD132 = 0x4984
    MediaGaugeD133 = 0x4985
    MediaGaugeD134 = 0x4986
    MediaGaugeD135 = 0x4987
    MediaGaugeD136 = 0x4988
    MediaGaugeD137 = 0x4989
    MediaGaugeD138 = 0x498A
    MediaGaugeD139 = 0x498B
    MediaGaugeD140 = 0x498C
    MediaGaugeD141 = 0x498D
    MediaGaugeD142 = 0x498E
    MediaGaugeD143 = 0x498F
    MediaGaugeD144 = 0x4990
    MediaGaugeD145 = 0x4991
    MediaGaugeD146 = 0x4992
    MediaGaugeD147 = 0x4993
    MediaGaugeD148 = 0x4994
    MediaGaugeD149 = 0x4995
    MediaGaugeD150 = 0x4996
    MediaGaugeD151 = 0x4997
    MediaGaugeD152 = 0x4998
    MediaGaugeD153 = 0x4999
    MediaGaugeD154 = 0x499A
    MediaGaugeD155 = 0x499B
    MediaGaugeD156 = 0x499C
    MediaGaugeD157 = 0x499D
    MediaGaugeD158 = 0x499E
    MediaGaugeD159 = 0x499F
    MediaGaugeD160 = 0x49A0
    MediaGaugeD161 = 0x49A1
    MediaGaugeD162 = 0x49A2
    MediaGaugeD163 = 0x49A3
    MediaGaugeD164 = 0x49A4
    MediaGaugeD165 = 0x49A5
    MediaGaugeD166 = 0x49A6
    MediaGaugeD167 = 0x49A7
    MediaGaugeD168 = 0x49A8
    MediaGaugeD169 = 0x49A9
    MediaGaugeD170 = 0x49AA
    MediaGaugeD171 = 0x49AB
    MediaGaugeD172 = 0x49AC
    MediaGaugeD173 = 0x49AD
    MediaGaugeD174 = 0x49AE
    MediaGaugeD175 = 0x49AF
    MediaGaugeD176 = 0x49B0
    MediaGaugeD177 = 0x49B1
    MediaGaugeD178 = 0x49B2
    MediaGaugeD179 = 0x49B3
    MediaGaugeD180 = 0x49B4
    MediaGaugeD181 = 0x49B5
    MediaGaugeD182 = 0x49B6
    MediaGaugeD183 = 0x49B7
    MediaGaugeD184 = 0x49B8
    MediaGaugeD185 = 0x49B9
    MediaGaugeD186 = 0x49BA
    MediaGaugeD187 = 0x49BB
    MediaGaugeD188 = 0x49BC
    MediaGaugeD189 = 0x49BD
    MediaGaugeD190 = 0x49BE
    MediaGaugeD191 = 0x49BF
    MediaGaugeD192 = 0x49C0
    MediaGaugeD193 = 0x49C1
    MediaGaugeD194 = 0x49C2
    MediaGaugeD195 = 0x49C3
    MediaGaugeD196 = 0x49C4
    MediaGaugeD197 = 0x49C5
    MediaGaugeD198 = 0x49C6
    MediaGaugeD199 = 0x49C7
    MediaGaugeD200 = 0x49C8
    MediaGaugeD201 = 0x49C9
    MediaGaugeD202 = 0x49CA
    MediaGaugeD203 = 0x49CB
    MediaGaugeD204 = 0x49CC
    MediaGaugeD205 = 0x49CD
    MediaGaugeD206 = 0x49CE
    MediaGaugeD207 = 0x49CF
    MediaGaugeD208 = 0x49D0
    MediaGaugeD209 = 0x49D1
    MediaGaugeD210 = 0x49D2
    MediaGaugeD211 = 0x49D3
    MediaGaugeD212 = 0x49D4
    MediaGaugeD213 = 0x49D5
    MediaGaugeD214 = 0x49D6
    MediaGaugeD215 = 0x49D7
    MediaGaugeD216 = 0x49D8
    MediaGaugeD217 = 0x49D9
    MediaGaugeD218 = 0x49DA
    MediaGaugeD219 = 0x49DB
    MediaGaugeD220 = 0x49DC
    MediaGaugeD221 = 0x49DD
    MediaGaugeD222 = 0x49DE
    MediaGaugeD223 = 0x49DF
    MediaGaugeD224 = 0x49E0
    MediaGaugeD225 = 0x49E1
    MediaGaugeD226 = 0x49E2
    MediaGaugeD227 = 0x49E3
    MediaGaugeD228 = 0x49E4
    MediaGaugeD229 = 0x49E5
    MediaGaugeD230 = 0x49E6
    MediaGaugeD231 = 0x49E7
    MediaGaugeD232 = 0x49E8
    MediaGaugeD233 = 0x49E9
    MediaGaugeD234 = 0x49EA
    MediaGaugeD235 = 0x49EB
    MediaGaugeD236 = 0x49EC
    MediaGaugeD237 = 0x49ED
    MediaGaugeD238 = 0x49EE
    MediaGaugeD239 = 0x49EF
    MediaGaugeD240 = 0x49F0
    MediaGaugeD241 = 0x49F1
    MediaGaugeD242 = 0x49F2
    MediaGaugeD243 = 0x49F3
    MediaGaugeD244 = 0x49F4
    MediaGaugeD245 = 0x49F5
    MediaGaugeD246 = 0x49F6
    MediaGaugeD247 = 0x49F7
    MediaGaugeD248 = 0x49F8
    MediaGaugeD249 = 0x49F9
    MediaGaugeD250 = 0x49FA
    MediaGaugeD251 = 0x49FB
    MediaGaugeD252 = 0x49FC
    MediaGaugeD253 = 0x49FD
    MediaGaugeD254 = 0x49FE
    MediaGaugeD255 = 0x49FF
    # MediaThermometer List
    MediaThermometer0 = 0x4A00
    MediaThermometer1 = 0x4A01
    MediaThermometer2 = 0x4A02
    MediaThermometer3 = 0x4A03
    MediaThermometer4 = 0x4A04
    MediaThermometer5 = 0x4A05
    MediaThermometer6 = 0x4A06
    MediaThermometer7 = 0x4A07
    MediaThermometer8 = 0x4A08
    MediaThermometer9 = 0x4A09
    MediaThermometer10 = 0x4A0A
    MediaThermometer11 = 0x4A0B
    MediaThermometer12 = 0x4A0C
    MediaThermometer13 = 0x4A0D
    MediaThermometer14 = 0x4A0E
    MediaThermometer15 = 0x4A0F
    MediaThermometer16 = 0x4A10
    MediaThermometer17 = 0x4A11
    MediaThermometer18 = 0x4A12
    MediaThermometer19 = 0x4A13
    MediaThermometer20 = 0x4A14
    MediaThermometer21 = 0x4A15
    MediaThermometer22 = 0x4A16
    MediaThermometer23 = 0x4A17
    MediaThermometer24 = 0x4A18
    MediaThermometer25 = 0x4A19
    MediaThermometer26 = 0x4A1A
    MediaThermometer27 = 0x4A1B
    MediaThermometer28 = 0x4A1C
    MediaThermometer29 = 0x4A1D
    MediaThermometer30 = 0x4A1E
    MediaThermometer31 = 0x4A1F
    MediaThermometer32 = 0x4A20
    MediaThermometer33 = 0x4A21
    MediaThermometer34 = 0x4A22
    MediaThermometer35 = 0x4A23
    MediaThermometer36 = 0x4A24
    MediaThermometer37 = 0x4A25
    MediaThermometer38 = 0x4A26
    MediaThermometer39 = 0x4A27
    MediaThermometer40 = 0x4A28
    MediaThermometer41 = 0x4A29
    MediaThermometer42 = 0x4A2A
    MediaThermometer43 = 0x4A2B
    MediaThermometer44 = 0x4A2C
    MediaThermometer45 = 0x4A2D
    MediaThermometer46 = 0x4A2E
    MediaThermometer47 = 0x4A2F
    MediaThermometer48 = 0x4A30
    MediaThermometer49 = 0x4A31
    MediaThermometer50 = 0x4A32
    MediaThermometer51 = 0x4A33
    MediaThermometer52 = 0x4A34
    MediaThermometer53 = 0x4A35
    MediaThermometer54 = 0x4A36
    MediaThermometer55 = 0x4A37
    MediaThermometer56 = 0x4A38
    MediaThermometer57 = 0x4A39
    MediaThermometer58 = 0x4A3A
    MediaThermometer59 = 0x4A3B
    MediaThermometer60 = 0x4A3C
    MediaThermometer61 = 0x4A3D
    MediaThermometer62 = 0x4A3E
    MediaThermometer63 = 0x4A3F
    MediaThermometer64 = 0x4A40
    MediaThermometer65 = 0x4A41
    MediaThermometer66 = 0x4A42
    MediaThermometer67 = 0x4A43
    MediaThermometer68 = 0x4A44
    MediaThermometer69 = 0x4A45
    MediaThermometer70 = 0x4A46
    MediaThermometer71 = 0x4A47
    MediaThermometer72 = 0x4A48
    MediaThermometer73 = 0x4A49
    MediaThermometer74 = 0x4A4A
    MediaThermometer75 = 0x4A4B
    MediaThermometer76 = 0x4A4C
    MediaThermometer77 = 0x4A4D
    MediaThermometer78 = 0x4A4E
    MediaThermometer79 = 0x4A4F
    MediaThermometer80 = 0x4A50
    MediaThermometer81 = 0x4A51
    MediaThermometer82 = 0x4A52
    MediaThermometer83 = 0x4A53
    MediaThermometer84 = 0x4A54
    MediaThermometer85 = 0x4A55
    MediaThermometer86 = 0x4A56
    MediaThermometer87 = 0x4A57
    MediaThermometer88 = 0x4A58
    MediaThermometer89 = 0x4A59
    MediaThermometer90 = 0x4A5A
    MediaThermometer91 = 0x4A5B
    MediaThermometer92 = 0x4A5C
    MediaThermometer93 = 0x4A5D
    MediaThermometer94 = 0x4A5E
    MediaThermometer95 = 0x4A5F
    MediaThermometer96 = 0x4A60
    MediaThermometer97 = 0x4A61
    MediaThermometer98 = 0x4A62
    MediaThermometer99 = 0x4A63
    MediaThermometer100 = 0x4A64
    MediaThermometer101 = 0x4A65
    MediaThermometer102 = 0x4A66
    MediaThermometer103 = 0x4A67
    MediaThermometer104 = 0x4A68
    MediaThermometer105 = 0x4A69
    MediaThermometer106 = 0x4A6A
    MediaThermometer107 = 0x4A6B
    MediaThermometer108 = 0x4A6C
    MediaThermometer109 = 0x4A6D
    MediaThermometer110 = 0x4A6E
    MediaThermometer111 = 0x4A6F
    MediaThermometer112 = 0x4A70
    MediaThermometer113 = 0x4A71
    MediaThermometer114 = 0x4A72
    MediaThermometer115 = 0x4A73
    MediaThermometer116 = 0x4A74
    MediaThermometer117 = 0x4A75
    MediaThermometer118 = 0x4A76
    MediaThermometer119 = 0x4A77
    MediaThermometer120 = 0x4A78
    MediaThermometer121 = 0x4A79
    MediaThermometer122 = 0x4A7A
    MediaThermometer123 = 0x4A7B
    MediaThermometer124 = 0x4A7C
    MediaThermometer125 = 0x4A7D
    MediaThermometer126 = 0x4A7E
    MediaThermometer127 = 0x4A7F
    MediaThermometer128 = 0x4A80
    MediaThermometer129 = 0x4A81
    MediaThermometer130 = 0x4A82
    MediaThermometer131 = 0x4A83
    MediaThermometer132 = 0x4A84
    MediaThermometer133 = 0x4A85
    MediaThermometer134 = 0x4A86
    MediaThermometer135 = 0x4A87
    MediaThermometer136 = 0x4A88
    MediaThermometer137 = 0x4A89
    MediaThermometer138 = 0x4A8A
    MediaThermometer139 = 0x4A8B
    MediaThermometer140 = 0x4A8C
    MediaThermometer141 = 0x4A8D
    MediaThermometer142 = 0x4A8E
    MediaThermometer143 = 0x4A8F
    MediaThermometer144 = 0x4A90
    MediaThermometer145 = 0x4A91
    MediaThermometer146 = 0x4A92
    MediaThermometer147 = 0x4A93
    MediaThermometer148 = 0x4A94
    MediaThermometer149 = 0x4A95
    MediaThermometer150 = 0x4A96
    MediaThermometer151 = 0x4A97
    MediaThermometer152 = 0x4A98
    MediaThermometer153 = 0x4A99
    MediaThermometer154 = 0x4A9A
    MediaThermometer155 = 0x4A9B
    MediaThermometer156 = 0x4A9C
    MediaThermometer157 = 0x4A9D
    MediaThermometer158 = 0x4A9E
    MediaThermometer159 = 0x4A9F
    MediaThermometer160 = 0x4AA0
    MediaThermometer161 = 0x4AA1
    MediaThermometer162 = 0x4AA2
    MediaThermometer163 = 0x4AA3
    MediaThermometer164 = 0x4AA4
    MediaThermometer165 = 0x4AA5
    MediaThermometer166 = 0x4AA6
    MediaThermometer167 = 0x4AA7
    MediaThermometer168 = 0x4AA8
    MediaThermometer169 = 0x4AA9
    MediaThermometer170 = 0x4AAA
    MediaThermometer171 = 0x4AAB
    MediaThermometer172 = 0x4AAC
    MediaThermometer173 = 0x4AAD
    MediaThermometer174 = 0x4AAE
    MediaThermometer175 = 0x4AAF
    MediaThermometer176 = 0x4AB0
    MediaThermometer177 = 0x4AB1
    MediaThermometer178 = 0x4AB2
    MediaThermometer179 = 0x4AB3
    MediaThermometer180 = 0x4AB4
    MediaThermometer181 = 0x4AB5
    MediaThermometer182 = 0x4AB6
    MediaThermometer183 = 0x4AB7
    MediaThermometer184 = 0x4AB8
    MediaThermometer185 = 0x4AB9
    MediaThermometer186 = 0x4ABA
    MediaThermometer187 = 0x4ABB
    MediaThermometer188 = 0x4ABC
    MediaThermometer189 = 0x4ABD
    MediaThermometer190 = 0x4ABE
    MediaThermometer191 = 0x4ABF
    MediaThermometer192 = 0x4AC0
    MediaThermometer193 = 0x4AC1
    MediaThermometer194 = 0x4AC2
    MediaThermometer195 = 0x4AC3
    MediaThermometer196 = 0x4AC4
    MediaThermometer197 = 0x4AC5
    MediaThermometer198 = 0x4AC6
    MediaThermometer199 = 0x4AC7
    MediaThermometer200 = 0x4AC8
    MediaThermometer201 = 0x4AC9
    MediaThermometer202 = 0x4ACA
    MediaThermometer203 = 0x4ACB
    MediaThermometer204 = 0x4ACC
    MediaThermometer205 = 0x4ACD
    MediaThermometer206 = 0x4ACE
    MediaThermometer207 = 0x4ACF
    MediaThermometer208 = 0x4AD0
    MediaThermometer209 = 0x4AD1
    MediaThermometer210 = 0x4AD2
    MediaThermometer211 = 0x4AD3
    MediaThermometer212 = 0x4AD4
    MediaThermometer213 = 0x4AD5
    MediaThermometer214 = 0x4AD6
    MediaThermometer215 = 0x4AD7
    MediaThermometer216 = 0x4AD8
    MediaThermometer217 = 0x4AD9
    MediaThermometer218 = 0x4ADA
    MediaThermometer219 = 0x4ADB
    MediaThermometer220 = 0x4ADC
    MediaThermometer221 = 0x4ADD
    MediaThermometer222 = 0x4ADE
    MediaThermometer223 = 0x4ADF
    MediaThermometer224 = 0x4AE0
    MediaThermometer225 = 0x4AE1
    MediaThermometer226 = 0x4AE2
    MediaThermometer227 = 0x4AE3
    MediaThermometer228 = 0x4AE4
    MediaThermometer229 = 0x4AE5
    MediaThermometer230 = 0x4AE6
    MediaThermometer231 = 0x4AE7
    MediaThermometer232 = 0x4AE8
    MediaThermometer233 = 0x4AE9
    MediaThermometer234 = 0x4AEA
    MediaThermometer235 = 0x4AEB
    MediaThermometer236 = 0x4AEC
    MediaThermometer237 = 0x4AED
    MediaThermometer238 = 0x4AEE
    MediaThermometer239 = 0x4AEF
    MediaThermometer240 = 0x4AF0
    MediaThermometer241 = 0x4AF1
    MediaThermometer242 = 0x4AF2
    MediaThermometer243 = 0x4AF3
    MediaThermometer244 = 0x4AF4
    MediaThermometer245 = 0x4AF5
    MediaThermometer246 = 0x4AF6
    MediaThermometer247 = 0x4AF7
    MediaThermometer248 = 0x4AF8
    MediaThermometer249 = 0x4AF9
    MediaThermometer250 = 0x4AFA
    MediaThermometer251 = 0x4AFB
    MediaThermometer252 = 0x4AFC
    MediaThermometer253 = 0x4AFD
    MediaThermometer254 = 0x4AFE
    MediaThermometer255 = 0x4AFF
    # LedSpectrum List
    LedSpectrum0 = 0x4B00
    LedSpectrum1 = 0x4B01
    LedSpectrum2 = 0x4B02
    LedSpectrum3 = 0x4B03
    LedSpectrum4 = 0x4B04
    LedSpectrum5 = 0x4B05
    LedSpectrum6 = 0x4B06
    LedSpectrum7 = 0x4B07
    LedSpectrum8 = 0x4B08
    LedSpectrum9 = 0x4B09
    LedSpectrum10 = 0x4B0A
    LedSpectrum11 = 0x4B0B
    LedSpectrum12 = 0x4B0C
    LedSpectrum13 = 0x4B0D
    LedSpectrum14 = 0x4B0E
    LedSpectrum15 = 0x4B0F
    LedSpectrum16 = 0x4B10
    LedSpectrum17 = 0x4B11
    LedSpectrum18 = 0x4B12
    LedSpectrum19 = 0x4B13
    LedSpectrum20 = 0x4B14
    LedSpectrum21 = 0x4B15
    LedSpectrum22 = 0x4B16
    LedSpectrum23 = 0x4B17
    LedSpectrum24 = 0x4B18
    LedSpectrum25 = 0x4B19
    LedSpectrum26 = 0x4B1A
    LedSpectrum27 = 0x4B1B
    LedSpectrum28 = 0x4B1C
    LedSpectrum29 = 0x4B1D
    LedSpectrum30 = 0x4B1E
    LedSpectrum31 = 0x4B1F
    LedSpectrum32 = 0x4B20
    LedSpectrum33 = 0x4B21
    LedSpectrum34 = 0x4B22
    LedSpectrum35 = 0x4B23
    LedSpectrum36 = 0x4B24
    LedSpectrum37 = 0x4B25
    LedSpectrum38 = 0x4B26
    LedSpectrum39 = 0x4B27
    LedSpectrum40 = 0x4B28
    LedSpectrum41 = 0x4B29
    LedSpectrum42 = 0x4B2A
    LedSpectrum43 = 0x4B2B
    LedSpectrum44 = 0x4B2C
    LedSpectrum45 = 0x4B2D
    LedSpectrum46 = 0x4B2E
    LedSpectrum47 = 0x4B2F
    LedSpectrum48 = 0x4B30
    LedSpectrum49 = 0x4B31
    LedSpectrum50 = 0x4B32
    LedSpectrum51 = 0x4B33
    LedSpectrum52 = 0x4B34
    LedSpectrum53 = 0x4B35
    LedSpectrum54 = 0x4B36
    LedSpectrum55 = 0x4B37
    LedSpectrum56 = 0x4B38
    LedSpectrum57 = 0x4B39
    LedSpectrum58 = 0x4B3A
    LedSpectrum59 = 0x4B3B
    LedSpectrum60 = 0x4B3C
    LedSpectrum61 = 0x4B3D
    LedSpectrum62 = 0x4B3E
    LedSpectrum63 = 0x4B3F
    LedSpectrum64 = 0x4B40
    LedSpectrum65 = 0x4B41
    LedSpectrum66 = 0x4B42
    LedSpectrum67 = 0x4B43
    LedSpectrum68 = 0x4B44
    LedSpectrum69 = 0x4B45
    LedSpectrum70 = 0x4B46
    LedSpectrum71 = 0x4B47
    LedSpectrum72 = 0x4B48
    LedSpectrum73 = 0x4B49
    LedSpectrum74 = 0x4B4A
    LedSpectrum75 = 0x4B4B
    LedSpectrum76 = 0x4B4C
    LedSpectrum77 = 0x4B4D
    LedSpectrum78 = 0x4B4E
    LedSpectrum79 = 0x4B4F
    LedSpectrum80 = 0x4B50
    LedSpectrum81 = 0x4B51
    LedSpectrum82 = 0x4B52
    LedSpectrum83 = 0x4B53
    LedSpectrum84 = 0x4B54
    LedSpectrum85 = 0x4B55
    LedSpectrum86 = 0x4B56
    LedSpectrum87 = 0x4B57
    LedSpectrum88 = 0x4B58
    LedSpectrum89 = 0x4B59
    LedSpectrum90 = 0x4B5A
    LedSpectrum91 = 0x4B5B
    LedSpectrum92 = 0x4B5C
    LedSpectrum93 = 0x4B5D
    LedSpectrum94 = 0x4B5E
    LedSpectrum95 = 0x4B5F
    LedSpectrum96 = 0x4B60
    LedSpectrum97 = 0x4B61
    LedSpectrum98 = 0x4B62
    LedSpectrum99 = 0x4B63
    LedSpectrum100 = 0x4B64
    LedSpectrum101 = 0x4B65
    LedSpectrum102 = 0x4B66
    LedSpectrum103 = 0x4B67
    LedSpectrum104 = 0x4B68
    LedSpectrum105 = 0x4B69
    LedSpectrum106 = 0x4B6A
    LedSpectrum107 = 0x4B6B
    LedSpectrum108 = 0x4B6C
    LedSpectrum109 = 0x4B6D
    LedSpectrum110 = 0x4B6E
    LedSpectrum111 = 0x4B6F
    LedSpectrum112 = 0x4B70
    LedSpectrum113 = 0x4B71
    LedSpectrum114 = 0x4B72
    LedSpectrum115 = 0x4B73
    LedSpectrum116 = 0x4B74
    LedSpectrum117 = 0x4B75
    LedSpectrum118 = 0x4B76
    LedSpectrum119 = 0x4B77
    LedSpectrum120 = 0x4B78
    LedSpectrum121 = 0x4B79
    LedSpectrum122 = 0x4B7A
    LedSpectrum123 = 0x4B7B
    LedSpectrum124 = 0x4B7C
    LedSpectrum125 = 0x4B7D
    LedSpectrum126 = 0x4B7E
    LedSpectrum127 = 0x4B7F
    LedSpectrum128 = 0x4B80
    LedSpectrum129 = 0x4B81
    LedSpectrum130 = 0x4B82
    LedSpectrum131 = 0x4B83
    LedSpectrum132 = 0x4B84
    LedSpectrum133 = 0x4B85
    LedSpectrum134 = 0x4B86
    LedSpectrum135 = 0x4B87
    LedSpectrum136 = 0x4B88
    LedSpectrum137 = 0x4B89
    LedSpectrum138 = 0x4B8A
    LedSpectrum139 = 0x4B8B
    LedSpectrum140 = 0x4B8C
    LedSpectrum141 = 0x4B8D
    LedSpectrum142 = 0x4B8E
    LedSpectrum143 = 0x4B8F
    LedSpectrum144 = 0x4B90
    LedSpectrum145 = 0x4B91
    LedSpectrum146 = 0x4B92
    LedSpectrum147 = 0x4B93
    LedSpectrum148 = 0x4B94
    LedSpectrum149 = 0x4B95
    LedSpectrum150 = 0x4B96
    LedSpectrum151 = 0x4B97
    LedSpectrum152 = 0x4B98
    LedSpectrum153 = 0x4B99
    LedSpectrum154 = 0x4B9A
    LedSpectrum155 = 0x4B9B
    LedSpectrum156 = 0x4B9C
    LedSpectrum157 = 0x4B9D
    LedSpectrum158 = 0x4B9E
    LedSpectrum159 = 0x4B9F
    LedSpectrum160 = 0x4BA0
    LedSpectrum161 = 0x4BA1
    LedSpectrum162 = 0x4BA2
    LedSpectrum163 = 0x4BA3
    LedSpectrum164 = 0x4BA4
    LedSpectrum165 = 0x4BA5
    LedSpectrum166 = 0x4BA6
    LedSpectrum167 = 0x4BA7
    LedSpectrum168 = 0x4BA8
    LedSpectrum169 = 0x4BA9
    LedSpectrum170 = 0x4BAA
    LedSpectrum171 = 0x4BAB
    LedSpectrum172 = 0x4BAC
    LedSpectrum173 = 0x4BAD
    LedSpectrum174 = 0x4BAE
    LedSpectrum175 = 0x4BAF
    LedSpectrum176 = 0x4BB0
    LedSpectrum177 = 0x4BB1
    LedSpectrum178 = 0x4BB2
    LedSpectrum179 = 0x4BB3
    LedSpectrum180 = 0x4BB4
    LedSpectrum181 = 0x4BB5
    LedSpectrum182 = 0x4BB6
    LedSpectrum183 = 0x4BB7
    LedSpectrum184 = 0x4BB8
    LedSpectrum185 = 0x4BB9
    LedSpectrum186 = 0x4BBA
    LedSpectrum187 = 0x4BBB
    LedSpectrum188 = 0x4BBC
    LedSpectrum189 = 0x4BBD
    LedSpectrum190 = 0x4BBE
    LedSpectrum191 = 0x4BBF
    LedSpectrum192 = 0x4BC0
    LedSpectrum193 = 0x4BC1
    LedSpectrum194 = 0x4BC2
    LedSpectrum195 = 0x4BC3
    LedSpectrum196 = 0x4BC4
    LedSpectrum197 = 0x4BC5
    LedSpectrum198 = 0x4BC6
    LedSpectrum199 = 0x4BC7
    LedSpectrum200 = 0x4BC8
    LedSpectrum201 = 0x4BC9
    LedSpectrum202 = 0x4BCA
    LedSpectrum203 = 0x4BCB
    LedSpectrum204 = 0x4BCC
    LedSpectrum205 = 0x4BCD
    LedSpectrum206 = 0x4BCE
    LedSpectrum207 = 0x4BCF
    LedSpectrum208 = 0x4BD0
    LedSpectrum209 = 0x4BD1
    LedSpectrum210 = 0x4BD2
    LedSpectrum211 = 0x4BD3
    LedSpectrum212 = 0x4BD4
    LedSpectrum213 = 0x4BD5
    LedSpectrum214 = 0x4BD6
    LedSpectrum215 = 0x4BD7
    LedSpectrum216 = 0x4BD8
    LedSpectrum217 = 0x4BD9
    LedSpectrum218 = 0x4BDA
    LedSpectrum219 = 0x4BDB
    LedSpectrum220 = 0x4BDC
    LedSpectrum221 = 0x4BDD
    LedSpectrum222 = 0x4BDE
    LedSpectrum223 = 0x4BDF
    LedSpectrum224 = 0x4BE0
    LedSpectrum225 = 0x4BE1
    LedSpectrum226 = 0x4BE2
    LedSpectrum227 = 0x4BE3
    LedSpectrum228 = 0x4BE4
    LedSpectrum229 = 0x4BE5
    LedSpectrum230 = 0x4BE6
    LedSpectrum231 = 0x4BE7
    LedSpectrum232 = 0x4BE8
    LedSpectrum233 = 0x4BE9
    LedSpectrum234 = 0x4BEA
    LedSpectrum235 = 0x4BEB
    LedSpectrum236 = 0x4BEC
    LedSpectrum237 = 0x4BED
    LedSpectrum238 = 0x4BEE
    LedSpectrum239 = 0x4BEF
    LedSpectrum240 = 0x4BF0
    LedSpectrum241 = 0x4BF1
    LedSpectrum242 = 0x4BF2
    LedSpectrum243 = 0x4BF3
    LedSpectrum244 = 0x4BF4
    LedSpectrum245 = 0x4BF5
    LedSpectrum246 = 0x4BF6
    LedSpectrum247 = 0x4BF7
    LedSpectrum248 = 0x4BF8
    LedSpectrum249 = 0x4BF9
    LedSpectrum250 = 0x4BFA
    LedSpectrum251 = 0x4BFB
    LedSpectrum252 = 0x4BFC
    LedSpectrum253 = 0x4BFD
    LedSpectrum254 = 0x4BFE
    LedSpectrum255 = 0x4BFF
    # MediaSpectrum List
    MediaSpectrum0 = 0x4C00
    MediaSpectrum1 = 0x4C01
    MediaSpectrum2 = 0x4C02
    MediaSpectrum3 = 0x4C03
    MediaSpectrum4 = 0x4C04
    MediaSpectrum5 = 0x4C05
    MediaSpectrum6 = 0x4C06
    MediaSpectrum7 = 0x4C07
    MediaSpectrum8 = 0x4C08
    MediaSpectrum9 = 0x4C09
    MediaSpectrum10 = 0x4C0A
    MediaSpectrum11 = 0x4C0B
    MediaSpectrum12 = 0x4C0C
    MediaSpectrum13 = 0x4C0D
    MediaSpectrum14 = 0x4C0E
    MediaSpectrum15 = 0x4C0F
    MediaSpectrum16 = 0x4C10
    MediaSpectrum17 = 0x4C11
    MediaSpectrum18 = 0x4C12
    MediaSpectrum19 = 0x4C13
    MediaSpectrum20 = 0x4C14
    MediaSpectrum21 = 0x4C15
    MediaSpectrum22 = 0x4C16
    MediaSpectrum23 = 0x4C17
    MediaSpectrum24 = 0x4C18
    MediaSpectrum25 = 0x4C19
    MediaSpectrum26 = 0x4C1A
    MediaSpectrum27 = 0x4C1B
    MediaSpectrum28 = 0x4C1C
    MediaSpectrum29 = 0x4C1D
    MediaSpectrum30 = 0x4C1E
    MediaSpectrum31 = 0x4C1F
    MediaSpectrum32 = 0x4C20
    MediaSpectrum33 = 0x4C21
    MediaSpectrum34 = 0x4C22
    MediaSpectrum35 = 0x4C23
    MediaSpectrum36 = 0x4C24
    MediaSpectrum37 = 0x4C25
    MediaSpectrum38 = 0x4C26
    MediaSpectrum39 = 0x4C27
    MediaSpectrum40 = 0x4C28
    MediaSpectrum41 = 0x4C29
    MediaSpectrum42 = 0x4C2A
    MediaSpectrum43 = 0x4C2B
    MediaSpectrum44 = 0x4C2C
    MediaSpectrum45 = 0x4C2D
    MediaSpectrum46 = 0x4C2E
    MediaSpectrum47 = 0x4C2F
    MediaSpectrum48 = 0x4C30
    MediaSpectrum49 = 0x4C31
    MediaSpectrum50 = 0x4C32
    MediaSpectrum51 = 0x4C33
    MediaSpectrum52 = 0x4C34
    MediaSpectrum53 = 0x4C35
    MediaSpectrum54 = 0x4C36
    MediaSpectrum55 = 0x4C37
    MediaSpectrum56 = 0x4C38
    MediaSpectrum57 = 0x4C39
    MediaSpectrum58 = 0x4C3A
    MediaSpectrum59 = 0x4C3B
    MediaSpectrum60 = 0x4C3C
    MediaSpectrum61 = 0x4C3D
    MediaSpectrum62 = 0x4C3E
    MediaSpectrum63 = 0x4C3F
    MediaSpectrum64 = 0x4C40
    MediaSpectrum65 = 0x4C41
    MediaSpectrum66 = 0x4C42
    MediaSpectrum67 = 0x4C43
    MediaSpectrum68 = 0x4C44
    MediaSpectrum69 = 0x4C45
    MediaSpectrum70 = 0x4C46
    MediaSpectrum71 = 0x4C47
    MediaSpectrum72 = 0x4C48
    MediaSpectrum73 = 0x4C49
    MediaSpectrum74 = 0x4C4A
    MediaSpectrum75 = 0x4C4B
    MediaSpectrum76 = 0x4C4C
    MediaSpectrum77 = 0x4C4D
    MediaSpectrum78 = 0x4C4E
    MediaSpectrum79 = 0x4C4F
    MediaSpectrum80 = 0x4C50
    MediaSpectrum81 = 0x4C51
    MediaSpectrum82 = 0x4C52
    MediaSpectrum83 = 0x4C53
    MediaSpectrum84 = 0x4C54
    MediaSpectrum85 = 0x4C55
    MediaSpectrum86 = 0x4C56
    MediaSpectrum87 = 0x4C57
    MediaSpectrum88 = 0x4C58
    MediaSpectrum89 = 0x4C59
    MediaSpectrum90 = 0x4C5A
    MediaSpectrum91 = 0x4C5B
    MediaSpectrum92 = 0x4C5C
    MediaSpectrum93 = 0x4C5D
    MediaSpectrum94 = 0x4C5E
    MediaSpectrum95 = 0x4C5F
    MediaSpectrum96 = 0x4C60
    MediaSpectrum97 = 0x4C61
    MediaSpectrum98 = 0x4C62
    MediaSpectrum99 = 0x4C63
    MediaSpectrum100 = 0x4C64
    MediaSpectrum101 = 0x4C65
    MediaSpectrum102 = 0x4C66
    MediaSpectrum103 = 0x4C67
    MediaSpectrum104 = 0x4C68
    MediaSpectrum105 = 0x4C69
    MediaSpectrum106 = 0x4C6A
    MediaSpectrum107 = 0x4C6B
    MediaSpectrum108 = 0x4C6C
    MediaSpectrum109 = 0x4C6D
    MediaSpectrum110 = 0x4C6E
    MediaSpectrum111 = 0x4C6F
    MediaSpectrum112 = 0x4C70
    MediaSpectrum113 = 0x4C71
    MediaSpectrum114 = 0x4C72
    MediaSpectrum115 = 0x4C73
    MediaSpectrum116 = 0x4C74
    MediaSpectrum117 = 0x4C75
    MediaSpectrum118 = 0x4C76
    MediaSpectrum119 = 0x4C77
    MediaSpectrum120 = 0x4C78
    MediaSpectrum121 = 0x4C79
    MediaSpectrum122 = 0x4C7A
    MediaSpectrum123 = 0x4C7B
    MediaSpectrum124 = 0x4C7C
    MediaSpectrum125 = 0x4C7D
    MediaSpectrum126 = 0x4C7E
    MediaSpectrum127 = 0x4C7F
    MediaSpectrum128 = 0x4C80
    MediaSpectrum129 = 0x4C81
    MediaSpectrum130 = 0x4C82
    MediaSpectrum131 = 0x4C83
    MediaSpectrum132 = 0x4C84
    MediaSpectrum133 = 0x4C85
    MediaSpectrum134 = 0x4C86
    MediaSpectrum135 = 0x4C87
    MediaSpectrum136 = 0x4C88
    MediaSpectrum137 = 0x4C89
    MediaSpectrum138 = 0x4C8A
    MediaSpectrum139 = 0x4C8B
    MediaSpectrum140 = 0x4C8C
    MediaSpectrum141 = 0x4C8D
    MediaSpectrum142 = 0x4C8E
    MediaSpectrum143 = 0x4C8F
    MediaSpectrum144 = 0x4C90
    MediaSpectrum145 = 0x4C91
    MediaSpectrum146 = 0x4C92
    MediaSpectrum147 = 0x4C93
    MediaSpectrum148 = 0x4C94
    MediaSpectrum149 = 0x4C95
    MediaSpectrum150 = 0x4C96
    MediaSpectrum151 = 0x4C97
    MediaSpectrum152 = 0x4C98
    MediaSpectrum153 = 0x4C99
    MediaSpectrum154 = 0x4C9A
    MediaSpectrum155 = 0x4C9B
    MediaSpectrum156 = 0x4C9C
    MediaSpectrum157 = 0x4C9D
    MediaSpectrum158 = 0x4C9E
    MediaSpectrum159 = 0x4C9F
    MediaSpectrum160 = 0x4CA0
    MediaSpectrum161 = 0x4CA1
    MediaSpectrum162 = 0x4CA2
    MediaSpectrum163 = 0x4CA3
    MediaSpectrum164 = 0x4CA4
    MediaSpectrum165 = 0x4CA5
    MediaSpectrum166 = 0x4CA6
    MediaSpectrum167 = 0x4CA7
    MediaSpectrum168 = 0x4CA8
    MediaSpectrum169 = 0x4CA9
    MediaSpectrum170 = 0x4CAA
    MediaSpectrum171 = 0x4CAB
    MediaSpectrum172 = 0x4CAC
    MediaSpectrum173 = 0x4CAD
    MediaSpectrum174 = 0x4CAE
    MediaSpectrum175 = 0x4CAF
    MediaSpectrum176 = 0x4CB0
    MediaSpectrum177 = 0x4CB1
    MediaSpectrum178 = 0x4CB2
    MediaSpectrum179 = 0x4CB3
    MediaSpectrum180 = 0x4CB4
    MediaSpectrum181 = 0x4CB5
    MediaSpectrum182 = 0x4CB6
    MediaSpectrum183 = 0x4CB7
    MediaSpectrum184 = 0x4CB8
    MediaSpectrum185 = 0x4CB9
    MediaSpectrum186 = 0x4CBA
    MediaSpectrum187 = 0x4CBB
    MediaSpectrum188 = 0x4CBC
    MediaSpectrum189 = 0x4CBD
    MediaSpectrum190 = 0x4CBE
    MediaSpectrum191 = 0x4CBF
    MediaSpectrum192 = 0x4CC0
    MediaSpectrum193 = 0x4CC1
    MediaSpectrum194 = 0x4CC2
    MediaSpectrum195 = 0x4CC3
    MediaSpectrum196 = 0x4CC4
    MediaSpectrum197 = 0x4CC5
    MediaSpectrum198 = 0x4CC6
    MediaSpectrum199 = 0x4CC7
    MediaSpectrum200 = 0x4CC8
    MediaSpectrum201 = 0x4CC9
    MediaSpectrum202 = 0x4CCA
    MediaSpectrum203 = 0x4CCB
    MediaSpectrum204 = 0x4CCC
    MediaSpectrum205 = 0x4CCD
    MediaSpectrum206 = 0x4CCE
    MediaSpectrum207 = 0x4CCF
    MediaSpectrum208 = 0x4CD0
    MediaSpectrum209 = 0x4CD1
    MediaSpectrum210 = 0x4CD2
    MediaSpectrum211 = 0x4CD3
    MediaSpectrum212 = 0x4CD4
    MediaSpectrum213 = 0x4CD5
    MediaSpectrum214 = 0x4CD6
    MediaSpectrum215 = 0x4CD7
    MediaSpectrum216 = 0x4CD8
    MediaSpectrum217 = 0x4CD9
    MediaSpectrum218 = 0x4CDA
    MediaSpectrum219 = 0x4CDB
    MediaSpectrum220 = 0x4CDC
    MediaSpectrum221 = 0x4CDD
    MediaSpectrum222 = 0x4CDE
    MediaSpectrum223 = 0x4CDF
    MediaSpectrum224 = 0x4CE0
    MediaSpectrum225 = 0x4CE1
    MediaSpectrum226 = 0x4CE2
    MediaSpectrum227 = 0x4CE3
    MediaSpectrum228 = 0x4CE4
    MediaSpectrum229 = 0x4CE5
    MediaSpectrum230 = 0x4CE6
    MediaSpectrum231 = 0x4CE7
    MediaSpectrum232 = 0x4CE8
    MediaSpectrum233 = 0x4CE9
    MediaSpectrum234 = 0x4CEA
    MediaSpectrum235 = 0x4CEB
    MediaSpectrum236 = 0x4CEC
    MediaSpectrum237 = 0x4CED
    MediaSpectrum238 = 0x4CEE
    MediaSpectrum239 = 0x4CEF
    MediaSpectrum240 = 0x4CF0
    MediaSpectrum241 = 0x4CF1
    MediaSpectrum242 = 0x4CF2
    MediaSpectrum243 = 0x4CF3
    MediaSpectrum244 = 0x4CF4
    MediaSpectrum245 = 0x4CF5
    MediaSpectrum246 = 0x4CF6
    MediaSpectrum247 = 0x4CF7
    MediaSpectrum248 = 0x4CF8
    MediaSpectrum249 = 0x4CF9
    MediaSpectrum250 = 0x4CFA
    MediaSpectrum251 = 0x4CFB
    MediaSpectrum252 = 0x4CFC
    MediaSpectrum253 = 0x4CFD
    MediaSpectrum254 = 0x4CFE
    MediaSpectrum255 = 0x4CFF
    # Scope List
    Scope0 = 0x4D00
    Scope1 = 0x4D01
    Scope2 = 0x4D02
    Scope3 = 0x4D03
    Scope4 = 0x4D04
    Scope5 = 0x4D05
    Scope6 = 0x4D06
    Scope7 = 0x4D07
    Scope8 = 0x4D08
    Scope9 = 0x4D09
    Scope10 = 0x4D0A
    Scope11 = 0x4D0B
    Scope12 = 0x4D0C
    Scope13 = 0x4D0D
    Scope14 = 0x4D0E
    Scope15 = 0x4D0F
    Scope16 = 0x4D10
    Scope17 = 0x4D11
    Scope18 = 0x4D12
    Scope19 = 0x4D13
    Scope20 = 0x4D14
    Scope21 = 0x4D15
    Scope22 = 0x4D16
    Scope23 = 0x4D17
    Scope24 = 0x4D18
    Scope25 = 0x4D19
    Scope26 = 0x4D1A
    Scope27 = 0x4D1B
    Scope28 = 0x4D1C
    Scope29 = 0x4D1D
    Scope30 = 0x4D1E
    Scope31 = 0x4D1F
    Scope32 = 0x4D20
    Scope33 = 0x4D21
    Scope34 = 0x4D22
    Scope35 = 0x4D23
    Scope36 = 0x4D24
    Scope37 = 0x4D25
    Scope38 = 0x4D26
    Scope39 = 0x4D27
    Scope40 = 0x4D28
    Scope41 = 0x4D29
    Scope42 = 0x4D2A
    Scope43 = 0x4D2B
    Scope44 = 0x4D2C
    Scope45 = 0x4D2D
    Scope46 = 0x4D2E
    Scope47 = 0x4D2F
    Scope48 = 0x4D30
    Scope49 = 0x4D31
    Scope50 = 0x4D32
    Scope51 = 0x4D33
    Scope52 = 0x4D34
    Scope53 = 0x4D35
    Scope54 = 0x4D36
    Scope55 = 0x4D37
    Scope56 = 0x4D38
    Scope57 = 0x4D39
    Scope58 = 0x4D3A
    Scope59 = 0x4D3B
    Scope60 = 0x4D3C
    Scope61 = 0x4D3D
    Scope62 = 0x4D3E
    Scope63 = 0x4D3F
    Scope64 = 0x4D40
    Scope65 = 0x4D41
    Scope66 = 0x4D42
    Scope67 = 0x4D43
    Scope68 = 0x4D44
    Scope69 = 0x4D45
    Scope70 = 0x4D46
    Scope71 = 0x4D47
    Scope72 = 0x4D48
    Scope73 = 0x4D49
    Scope74 = 0x4D4A
    Scope75 = 0x4D4B
    Scope76 = 0x4D4C
    Scope77 = 0x4D4D
    Scope78 = 0x4D4E
    Scope79 = 0x4D4F
    Scope80 = 0x4D50
    Scope81 = 0x4D51
    Scope82 = 0x4D52
    Scope83 = 0x4D53
    Scope84 = 0x4D54
    Scope85 = 0x4D55
    Scope86 = 0x4D56
    Scope87 = 0x4D57
    Scope88 = 0x4D58
    Scope89 = 0x4D59
    Scope90 = 0x4D5A
    Scope91 = 0x4D5B
    Scope92 = 0x4D5C
    Scope93 = 0x4D5D
    Scope94 = 0x4D5E
    Scope95 = 0x4D5F
    Scope96 = 0x4D60
    Scope97 = 0x4D61
    Scope98 = 0x4D62
    Scope99 = 0x4D63
    Scope100 = 0x4D64
    Scope101 = 0x4D65
    Scope102 = 0x4D66
    Scope103 = 0x4D67
    Scope104 = 0x4D68
    Scope105 = 0x4D69
    Scope106 = 0x4D6A
    Scope107 = 0x4D6B
    Scope108 = 0x4D6C
    Scope109 = 0x4D6D
    Scope110 = 0x4D6E
    Scope111 = 0x4D6F
    Scope112 = 0x4D70
    Scope113 = 0x4D71
    Scope114 = 0x4D72
    Scope115 = 0x4D73
    Scope116 = 0x4D74
    Scope117 = 0x4D75
    Scope118 = 0x4D76
    Scope119 = 0x4D77
    Scope120 = 0x4D78
    Scope121 = 0x4D79
    Scope122 = 0x4D7A
    Scope123 = 0x4D7B
    Scope124 = 0x4D7C
    Scope125 = 0x4D7D
    Scope126 = 0x4D7E
    Scope127 = 0x4D7F
    Scope128 = 0x4D80
    Scope129 = 0x4D81
    Scope130 = 0x4D82
    Scope131 = 0x4D83
    Scope132 = 0x4D84
    Scope133 = 0x4D85
    Scope134 = 0x4D86
    Scope135 = 0x4D87
    Scope136 = 0x4D88
    Scope137 = 0x4D89
    Scope138 = 0x4D8A
    Scope139 = 0x4D8B
    Scope140 = 0x4D8C
    Scope141 = 0x4D8D
    Scope142 = 0x4D8E
    Scope143 = 0x4D8F
    Scope144 = 0x4D90
    Scope145 = 0x4D91
    Scope146 = 0x4D92
    Scope147 = 0x4D93
    Scope148 = 0x4D94
    Scope149 = 0x4D95
    Scope150 = 0x4D96
    Scope151 = 0x4D97
    Scope152 = 0x4D98
    Scope153 = 0x4D99
    Scope154 = 0x4D9A
    Scope155 = 0x4D9B
    Scope156 = 0x4D9C
    Scope157 = 0x4D9D
    Scope158 = 0x4D9E
    Scope159 = 0x4D9F
    Scope160 = 0x4DA0
    Scope161 = 0x4DA1
    Scope162 = 0x4DA2
    Scope163 = 0x4DA3
    Scope164 = 0x4DA4
    Scope165 = 0x4DA5
    Scope166 = 0x4DA6
    Scope167 = 0x4DA7
    Scope168 = 0x4DA8
    Scope169 = 0x4DA9
    Scope170 = 0x4DAA
    Scope171 = 0x4DAB
    Scope172 = 0x4DAC
    Scope173 = 0x4DAD
    Scope174 = 0x4DAE
    Scope175 = 0x4DAF
    Scope176 = 0x4DB0
    Scope177 = 0x4DB1
    Scope178 = 0x4DB2
    Scope179 = 0x4DB3
    Scope180 = 0x4DB4
    Scope181 = 0x4DB5
    Scope182 = 0x4DB6
    Scope183 = 0x4DB7
    Scope184 = 0x4DB8
    Scope185 = 0x4DB9
    Scope186 = 0x4DBA
    Scope187 = 0x4DBB
    Scope188 = 0x4DBC
    Scope189 = 0x4DBD
    Scope190 = 0x4DBE
    Scope191 = 0x4DBF
    Scope192 = 0x4DC0
    Scope193 = 0x4DC1
    Scope194 = 0x4DC2
    Scope195 = 0x4DC3
    Scope196 = 0x4DC4
    Scope197 = 0x4DC5
    Scope198 = 0x4DC6
    Scope199 = 0x4DC7
    Scope200 = 0x4DC8
    Scope201 = 0x4DC9
    Scope202 = 0x4DCA
    Scope203 = 0x4DCB
    Scope204 = 0x4DCC
    Scope205 = 0x4DCD
    Scope206 = 0x4DCE
    Scope207 = 0x4DCF
    Scope208 = 0x4DD0
    Scope209 = 0x4DD1
    Scope210 = 0x4DD2
    Scope211 = 0x4DD3
    Scope212 = 0x4DD4
    Scope213 = 0x4DD5
    Scope214 = 0x4DD6
    Scope215 = 0x4DD7
    Scope216 = 0x4DD8
    Scope217 = 0x4DD9
    Scope218 = 0x4DDA
    Scope219 = 0x4DDB
    Scope220 = 0x4DDC
    Scope221 = 0x4DDD
    Scope222 = 0x4DDE
    Scope223 = 0x4DDF
    Scope224 = 0x4DE0
    Scope225 = 0x4DE1
    Scope226 = 0x4DE2
    Scope227 = 0x4DE3
    Scope228 = 0x4DE4
    Scope229 = 0x4DE5
    Scope230 = 0x4DE6
    Scope231 = 0x4DE7
    Scope232 = 0x4DE8
    Scope233 = 0x4DE9
    Scope234 = 0x4DEA
    Scope235 = 0x4DEB
    Scope236 = 0x4DEC
    Scope237 = 0x4DED
    Scope238 = 0x4DEE
    Scope239 = 0x4DEF
    Scope240 = 0x4DF0
    Scope241 = 0x4DF1
    Scope242 = 0x4DF2
    Scope243 = 0x4DF3
    Scope244 = 0x4DF4
    Scope245 = 0x4DF5
    Scope246 = 0x4DF6
    Scope247 = 0x4DF7
    Scope248 = 0x4DF8
    Scope249 = 0x4DF9
    Scope250 = 0x4DFA
    Scope251 = 0x4DFB
    Scope252 = 0x4DFC
    Scope253 = 0x4DFD
    Scope254 = 0x4DFE
    Scope255 = 0x4DFF
    # Symbols List
    Symbols0 = 0x4E00
    Symbols1 = 0x4E01
    Symbols2 = 0x4E02
    Symbols3 = 0x4E03
    Symbols4 = 0x4E04
    Symbols5 = 0x4E05
    Symbols6 = 0x4E06
    Symbols7 = 0x4E07
    Symbols8 = 0x4E08
    Symbols9 = 0x4E09
    Symbols10 = 0x4E0A
    Symbols11 = 0x4E0B
    Symbols12 = 0x4E0C
    Symbols13 = 0x4E0D
    Symbols14 = 0x4E0E
    Symbols15 = 0x4E0F
    Symbols16 = 0x4E10
    Symbols17 = 0x4E11
    Symbols18 = 0x4E12
    Symbols19 = 0x4E13
    Symbols20 = 0x4E14
    Symbols21 = 0x4E15
    Symbols22 = 0x4E16
    Symbols23 = 0x4E17
    Symbols24 = 0x4E18
    Symbols25 = 0x4E19
    Symbols26 = 0x4E1A
    Symbols27 = 0x4E1B
    Symbols28 = 0x4E1C
    Symbols29 = 0x4E1D
    Symbols30 = 0x4E1E
    Symbols31 = 0x4E1F
    Symbols32 = 0x4E20
    Symbols33 = 0x4E21
    Symbols34 = 0x4E22
    Symbols35 = 0x4E23
    Symbols36 = 0x4E24
    Symbols37 = 0x4E25
    Symbols38 = 0x4E26
    Symbols39 = 0x4E27
    Symbols40 = 0x4E28
    Symbols41 = 0x4E29
    Symbols42 = 0x4E2A
    Symbols43 = 0x4E2B
    Symbols44 = 0x4E2C
    Symbols45 = 0x4E2D
    Symbols46 = 0x4E2E
    Symbols47 = 0x4E2F
    Symbols48 = 0x4E30
    Symbols49 = 0x4E31
    Symbols50 = 0x4E32
    Symbols51 = 0x4E33
    Symbols52 = 0x4E34
    Symbols53 = 0x4E35
    Symbols54 = 0x4E36
    Symbols55 = 0x4E37
    Symbols56 = 0x4E38
    Symbols57 = 0x4E39
    Symbols58 = 0x4E3A
    Symbols59 = 0x4E3B
    Symbols60 = 0x4E3C
    Symbols61 = 0x4E3D
    Symbols62 = 0x4E3E
    Symbols63 = 0x4E3F
    Symbols64 = 0x4E40
    Symbols65 = 0x4E41
    Symbols66 = 0x4E42
    Symbols67 = 0x4E43
    Symbols68 = 0x4E44
    Symbols69 = 0x4E45
    Symbols70 = 0x4E46
    Symbols71 = 0x4E47
    Symbols72 = 0x4E48
    Symbols73 = 0x4E49
    Symbols74 = 0x4E4A
    Symbols75 = 0x4E4B
    Symbols76 = 0x4E4C
    Symbols77 = 0x4E4D
    Symbols78 = 0x4E4E
    Symbols79 = 0x4E4F
    Symbols80 = 0x4E50
    Symbols81 = 0x4E51
    Symbols82 = 0x4E52
    Symbols83 = 0x4E53
    Symbols84 = 0x4E54
    Symbols85 = 0x4E55
    Symbols86 = 0x4E56
    Symbols87 = 0x4E57
    Symbols88 = 0x4E58
    Symbols89 = 0x4E59
    Symbols90 = 0x4E5A
    Symbols91 = 0x4E5B
    Symbols92 = 0x4E5C
    Symbols93 = 0x4E5D
    Symbols94 = 0x4E5E
    Symbols95 = 0x4E5F
    Symbols96 = 0x4E60
    Symbols97 = 0x4E61
    Symbols98 = 0x4E62
    Symbols99 = 0x4E63
    Symbols100 = 0x4E64
    Symbols101 = 0x4E65
    Symbols102 = 0x4E66
    Symbols103 = 0x4E67
    Symbols104 = 0x4E68
    Symbols105 = 0x4E69
    Symbols106 = 0x4E6A
    Symbols107 = 0x4E6B
    Symbols108 = 0x4E6C
    Symbols109 = 0x4E6D
    Symbols110 = 0x4E6E
    Symbols111 = 0x4E6F
    Symbols112 = 0x4E70
    Symbols113 = 0x4E71
    Symbols114 = 0x4E72
    Symbols115 = 0x4E73
    Symbols116 = 0x4E74
    Symbols117 = 0x4E75
    Symbols118 = 0x4E76
    Symbols119 = 0x4E77
    Symbols120 = 0x4E78
    Symbols121 = 0x4E79
    Symbols122 = 0x4E7A
    Symbols123 = 0x4E7B
    Symbols124 = 0x4E7C
    Symbols125 = 0x4E7D
    Symbols126 = 0x4E7E
    Symbols127 = 0x4E7F
    Symbols128 = 0x4E80
    Symbols129 = 0x4E81
    Symbols130 = 0x4E82
    Symbols131 = 0x4E83
    Symbols132 = 0x4E84
    Symbols133 = 0x4E85
    Symbols134 = 0x4E86
    Symbols135 = 0x4E87
    Symbols136 = 0x4E88
    Symbols137 = 0x4E89
    Symbols138 = 0x4E8A
    Symbols139 = 0x4E8B
    Symbols140 = 0x4E8C
    Symbols141 = 0x4E8D
    Symbols142 = 0x4E8E
    Symbols143 = 0x4E8F
    Symbols144 = 0x4E90
    Symbols145 = 0x4E91
    Symbols146 = 0x4E92
    Symbols147 = 0x4E93
    Symbols148 = 0x4E94
    Symbols149 = 0x4E95
    Symbols150 = 0x4E96
    Symbols151 = 0x4E97
    Symbols152 = 0x4E98
    Symbols153 = 0x4E99
    Symbols154 = 0x4E9A
    Symbols155 = 0x4E9B
    Symbols156 = 0x4E9C
    Symbols157 = 0x4E9D
    Symbols158 = 0x4E9E
    Symbols159 = 0x4E9F
    Symbols160 = 0x4EA0
    Symbols161 = 0x4EA1
    Symbols162 = 0x4EA2
    Symbols163 = 0x4EA3
    Symbols164 = 0x4EA4
    Symbols165 = 0x4EA5
    Symbols166 = 0x4EA6
    Symbols167 = 0x4EA7
    Symbols168 = 0x4EA8
    Symbols169 = 0x4EA9
    Symbols170 = 0x4EAA
    Symbols171 = 0x4EAB
    Symbols172 = 0x4EAC
    Symbols173 = 0x4EAD
    Symbols174 = 0x4EAE
    Symbols175 = 0x4EAF
    Symbols176 = 0x4EB0
    Symbols177 = 0x4EB1
    Symbols178 = 0x4EB2
    Symbols179 = 0x4EB3
    Symbols180 = 0x4EB4
    Symbols181 = 0x4EB5
    Symbols182 = 0x4EB6
    Symbols183 = 0x4EB7
    Symbols184 = 0x4EB8
    Symbols185 = 0x4EB9
    Symbols186 = 0x4EBA
    Symbols187 = 0x4EBB
    Symbols188 = 0x4EBC
    Symbols189 = 0x4EBD
    Symbols190 = 0x4EBE
    Symbols191 = 0x4EBF
    Symbols192 = 0x4EC0
    Symbols193 = 0x4EC1
    Symbols194 = 0x4EC2
    Symbols195 = 0x4EC3
    Symbols196 = 0x4EC4
    Symbols197 = 0x4EC5
    Symbols198 = 0x4EC6
    Symbols199 = 0x4EC7
    Symbols200 = 0x4EC8
    Symbols201 = 0x4EC9
    Symbols202 = 0x4ECA
    Symbols203 = 0x4ECB
    Symbols204 = 0x4ECC
    Symbols205 = 0x4ECD
    Symbols206 = 0x4ECE
    Symbols207 = 0x4ECF
    Symbols208 = 0x4ED0
    Symbols209 = 0x4ED1
    Symbols210 = 0x4ED2
    Symbols211 = 0x4ED3
    Symbols212 = 0x4ED4
    Symbols213 = 0x4ED5
    Symbols214 = 0x4ED6
    Symbols215 = 0x4ED7
    Symbols216 = 0x4ED8
    Symbols217 = 0x4ED9
    Symbols218 = 0x4EDA
    Symbols219 = 0x4EDB
    Symbols220 = 0x4EDC
    Symbols221 = 0x4EDD
    Symbols222 = 0x4EDE
    Symbols223 = 0x4EDF
    Symbols224 = 0x4EE0
    Symbols225 = 0x4EE1
    Symbols226 = 0x4EE2
    Symbols227 = 0x4EE3
    Symbols228 = 0x4EE4
    Symbols229 = 0x4EE5
    Symbols230 = 0x4EE6
    Symbols231 = 0x4EE7
    Symbols232 = 0x4EE8
    Symbols233 = 0x4EE9
    Symbols234 = 0x4EEA
    Symbols235 = 0x4EEB
    Symbols236 = 0x4EEC
    Symbols237 = 0x4EED
    Symbols238 = 0x4EEE
    Symbols239 = 0x4EEF
    Symbols240 = 0x4EF0
    Symbols241 = 0x4EF1
    Symbols242 = 0x4EF2
    Symbols243 = 0x4EF3
    Symbols244 = 0x4EF4
    Symbols245 = 0x4EF5
    Symbols246 = 0x4EF6
    Symbols247 = 0x4EF7
    Symbols248 = 0x4EF8
    Symbols249 = 0x4EF9
    Symbols250 = 0x4EFA
    Symbols251 = 0x4EFB
    Symbols252 = 0x4EFC
    Symbols253 = 0x4EFD
    Symbols254 = 0x4EFE
    Symbols255 = 0x4EFF
    # RotaryGauge List
    RotaryGauge0 = 0x4F00
    RotaryGauge1 = 0x4F01
    RotaryGauge2 = 0x4F02
    RotaryGauge3 = 0x4F03
    RotaryGauge4 = 0x4F04
    RotaryGauge5 = 0x4F05
    RotaryGauge6 = 0x4F06
    RotaryGauge7 = 0x4F07
    RotaryGauge8 = 0x4F08
    RotaryGauge9 = 0x4F09
    RotaryGauge10 = 0x4F0A
    RotaryGauge11 = 0x4F0B
    RotaryGauge12 = 0x4F0C
    RotaryGauge13 = 0x4F0D
    RotaryGauge14 = 0x4F0E
    RotaryGauge15 = 0x4F0F
    RotaryGauge16 = 0x4F10
    RotaryGauge17 = 0x4F11
    RotaryGauge18 = 0x4F12
    RotaryGauge19 = 0x4F13
    RotaryGauge20 = 0x4F14
    RotaryGauge21 = 0x4F15
    RotaryGauge22 = 0x4F16
    RotaryGauge23 = 0x4F17
    RotaryGauge24 = 0x4F18
    RotaryGauge25 = 0x4F19
    RotaryGauge26 = 0x4F1A
    RotaryGauge27 = 0x4F1B
    RotaryGauge28 = 0x4F1C
    RotaryGauge29 = 0x4F1D
    RotaryGauge30 = 0x4F1E
    RotaryGauge31 = 0x4F1F
    RotaryGauge32 = 0x4F20
    RotaryGauge33 = 0x4F21
    RotaryGauge34 = 0x4F22
    RotaryGauge35 = 0x4F23
    RotaryGauge36 = 0x4F24
    RotaryGauge37 = 0x4F25
    RotaryGauge38 = 0x4F26
    RotaryGauge39 = 0x4F27
    RotaryGauge40 = 0x4F28
    RotaryGauge41 = 0x4F29
    RotaryGauge42 = 0x4F2A
    RotaryGauge43 = 0x4F2B
    RotaryGauge44 = 0x4F2C
    RotaryGauge45 = 0x4F2D
    RotaryGauge46 = 0x4F2E
    RotaryGauge47 = 0x4F2F
    RotaryGauge48 = 0x4F30
    RotaryGauge49 = 0x4F31
    RotaryGauge50 = 0x4F32
    RotaryGauge51 = 0x4F33
    RotaryGauge52 = 0x4F34
    RotaryGauge53 = 0x4F35
    RotaryGauge54 = 0x4F36
    RotaryGauge55 = 0x4F37
    RotaryGauge56 = 0x4F38
    RotaryGauge57 = 0x4F39
    RotaryGauge58 = 0x4F3A
    RotaryGauge59 = 0x4F3B
    RotaryGauge60 = 0x4F3C
    RotaryGauge61 = 0x4F3D
    RotaryGauge62 = 0x4F3E
    RotaryGauge63 = 0x4F3F
    RotaryGauge64 = 0x4F40
    RotaryGauge65 = 0x4F41
    RotaryGauge66 = 0x4F42
    RotaryGauge67 = 0x4F43
    RotaryGauge68 = 0x4F44
    RotaryGauge69 = 0x4F45
    RotaryGauge70 = 0x4F46
    RotaryGauge71 = 0x4F47
    RotaryGauge72 = 0x4F48
    RotaryGauge73 = 0x4F49
    RotaryGauge74 = 0x4F4A
    RotaryGauge75 = 0x4F4B
    RotaryGauge76 = 0x4F4C
    RotaryGauge77 = 0x4F4D
    RotaryGauge78 = 0x4F4E
    RotaryGauge79 = 0x4F4F
    RotaryGauge80 = 0x4F50
    RotaryGauge81 = 0x4F51
    RotaryGauge82 = 0x4F52
    RotaryGauge83 = 0x4F53
    RotaryGauge84 = 0x4F54
    RotaryGauge85 = 0x4F55
    RotaryGauge86 = 0x4F56
    RotaryGauge87 = 0x4F57
    RotaryGauge88 = 0x4F58
    RotaryGauge89 = 0x4F59
    RotaryGauge90 = 0x4F5A
    RotaryGauge91 = 0x4F5B
    RotaryGauge92 = 0x4F5C
    RotaryGauge93 = 0x4F5D
    RotaryGauge94 = 0x4F5E
    RotaryGauge95 = 0x4F5F
    RotaryGauge96 = 0x4F60
    RotaryGauge97 = 0x4F61
    RotaryGauge98 = 0x4F62
    RotaryGauge99 = 0x4F63
    RotaryGauge100 = 0x4F64
    RotaryGauge101 = 0x4F65
    RotaryGauge102 = 0x4F66
    RotaryGauge103 = 0x4F67
    RotaryGauge104 = 0x4F68
    RotaryGauge105 = 0x4F69
    RotaryGauge106 = 0x4F6A
    RotaryGauge107 = 0x4F6B
    RotaryGauge108 = 0x4F6C
    RotaryGauge109 = 0x4F6D
    RotaryGauge110 = 0x4F6E
    RotaryGauge111 = 0x4F6F
    RotaryGauge112 = 0x4F70
    RotaryGauge113 = 0x4F71
    RotaryGauge114 = 0x4F72
    RotaryGauge115 = 0x4F73
    RotaryGauge116 = 0x4F74
    RotaryGauge117 = 0x4F75
    RotaryGauge118 = 0x4F76
    RotaryGauge119 = 0x4F77
    RotaryGauge120 = 0x4F78
    RotaryGauge121 = 0x4F79
    RotaryGauge122 = 0x4F7A
    RotaryGauge123 = 0x4F7B
    RotaryGauge124 = 0x4F7C
    RotaryGauge125 = 0x4F7D
    RotaryGauge126 = 0x4F7E
    RotaryGauge127 = 0x4F7F
    RotaryGauge128 = 0x4F80
    RotaryGauge129 = 0x4F81
    RotaryGauge130 = 0x4F82
    RotaryGauge131 = 0x4F83
    RotaryGauge132 = 0x4F84
    RotaryGauge133 = 0x4F85
    RotaryGauge134 = 0x4F86
    RotaryGauge135 = 0x4F87
    RotaryGauge136 = 0x4F88
    RotaryGauge137 = 0x4F89
    RotaryGauge138 = 0x4F8A
    RotaryGauge139 = 0x4F8B
    RotaryGauge140 = 0x4F8C
    RotaryGauge141 = 0x4F8D
    RotaryGauge142 = 0x4F8E
    RotaryGauge143 = 0x4F8F
    RotaryGauge144 = 0x4F90
    RotaryGauge145 = 0x4F91
    RotaryGauge146 = 0x4F92
    RotaryGauge147 = 0x4F93
    RotaryGauge148 = 0x4F94
    RotaryGauge149 = 0x4F95
    RotaryGauge150 = 0x4F96
    RotaryGauge151 = 0x4F97
    RotaryGauge152 = 0x4F98
    RotaryGauge153 = 0x4F99
    RotaryGauge154 = 0x4F9A
    RotaryGauge155 = 0x4F9B
    RotaryGauge156 = 0x4F9C
    RotaryGauge157 = 0x4F9D
    RotaryGauge158 = 0x4F9E
    RotaryGauge159 = 0x4F9F
    RotaryGauge160 = 0x4FA0
    RotaryGauge161 = 0x4FA1
    RotaryGauge162 = 0x4FA2
    RotaryGauge163 = 0x4FA3
    RotaryGauge164 = 0x4FA4
    RotaryGauge165 = 0x4FA5
    RotaryGauge166 = 0x4FA6
    RotaryGauge167 = 0x4FA7
    RotaryGauge168 = 0x4FA8
    RotaryGauge169 = 0x4FA9
    RotaryGauge170 = 0x4FAA
    RotaryGauge171 = 0x4FAB
    RotaryGauge172 = 0x4FAC
    RotaryGauge173 = 0x4FAD
    RotaryGauge174 = 0x4FAE
    RotaryGauge175 = 0x4FAF
    RotaryGauge176 = 0x4FB0
    RotaryGauge177 = 0x4FB1
    RotaryGauge178 = 0x4FB2
    RotaryGauge179 = 0x4FB3
    RotaryGauge180 = 0x4FB4
    RotaryGauge181 = 0x4FB5
    RotaryGauge182 = 0x4FB6
    RotaryGauge183 = 0x4FB7
    RotaryGauge184 = 0x4FB8
    RotaryGauge185 = 0x4FB9
    RotaryGauge186 = 0x4FBA
    RotaryGauge187 = 0x4FBB
    RotaryGauge188 = 0x4FBC
    RotaryGauge189 = 0x4FBD
    RotaryGauge190 = 0x4FBE
    RotaryGauge191 = 0x4FBF
    RotaryGauge192 = 0x4FC0
    RotaryGauge193 = 0x4FC1
    RotaryGauge194 = 0x4FC2
    RotaryGauge195 = 0x4FC3
    RotaryGauge196 = 0x4FC4
    RotaryGauge197 = 0x4FC5
    RotaryGauge198 = 0x4FC6
    RotaryGauge199 = 0x4FC7
    RotaryGauge200 = 0x4FC8
    RotaryGauge201 = 0x4FC9
    RotaryGauge202 = 0x4FCA
    RotaryGauge203 = 0x4FCB
    RotaryGauge204 = 0x4FCC
    RotaryGauge205 = 0x4FCD
    RotaryGauge206 = 0x4FCE
    RotaryGauge207 = 0x4FCF
    RotaryGauge208 = 0x4FD0
    RotaryGauge209 = 0x4FD1
    RotaryGauge210 = 0x4FD2
    RotaryGauge211 = 0x4FD3
    RotaryGauge212 = 0x4FD4
    RotaryGauge213 = 0x4FD5
    RotaryGauge214 = 0x4FD6
    RotaryGauge215 = 0x4FD7
    RotaryGauge216 = 0x4FD8
    RotaryGauge217 = 0x4FD9
    RotaryGauge218 = 0x4FDA
    RotaryGauge219 = 0x4FDB
    RotaryGauge220 = 0x4FDC
    RotaryGauge221 = 0x4FDD
    RotaryGauge222 = 0x4FDE
    RotaryGauge223 = 0x4FDF
    RotaryGauge224 = 0x4FE0
    RotaryGauge225 = 0x4FE1
    RotaryGauge226 = 0x4FE2
    RotaryGauge227 = 0x4FE3
    RotaryGauge228 = 0x4FE4
    RotaryGauge229 = 0x4FE5
    RotaryGauge230 = 0x4FE6
    RotaryGauge231 = 0x4FE7
    RotaryGauge232 = 0x4FE8
    RotaryGauge233 = 0x4FE9
    RotaryGauge234 = 0x4FEA
    RotaryGauge235 = 0x4FEB
    RotaryGauge236 = 0x4FEC
    RotaryGauge237 = 0x4FED
    RotaryGauge238 = 0x4FEE
    RotaryGauge239 = 0x4FEF
    RotaryGauge240 = 0x4FF0
    RotaryGauge241 = 0x4FF1
    RotaryGauge242 = 0x4FF2
    RotaryGauge243 = 0x4FF3
    RotaryGauge244 = 0x4FF4
    RotaryGauge245 = 0x4FF5
    RotaryGauge246 = 0x4FF6
    RotaryGauge247 = 0x4FF7
    RotaryGauge248 = 0x4FF8
    RotaryGauge249 = 0x4FF9
    RotaryGauge250 = 0x4FFA
    RotaryGauge251 = 0x4FFB
    RotaryGauge252 = 0x4FFC
    RotaryGauge253 = 0x4FFD
    RotaryGauge254 = 0x4FFE
    RotaryGauge255 = 0x4FFF
    # ButtonB List
    ButtonB0 = 0x6000
    ButtonB1 = 0x6001
    ButtonB2 = 0x6002
    ButtonB3 = 0x6003
    ButtonB4 = 0x6004
    ButtonB5 = 0x6005
    ButtonB6 = 0x6006
    ButtonB7 = 0x6007
    ButtonB8 = 0x6008
    ButtonB9 = 0x6009
    ButtonB10 = 0x600A
    ButtonB11 = 0x600B
    ButtonB12 = 0x600C
    ButtonB13 = 0x600D
    ButtonB14 = 0x600E
    ButtonB15 = 0x600F
    ButtonB16 = 0x6010
    ButtonB17 = 0x6011
    ButtonB18 = 0x6012
    ButtonB19 = 0x6013
    ButtonB20 = 0x6014
    ButtonB21 = 0x6015
    ButtonB22 = 0x6016
    ButtonB23 = 0x6017
    ButtonB24 = 0x6018
    ButtonB25 = 0x6019
    ButtonB26 = 0x601A
    ButtonB27 = 0x601B
    ButtonB28 = 0x601C
    ButtonB29 = 0x601D
    ButtonB30 = 0x601E
    ButtonB31 = 0x601F
    ButtonB32 = 0x6020
    ButtonB33 = 0x6021
    ButtonB34 = 0x6022
    ButtonB35 = 0x6023
    ButtonB36 = 0x6024
    ButtonB37 = 0x6025
    ButtonB38 = 0x6026
    ButtonB39 = 0x6027
    ButtonB40 = 0x6028
    ButtonB41 = 0x6029
    ButtonB42 = 0x602A
    ButtonB43 = 0x602B
    ButtonB44 = 0x602C
    ButtonB45 = 0x602D
    ButtonB46 = 0x602E
    ButtonB47 = 0x602F
    ButtonB48 = 0x6030
    ButtonB49 = 0x6031
    ButtonB50 = 0x6032
    ButtonB51 = 0x6033
    ButtonB52 = 0x6034
    ButtonB53 = 0x6035
    ButtonB54 = 0x6036
    ButtonB55 = 0x6037
    ButtonB56 = 0x6038
    ButtonB57 = 0x6039
    ButtonB58 = 0x603A
    ButtonB59 = 0x603B
    ButtonB60 = 0x603C
    ButtonB61 = 0x603D
    ButtonB62 = 0x603E
    ButtonB63 = 0x603F
    ButtonB64 = 0x6040
    ButtonB65 = 0x6041
    ButtonB66 = 0x6042
    ButtonB67 = 0x6043
    ButtonB68 = 0x6044
    ButtonB69 = 0x6045
    ButtonB70 = 0x6046
    ButtonB71 = 0x6047
    ButtonB72 = 0x6048
    ButtonB73 = 0x6049
    ButtonB74 = 0x604A
    ButtonB75 = 0x604B
    ButtonB76 = 0x604C
    ButtonB77 = 0x604D
    ButtonB78 = 0x604E
    ButtonB79 = 0x604F
    ButtonB80 = 0x6050
    ButtonB81 = 0x6051
    ButtonB82 = 0x6052
    ButtonB83 = 0x6053
    ButtonB84 = 0x6054
    ButtonB85 = 0x6055
    ButtonB86 = 0x6056
    ButtonB87 = 0x6057
    ButtonB88 = 0x6058
    ButtonB89 = 0x6059
    ButtonB90 = 0x605A
    ButtonB91 = 0x605B
    ButtonB92 = 0x605C
    ButtonB93 = 0x605D
    ButtonB94 = 0x605E
    ButtonB95 = 0x605F
    ButtonB96 = 0x6060
    ButtonB97 = 0x6061
    ButtonB98 = 0x6062
    ButtonB99 = 0x6063
    ButtonB100 = 0x6064
    ButtonB101 = 0x6065
    ButtonB102 = 0x6066
    ButtonB103 = 0x6067
    ButtonB104 = 0x6068
    ButtonB105 = 0x6069
    ButtonB106 = 0x606A
    ButtonB107 = 0x606B
    ButtonB108 = 0x606C
    ButtonB109 = 0x606D
    ButtonB110 = 0x606E
    ButtonB111 = 0x606F
    ButtonB112 = 0x6070
    ButtonB113 = 0x6071
    ButtonB114 = 0x6072
    ButtonB115 = 0x6073
    ButtonB116 = 0x6074
    ButtonB117 = 0x6075
    ButtonB118 = 0x6076
    ButtonB119 = 0x6077
    ButtonB120 = 0x6078
    ButtonB121 = 0x6079
    ButtonB122 = 0x607A
    ButtonB123 = 0x607B
    ButtonB124 = 0x607C
    ButtonB125 = 0x607D
    ButtonB126 = 0x607E
    ButtonB127 = 0x607F
    ButtonB128 = 0x6080
    ButtonB129 = 0x6081
    ButtonB130 = 0x6082
    ButtonB131 = 0x6083
    ButtonB132 = 0x6084
    ButtonB133 = 0x6085
    ButtonB134 = 0x6086
    ButtonB135 = 0x6087
    ButtonB136 = 0x6088
    ButtonB137 = 0x6089
    ButtonB138 = 0x608A
    ButtonB139 = 0x608B
    ButtonB140 = 0x608C
    ButtonB141 = 0x608D
    ButtonB142 = 0x608E
    ButtonB143 = 0x608F
    ButtonB144 = 0x6090
    ButtonB145 = 0x6091
    ButtonB146 = 0x6092
    ButtonB147 = 0x6093
    ButtonB148 = 0x6094
    ButtonB149 = 0x6095
    ButtonB150 = 0x6096
    ButtonB151 = 0x6097
    ButtonB152 = 0x6098
    ButtonB153 = 0x6099
    ButtonB154 = 0x609A
    ButtonB155 = 0x609B
    ButtonB156 = 0x609C
    ButtonB157 = 0x609D
    ButtonB158 = 0x609E
    ButtonB159 = 0x609F
    ButtonB160 = 0x60A0
    ButtonB161 = 0x60A1
    ButtonB162 = 0x60A2
    ButtonB163 = 0x60A3
    ButtonB164 = 0x60A4
    ButtonB165 = 0x60A5
    ButtonB166 = 0x60A6
    ButtonB167 = 0x60A7
    ButtonB168 = 0x60A8
    ButtonB169 = 0x60A9
    ButtonB170 = 0x60AA
    ButtonB171 = 0x60AB
    ButtonB172 = 0x60AC
    ButtonB173 = 0x60AD
    ButtonB174 = 0x60AE
    ButtonB175 = 0x60AF
    ButtonB176 = 0x60B0
    ButtonB177 = 0x60B1
    ButtonB178 = 0x60B2
    ButtonB179 = 0x60B3
    ButtonB180 = 0x60B4
    ButtonB181 = 0x60B5
    ButtonB182 = 0x60B6
    ButtonB183 = 0x60B7
    ButtonB184 = 0x60B8
    ButtonB185 = 0x60B9
    ButtonB186 = 0x60BA
    ButtonB187 = 0x60BB
    ButtonB188 = 0x60BC
    ButtonB189 = 0x60BD
    ButtonB190 = 0x60BE
    ButtonB191 = 0x60BF
    ButtonB192 = 0x60C0
    ButtonB193 = 0x60C1
    ButtonB194 = 0x60C2
    ButtonB195 = 0x60C3
    ButtonB196 = 0x60C4
    ButtonB197 = 0x60C5
    ButtonB198 = 0x60C6
    ButtonB199 = 0x60C7
    ButtonB200 = 0x60C8
    ButtonB201 = 0x60C9
    ButtonB202 = 0x60CA
    ButtonB203 = 0x60CB
    ButtonB204 = 0x60CC
    ButtonB205 = 0x60CD
    ButtonB206 = 0x60CE
    ButtonB207 = 0x60CF
    ButtonB208 = 0x60D0
    ButtonB209 = 0x60D1
    ButtonB210 = 0x60D2
    ButtonB211 = 0x60D3
    ButtonB212 = 0x60D4
    ButtonB213 = 0x60D5
    ButtonB214 = 0x60D6
    ButtonB215 = 0x60D7
    ButtonB216 = 0x60D8
    ButtonB217 = 0x60D9
    ButtonB218 = 0x60DA
    ButtonB219 = 0x60DB
    ButtonB220 = 0x60DC
    ButtonB221 = 0x60DD
    ButtonB222 = 0x60DE
    ButtonB223 = 0x60DF
    ButtonB224 = 0x60E0
    ButtonB225 = 0x60E1
    ButtonB226 = 0x60E2
    ButtonB227 = 0x60E3
    ButtonB228 = 0x60E4
    ButtonB229 = 0x60E5
    ButtonB230 = 0x60E6
    ButtonB231 = 0x60E7
    ButtonB232 = 0x60E8
    ButtonB233 = 0x60E9
    ButtonB234 = 0x60EA
    ButtonB235 = 0x60EB
    ButtonB236 = 0x60EC
    ButtonB237 = 0x60ED
    ButtonB238 = 0x60EE
    ButtonB239 = 0x60EF
    ButtonB240 = 0x60F0
    ButtonB241 = 0x60F1
    ButtonB242 = 0x60F2
    ButtonB243 = 0x60F3
    ButtonB244 = 0x60F4
    ButtonB245 = 0x60F5
    ButtonB246 = 0x60F6
    ButtonB247 = 0x60F7
    ButtonB248 = 0x60F8
    ButtonB249 = 0x60F9
    ButtonB250 = 0x60FA
    ButtonB251 = 0x60FB
    ButtonB252 = 0x60FC
    ButtonB253 = 0x60FD
    ButtonB254 = 0x60FE
    ButtonB255 = 0x60FF
    # SwitchB List
    SwitchB0 = 0x6100
    SwitchB1 = 0x6101
    SwitchB2 = 0x6102
    SwitchB3 = 0x6103
    SwitchB4 = 0x6104
    SwitchB5 = 0x6105
    SwitchB6 = 0x6106
    SwitchB7 = 0x6107
    SwitchB8 = 0x6108
    SwitchB9 = 0x6109
    SwitchB10 = 0x610A
    SwitchB11 = 0x610B
    SwitchB12 = 0x610C
    SwitchB13 = 0x610D
    SwitchB14 = 0x610E
    SwitchB15 = 0x610F
    SwitchB16 = 0x6110
    SwitchB17 = 0x6111
    SwitchB18 = 0x6112
    SwitchB19 = 0x6113
    SwitchB20 = 0x6114
    SwitchB21 = 0x6115
    SwitchB22 = 0x6116
    SwitchB23 = 0x6117
    SwitchB24 = 0x6118
    SwitchB25 = 0x6119
    SwitchB26 = 0x611A
    SwitchB27 = 0x611B
    SwitchB28 = 0x611C
    SwitchB29 = 0x611D
    SwitchB30 = 0x611E
    SwitchB31 = 0x611F
    SwitchB32 = 0x6120
    SwitchB33 = 0x6121
    SwitchB34 = 0x6122
    SwitchB35 = 0x6123
    SwitchB36 = 0x6124
    SwitchB37 = 0x6125
    SwitchB38 = 0x6126
    SwitchB39 = 0x6127
    SwitchB40 = 0x6128
    SwitchB41 = 0x6129
    SwitchB42 = 0x612A
    SwitchB43 = 0x612B
    SwitchB44 = 0x612C
    SwitchB45 = 0x612D
    SwitchB46 = 0x612E
    SwitchB47 = 0x612F
    SwitchB48 = 0x6130
    SwitchB49 = 0x6131
    SwitchB50 = 0x6132
    SwitchB51 = 0x6133
    SwitchB52 = 0x6134
    SwitchB53 = 0x6135
    SwitchB54 = 0x6136
    SwitchB55 = 0x6137
    SwitchB56 = 0x6138
    SwitchB57 = 0x6139
    SwitchB58 = 0x613A
    SwitchB59 = 0x613B
    SwitchB60 = 0x613C
    SwitchB61 = 0x613D
    SwitchB62 = 0x613E
    SwitchB63 = 0x613F
    SwitchB64 = 0x6140
    SwitchB65 = 0x6141
    SwitchB66 = 0x6142
    SwitchB67 = 0x6143
    SwitchB68 = 0x6144
    SwitchB69 = 0x6145
    SwitchB70 = 0x6146
    SwitchB71 = 0x6147
    SwitchB72 = 0x6148
    SwitchB73 = 0x6149
    SwitchB74 = 0x614A
    SwitchB75 = 0x614B
    SwitchB76 = 0x614C
    SwitchB77 = 0x614D
    SwitchB78 = 0x614E
    SwitchB79 = 0x614F
    SwitchB80 = 0x6150
    SwitchB81 = 0x6151
    SwitchB82 = 0x6152
    SwitchB83 = 0x6153
    SwitchB84 = 0x6154
    SwitchB85 = 0x6155
    SwitchB86 = 0x6156
    SwitchB87 = 0x6157
    SwitchB88 = 0x6158
    SwitchB89 = 0x6159
    SwitchB90 = 0x615A
    SwitchB91 = 0x615B
    SwitchB92 = 0x615C
    SwitchB93 = 0x615D
    SwitchB94 = 0x615E
    SwitchB95 = 0x615F
    SwitchB96 = 0x6160
    SwitchB97 = 0x6161
    SwitchB98 = 0x6162
    SwitchB99 = 0x6163
    SwitchB100 = 0x6164
    SwitchB101 = 0x6165
    SwitchB102 = 0x6166
    SwitchB103 = 0x6167
    SwitchB104 = 0x6168
    SwitchB105 = 0x6169
    SwitchB106 = 0x616A
    SwitchB107 = 0x616B
    SwitchB108 = 0x616C
    SwitchB109 = 0x616D
    SwitchB110 = 0x616E
    SwitchB111 = 0x616F
    SwitchB112 = 0x6170
    SwitchB113 = 0x6171
    SwitchB114 = 0x6172
    SwitchB115 = 0x6173
    SwitchB116 = 0x6174
    SwitchB117 = 0x6175
    SwitchB118 = 0x6176
    SwitchB119 = 0x6177
    SwitchB120 = 0x6178
    SwitchB121 = 0x6179
    SwitchB122 = 0x617A
    SwitchB123 = 0x617B
    SwitchB124 = 0x617C
    SwitchB125 = 0x617D
    SwitchB126 = 0x617E
    SwitchB127 = 0x617F
    SwitchB128 = 0x6180
    SwitchB129 = 0x6181
    SwitchB130 = 0x6182
    SwitchB131 = 0x6183
    SwitchB132 = 0x6184
    SwitchB133 = 0x6185
    SwitchB134 = 0x6186
    SwitchB135 = 0x6187
    SwitchB136 = 0x6188
    SwitchB137 = 0x6189
    SwitchB138 = 0x618A
    SwitchB139 = 0x618B
    SwitchB140 = 0x618C
    SwitchB141 = 0x618D
    SwitchB142 = 0x618E
    SwitchB143 = 0x618F
    SwitchB144 = 0x6190
    SwitchB145 = 0x6191
    SwitchB146 = 0x6192
    SwitchB147 = 0x6193
    SwitchB148 = 0x6194
    SwitchB149 = 0x6195
    SwitchB150 = 0x6196
    SwitchB151 = 0x6197
    SwitchB152 = 0x6198
    SwitchB153 = 0x6199
    SwitchB154 = 0x619A
    SwitchB155 = 0x619B
    SwitchB156 = 0x619C
    SwitchB157 = 0x619D
    SwitchB158 = 0x619E
    SwitchB159 = 0x619F
    SwitchB160 = 0x61A0
    SwitchB161 = 0x61A1
    SwitchB162 = 0x61A2
    SwitchB163 = 0x61A3
    SwitchB164 = 0x61A4
    SwitchB165 = 0x61A5
    SwitchB166 = 0x61A6
    SwitchB167 = 0x61A7
    SwitchB168 = 0x61A8
    SwitchB169 = 0x61A9
    SwitchB170 = 0x61AA
    SwitchB171 = 0x61AB
    SwitchB172 = 0x61AC
    SwitchB173 = 0x61AD
    SwitchB174 = 0x61AE
    SwitchB175 = 0x61AF
    SwitchB176 = 0x61B0
    SwitchB177 = 0x61B1
    SwitchB178 = 0x61B2
    SwitchB179 = 0x61B3
    SwitchB180 = 0x61B4
    SwitchB181 = 0x61B5
    SwitchB182 = 0x61B6
    SwitchB183 = 0x61B7
    SwitchB184 = 0x61B8
    SwitchB185 = 0x61B9
    SwitchB186 = 0x61BA
    SwitchB187 = 0x61BB
    SwitchB188 = 0x61BC
    SwitchB189 = 0x61BD
    SwitchB190 = 0x61BE
    SwitchB191 = 0x61BF
    SwitchB192 = 0x61C0
    SwitchB193 = 0x61C1
    SwitchB194 = 0x61C2
    SwitchB195 = 0x61C3
    SwitchB196 = 0x61C4
    SwitchB197 = 0x61C5
    SwitchB198 = 0x61C6
    SwitchB199 = 0x61C7
    SwitchB200 = 0x61C8
    SwitchB201 = 0x61C9
    SwitchB202 = 0x61CA
    SwitchB203 = 0x61CB
    SwitchB204 = 0x61CC
    SwitchB205 = 0x61CD
    SwitchB206 = 0x61CE
    SwitchB207 = 0x61CF
    SwitchB208 = 0x61D0
    SwitchB209 = 0x61D1
    SwitchB210 = 0x61D2
    SwitchB211 = 0x61D3
    SwitchB212 = 0x61D4
    SwitchB213 = 0x61D5
    SwitchB214 = 0x61D6
    SwitchB215 = 0x61D7
    SwitchB216 = 0x61D8
    SwitchB217 = 0x61D9
    SwitchB218 = 0x61DA
    SwitchB219 = 0x61DB
    SwitchB220 = 0x61DC
    SwitchB221 = 0x61DD
    SwitchB222 = 0x61DE
    SwitchB223 = 0x61DF
    SwitchB224 = 0x61E0
    SwitchB225 = 0x61E1
    SwitchB226 = 0x61E2
    SwitchB227 = 0x61E3
    SwitchB228 = 0x61E4
    SwitchB229 = 0x61E5
    SwitchB230 = 0x61E6
    SwitchB231 = 0x61E7
    SwitchB232 = 0x61E8
    SwitchB233 = 0x61E9
    SwitchB234 = 0x61EA
    SwitchB235 = 0x61EB
    SwitchB236 = 0x61EC
    SwitchB237 = 0x61ED
    SwitchB238 = 0x61EE
    SwitchB239 = 0x61EF
    SwitchB240 = 0x61F0
    SwitchB241 = 0x61F1
    SwitchB242 = 0x61F2
    SwitchB243 = 0x61F3
    SwitchB244 = 0x61F4
    SwitchB245 = 0x61F5
    SwitchB246 = 0x61F6
    SwitchB247 = 0x61F7
    SwitchB248 = 0x61F8
    SwitchB249 = 0x61F9
    SwitchB250 = 0x61FA
    SwitchB251 = 0x61FB
    SwitchB252 = 0x61FC
    SwitchB253 = 0x61FD
    SwitchB254 = 0x61FE
    SwitchB255 = 0x61FF
    # MediaButton List
    MediaButton0 = 0x6200
    MediaButton1 = 0x6201
    MediaButton2 = 0x6202
    MediaButton3 = 0x6203
    MediaButton4 = 0x6204
    MediaButton5 = 0x6205
    MediaButton6 = 0x6206
    MediaButton7 = 0x6207
    MediaButton8 = 0x6208
    MediaButton9 = 0x6209
    MediaButton10 = 0x620A
    MediaButton11 = 0x620B
    MediaButton12 = 0x620C
    MediaButton13 = 0x620D
    MediaButton14 = 0x620E
    MediaButton15 = 0x620F
    MediaButton16 = 0x6210
    MediaButton17 = 0x6211
    MediaButton18 = 0x6212
    MediaButton19 = 0x6213
    MediaButton20 = 0x6214
    MediaButton21 = 0x6215
    MediaButton22 = 0x6216
    MediaButton23 = 0x6217
    MediaButton24 = 0x6218
    MediaButton25 = 0x6219
    MediaButton26 = 0x621A
    MediaButton27 = 0x621B
    MediaButton28 = 0x621C
    MediaButton29 = 0x621D
    MediaButton30 = 0x621E
    MediaButton31 = 0x621F
    MediaButton32 = 0x6220
    MediaButton33 = 0x6221
    MediaButton34 = 0x6222
    MediaButton35 = 0x6223
    MediaButton36 = 0x6224
    MediaButton37 = 0x6225
    MediaButton38 = 0x6226
    MediaButton39 = 0x6227
    MediaButton40 = 0x6228
    MediaButton41 = 0x6229
    MediaButton42 = 0x622A
    MediaButton43 = 0x622B
    MediaButton44 = 0x622C
    MediaButton45 = 0x622D
    MediaButton46 = 0x622E
    MediaButton47 = 0x622F
    MediaButton48 = 0x6230
    MediaButton49 = 0x6231
    MediaButton50 = 0x6232
    MediaButton51 = 0x6233
    MediaButton52 = 0x6234
    MediaButton53 = 0x6235
    MediaButton54 = 0x6236
    MediaButton55 = 0x6237
    MediaButton56 = 0x6238
    MediaButton57 = 0x6239
    MediaButton58 = 0x623A
    MediaButton59 = 0x623B
    MediaButton60 = 0x623C
    MediaButton61 = 0x623D
    MediaButton62 = 0x623E
    MediaButton63 = 0x623F
    MediaButton64 = 0x6240
    MediaButton65 = 0x6241
    MediaButton66 = 0x6242
    MediaButton67 = 0x6243
    MediaButton68 = 0x6244
    MediaButton69 = 0x6245
    MediaButton70 = 0x6246
    MediaButton71 = 0x6247
    MediaButton72 = 0x6248
    MediaButton73 = 0x6249
    MediaButton74 = 0x624A
    MediaButton75 = 0x624B
    MediaButton76 = 0x624C
    MediaButton77 = 0x624D
    MediaButton78 = 0x624E
    MediaButton79 = 0x624F
    MediaButton80 = 0x6250
    MediaButton81 = 0x6251
    MediaButton82 = 0x6252
    MediaButton83 = 0x6253
    MediaButton84 = 0x6254
    MediaButton85 = 0x6255
    MediaButton86 = 0x6256
    MediaButton87 = 0x6257
    MediaButton88 = 0x6258
    MediaButton89 = 0x6259
    MediaButton90 = 0x625A
    MediaButton91 = 0x625B
    MediaButton92 = 0x625C
    MediaButton93 = 0x625D
    MediaButton94 = 0x625E
    MediaButton95 = 0x625F
    MediaButton96 = 0x6260
    MediaButton97 = 0x6261
    MediaButton98 = 0x6262
    MediaButton99 = 0x6263
    MediaButton100 = 0x6264
    MediaButton101 = 0x6265
    MediaButton102 = 0x6266
    MediaButton103 = 0x6267
    MediaButton104 = 0x6268
    MediaButton105 = 0x6269
    MediaButton106 = 0x626A
    MediaButton107 = 0x626B
    MediaButton108 = 0x626C
    MediaButton109 = 0x626D
    MediaButton110 = 0x626E
    MediaButton111 = 0x626F
    MediaButton112 = 0x6270
    MediaButton113 = 0x6271
    MediaButton114 = 0x6272
    MediaButton115 = 0x6273
    MediaButton116 = 0x6274
    MediaButton117 = 0x6275
    MediaButton118 = 0x6276
    MediaButton119 = 0x6277
    MediaButton120 = 0x6278
    MediaButton121 = 0x6279
    MediaButton122 = 0x627A
    MediaButton123 = 0x627B
    MediaButton124 = 0x627C
    MediaButton125 = 0x627D
    MediaButton126 = 0x627E
    MediaButton127 = 0x627F
    MediaButton128 = 0x6280
    MediaButton129 = 0x6281
    MediaButton130 = 0x6282
    MediaButton131 = 0x6283
    MediaButton132 = 0x6284
    MediaButton133 = 0x6285
    MediaButton134 = 0x6286
    MediaButton135 = 0x6287
    MediaButton136 = 0x6288
    MediaButton137 = 0x6289
    MediaButton138 = 0x628A
    MediaButton139 = 0x628B
    MediaButton140 = 0x628C
    MediaButton141 = 0x628D
    MediaButton142 = 0x628E
    MediaButton143 = 0x628F
    MediaButton144 = 0x6290
    MediaButton145 = 0x6291
    MediaButton146 = 0x6292
    MediaButton147 = 0x6293
    MediaButton148 = 0x6294
    MediaButton149 = 0x6295
    MediaButton150 = 0x6296
    MediaButton151 = 0x6297
    MediaButton152 = 0x6298
    MediaButton153 = 0x6299
    MediaButton154 = 0x629A
    MediaButton155 = 0x629B
    MediaButton156 = 0x629C
    MediaButton157 = 0x629D
    MediaButton158 = 0x629E
    MediaButton159 = 0x629F
    MediaButton160 = 0x62A0
    MediaButton161 = 0x62A1
    MediaButton162 = 0x62A2
    MediaButton163 = 0x62A3
    MediaButton164 = 0x62A4
    MediaButton165 = 0x62A5
    MediaButton166 = 0x62A6
    MediaButton167 = 0x62A7
    MediaButton168 = 0x62A8
    MediaButton169 = 0x62A9
    MediaButton170 = 0x62AA
    MediaButton171 = 0x62AB
    MediaButton172 = 0x62AC
    MediaButton173 = 0x62AD
    MediaButton174 = 0x62AE
    MediaButton175 = 0x62AF
    MediaButton176 = 0x62B0
    MediaButton177 = 0x62B1
    MediaButton178 = 0x62B2
    MediaButton179 = 0x62B3
    MediaButton180 = 0x62B4
    MediaButton181 = 0x62B5
    MediaButton182 = 0x62B6
    MediaButton183 = 0x62B7
    MediaButton184 = 0x62B8
    MediaButton185 = 0x62B9
    MediaButton186 = 0x62BA
    MediaButton187 = 0x62BB
    MediaButton188 = 0x62BC
    MediaButton189 = 0x62BD
    MediaButton190 = 0x62BE
    MediaButton191 = 0x62BF
    MediaButton192 = 0x62C0
    MediaButton193 = 0x62C1
    MediaButton194 = 0x62C2
    MediaButton195 = 0x62C3
    MediaButton196 = 0x62C4
    MediaButton197 = 0x62C5
    MediaButton198 = 0x62C6
    MediaButton199 = 0x62C7
    MediaButton200 = 0x62C8
    MediaButton201 = 0x62C9
    MediaButton202 = 0x62CA
    MediaButton203 = 0x62CB
    MediaButton204 = 0x62CC
    MediaButton205 = 0x62CD
    MediaButton206 = 0x62CE
    MediaButton207 = 0x62CF
    MediaButton208 = 0x62D0
    MediaButton209 = 0x62D1
    MediaButton210 = 0x62D2
    MediaButton211 = 0x62D3
    MediaButton212 = 0x62D4
    MediaButton213 = 0x62D5
    MediaButton214 = 0x62D6
    MediaButton215 = 0x62D7
    MediaButton216 = 0x62D8
    MediaButton217 = 0x62D9
    MediaButton218 = 0x62DA
    MediaButton219 = 0x62DB
    MediaButton220 = 0x62DC
    MediaButton221 = 0x62DD
    MediaButton222 = 0x62DE
    MediaButton223 = 0x62DF
    MediaButton224 = 0x62E0
    MediaButton225 = 0x62E1
    MediaButton226 = 0x62E2
    MediaButton227 = 0x62E3
    MediaButton228 = 0x62E4
    MediaButton229 = 0x62E5
    MediaButton230 = 0x62E6
    MediaButton231 = 0x62E7
    MediaButton232 = 0x62E8
    MediaButton233 = 0x62E9
    MediaButton234 = 0x62EA
    MediaButton235 = 0x62EB
    MediaButton236 = 0x62EC
    MediaButton237 = 0x62ED
    MediaButton238 = 0x62EE
    MediaButton239 = 0x62EF
    MediaButton240 = 0x62F0
    MediaButton241 = 0x62F1
    MediaButton242 = 0x62F2
    MediaButton243 = 0x62F3
    MediaButton244 = 0x62F4
    MediaButton245 = 0x62F5
    MediaButton246 = 0x62F6
    MediaButton247 = 0x62F7
    MediaButton248 = 0x62F8
    MediaButton249 = 0x62F9
    MediaButton250 = 0x62FA
    MediaButton251 = 0x62FB
    MediaButton252 = 0x62FC
    MediaButton253 = 0x62FD
    MediaButton254 = 0x62FE
    MediaButton255 = 0x62FF
    # SliderA List
    SliderA0 = 0x6300
    SliderA1 = 0x6301
    SliderA2 = 0x6302
    SliderA3 = 0x6303
    SliderA4 = 0x6304
    SliderA5 = 0x6305
    SliderA6 = 0x6306
    SliderA7 = 0x6307
    SliderA8 = 0x6308
    SliderA9 = 0x6309
    SliderA10 = 0x630A
    SliderA11 = 0x630B
    SliderA12 = 0x630C
    SliderA13 = 0x630D
    SliderA14 = 0x630E
    SliderA15 = 0x630F
    SliderA16 = 0x6310
    SliderA17 = 0x6311
    SliderA18 = 0x6312
    SliderA19 = 0x6313
    SliderA20 = 0x6314
    SliderA21 = 0x6315
    SliderA22 = 0x6316
    SliderA23 = 0x6317
    SliderA24 = 0x6318
    SliderA25 = 0x6319
    SliderA26 = 0x631A
    SliderA27 = 0x631B
    SliderA28 = 0x631C
    SliderA29 = 0x631D
    SliderA30 = 0x631E
    SliderA31 = 0x631F
    SliderA32 = 0x6320
    SliderA33 = 0x6321
    SliderA34 = 0x6322
    SliderA35 = 0x6323
    SliderA36 = 0x6324
    SliderA37 = 0x6325
    SliderA38 = 0x6326
    SliderA39 = 0x6327
    SliderA40 = 0x6328
    SliderA41 = 0x6329
    SliderA42 = 0x632A
    SliderA43 = 0x632B
    SliderA44 = 0x632C
    SliderA45 = 0x632D
    SliderA46 = 0x632E
    SliderA47 = 0x632F
    SliderA48 = 0x6330
    SliderA49 = 0x6331
    SliderA50 = 0x6332
    SliderA51 = 0x6333
    SliderA52 = 0x6334
    SliderA53 = 0x6335
    SliderA54 = 0x6336
    SliderA55 = 0x6337
    SliderA56 = 0x6338
    SliderA57 = 0x6339
    SliderA58 = 0x633A
    SliderA59 = 0x633B
    SliderA60 = 0x633C
    SliderA61 = 0x633D
    SliderA62 = 0x633E
    SliderA63 = 0x633F
    SliderA64 = 0x6340
    SliderA65 = 0x6341
    SliderA66 = 0x6342
    SliderA67 = 0x6343
    SliderA68 = 0x6344
    SliderA69 = 0x6345
    SliderA70 = 0x6346
    SliderA71 = 0x6347
    SliderA72 = 0x6348
    SliderA73 = 0x6349
    SliderA74 = 0x634A
    SliderA75 = 0x634B
    SliderA76 = 0x634C
    SliderA77 = 0x634D
    SliderA78 = 0x634E
    SliderA79 = 0x634F
    SliderA80 = 0x6350
    SliderA81 = 0x6351
    SliderA82 = 0x6352
    SliderA83 = 0x6353
    SliderA84 = 0x6354
    SliderA85 = 0x6355
    SliderA86 = 0x6356
    SliderA87 = 0x6357
    SliderA88 = 0x6358
    SliderA89 = 0x6359
    SliderA90 = 0x635A
    SliderA91 = 0x635B
    SliderA92 = 0x635C
    SliderA93 = 0x635D
    SliderA94 = 0x635E
    SliderA95 = 0x635F
    SliderA96 = 0x6360
    SliderA97 = 0x6361
    SliderA98 = 0x6362
    SliderA99 = 0x6363
    SliderA100 = 0x6364
    SliderA101 = 0x6365
    SliderA102 = 0x6366
    SliderA103 = 0x6367
    SliderA104 = 0x6368
    SliderA105 = 0x6369
    SliderA106 = 0x636A
    SliderA107 = 0x636B
    SliderA108 = 0x636C
    SliderA109 = 0x636D
    SliderA110 = 0x636E
    SliderA111 = 0x636F
    SliderA112 = 0x6370
    SliderA113 = 0x6371
    SliderA114 = 0x6372
    SliderA115 = 0x6373
    SliderA116 = 0x6374
    SliderA117 = 0x6375
    SliderA118 = 0x6376
    SliderA119 = 0x6377
    SliderA120 = 0x6378
    SliderA121 = 0x6379
    SliderA122 = 0x637A
    SliderA123 = 0x637B
    SliderA124 = 0x637C
    SliderA125 = 0x637D
    SliderA126 = 0x637E
    SliderA127 = 0x637F
    SliderA128 = 0x6380
    SliderA129 = 0x6381
    SliderA130 = 0x6382
    SliderA131 = 0x6383
    SliderA132 = 0x6384
    SliderA133 = 0x6385
    SliderA134 = 0x6386
    SliderA135 = 0x6387
    SliderA136 = 0x6388
    SliderA137 = 0x6389
    SliderA138 = 0x638A
    SliderA139 = 0x638B
    SliderA140 = 0x638C
    SliderA141 = 0x638D
    SliderA142 = 0x638E
    SliderA143 = 0x638F
    SliderA144 = 0x6390
    SliderA145 = 0x6391
    SliderA146 = 0x6392
    SliderA147 = 0x6393
    SliderA148 = 0x6394
    SliderA149 = 0x6395
    SliderA150 = 0x6396
    SliderA151 = 0x6397
    SliderA152 = 0x6398
    SliderA153 = 0x6399
    SliderA154 = 0x639A
    SliderA155 = 0x639B
    SliderA156 = 0x639C
    SliderA157 = 0x639D
    SliderA158 = 0x639E
    SliderA159 = 0x639F
    SliderA160 = 0x63A0
    SliderA161 = 0x63A1
    SliderA162 = 0x63A2
    SliderA163 = 0x63A3
    SliderA164 = 0x63A4
    SliderA165 = 0x63A5
    SliderA166 = 0x63A6
    SliderA167 = 0x63A7
    SliderA168 = 0x63A8
    SliderA169 = 0x63A9
    SliderA170 = 0x63AA
    SliderA171 = 0x63AB
    SliderA172 = 0x63AC
    SliderA173 = 0x63AD
    SliderA174 = 0x63AE
    SliderA175 = 0x63AF
    SliderA176 = 0x63B0
    SliderA177 = 0x63B1
    SliderA178 = 0x63B2
    SliderA179 = 0x63B3
    SliderA180 = 0x63B4
    SliderA181 = 0x63B5
    SliderA182 = 0x63B6
    SliderA183 = 0x63B7
    SliderA184 = 0x63B8
    SliderA185 = 0x63B9
    SliderA186 = 0x63BA
    SliderA187 = 0x63BB
    SliderA188 = 0x63BC
    SliderA189 = 0x63BD
    SliderA190 = 0x63BE
    SliderA191 = 0x63BF
    SliderA192 = 0x63C0
    SliderA193 = 0x63C1
    SliderA194 = 0x63C2
    SliderA195 = 0x63C3
    SliderA196 = 0x63C4
    SliderA197 = 0x63C5
    SliderA198 = 0x63C6
    SliderA199 = 0x63C7
    SliderA200 = 0x63C8
    SliderA201 = 0x63C9
    SliderA202 = 0x63CA
    SliderA203 = 0x63CB
    SliderA204 = 0x63CC
    SliderA205 = 0x63CD
    SliderA206 = 0x63CE
    SliderA207 = 0x63CF
    SliderA208 = 0x63D0
    SliderA209 = 0x63D1
    SliderA210 = 0x63D2
    SliderA211 = 0x63D3
    SliderA212 = 0x63D4
    SliderA213 = 0x63D5
    SliderA214 = 0x63D6
    SliderA215 = 0x63D7
    SliderA216 = 0x63D8
    SliderA217 = 0x63D9
    SliderA218 = 0x63DA
    SliderA219 = 0x63DB
    SliderA220 = 0x63DC
    SliderA221 = 0x63DD
    SliderA222 = 0x63DE
    SliderA223 = 0x63DF
    SliderA224 = 0x63E0
    SliderA225 = 0x63E1
    SliderA226 = 0x63E2
    SliderA227 = 0x63E3
    SliderA228 = 0x63E4
    SliderA229 = 0x63E5
    SliderA230 = 0x63E6
    SliderA231 = 0x63E7
    SliderA232 = 0x63E8
    SliderA233 = 0x63E9
    SliderA234 = 0x63EA
    SliderA235 = 0x63EB
    SliderA236 = 0x63EC
    SliderA237 = 0x63ED
    SliderA238 = 0x63EE
    SliderA239 = 0x63EF
    SliderA240 = 0x63F0
    SliderA241 = 0x63F1
    SliderA242 = 0x63F2
    SliderA243 = 0x63F3
    SliderA244 = 0x63F4
    SliderA245 = 0x63F5
    SliderA246 = 0x63F6
    SliderA247 = 0x63F7
    SliderA248 = 0x63F8
    SliderA249 = 0x63F9
    SliderA250 = 0x63FA
    SliderA251 = 0x63FB
    SliderA252 = 0x63FC
    SliderA253 = 0x63FD
    SliderA254 = 0x63FE
    SliderA255 = 0x63FF
    # SliderC List
    SliderC0 = 0x6400
    SliderC1 = 0x6401
    SliderC2 = 0x6402
    SliderC3 = 0x6403
    SliderC4 = 0x6404
    SliderC5 = 0x6405
    SliderC6 = 0x6406
    SliderC7 = 0x6407
    SliderC8 = 0x6408
    SliderC9 = 0x6409
    SliderC10 = 0x640A
    SliderC11 = 0x640B
    SliderC12 = 0x640C
    SliderC13 = 0x640D
    SliderC14 = 0x640E
    SliderC15 = 0x640F
    SliderC16 = 0x6410
    SliderC17 = 0x6411
    SliderC18 = 0x6412
    SliderC19 = 0x6413
    SliderC20 = 0x6414
    SliderC21 = 0x6415
    SliderC22 = 0x6416
    SliderC23 = 0x6417
    SliderC24 = 0x6418
    SliderC25 = 0x6419
    SliderC26 = 0x641A
    SliderC27 = 0x641B
    SliderC28 = 0x641C
    SliderC29 = 0x641D
    SliderC30 = 0x641E
    SliderC31 = 0x641F
    SliderC32 = 0x6420
    SliderC33 = 0x6421
    SliderC34 = 0x6422
    SliderC35 = 0x6423
    SliderC36 = 0x6424
    SliderC37 = 0x6425
    SliderC38 = 0x6426
    SliderC39 = 0x6427
    SliderC40 = 0x6428
    SliderC41 = 0x6429
    SliderC42 = 0x642A
    SliderC43 = 0x642B
    SliderC44 = 0x642C
    SliderC45 = 0x642D
    SliderC46 = 0x642E
    SliderC47 = 0x642F
    SliderC48 = 0x6430
    SliderC49 = 0x6431
    SliderC50 = 0x6432
    SliderC51 = 0x6433
    SliderC52 = 0x6434
    SliderC53 = 0x6435
    SliderC54 = 0x6436
    SliderC55 = 0x6437
    SliderC56 = 0x6438
    SliderC57 = 0x6439
    SliderC58 = 0x643A
    SliderC59 = 0x643B
    SliderC60 = 0x643C
    SliderC61 = 0x643D
    SliderC62 = 0x643E
    SliderC63 = 0x643F
    SliderC64 = 0x6440
    SliderC65 = 0x6441
    SliderC66 = 0x6442
    SliderC67 = 0x6443
    SliderC68 = 0x6444
    SliderC69 = 0x6445
    SliderC70 = 0x6446
    SliderC71 = 0x6447
    SliderC72 = 0x6448
    SliderC73 = 0x6449
    SliderC74 = 0x644A
    SliderC75 = 0x644B
    SliderC76 = 0x644C
    SliderC77 = 0x644D
    SliderC78 = 0x644E
    SliderC79 = 0x644F
    SliderC80 = 0x6450
    SliderC81 = 0x6451
    SliderC82 = 0x6452
    SliderC83 = 0x6453
    SliderC84 = 0x6454
    SliderC85 = 0x6455
    SliderC86 = 0x6456
    SliderC87 = 0x6457
    SliderC88 = 0x6458
    SliderC89 = 0x6459
    SliderC90 = 0x645A
    SliderC91 = 0x645B
    SliderC92 = 0x645C
    SliderC93 = 0x645D
    SliderC94 = 0x645E
    SliderC95 = 0x645F
    SliderC96 = 0x6460
    SliderC97 = 0x6461
    SliderC98 = 0x6462
    SliderC99 = 0x6463
    SliderC100 = 0x6464
    SliderC101 = 0x6465
    SliderC102 = 0x6466
    SliderC103 = 0x6467
    SliderC104 = 0x6468
    SliderC105 = 0x6469
    SliderC106 = 0x646A
    SliderC107 = 0x646B
    SliderC108 = 0x646C
    SliderC109 = 0x646D
    SliderC110 = 0x646E
    SliderC111 = 0x646F
    SliderC112 = 0x6470
    SliderC113 = 0x6471
    SliderC114 = 0x6472
    SliderC115 = 0x6473
    SliderC116 = 0x6474
    SliderC117 = 0x6475
    SliderC118 = 0x6476
    SliderC119 = 0x6477
    SliderC120 = 0x6478
    SliderC121 = 0x6479
    SliderC122 = 0x647A
    SliderC123 = 0x647B
    SliderC124 = 0x647C
    SliderC125 = 0x647D
    SliderC126 = 0x647E
    SliderC127 = 0x647F
    SliderC128 = 0x6480
    SliderC129 = 0x6481
    SliderC130 = 0x6482
    SliderC131 = 0x6483
    SliderC132 = 0x6484
    SliderC133 = 0x6485
    SliderC134 = 0x6486
    SliderC135 = 0x6487
    SliderC136 = 0x6488
    SliderC137 = 0x6489
    SliderC138 = 0x648A
    SliderC139 = 0x648B
    SliderC140 = 0x648C
    SliderC141 = 0x648D
    SliderC142 = 0x648E
    SliderC143 = 0x648F
    SliderC144 = 0x6490
    SliderC145 = 0x6491
    SliderC146 = 0x6492
    SliderC147 = 0x6493
    SliderC148 = 0x6494
    SliderC149 = 0x6495
    SliderC150 = 0x6496
    SliderC151 = 0x6497
    SliderC152 = 0x6498
    SliderC153 = 0x6499
    SliderC154 = 0x649A
    SliderC155 = 0x649B
    SliderC156 = 0x649C
    SliderC157 = 0x649D
    SliderC158 = 0x649E
    SliderC159 = 0x649F
    SliderC160 = 0x64A0
    SliderC161 = 0x64A1
    SliderC162 = 0x64A2
    SliderC163 = 0x64A3
    SliderC164 = 0x64A4
    SliderC165 = 0x64A5
    SliderC166 = 0x64A6
    SliderC167 = 0x64A7
    SliderC168 = 0x64A8
    SliderC169 = 0x64A9
    SliderC170 = 0x64AA
    SliderC171 = 0x64AB
    SliderC172 = 0x64AC
    SliderC173 = 0x64AD
    SliderC174 = 0x64AE
    SliderC175 = 0x64AF
    SliderC176 = 0x64B0
    SliderC177 = 0x64B1
    SliderC178 = 0x64B2
    SliderC179 = 0x64B3
    SliderC180 = 0x64B4
    SliderC181 = 0x64B5
    SliderC182 = 0x64B6
    SliderC183 = 0x64B7
    SliderC184 = 0x64B8
    SliderC185 = 0x64B9
    SliderC186 = 0x64BA
    SliderC187 = 0x64BB
    SliderC188 = 0x64BC
    SliderC189 = 0x64BD
    SliderC190 = 0x64BE
    SliderC191 = 0x64BF
    SliderC192 = 0x64C0
    SliderC193 = 0x64C1
    SliderC194 = 0x64C2
    SliderC195 = 0x64C3
    SliderC196 = 0x64C4
    SliderC197 = 0x64C5
    SliderC198 = 0x64C6
    SliderC199 = 0x64C7
    SliderC200 = 0x64C8
    SliderC201 = 0x64C9
    SliderC202 = 0x64CA
    SliderC203 = 0x64CB
    SliderC204 = 0x64CC
    SliderC205 = 0x64CD
    SliderC206 = 0x64CE
    SliderC207 = 0x64CF
    SliderC208 = 0x64D0
    SliderC209 = 0x64D1
    SliderC210 = 0x64D2
    SliderC211 = 0x64D3
    SliderC212 = 0x64D4
    SliderC213 = 0x64D5
    SliderC214 = 0x64D6
    SliderC215 = 0x64D7
    SliderC216 = 0x64D8
    SliderC217 = 0x64D9
    SliderC218 = 0x64DA
    SliderC219 = 0x64DB
    SliderC220 = 0x64DC
    SliderC221 = 0x64DD
    SliderC222 = 0x64DE
    SliderC223 = 0x64DF
    SliderC224 = 0x64E0
    SliderC225 = 0x64E1
    SliderC226 = 0x64E2
    SliderC227 = 0x64E3
    SliderC228 = 0x64E4
    SliderC229 = 0x64E5
    SliderC230 = 0x64E6
    SliderC231 = 0x64E7
    SliderC232 = 0x64E8
    SliderC233 = 0x64E9
    SliderC234 = 0x64EA
    SliderC235 = 0x64EB
    SliderC236 = 0x64EC
    SliderC237 = 0x64ED
    SliderC238 = 0x64EE
    SliderC239 = 0x64EF
    SliderC240 = 0x64F0
    SliderC241 = 0x64F1
    SliderC242 = 0x64F2
    SliderC243 = 0x64F3
    SliderC244 = 0x64F4
    SliderC245 = 0x64F5
    SliderC246 = 0x64F6
    SliderC247 = 0x64F7
    SliderC248 = 0x64F8
    SliderC249 = 0x64F9
    SliderC250 = 0x64FA
    SliderC251 = 0x64FB
    SliderC252 = 0x64FC
    SliderC253 = 0x64FD
    SliderC254 = 0x64FE
    SliderC255 = 0x64FF
    # SliderD List
    SliderD0 = 0x6500
    SliderD1 = 0x6501
    SliderD2 = 0x6502
    SliderD3 = 0x6503
    SliderD4 = 0x6504
    SliderD5 = 0x6505
    SliderD6 = 0x6506
    SliderD7 = 0x6507
    SliderD8 = 0x6508
    SliderD9 = 0x6509
    SliderD10 = 0x650A
    SliderD11 = 0x650B
    SliderD12 = 0x650C
    SliderD13 = 0x650D
    SliderD14 = 0x650E
    SliderD15 = 0x650F
    SliderD16 = 0x6510
    SliderD17 = 0x6511
    SliderD18 = 0x6512
    SliderD19 = 0x6513
    SliderD20 = 0x6514
    SliderD21 = 0x6515
    SliderD22 = 0x6516
    SliderD23 = 0x6517
    SliderD24 = 0x6518
    SliderD25 = 0x6519
    SliderD26 = 0x651A
    SliderD27 = 0x651B
    SliderD28 = 0x651C
    SliderD29 = 0x651D
    SliderD30 = 0x651E
    SliderD31 = 0x651F
    SliderD32 = 0x6520
    SliderD33 = 0x6521
    SliderD34 = 0x6522
    SliderD35 = 0x6523
    SliderD36 = 0x6524
    SliderD37 = 0x6525
    SliderD38 = 0x6526
    SliderD39 = 0x6527
    SliderD40 = 0x6528
    SliderD41 = 0x6529
    SliderD42 = 0x652A
    SliderD43 = 0x652B
    SliderD44 = 0x652C
    SliderD45 = 0x652D
    SliderD46 = 0x652E
    SliderD47 = 0x652F
    SliderD48 = 0x6530
    SliderD49 = 0x6531
    SliderD50 = 0x6532
    SliderD51 = 0x6533
    SliderD52 = 0x6534
    SliderD53 = 0x6535
    SliderD54 = 0x6536
    SliderD55 = 0x6537
    SliderD56 = 0x6538
    SliderD57 = 0x6539
    SliderD58 = 0x653A
    SliderD59 = 0x653B
    SliderD60 = 0x653C
    SliderD61 = 0x653D
    SliderD62 = 0x653E
    SliderD63 = 0x653F
    SliderD64 = 0x6540
    SliderD65 = 0x6541
    SliderD66 = 0x6542
    SliderD67 = 0x6543
    SliderD68 = 0x6544
    SliderD69 = 0x6545
    SliderD70 = 0x6546
    SliderD71 = 0x6547
    SliderD72 = 0x6548
    SliderD73 = 0x6549
    SliderD74 = 0x654A
    SliderD75 = 0x654B
    SliderD76 = 0x654C
    SliderD77 = 0x654D
    SliderD78 = 0x654E
    SliderD79 = 0x654F
    SliderD80 = 0x6550
    SliderD81 = 0x6551
    SliderD82 = 0x6552
    SliderD83 = 0x6553
    SliderD84 = 0x6554
    SliderD85 = 0x6555
    SliderD86 = 0x6556
    SliderD87 = 0x6557
    SliderD88 = 0x6558
    SliderD89 = 0x6559
    SliderD90 = 0x655A
    SliderD91 = 0x655B
    SliderD92 = 0x655C
    SliderD93 = 0x655D
    SliderD94 = 0x655E
    SliderD95 = 0x655F
    SliderD96 = 0x6560
    SliderD97 = 0x6561
    SliderD98 = 0x6562
    SliderD99 = 0x6563
    SliderD100 = 0x6564
    SliderD101 = 0x6565
    SliderD102 = 0x6566
    SliderD103 = 0x6567
    SliderD104 = 0x6568
    SliderD105 = 0x6569
    SliderD106 = 0x656A
    SliderD107 = 0x656B
    SliderD108 = 0x656C
    SliderD109 = 0x656D
    SliderD110 = 0x656E
    SliderD111 = 0x656F
    SliderD112 = 0x6570
    SliderD113 = 0x6571
    SliderD114 = 0x6572
    SliderD115 = 0x6573
    SliderD116 = 0x6574
    SliderD117 = 0x6575
    SliderD118 = 0x6576
    SliderD119 = 0x6577
    SliderD120 = 0x6578
    SliderD121 = 0x6579
    SliderD122 = 0x657A
    SliderD123 = 0x657B
    SliderD124 = 0x657C
    SliderD125 = 0x657D
    SliderD126 = 0x657E
    SliderD127 = 0x657F
    SliderD128 = 0x6580
    SliderD129 = 0x6581
    SliderD130 = 0x6582
    SliderD131 = 0x6583
    SliderD132 = 0x6584
    SliderD133 = 0x6585
    SliderD134 = 0x6586
    SliderD135 = 0x6587
    SliderD136 = 0x6588
    SliderD137 = 0x6589
    SliderD138 = 0x658A
    SliderD139 = 0x658B
    SliderD140 = 0x658C
    SliderD141 = 0x658D
    SliderD142 = 0x658E
    SliderD143 = 0x658F
    SliderD144 = 0x6590
    SliderD145 = 0x6591
    SliderD146 = 0x6592
    SliderD147 = 0x6593
    SliderD148 = 0x6594
    SliderD149 = 0x6595
    SliderD150 = 0x6596
    SliderD151 = 0x6597
    SliderD152 = 0x6598
    SliderD153 = 0x6599
    SliderD154 = 0x659A
    SliderD155 = 0x659B
    SliderD156 = 0x659C
    SliderD157 = 0x659D
    SliderD158 = 0x659E
    SliderD159 = 0x659F
    SliderD160 = 0x65A0
    SliderD161 = 0x65A1
    SliderD162 = 0x65A2
    SliderD163 = 0x65A3
    SliderD164 = 0x65A4
    SliderD165 = 0x65A5
    SliderD166 = 0x65A6
    SliderD167 = 0x65A7
    SliderD168 = 0x65A8
    SliderD169 = 0x65A9
    SliderD170 = 0x65AA
    SliderD171 = 0x65AB
    SliderD172 = 0x65AC
    SliderD173 = 0x65AD
    SliderD174 = 0x65AE
    SliderD175 = 0x65AF
    SliderD176 = 0x65B0
    SliderD177 = 0x65B1
    SliderD178 = 0x65B2
    SliderD179 = 0x65B3
    SliderD180 = 0x65B4
    SliderD181 = 0x65B5
    SliderD182 = 0x65B6
    SliderD183 = 0x65B7
    SliderD184 = 0x65B8
    SliderD185 = 0x65B9
    SliderD186 = 0x65BA
    SliderD187 = 0x65BB
    SliderD188 = 0x65BC
    SliderD189 = 0x65BD
    SliderD190 = 0x65BE
    SliderD191 = 0x65BF
    SliderD192 = 0x65C0
    SliderD193 = 0x65C1
    SliderD194 = 0x65C2
    SliderD195 = 0x65C3
    SliderD196 = 0x65C4
    SliderD197 = 0x65C5
    SliderD198 = 0x65C6
    SliderD199 = 0x65C7
    SliderD200 = 0x65C8
    SliderD201 = 0x65C9
    SliderD202 = 0x65CA
    SliderD203 = 0x65CB
    SliderD204 = 0x65CC
    SliderD205 = 0x65CD
    SliderD206 = 0x65CE
    SliderD207 = 0x65CF
    SliderD208 = 0x65D0
    SliderD209 = 0x65D1
    SliderD210 = 0x65D2
    SliderD211 = 0x65D3
    SliderD212 = 0x65D4
    SliderD213 = 0x65D5
    SliderD214 = 0x65D6
    SliderD215 = 0x65D7
    SliderD216 = 0x65D8
    SliderD217 = 0x65D9
    SliderD218 = 0x65DA
    SliderD219 = 0x65DB
    SliderD220 = 0x65DC
    SliderD221 = 0x65DD
    SliderD222 = 0x65DE
    SliderD223 = 0x65DF
    SliderD224 = 0x65E0
    SliderD225 = 0x65E1
    SliderD226 = 0x65E2
    SliderD227 = 0x65E3
    SliderD228 = 0x65E4
    SliderD229 = 0x65E5
    SliderD230 = 0x65E6
    SliderD231 = 0x65E7
    SliderD232 = 0x65E8
    SliderD233 = 0x65E9
    SliderD234 = 0x65EA
    SliderD235 = 0x65EB
    SliderD236 = 0x65EC
    SliderD237 = 0x65ED
    SliderD238 = 0x65EE
    SliderD239 = 0x65EF
    SliderD240 = 0x65F0
    SliderD241 = 0x65F1
    SliderD242 = 0x65F2
    SliderD243 = 0x65F3
    SliderD244 = 0x65F4
    SliderD245 = 0x65F5
    SliderD246 = 0x65F6
    SliderD247 = 0x65F7
    SliderD248 = 0x65F8
    SliderD249 = 0x65F9
    SliderD250 = 0x65FA
    SliderD251 = 0x65FB
    SliderD252 = 0x65FC
    SliderD253 = 0x65FD
    SliderD254 = 0x65FE
    SliderD255 = 0x65FF
    # SliderE List
    SliderE0 = 0x6600
    SliderE1 = 0x6601
    SliderE2 = 0x6602
    SliderE3 = 0x6603
    SliderE4 = 0x6604
    SliderE5 = 0x6605
    SliderE6 = 0x6606
    SliderE7 = 0x6607
    SliderE8 = 0x6608
    SliderE9 = 0x6609
    SliderE10 = 0x660A
    SliderE11 = 0x660B
    SliderE12 = 0x660C
    SliderE13 = 0x660D
    SliderE14 = 0x660E
    SliderE15 = 0x660F
    SliderE16 = 0x6610
    SliderE17 = 0x6611
    SliderE18 = 0x6612
    SliderE19 = 0x6613
    SliderE20 = 0x6614
    SliderE21 = 0x6615
    SliderE22 = 0x6616
    SliderE23 = 0x6617
    SliderE24 = 0x6618
    SliderE25 = 0x6619
    SliderE26 = 0x661A
    SliderE27 = 0x661B
    SliderE28 = 0x661C
    SliderE29 = 0x661D
    SliderE30 = 0x661E
    SliderE31 = 0x661F
    SliderE32 = 0x6620
    SliderE33 = 0x6621
    SliderE34 = 0x6622
    SliderE35 = 0x6623
    SliderE36 = 0x6624
    SliderE37 = 0x6625
    SliderE38 = 0x6626
    SliderE39 = 0x6627
    SliderE40 = 0x6628
    SliderE41 = 0x6629
    SliderE42 = 0x662A
    SliderE43 = 0x662B
    SliderE44 = 0x662C
    SliderE45 = 0x662D
    SliderE46 = 0x662E
    SliderE47 = 0x662F
    SliderE48 = 0x6630
    SliderE49 = 0x6631
    SliderE50 = 0x6632
    SliderE51 = 0x6633
    SliderE52 = 0x6634
    SliderE53 = 0x6635
    SliderE54 = 0x6636
    SliderE55 = 0x6637
    SliderE56 = 0x6638
    SliderE57 = 0x6639
    SliderE58 = 0x663A
    SliderE59 = 0x663B
    SliderE60 = 0x663C
    SliderE61 = 0x663D
    SliderE62 = 0x663E
    SliderE63 = 0x663F
    SliderE64 = 0x6640
    SliderE65 = 0x6641
    SliderE66 = 0x6642
    SliderE67 = 0x6643
    SliderE68 = 0x6644
    SliderE69 = 0x6645
    SliderE70 = 0x6646
    SliderE71 = 0x6647
    SliderE72 = 0x6648
    SliderE73 = 0x6649
    SliderE74 = 0x664A
    SliderE75 = 0x664B
    SliderE76 = 0x664C
    SliderE77 = 0x664D
    SliderE78 = 0x664E
    SliderE79 = 0x664F
    SliderE80 = 0x6650
    SliderE81 = 0x6651
    SliderE82 = 0x6652
    SliderE83 = 0x6653
    SliderE84 = 0x6654
    SliderE85 = 0x6655
    SliderE86 = 0x6656
    SliderE87 = 0x6657
    SliderE88 = 0x6658
    SliderE89 = 0x6659
    SliderE90 = 0x665A
    SliderE91 = 0x665B
    SliderE92 = 0x665C
    SliderE93 = 0x665D
    SliderE94 = 0x665E
    SliderE95 = 0x665F
    SliderE96 = 0x6660
    SliderE97 = 0x6661
    SliderE98 = 0x6662
    SliderE99 = 0x6663
    SliderE100 = 0x6664
    SliderE101 = 0x6665
    SliderE102 = 0x6666
    SliderE103 = 0x6667
    SliderE104 = 0x6668
    SliderE105 = 0x6669
    SliderE106 = 0x666A
    SliderE107 = 0x666B
    SliderE108 = 0x666C
    SliderE109 = 0x666D
    SliderE110 = 0x666E
    SliderE111 = 0x666F
    SliderE112 = 0x6670
    SliderE113 = 0x6671
    SliderE114 = 0x6672
    SliderE115 = 0x6673
    SliderE116 = 0x6674
    SliderE117 = 0x6675
    SliderE118 = 0x6676
    SliderE119 = 0x6677
    SliderE120 = 0x6678
    SliderE121 = 0x6679
    SliderE122 = 0x667A
    SliderE123 = 0x667B
    SliderE124 = 0x667C
    SliderE125 = 0x667D
    SliderE126 = 0x667E
    SliderE127 = 0x667F
    SliderE128 = 0x6680
    SliderE129 = 0x6681
    SliderE130 = 0x6682
    SliderE131 = 0x6683
    SliderE132 = 0x6684
    SliderE133 = 0x6685
    SliderE134 = 0x6686
    SliderE135 = 0x6687
    SliderE136 = 0x6688
    SliderE137 = 0x6689
    SliderE138 = 0x668A
    SliderE139 = 0x668B
    SliderE140 = 0x668C
    SliderE141 = 0x668D
    SliderE142 = 0x668E
    SliderE143 = 0x668F
    SliderE144 = 0x6690
    SliderE145 = 0x6691
    SliderE146 = 0x6692
    SliderE147 = 0x6693
    SliderE148 = 0x6694
    SliderE149 = 0x6695
    SliderE150 = 0x6696
    SliderE151 = 0x6697
    SliderE152 = 0x6698
    SliderE153 = 0x6699
    SliderE154 = 0x669A
    SliderE155 = 0x669B
    SliderE156 = 0x669C
    SliderE157 = 0x669D
    SliderE158 = 0x669E
    SliderE159 = 0x669F
    SliderE160 = 0x66A0
    SliderE161 = 0x66A1
    SliderE162 = 0x66A2
    SliderE163 = 0x66A3
    SliderE164 = 0x66A4
    SliderE165 = 0x66A5
    SliderE166 = 0x66A6
    SliderE167 = 0x66A7
    SliderE168 = 0x66A8
    SliderE169 = 0x66A9
    SliderE170 = 0x66AA
    SliderE171 = 0x66AB
    SliderE172 = 0x66AC
    SliderE173 = 0x66AD
    SliderE174 = 0x66AE
    SliderE175 = 0x66AF
    SliderE176 = 0x66B0
    SliderE177 = 0x66B1
    SliderE178 = 0x66B2
    SliderE179 = 0x66B3
    SliderE180 = 0x66B4
    SliderE181 = 0x66B5
    SliderE182 = 0x66B6
    SliderE183 = 0x66B7
    SliderE184 = 0x66B8
    SliderE185 = 0x66B9
    SliderE186 = 0x66BA
    SliderE187 = 0x66BB
    SliderE188 = 0x66BC
    SliderE189 = 0x66BD
    SliderE190 = 0x66BE
    SliderE191 = 0x66BF
    SliderE192 = 0x66C0
    SliderE193 = 0x66C1
    SliderE194 = 0x66C2
    SliderE195 = 0x66C3
    SliderE196 = 0x66C4
    SliderE197 = 0x66C5
    SliderE198 = 0x66C6
    SliderE199 = 0x66C7
    SliderE200 = 0x66C8
    SliderE201 = 0x66C9
    SliderE202 = 0x66CA
    SliderE203 = 0x66CB
    SliderE204 = 0x66CC
    SliderE205 = 0x66CD
    SliderE206 = 0x66CE
    SliderE207 = 0x66CF
    SliderE208 = 0x66D0
    SliderE209 = 0x66D1
    SliderE210 = 0x66D2
    SliderE211 = 0x66D3
    SliderE212 = 0x66D4
    SliderE213 = 0x66D5
    SliderE214 = 0x66D6
    SliderE215 = 0x66D7
    SliderE216 = 0x66D8
    SliderE217 = 0x66D9
    SliderE218 = 0x66DA
    SliderE219 = 0x66DB
    SliderE220 = 0x66DC
    SliderE221 = 0x66DD
    SliderE222 = 0x66DE
    SliderE223 = 0x66DF
    SliderE224 = 0x66E0
    SliderE225 = 0x66E1
    SliderE226 = 0x66E2
    SliderE227 = 0x66E3
    SliderE228 = 0x66E4
    SliderE229 = 0x66E5
    SliderE230 = 0x66E6
    SliderE231 = 0x66E7
    SliderE232 = 0x66E8
    SliderE233 = 0x66E9
    SliderE234 = 0x66EA
    SliderE235 = 0x66EB
    SliderE236 = 0x66EC
    SliderE237 = 0x66ED
    SliderE238 = 0x66EE
    SliderE239 = 0x66EF
    SliderE240 = 0x66F0
    SliderE241 = 0x66F1
    SliderE242 = 0x66F2
    SliderE243 = 0x66F3
    SliderE244 = 0x66F4
    SliderE245 = 0x66F5
    SliderE246 = 0x66F6
    SliderE247 = 0x66F7
    SliderE248 = 0x66F8
    SliderE249 = 0x66F9
    SliderE250 = 0x66FA
    SliderE251 = 0x66FB
    SliderE252 = 0x66FC
    SliderE253 = 0x66FD
    SliderE254 = 0x66FE
    SliderE255 = 0x66FF
    # SliderF List
    SliderF0 = 0x6700
    SliderF1 = 0x6701
    SliderF2 = 0x6702
    SliderF3 = 0x6703
    SliderF4 = 0x6704
    SliderF5 = 0x6705
    SliderF6 = 0x6706
    SliderF7 = 0x6707
    SliderF8 = 0x6708
    SliderF9 = 0x6709
    SliderF10 = 0x670A
    SliderF11 = 0x670B
    SliderF12 = 0x670C
    SliderF13 = 0x670D
    SliderF14 = 0x670E
    SliderF15 = 0x670F
    SliderF16 = 0x6710
    SliderF17 = 0x6711
    SliderF18 = 0x6712
    SliderF19 = 0x6713
    SliderF20 = 0x6714
    SliderF21 = 0x6715
    SliderF22 = 0x6716
    SliderF23 = 0x6717
    SliderF24 = 0x6718
    SliderF25 = 0x6719
    SliderF26 = 0x671A
    SliderF27 = 0x671B
    SliderF28 = 0x671C
    SliderF29 = 0x671D
    SliderF30 = 0x671E
    SliderF31 = 0x671F
    SliderF32 = 0x6720
    SliderF33 = 0x6721
    SliderF34 = 0x6722
    SliderF35 = 0x6723
    SliderF36 = 0x6724
    SliderF37 = 0x6725
    SliderF38 = 0x6726
    SliderF39 = 0x6727
    SliderF40 = 0x6728
    SliderF41 = 0x6729
    SliderF42 = 0x672A
    SliderF43 = 0x672B
    SliderF44 = 0x672C
    SliderF45 = 0x672D
    SliderF46 = 0x672E
    SliderF47 = 0x672F
    SliderF48 = 0x6730
    SliderF49 = 0x6731
    SliderF50 = 0x6732
    SliderF51 = 0x6733
    SliderF52 = 0x6734
    SliderF53 = 0x6735
    SliderF54 = 0x6736
    SliderF55 = 0x6737
    SliderF56 = 0x6738
    SliderF57 = 0x6739
    SliderF58 = 0x673A
    SliderF59 = 0x673B
    SliderF60 = 0x673C
    SliderF61 = 0x673D
    SliderF62 = 0x673E
    SliderF63 = 0x673F
    SliderF64 = 0x6740
    SliderF65 = 0x6741
    SliderF66 = 0x6742
    SliderF67 = 0x6743
    SliderF68 = 0x6744
    SliderF69 = 0x6745
    SliderF70 = 0x6746
    SliderF71 = 0x6747
    SliderF72 = 0x6748
    SliderF73 = 0x6749
    SliderF74 = 0x674A
    SliderF75 = 0x674B
    SliderF76 = 0x674C
    SliderF77 = 0x674D
    SliderF78 = 0x674E
    SliderF79 = 0x674F
    SliderF80 = 0x6750
    SliderF81 = 0x6751
    SliderF82 = 0x6752
    SliderF83 = 0x6753
    SliderF84 = 0x6754
    SliderF85 = 0x6755
    SliderF86 = 0x6756
    SliderF87 = 0x6757
    SliderF88 = 0x6758
    SliderF89 = 0x6759
    SliderF90 = 0x675A
    SliderF91 = 0x675B
    SliderF92 = 0x675C
    SliderF93 = 0x675D
    SliderF94 = 0x675E
    SliderF95 = 0x675F
    SliderF96 = 0x6760
    SliderF97 = 0x6761
    SliderF98 = 0x6762
    SliderF99 = 0x6763
    SliderF100 = 0x6764
    SliderF101 = 0x6765
    SliderF102 = 0x6766
    SliderF103 = 0x6767
    SliderF104 = 0x6768
    SliderF105 = 0x6769
    SliderF106 = 0x676A
    SliderF107 = 0x676B
    SliderF108 = 0x676C
    SliderF109 = 0x676D
    SliderF110 = 0x676E
    SliderF111 = 0x676F
    SliderF112 = 0x6770
    SliderF113 = 0x6771
    SliderF114 = 0x6772
    SliderF115 = 0x6773
    SliderF116 = 0x6774
    SliderF117 = 0x6775
    SliderF118 = 0x6776
    SliderF119 = 0x6777
    SliderF120 = 0x6778
    SliderF121 = 0x6779
    SliderF122 = 0x677A
    SliderF123 = 0x677B
    SliderF124 = 0x677C
    SliderF125 = 0x677D
    SliderF126 = 0x677E
    SliderF127 = 0x677F
    SliderF128 = 0x6780
    SliderF129 = 0x6781
    SliderF130 = 0x6782
    SliderF131 = 0x6783
    SliderF132 = 0x6784
    SliderF133 = 0x6785
    SliderF134 = 0x6786
    SliderF135 = 0x6787
    SliderF136 = 0x6788
    SliderF137 = 0x6789
    SliderF138 = 0x678A
    SliderF139 = 0x678B
    SliderF140 = 0x678C
    SliderF141 = 0x678D
    SliderF142 = 0x678E
    SliderF143 = 0x678F
    SliderF144 = 0x6790
    SliderF145 = 0x6791
    SliderF146 = 0x6792
    SliderF147 = 0x6793
    SliderF148 = 0x6794
    SliderF149 = 0x6795
    SliderF150 = 0x6796
    SliderF151 = 0x6797
    SliderF152 = 0x6798
    SliderF153 = 0x6799
    SliderF154 = 0x679A
    SliderF155 = 0x679B
    SliderF156 = 0x679C
    SliderF157 = 0x679D
    SliderF158 = 0x679E
    SliderF159 = 0x679F
    SliderF160 = 0x67A0
    SliderF161 = 0x67A1
    SliderF162 = 0x67A2
    SliderF163 = 0x67A3
    SliderF164 = 0x67A4
    SliderF165 = 0x67A5
    SliderF166 = 0x67A6
    SliderF167 = 0x67A7
    SliderF168 = 0x67A8
    SliderF169 = 0x67A9
    SliderF170 = 0x67AA
    SliderF171 = 0x67AB
    SliderF172 = 0x67AC
    SliderF173 = 0x67AD
    SliderF174 = 0x67AE
    SliderF175 = 0x67AF
    SliderF176 = 0x67B0
    SliderF177 = 0x67B1
    SliderF178 = 0x67B2
    SliderF179 = 0x67B3
    SliderF180 = 0x67B4
    SliderF181 = 0x67B5
    SliderF182 = 0x67B6
    SliderF183 = 0x67B7
    SliderF184 = 0x67B8
    SliderF185 = 0x67B9
    SliderF186 = 0x67BA
    SliderF187 = 0x67BB
    SliderF188 = 0x67BC
    SliderF189 = 0x67BD
    SliderF190 = 0x67BE
    SliderF191 = 0x67BF
    SliderF192 = 0x67C0
    SliderF193 = 0x67C1
    SliderF194 = 0x67C2
    SliderF195 = 0x67C3
    SliderF196 = 0x67C4
    SliderF197 = 0x67C5
    SliderF198 = 0x67C6
    SliderF199 = 0x67C7
    SliderF200 = 0x67C8
    SliderF201 = 0x67C9
    SliderF202 = 0x67CA
    SliderF203 = 0x67CB
    SliderF204 = 0x67CC
    SliderF205 = 0x67CD
    SliderF206 = 0x67CE
    SliderF207 = 0x67CF
    SliderF208 = 0x67D0
    SliderF209 = 0x67D1
    SliderF210 = 0x67D2
    SliderF211 = 0x67D3
    SliderF212 = 0x67D4
    SliderF213 = 0x67D5
    SliderF214 = 0x67D6
    SliderF215 = 0x67D7
    SliderF216 = 0x67D8
    SliderF217 = 0x67D9
    SliderF218 = 0x67DA
    SliderF219 = 0x67DB
    SliderF220 = 0x67DC
    SliderF221 = 0x67DD
    SliderF222 = 0x67DE
    SliderF223 = 0x67DF
    SliderF224 = 0x67E0
    SliderF225 = 0x67E1
    SliderF226 = 0x67E2
    SliderF227 = 0x67E3
    SliderF228 = 0x67E4
    SliderF229 = 0x67E5
    SliderF230 = 0x67E6
    SliderF231 = 0x67E7
    SliderF232 = 0x67E8
    SliderF233 = 0x67E9
    SliderF234 = 0x67EA
    SliderF235 = 0x67EB
    SliderF236 = 0x67EC
    SliderF237 = 0x67ED
    SliderF238 = 0x67EE
    SliderF239 = 0x67EF
    SliderF240 = 0x67F0
    SliderF241 = 0x67F1
    SliderF242 = 0x67F2
    SliderF243 = 0x67F3
    SliderF244 = 0x67F4
    SliderF245 = 0x67F5
    SliderF246 = 0x67F6
    SliderF247 = 0x67F7
    SliderF248 = 0x67F8
    SliderF249 = 0x67F9
    SliderF250 = 0x67FA
    SliderF251 = 0x67FB
    SliderF252 = 0x67FC
    SliderF253 = 0x67FD
    SliderF254 = 0x67FE
    SliderF255 = 0x67FF
    # MediaSlider List
    MediaSlider0 = 0x6800
    MediaSlider1 = 0x6801
    MediaSlider2 = 0x6802
    MediaSlider3 = 0x6803
    MediaSlider4 = 0x6804
    MediaSlider5 = 0x6805
    MediaSlider6 = 0x6806
    MediaSlider7 = 0x6807
    MediaSlider8 = 0x6808
    MediaSlider9 = 0x6809
    MediaSlider10 = 0x680A
    MediaSlider11 = 0x680B
    MediaSlider12 = 0x680C
    MediaSlider13 = 0x680D
    MediaSlider14 = 0x680E
    MediaSlider15 = 0x680F
    MediaSlider16 = 0x6810
    MediaSlider17 = 0x6811
    MediaSlider18 = 0x6812
    MediaSlider19 = 0x6813
    MediaSlider20 = 0x6814
    MediaSlider21 = 0x6815
    MediaSlider22 = 0x6816
    MediaSlider23 = 0x6817
    MediaSlider24 = 0x6818
    MediaSlider25 = 0x6819
    MediaSlider26 = 0x681A
    MediaSlider27 = 0x681B
    MediaSlider28 = 0x681C
    MediaSlider29 = 0x681D
    MediaSlider30 = 0x681E
    MediaSlider31 = 0x681F
    MediaSlider32 = 0x6820
    MediaSlider33 = 0x6821
    MediaSlider34 = 0x6822
    MediaSlider35 = 0x6823
    MediaSlider36 = 0x6824
    MediaSlider37 = 0x6825
    MediaSlider38 = 0x6826
    MediaSlider39 = 0x6827
    MediaSlider40 = 0x6828
    MediaSlider41 = 0x6829
    MediaSlider42 = 0x682A
    MediaSlider43 = 0x682B
    MediaSlider44 = 0x682C
    MediaSlider45 = 0x682D
    MediaSlider46 = 0x682E
    MediaSlider47 = 0x682F
    MediaSlider48 = 0x6830
    MediaSlider49 = 0x6831
    MediaSlider50 = 0x6832
    MediaSlider51 = 0x6833
    MediaSlider52 = 0x6834
    MediaSlider53 = 0x6835
    MediaSlider54 = 0x6836
    MediaSlider55 = 0x6837
    MediaSlider56 = 0x6838
    MediaSlider57 = 0x6839
    MediaSlider58 = 0x683A
    MediaSlider59 = 0x683B
    MediaSlider60 = 0x683C
    MediaSlider61 = 0x683D
    MediaSlider62 = 0x683E
    MediaSlider63 = 0x683F
    MediaSlider64 = 0x6840
    MediaSlider65 = 0x6841
    MediaSlider66 = 0x6842
    MediaSlider67 = 0x6843
    MediaSlider68 = 0x6844
    MediaSlider69 = 0x6845
    MediaSlider70 = 0x6846
    MediaSlider71 = 0x6847
    MediaSlider72 = 0x6848
    MediaSlider73 = 0x6849
    MediaSlider74 = 0x684A
    MediaSlider75 = 0x684B
    MediaSlider76 = 0x684C
    MediaSlider77 = 0x684D
    MediaSlider78 = 0x684E
    MediaSlider79 = 0x684F
    MediaSlider80 = 0x6850
    MediaSlider81 = 0x6851
    MediaSlider82 = 0x6852
    MediaSlider83 = 0x6853
    MediaSlider84 = 0x6854
    MediaSlider85 = 0x6855
    MediaSlider86 = 0x6856
    MediaSlider87 = 0x6857
    MediaSlider88 = 0x6858
    MediaSlider89 = 0x6859
    MediaSlider90 = 0x685A
    MediaSlider91 = 0x685B
    MediaSlider92 = 0x685C
    MediaSlider93 = 0x685D
    MediaSlider94 = 0x685E
    MediaSlider95 = 0x685F
    MediaSlider96 = 0x6860
    MediaSlider97 = 0x6861
    MediaSlider98 = 0x6862
    MediaSlider99 = 0x6863
    MediaSlider100 = 0x6864
    MediaSlider101 = 0x6865
    MediaSlider102 = 0x6866
    MediaSlider103 = 0x6867
    MediaSlider104 = 0x6868
    MediaSlider105 = 0x6869
    MediaSlider106 = 0x686A
    MediaSlider107 = 0x686B
    MediaSlider108 = 0x686C
    MediaSlider109 = 0x686D
    MediaSlider110 = 0x686E
    MediaSlider111 = 0x686F
    MediaSlider112 = 0x6870
    MediaSlider113 = 0x6871
    MediaSlider114 = 0x6872
    MediaSlider115 = 0x6873
    MediaSlider116 = 0x6874
    MediaSlider117 = 0x6875
    MediaSlider118 = 0x6876
    MediaSlider119 = 0x6877
    MediaSlider120 = 0x6878
    MediaSlider121 = 0x6879
    MediaSlider122 = 0x687A
    MediaSlider123 = 0x687B
    MediaSlider124 = 0x687C
    MediaSlider125 = 0x687D
    MediaSlider126 = 0x687E
    MediaSlider127 = 0x687F
    MediaSlider128 = 0x6880
    MediaSlider129 = 0x6881
    MediaSlider130 = 0x6882
    MediaSlider131 = 0x6883
    MediaSlider132 = 0x6884
    MediaSlider133 = 0x6885
    MediaSlider134 = 0x6886
    MediaSlider135 = 0x6887
    MediaSlider136 = 0x6888
    MediaSlider137 = 0x6889
    MediaSlider138 = 0x688A
    MediaSlider139 = 0x688B
    MediaSlider140 = 0x688C
    MediaSlider141 = 0x688D
    MediaSlider142 = 0x688E
    MediaSlider143 = 0x688F
    MediaSlider144 = 0x6890
    MediaSlider145 = 0x6891
    MediaSlider146 = 0x6892
    MediaSlider147 = 0x6893
    MediaSlider148 = 0x6894
    MediaSlider149 = 0x6895
    MediaSlider150 = 0x6896
    MediaSlider151 = 0x6897
    MediaSlider152 = 0x6898
    MediaSlider153 = 0x6899
    MediaSlider154 = 0x689A
    MediaSlider155 = 0x689B
    MediaSlider156 = 0x689C
    MediaSlider157 = 0x689D
    MediaSlider158 = 0x689E
    MediaSlider159 = 0x689F
    MediaSlider160 = 0x68A0
    MediaSlider161 = 0x68A1
    MediaSlider162 = 0x68A2
    MediaSlider163 = 0x68A3
    MediaSlider164 = 0x68A4
    MediaSlider165 = 0x68A5
    MediaSlider166 = 0x68A6
    MediaSlider167 = 0x68A7
    MediaSlider168 = 0x68A8
    MediaSlider169 = 0x68A9
    MediaSlider170 = 0x68AA
    MediaSlider171 = 0x68AB
    MediaSlider172 = 0x68AC
    MediaSlider173 = 0x68AD
    MediaSlider174 = 0x68AE
    MediaSlider175 = 0x68AF
    MediaSlider176 = 0x68B0
    MediaSlider177 = 0x68B1
    MediaSlider178 = 0x68B2
    MediaSlider179 = 0x68B3
    MediaSlider180 = 0x68B4
    MediaSlider181 = 0x68B5
    MediaSlider182 = 0x68B6
    MediaSlider183 = 0x68B7
    MediaSlider184 = 0x68B8
    MediaSlider185 = 0x68B9
    MediaSlider186 = 0x68BA
    MediaSlider187 = 0x68BB
    MediaSlider188 = 0x68BC
    MediaSlider189 = 0x68BD
    MediaSlider190 = 0x68BE
    MediaSlider191 = 0x68BF
    MediaSlider192 = 0x68C0
    MediaSlider193 = 0x68C1
    MediaSlider194 = 0x68C2
    MediaSlider195 = 0x68C3
    MediaSlider196 = 0x68C4
    MediaSlider197 = 0x68C5
    MediaSlider198 = 0x68C6
    MediaSlider199 = 0x68C7
    MediaSlider200 = 0x68C8
    MediaSlider201 = 0x68C9
    MediaSlider202 = 0x68CA
    MediaSlider203 = 0x68CB
    MediaSlider204 = 0x68CC
    MediaSlider205 = 0x68CD
    MediaSlider206 = 0x68CE
    MediaSlider207 = 0x68CF
    MediaSlider208 = 0x68D0
    MediaSlider209 = 0x68D1
    MediaSlider210 = 0x68D2
    MediaSlider211 = 0x68D3
    MediaSlider212 = 0x68D4
    MediaSlider213 = 0x68D5
    MediaSlider214 = 0x68D6
    MediaSlider215 = 0x68D7
    MediaSlider216 = 0x68D8
    MediaSlider217 = 0x68D9
    MediaSlider218 = 0x68DA
    MediaSlider219 = 0x68DB
    MediaSlider220 = 0x68DC
    MediaSlider221 = 0x68DD
    MediaSlider222 = 0x68DE
    MediaSlider223 = 0x68DF
    MediaSlider224 = 0x68E0
    MediaSlider225 = 0x68E1
    MediaSlider226 = 0x68E2
    MediaSlider227 = 0x68E3
    MediaSlider228 = 0x68E4
    MediaSlider229 = 0x68E5
    MediaSlider230 = 0x68E6
    MediaSlider231 = 0x68E7
    MediaSlider232 = 0x68E8
    MediaSlider233 = 0x68E9
    MediaSlider234 = 0x68EA
    MediaSlider235 = 0x68EB
    MediaSlider236 = 0x68EC
    MediaSlider237 = 0x68ED
    MediaSlider238 = 0x68EE
    MediaSlider239 = 0x68EF
    MediaSlider240 = 0x68F0
    MediaSlider241 = 0x68F1
    MediaSlider242 = 0x68F2
    MediaSlider243 = 0x68F3
    MediaSlider244 = 0x68F4
    MediaSlider245 = 0x68F5
    MediaSlider246 = 0x68F6
    MediaSlider247 = 0x68F7
    MediaSlider248 = 0x68F8
    MediaSlider249 = 0x68F9
    MediaSlider250 = 0x68FA
    MediaSlider251 = 0x68FB
    MediaSlider252 = 0x68FC
    MediaSlider253 = 0x68FD
    MediaSlider254 = 0x68FE
    MediaSlider255 = 0x68FF
    # MediaRotary List
    MediaRotary0 = 0x6900
    MediaRotary1 = 0x6901
    MediaRotary2 = 0x6902
    MediaRotary3 = 0x6903
    MediaRotary4 = 0x6904
    MediaRotary5 = 0x6905
    MediaRotary6 = 0x6906
    MediaRotary7 = 0x6907
    MediaRotary8 = 0x6908
    MediaRotary9 = 0x6909
    MediaRotary10 = 0x690A
    MediaRotary11 = 0x690B
    MediaRotary12 = 0x690C
    MediaRotary13 = 0x690D
    MediaRotary14 = 0x690E
    MediaRotary15 = 0x690F
    MediaRotary16 = 0x6910
    MediaRotary17 = 0x6911
    MediaRotary18 = 0x6912
    MediaRotary19 = 0x6913
    MediaRotary20 = 0x6914
    MediaRotary21 = 0x6915
    MediaRotary22 = 0x6916
    MediaRotary23 = 0x6917
    MediaRotary24 = 0x6918
    MediaRotary25 = 0x6919
    MediaRotary26 = 0x691A
    MediaRotary27 = 0x691B
    MediaRotary28 = 0x691C
    MediaRotary29 = 0x691D
    MediaRotary30 = 0x691E
    MediaRotary31 = 0x691F
    MediaRotary32 = 0x6920
    MediaRotary33 = 0x6921
    MediaRotary34 = 0x6922
    MediaRotary35 = 0x6923
    MediaRotary36 = 0x6924
    MediaRotary37 = 0x6925
    MediaRotary38 = 0x6926
    MediaRotary39 = 0x6927
    MediaRotary40 = 0x6928
    MediaRotary41 = 0x6929
    MediaRotary42 = 0x692A
    MediaRotary43 = 0x692B
    MediaRotary44 = 0x692C
    MediaRotary45 = 0x692D
    MediaRotary46 = 0x692E
    MediaRotary47 = 0x692F
    MediaRotary48 = 0x6930
    MediaRotary49 = 0x6931
    MediaRotary50 = 0x6932
    MediaRotary51 = 0x6933
    MediaRotary52 = 0x6934
    MediaRotary53 = 0x6935
    MediaRotary54 = 0x6936
    MediaRotary55 = 0x6937
    MediaRotary56 = 0x6938
    MediaRotary57 = 0x6939
    MediaRotary58 = 0x693A
    MediaRotary59 = 0x693B
    MediaRotary60 = 0x693C
    MediaRotary61 = 0x693D
    MediaRotary62 = 0x693E
    MediaRotary63 = 0x693F
    MediaRotary64 = 0x6940
    MediaRotary65 = 0x6941
    MediaRotary66 = 0x6942
    MediaRotary67 = 0x6943
    MediaRotary68 = 0x6944
    MediaRotary69 = 0x6945
    MediaRotary70 = 0x6946
    MediaRotary71 = 0x6947
    MediaRotary72 = 0x6948
    MediaRotary73 = 0x6949
    MediaRotary74 = 0x694A
    MediaRotary75 = 0x694B
    MediaRotary76 = 0x694C
    MediaRotary77 = 0x694D
    MediaRotary78 = 0x694E
    MediaRotary79 = 0x694F
    MediaRotary80 = 0x6950
    MediaRotary81 = 0x6951
    MediaRotary82 = 0x6952
    MediaRotary83 = 0x6953
    MediaRotary84 = 0x6954
    MediaRotary85 = 0x6955
    MediaRotary86 = 0x6956
    MediaRotary87 = 0x6957
    MediaRotary88 = 0x6958
    MediaRotary89 = 0x6959
    MediaRotary90 = 0x695A
    MediaRotary91 = 0x695B
    MediaRotary92 = 0x695C
    MediaRotary93 = 0x695D
    MediaRotary94 = 0x695E
    MediaRotary95 = 0x695F
    MediaRotary96 = 0x6960
    MediaRotary97 = 0x6961
    MediaRotary98 = 0x6962
    MediaRotary99 = 0x6963
    MediaRotary100 = 0x6964
    MediaRotary101 = 0x6965
    MediaRotary102 = 0x6966
    MediaRotary103 = 0x6967
    MediaRotary104 = 0x6968
    MediaRotary105 = 0x6969
    MediaRotary106 = 0x696A
    MediaRotary107 = 0x696B
    MediaRotary108 = 0x696C
    MediaRotary109 = 0x696D
    MediaRotary110 = 0x696E
    MediaRotary111 = 0x696F
    MediaRotary112 = 0x6970
    MediaRotary113 = 0x6971
    MediaRotary114 = 0x6972
    MediaRotary115 = 0x6973
    MediaRotary116 = 0x6974
    MediaRotary117 = 0x6975
    MediaRotary118 = 0x6976
    MediaRotary119 = 0x6977
    MediaRotary120 = 0x6978
    MediaRotary121 = 0x6979
    MediaRotary122 = 0x697A
    MediaRotary123 = 0x697B
    MediaRotary124 = 0x697C
    MediaRotary125 = 0x697D
    MediaRotary126 = 0x697E
    MediaRotary127 = 0x697F
    MediaRotary128 = 0x6980
    MediaRotary129 = 0x6981
    MediaRotary130 = 0x6982
    MediaRotary131 = 0x6983
    MediaRotary132 = 0x6984
    MediaRotary133 = 0x6985
    MediaRotary134 = 0x6986
    MediaRotary135 = 0x6987
    MediaRotary136 = 0x6988
    MediaRotary137 = 0x6989
    MediaRotary138 = 0x698A
    MediaRotary139 = 0x698B
    MediaRotary140 = 0x698C
    MediaRotary141 = 0x698D
    MediaRotary142 = 0x698E
    MediaRotary143 = 0x698F
    MediaRotary144 = 0x6990
    MediaRotary145 = 0x6991
    MediaRotary146 = 0x6992
    MediaRotary147 = 0x6993
    MediaRotary148 = 0x6994
    MediaRotary149 = 0x6995
    MediaRotary150 = 0x6996
    MediaRotary151 = 0x6997
    MediaRotary152 = 0x6998
    MediaRotary153 = 0x6999
    MediaRotary154 = 0x699A
    MediaRotary155 = 0x699B
    MediaRotary156 = 0x699C
    MediaRotary157 = 0x699D
    MediaRotary158 = 0x699E
    MediaRotary159 = 0x699F
    MediaRotary160 = 0x69A0
    MediaRotary161 = 0x69A1
    MediaRotary162 = 0x69A2
    MediaRotary163 = 0x69A3
    MediaRotary164 = 0x69A4
    MediaRotary165 = 0x69A5
    MediaRotary166 = 0x69A6
    MediaRotary167 = 0x69A7
    MediaRotary168 = 0x69A8
    MediaRotary169 = 0x69A9
    MediaRotary170 = 0x69AA
    MediaRotary171 = 0x69AB
    MediaRotary172 = 0x69AC
    MediaRotary173 = 0x69AD
    MediaRotary174 = 0x69AE
    MediaRotary175 = 0x69AF
    MediaRotary176 = 0x69B0
    MediaRotary177 = 0x69B1
    MediaRotary178 = 0x69B2
    MediaRotary179 = 0x69B3
    MediaRotary180 = 0x69B4
    MediaRotary181 = 0x69B5
    MediaRotary182 = 0x69B6
    MediaRotary183 = 0x69B7
    MediaRotary184 = 0x69B8
    MediaRotary185 = 0x69B9
    MediaRotary186 = 0x69BA
    MediaRotary187 = 0x69BB
    MediaRotary188 = 0x69BC
    MediaRotary189 = 0x69BD
    MediaRotary190 = 0x69BE
    MediaRotary191 = 0x69BF
    MediaRotary192 = 0x69C0
    MediaRotary193 = 0x69C1
    MediaRotary194 = 0x69C2
    MediaRotary195 = 0x69C3
    MediaRotary196 = 0x69C4
    MediaRotary197 = 0x69C5
    MediaRotary198 = 0x69C6
    MediaRotary199 = 0x69C7
    MediaRotary200 = 0x69C8
    MediaRotary201 = 0x69C9
    MediaRotary202 = 0x69CA
    MediaRotary203 = 0x69CB
    MediaRotary204 = 0x69CC
    MediaRotary205 = 0x69CD
    MediaRotary206 = 0x69CE
    MediaRotary207 = 0x69CF
    MediaRotary208 = 0x69D0
    MediaRotary209 = 0x69D1
    MediaRotary210 = 0x69D2
    MediaRotary211 = 0x69D3
    MediaRotary212 = 0x69D4
    MediaRotary213 = 0x69D5
    MediaRotary214 = 0x69D6
    MediaRotary215 = 0x69D7
    MediaRotary216 = 0x69D8
    MediaRotary217 = 0x69D9
    MediaRotary218 = 0x69DA
    MediaRotary219 = 0x69DB
    MediaRotary220 = 0x69DC
    MediaRotary221 = 0x69DD
    MediaRotary222 = 0x69DE
    MediaRotary223 = 0x69DF
    MediaRotary224 = 0x69E0
    MediaRotary225 = 0x69E1
    MediaRotary226 = 0x69E2
    MediaRotary227 = 0x69E3
    MediaRotary228 = 0x69E4
    MediaRotary229 = 0x69E5
    MediaRotary230 = 0x69E6
    MediaRotary231 = 0x69E7
    MediaRotary232 = 0x69E8
    MediaRotary233 = 0x69E9
    MediaRotary234 = 0x69EA
    MediaRotary235 = 0x69EB
    MediaRotary236 = 0x69EC
    MediaRotary237 = 0x69ED
    MediaRotary238 = 0x69EE
    MediaRotary239 = 0x69EF
    MediaRotary240 = 0x69F0
    MediaRotary241 = 0x69F1
    MediaRotary242 = 0x69F2
    MediaRotary243 = 0x69F3
    MediaRotary244 = 0x69F4
    MediaRotary245 = 0x69F5
    MediaRotary246 = 0x69F6
    MediaRotary247 = 0x69F7
    MediaRotary248 = 0x69F8
    MediaRotary249 = 0x69F9
    MediaRotary250 = 0x69FA
    MediaRotary251 = 0x69FB
    MediaRotary252 = 0x69FC
    MediaRotary253 = 0x69FD
    MediaRotary254 = 0x69FE
    MediaRotary255 = 0x69FF
    # SlideShow List
    SlideShow0 = 0x8000
    SlideShow1 = 0x8001
    SlideShow2 = 0x8002
    SlideShow3 = 0x8003
    SlideShow4 = 0x8004
    SlideShow5 = 0x8005
    SlideShow6 = 0x8006
    SlideShow7 = 0x8007
    SlideShow8 = 0x8008
    SlideShow9 = 0x8009
    SlideShow10 = 0x800A
    SlideShow11 = 0x800B
    SlideShow12 = 0x800C
    SlideShow13 = 0x800D
    SlideShow14 = 0x800E
    SlideShow15 = 0x800F
    SlideShow16 = 0x8010
    SlideShow17 = 0x8011
    SlideShow18 = 0x8012
    SlideShow19 = 0x8013
    SlideShow20 = 0x8014
    SlideShow21 = 0x8015
    SlideShow22 = 0x8016
    SlideShow23 = 0x8017
    SlideShow24 = 0x8018
    SlideShow25 = 0x8019
    SlideShow26 = 0x801A
    SlideShow27 = 0x801B
    SlideShow28 = 0x801C
    SlideShow29 = 0x801D
    SlideShow30 = 0x801E
    SlideShow31 = 0x801F
    SlideShow32 = 0x8020
    SlideShow33 = 0x8021
    SlideShow34 = 0x8022
    SlideShow35 = 0x8023
    SlideShow36 = 0x8024
    SlideShow37 = 0x8025
    SlideShow38 = 0x8026
    SlideShow39 = 0x8027
    SlideShow40 = 0x8028
    SlideShow41 = 0x8029
    SlideShow42 = 0x802A
    SlideShow43 = 0x802B
    SlideShow44 = 0x802C
    SlideShow45 = 0x802D
    SlideShow46 = 0x802E
    SlideShow47 = 0x802F
    SlideShow48 = 0x8030
    SlideShow49 = 0x8031
    SlideShow50 = 0x8032
    SlideShow51 = 0x8033
    SlideShow52 = 0x8034
    SlideShow53 = 0x8035
    SlideShow54 = 0x8036
    SlideShow55 = 0x8037
    SlideShow56 = 0x8038
    SlideShow57 = 0x8039
    SlideShow58 = 0x803A
    SlideShow59 = 0x803B
    SlideShow60 = 0x803C
    SlideShow61 = 0x803D
    SlideShow62 = 0x803E
    SlideShow63 = 0x803F
    SlideShow64 = 0x8040
    SlideShow65 = 0x8041
    SlideShow66 = 0x8042
    SlideShow67 = 0x8043
    SlideShow68 = 0x8044
    SlideShow69 = 0x8045
    SlideShow70 = 0x8046
    SlideShow71 = 0x8047
    SlideShow72 = 0x8048
    SlideShow73 = 0x8049
    SlideShow74 = 0x804A
    SlideShow75 = 0x804B
    SlideShow76 = 0x804C
    SlideShow77 = 0x804D
    SlideShow78 = 0x804E
    SlideShow79 = 0x804F
    SlideShow80 = 0x8050
    SlideShow81 = 0x8051
    SlideShow82 = 0x8052
    SlideShow83 = 0x8053
    SlideShow84 = 0x8054
    SlideShow85 = 0x8055
    SlideShow86 = 0x8056
    SlideShow87 = 0x8057
    SlideShow88 = 0x8058
    SlideShow89 = 0x8059
    SlideShow90 = 0x805A
    SlideShow91 = 0x805B
    SlideShow92 = 0x805C
    SlideShow93 = 0x805D
    SlideShow94 = 0x805E
    SlideShow95 = 0x805F
    SlideShow96 = 0x8060
    SlideShow97 = 0x8061
    SlideShow98 = 0x8062
    SlideShow99 = 0x8063
    SlideShow100 = 0x8064
    SlideShow101 = 0x8065
    SlideShow102 = 0x8066
    SlideShow103 = 0x8067
    SlideShow104 = 0x8068
    SlideShow105 = 0x8069
    SlideShow106 = 0x806A
    SlideShow107 = 0x806B
    SlideShow108 = 0x806C
    SlideShow109 = 0x806D
    SlideShow110 = 0x806E
    SlideShow111 = 0x806F
    SlideShow112 = 0x8070
    SlideShow113 = 0x8071
    SlideShow114 = 0x8072
    SlideShow115 = 0x8073
    SlideShow116 = 0x8074
    SlideShow117 = 0x8075
    SlideShow118 = 0x8076
    SlideShow119 = 0x8077
    SlideShow120 = 0x8078
    SlideShow121 = 0x8079
    SlideShow122 = 0x807A
    SlideShow123 = 0x807B
    SlideShow124 = 0x807C
    SlideShow125 = 0x807D
    SlideShow126 = 0x807E
    SlideShow127 = 0x807F
    SlideShow128 = 0x8080
    SlideShow129 = 0x8081
    SlideShow130 = 0x8082
    SlideShow131 = 0x8083
    SlideShow132 = 0x8084
    SlideShow133 = 0x8085
    SlideShow134 = 0x8086
    SlideShow135 = 0x8087
    SlideShow136 = 0x8088
    SlideShow137 = 0x8089
    SlideShow138 = 0x808A
    SlideShow139 = 0x808B
    SlideShow140 = 0x808C
    SlideShow141 = 0x808D
    SlideShow142 = 0x808E
    SlideShow143 = 0x808F
    SlideShow144 = 0x8090
    SlideShow145 = 0x8091
    SlideShow146 = 0x8092
    SlideShow147 = 0x8093
    SlideShow148 = 0x8094
    SlideShow149 = 0x8095
    SlideShow150 = 0x8096
    SlideShow151 = 0x8097
    SlideShow152 = 0x8098
    SlideShow153 = 0x8099
    SlideShow154 = 0x809A
    SlideShow155 = 0x809B
    SlideShow156 = 0x809C
    SlideShow157 = 0x809D
    SlideShow158 = 0x809E
    SlideShow159 = 0x809F
    SlideShow160 = 0x80A0
    SlideShow161 = 0x80A1
    SlideShow162 = 0x80A2
    SlideShow163 = 0x80A3
    SlideShow164 = 0x80A4
    SlideShow165 = 0x80A5
    SlideShow166 = 0x80A6
    SlideShow167 = 0x80A7
    SlideShow168 = 0x80A8
    SlideShow169 = 0x80A9
    SlideShow170 = 0x80AA
    SlideShow171 = 0x80AB
    SlideShow172 = 0x80AC
    SlideShow173 = 0x80AD
    SlideShow174 = 0x80AE
    SlideShow175 = 0x80AF
    SlideShow176 = 0x80B0
    SlideShow177 = 0x80B1
    SlideShow178 = 0x80B2
    SlideShow179 = 0x80B3
    SlideShow180 = 0x80B4
    SlideShow181 = 0x80B5
    SlideShow182 = 0x80B6
    SlideShow183 = 0x80B7
    SlideShow184 = 0x80B8
    SlideShow185 = 0x80B9
    SlideShow186 = 0x80BA
    SlideShow187 = 0x80BB
    SlideShow188 = 0x80BC
    SlideShow189 = 0x80BD
    SlideShow190 = 0x80BE
    SlideShow191 = 0x80BF
    SlideShow192 = 0x80C0
    SlideShow193 = 0x80C1
    SlideShow194 = 0x80C2
    SlideShow195 = 0x80C3
    SlideShow196 = 0x80C4
    SlideShow197 = 0x80C5
    SlideShow198 = 0x80C6
    SlideShow199 = 0x80C7
    SlideShow200 = 0x80C8
    SlideShow201 = 0x80C9
    SlideShow202 = 0x80CA
    SlideShow203 = 0x80CB
    SlideShow204 = 0x80CC
    SlideShow205 = 0x80CD
    SlideShow206 = 0x80CE
    SlideShow207 = 0x80CF
    SlideShow208 = 0x80D0
    SlideShow209 = 0x80D1
    SlideShow210 = 0x80D2
    SlideShow211 = 0x80D3
    SlideShow212 = 0x80D4
    SlideShow213 = 0x80D5
    SlideShow214 = 0x80D6
    SlideShow215 = 0x80D7
    SlideShow216 = 0x80D8
    SlideShow217 = 0x80D9
    SlideShow218 = 0x80DA
    SlideShow219 = 0x80DB
    SlideShow220 = 0x80DC
    SlideShow221 = 0x80DD
    SlideShow222 = 0x80DE
    SlideShow223 = 0x80DF
    SlideShow224 = 0x80E0
    SlideShow225 = 0x80E1
    SlideShow226 = 0x80E2
    SlideShow227 = 0x80E3
    SlideShow228 = 0x80E4
    SlideShow229 = 0x80E5
    SlideShow230 = 0x80E6
    SlideShow231 = 0x80E7
    SlideShow232 = 0x80E8
    SlideShow233 = 0x80E9
    SlideShow234 = 0x80EA
    SlideShow235 = 0x80EB
    SlideShow236 = 0x80EC
    SlideShow237 = 0x80ED
    SlideShow238 = 0x80EE
    SlideShow239 = 0x80EF
    SlideShow240 = 0x80F0
    SlideShow241 = 0x80F1
    SlideShow242 = 0x80F2
    SlideShow243 = 0x80F3
    SlideShow244 = 0x80F4
    SlideShow245 = 0x80F5
    SlideShow246 = 0x80F6
    SlideShow247 = 0x80F7
    SlideShow248 = 0x80F8
    SlideShow249 = 0x80F9
    SlideShow250 = 0x80FA
    SlideShow251 = 0x80FB
    SlideShow252 = 0x80FC
    SlideShow253 = 0x80FD
    SlideShow254 = 0x80FE
    SlideShow255 = 0x80FF
    # Animation List
    Animation0 = 0x8100
    Animation1 = 0x8101
    Animation2 = 0x8102
    Animation3 = 0x8103
    Animation4 = 0x8104
    Animation5 = 0x8105
    Animation6 = 0x8106
    Animation7 = 0x8107
    Animation8 = 0x8108
    Animation9 = 0x8109
    Animation10 = 0x810A
    Animation11 = 0x810B
    Animation12 = 0x810C
    Animation13 = 0x810D
    Animation14 = 0x810E
    Animation15 = 0x810F
    Animation16 = 0x8110
    Animation17 = 0x8111
    Animation18 = 0x8112
    Animation19 = 0x8113
    Animation20 = 0x8114
    Animation21 = 0x8115
    Animation22 = 0x8116
    Animation23 = 0x8117
    Animation24 = 0x8118
    Animation25 = 0x8119
    Animation26 = 0x811A
    Animation27 = 0x811B
    Animation28 = 0x811C
    Animation29 = 0x811D
    Animation30 = 0x811E
    Animation31 = 0x811F
    Animation32 = 0x8120
    Animation33 = 0x8121
    Animation34 = 0x8122
    Animation35 = 0x8123
    Animation36 = 0x8124
    Animation37 = 0x8125
    Animation38 = 0x8126
    Animation39 = 0x8127
    Animation40 = 0x8128
    Animation41 = 0x8129
    Animation42 = 0x812A
    Animation43 = 0x812B
    Animation44 = 0x812C
    Animation45 = 0x812D
    Animation46 = 0x812E
    Animation47 = 0x812F
    Animation48 = 0x8130
    Animation49 = 0x8131
    Animation50 = 0x8132
    Animation51 = 0x8133
    Animation52 = 0x8134
    Animation53 = 0x8135
    Animation54 = 0x8136
    Animation55 = 0x8137
    Animation56 = 0x8138
    Animation57 = 0x8139
    Animation58 = 0x813A
    Animation59 = 0x813B
    Animation60 = 0x813C
    Animation61 = 0x813D
    Animation62 = 0x813E
    Animation63 = 0x813F
    Animation64 = 0x8140
    Animation65 = 0x8141
    Animation66 = 0x8142
    Animation67 = 0x8143
    Animation68 = 0x8144
    Animation69 = 0x8145
    Animation70 = 0x8146
    Animation71 = 0x8147
    Animation72 = 0x8148
    Animation73 = 0x8149
    Animation74 = 0x814A
    Animation75 = 0x814B
    Animation76 = 0x814C
    Animation77 = 0x814D
    Animation78 = 0x814E
    Animation79 = 0x814F
    Animation80 = 0x8150
    Animation81 = 0x8151
    Animation82 = 0x8152
    Animation83 = 0x8153
    Animation84 = 0x8154
    Animation85 = 0x8155
    Animation86 = 0x8156
    Animation87 = 0x8157
    Animation88 = 0x8158
    Animation89 = 0x8159
    Animation90 = 0x815A
    Animation91 = 0x815B
    Animation92 = 0x815C
    Animation93 = 0x815D
    Animation94 = 0x815E
    Animation95 = 0x815F
    Animation96 = 0x8160
    Animation97 = 0x8161
    Animation98 = 0x8162
    Animation99 = 0x8163
    Animation100 = 0x8164
    Animation101 = 0x8165
    Animation102 = 0x8166
    Animation103 = 0x8167
    Animation104 = 0x8168
    Animation105 = 0x8169
    Animation106 = 0x816A
    Animation107 = 0x816B
    Animation108 = 0x816C
    Animation109 = 0x816D
    Animation110 = 0x816E
    Animation111 = 0x816F
    Animation112 = 0x8170
    Animation113 = 0x8171
    Animation114 = 0x8172
    Animation115 = 0x8173
    Animation116 = 0x8174
    Animation117 = 0x8175
    Animation118 = 0x8176
    Animation119 = 0x8177
    Animation120 = 0x8178
    Animation121 = 0x8179
    Animation122 = 0x817A
    Animation123 = 0x817B
    Animation124 = 0x817C
    Animation125 = 0x817D
    Animation126 = 0x817E
    Animation127 = 0x817F
    Animation128 = 0x8180
    Animation129 = 0x8181
    Animation130 = 0x8182
    Animation131 = 0x8183
    Animation132 = 0x8184
    Animation133 = 0x8185
    Animation134 = 0x8186
    Animation135 = 0x8187
    Animation136 = 0x8188
    Animation137 = 0x8189
    Animation138 = 0x818A
    Animation139 = 0x818B
    Animation140 = 0x818C
    Animation141 = 0x818D
    Animation142 = 0x818E
    Animation143 = 0x818F
    Animation144 = 0x8190
    Animation145 = 0x8191
    Animation146 = 0x8192
    Animation147 = 0x8193
    Animation148 = 0x8194
    Animation149 = 0x8195
    Animation150 = 0x8196
    Animation151 = 0x8197
    Animation152 = 0x8198
    Animation153 = 0x8199
    Animation154 = 0x819A
    Animation155 = 0x819B
    Animation156 = 0x819C
    Animation157 = 0x819D
    Animation158 = 0x819E
    Animation159 = 0x819F
    Animation160 = 0x81A0
    Animation161 = 0x81A1
    Animation162 = 0x81A2
    Animation163 = 0x81A3
    Animation164 = 0x81A4
    Animation165 = 0x81A5
    Animation166 = 0x81A6
    Animation167 = 0x81A7
    Animation168 = 0x81A8
    Animation169 = 0x81A9
    Animation170 = 0x81AA
    Animation171 = 0x81AB
    Animation172 = 0x81AC
    Animation173 = 0x81AD
    Animation174 = 0x81AE
    Animation175 = 0x81AF
    Animation176 = 0x81B0
    Animation177 = 0x81B1
    Animation178 = 0x81B2
    Animation179 = 0x81B3
    Animation180 = 0x81B4
    Animation181 = 0x81B5
    Animation182 = 0x81B6
    Animation183 = 0x81B7
    Animation184 = 0x81B8
    Animation185 = 0x81B9
    Animation186 = 0x81BA
    Animation187 = 0x81BB
    Animation188 = 0x81BC
    Animation189 = 0x81BD
    Animation190 = 0x81BE
    Animation191 = 0x81BF
    Animation192 = 0x81C0
    Animation193 = 0x81C1
    Animation194 = 0x81C2
    Animation195 = 0x81C3
    Animation196 = 0x81C4
    Animation197 = 0x81C5
    Animation198 = 0x81C6
    Animation199 = 0x81C7
    Animation200 = 0x81C8
    Animation201 = 0x81C9
    Animation202 = 0x81CA
    Animation203 = 0x81CB
    Animation204 = 0x81CC
    Animation205 = 0x81CD
    Animation206 = 0x81CE
    Animation207 = 0x81CF
    Animation208 = 0x81D0
    Animation209 = 0x81D1
    Animation210 = 0x81D2
    Animation211 = 0x81D3
    Animation212 = 0x81D4
    Animation213 = 0x81D5
    Animation214 = 0x81D6
    Animation215 = 0x81D7
    Animation216 = 0x81D8
    Animation217 = 0x81D9
    Animation218 = 0x81DA
    Animation219 = 0x81DB
    Animation220 = 0x81DC
    Animation221 = 0x81DD
    Animation222 = 0x81DE
    Animation223 = 0x81DF
    Animation224 = 0x81E0
    Animation225 = 0x81E1
    Animation226 = 0x81E2
    Animation227 = 0x81E3
    Animation228 = 0x81E4
    Animation229 = 0x81E5
    Animation230 = 0x81E6
    Animation231 = 0x81E7
    Animation232 = 0x81E8
    Animation233 = 0x81E9
    Animation234 = 0x81EA
    Animation235 = 0x81EB
    Animation236 = 0x81EC
    Animation237 = 0x81ED
    Animation238 = 0x81EE
    Animation239 = 0x81EF
    Animation240 = 0x81F0
    Animation241 = 0x81F1
    Animation242 = 0x81F2
    Animation243 = 0x81F3
    Animation244 = 0x81F4
    Animation245 = 0x81F5
    Animation246 = 0x81F6
    Animation247 = 0x81F7
    Animation248 = 0x81F8
    Animation249 = 0x81F9
    Animation250 = 0x81FA
    Animation251 = 0x81FB
    Animation252 = 0x81FC
    Animation253 = 0x81FD
    Animation254 = 0x81FE
    Animation255 = 0x81FF
    # FancyLedA List
    FancyLedA0 = 0x8200
    FancyLedA1 = 0x8201
    FancyLedA2 = 0x8202
    FancyLedA3 = 0x8203
    FancyLedA4 = 0x8204
    FancyLedA5 = 0x8205
    FancyLedA6 = 0x8206
    FancyLedA7 = 0x8207
    FancyLedA8 = 0x8208
    FancyLedA9 = 0x8209
    FancyLedA10 = 0x820A
    FancyLedA11 = 0x820B
    FancyLedA12 = 0x820C
    FancyLedA13 = 0x820D
    FancyLedA14 = 0x820E
    FancyLedA15 = 0x820F
    FancyLedA16 = 0x8210
    FancyLedA17 = 0x8211
    FancyLedA18 = 0x8212
    FancyLedA19 = 0x8213
    FancyLedA20 = 0x8214
    FancyLedA21 = 0x8215
    FancyLedA22 = 0x8216
    FancyLedA23 = 0x8217
    FancyLedA24 = 0x8218
    FancyLedA25 = 0x8219
    FancyLedA26 = 0x821A
    FancyLedA27 = 0x821B
    FancyLedA28 = 0x821C
    FancyLedA29 = 0x821D
    FancyLedA30 = 0x821E
    FancyLedA31 = 0x821F
    FancyLedA32 = 0x8220
    FancyLedA33 = 0x8221
    FancyLedA34 = 0x8222
    FancyLedA35 = 0x8223
    FancyLedA36 = 0x8224
    FancyLedA37 = 0x8225
    FancyLedA38 = 0x8226
    FancyLedA39 = 0x8227
    FancyLedA40 = 0x8228
    FancyLedA41 = 0x8229
    FancyLedA42 = 0x822A
    FancyLedA43 = 0x822B
    FancyLedA44 = 0x822C
    FancyLedA45 = 0x822D
    FancyLedA46 = 0x822E
    FancyLedA47 = 0x822F
    FancyLedA48 = 0x8230
    FancyLedA49 = 0x8231
    FancyLedA50 = 0x8232
    FancyLedA51 = 0x8233
    FancyLedA52 = 0x8234
    FancyLedA53 = 0x8235
    FancyLedA54 = 0x8236
    FancyLedA55 = 0x8237
    FancyLedA56 = 0x8238
    FancyLedA57 = 0x8239
    FancyLedA58 = 0x823A
    FancyLedA59 = 0x823B
    FancyLedA60 = 0x823C
    FancyLedA61 = 0x823D
    FancyLedA62 = 0x823E
    FancyLedA63 = 0x823F
    FancyLedA64 = 0x8240
    FancyLedA65 = 0x8241
    FancyLedA66 = 0x8242
    FancyLedA67 = 0x8243
    FancyLedA68 = 0x8244
    FancyLedA69 = 0x8245
    FancyLedA70 = 0x8246
    FancyLedA71 = 0x8247
    FancyLedA72 = 0x8248
    FancyLedA73 = 0x8249
    FancyLedA74 = 0x824A
    FancyLedA75 = 0x824B
    FancyLedA76 = 0x824C
    FancyLedA77 = 0x824D
    FancyLedA78 = 0x824E
    FancyLedA79 = 0x824F
    FancyLedA80 = 0x8250
    FancyLedA81 = 0x8251
    FancyLedA82 = 0x8252
    FancyLedA83 = 0x8253
    FancyLedA84 = 0x8254
    FancyLedA85 = 0x8255
    FancyLedA86 = 0x8256
    FancyLedA87 = 0x8257
    FancyLedA88 = 0x8258
    FancyLedA89 = 0x8259
    FancyLedA90 = 0x825A
    FancyLedA91 = 0x825B
    FancyLedA92 = 0x825C
    FancyLedA93 = 0x825D
    FancyLedA94 = 0x825E
    FancyLedA95 = 0x825F
    FancyLedA96 = 0x8260
    FancyLedA97 = 0x8261
    FancyLedA98 = 0x8262
    FancyLedA99 = 0x8263
    FancyLedA100 = 0x8264
    FancyLedA101 = 0x8265
    FancyLedA102 = 0x8266
    FancyLedA103 = 0x8267
    FancyLedA104 = 0x8268
    FancyLedA105 = 0x8269
    FancyLedA106 = 0x826A
    FancyLedA107 = 0x826B
    FancyLedA108 = 0x826C
    FancyLedA109 = 0x826D
    FancyLedA110 = 0x826E
    FancyLedA111 = 0x826F
    FancyLedA112 = 0x8270
    FancyLedA113 = 0x8271
    FancyLedA114 = 0x8272
    FancyLedA115 = 0x8273
    FancyLedA116 = 0x8274
    FancyLedA117 = 0x8275
    FancyLedA118 = 0x8276
    FancyLedA119 = 0x8277
    FancyLedA120 = 0x8278
    FancyLedA121 = 0x8279
    FancyLedA122 = 0x827A
    FancyLedA123 = 0x827B
    FancyLedA124 = 0x827C
    FancyLedA125 = 0x827D
    FancyLedA126 = 0x827E
    FancyLedA127 = 0x827F
    FancyLedA128 = 0x8280
    FancyLedA129 = 0x8281
    FancyLedA130 = 0x8282
    FancyLedA131 = 0x8283
    FancyLedA132 = 0x8284
    FancyLedA133 = 0x8285
    FancyLedA134 = 0x8286
    FancyLedA135 = 0x8287
    FancyLedA136 = 0x8288
    FancyLedA137 = 0x8289
    FancyLedA138 = 0x828A
    FancyLedA139 = 0x828B
    FancyLedA140 = 0x828C
    FancyLedA141 = 0x828D
    FancyLedA142 = 0x828E
    FancyLedA143 = 0x828F
    FancyLedA144 = 0x8290
    FancyLedA145 = 0x8291
    FancyLedA146 = 0x8292
    FancyLedA147 = 0x8293
    FancyLedA148 = 0x8294
    FancyLedA149 = 0x8295
    FancyLedA150 = 0x8296
    FancyLedA151 = 0x8297
    FancyLedA152 = 0x8298
    FancyLedA153 = 0x8299
    FancyLedA154 = 0x829A
    FancyLedA155 = 0x829B
    FancyLedA156 = 0x829C
    FancyLedA157 = 0x829D
    FancyLedA158 = 0x829E
    FancyLedA159 = 0x829F
    FancyLedA160 = 0x82A0
    FancyLedA161 = 0x82A1
    FancyLedA162 = 0x82A2
    FancyLedA163 = 0x82A3
    FancyLedA164 = 0x82A4
    FancyLedA165 = 0x82A5
    FancyLedA166 = 0x82A6
    FancyLedA167 = 0x82A7
    FancyLedA168 = 0x82A8
    FancyLedA169 = 0x82A9
    FancyLedA170 = 0x82AA
    FancyLedA171 = 0x82AB
    FancyLedA172 = 0x82AC
    FancyLedA173 = 0x82AD
    FancyLedA174 = 0x82AE
    FancyLedA175 = 0x82AF
    FancyLedA176 = 0x82B0
    FancyLedA177 = 0x82B1
    FancyLedA178 = 0x82B2
    FancyLedA179 = 0x82B3
    FancyLedA180 = 0x82B4
    FancyLedA181 = 0x82B5
    FancyLedA182 = 0x82B6
    FancyLedA183 = 0x82B7
    FancyLedA184 = 0x82B8
    FancyLedA185 = 0x82B9
    FancyLedA186 = 0x82BA
    FancyLedA187 = 0x82BB
    FancyLedA188 = 0x82BC
    FancyLedA189 = 0x82BD
    FancyLedA190 = 0x82BE
    FancyLedA191 = 0x82BF
    FancyLedA192 = 0x82C0
    FancyLedA193 = 0x82C1
    FancyLedA194 = 0x82C2
    FancyLedA195 = 0x82C3
    FancyLedA196 = 0x82C4
    FancyLedA197 = 0x82C5
    FancyLedA198 = 0x82C6
    FancyLedA199 = 0x82C7
    FancyLedA200 = 0x82C8
    FancyLedA201 = 0x82C9
    FancyLedA202 = 0x82CA
    FancyLedA203 = 0x82CB
    FancyLedA204 = 0x82CC
    FancyLedA205 = 0x82CD
    FancyLedA206 = 0x82CE
    FancyLedA207 = 0x82CF
    FancyLedA208 = 0x82D0
    FancyLedA209 = 0x82D1
    FancyLedA210 = 0x82D2
    FancyLedA211 = 0x82D3
    FancyLedA212 = 0x82D4
    FancyLedA213 = 0x82D5
    FancyLedA214 = 0x82D6
    FancyLedA215 = 0x82D7
    FancyLedA216 = 0x82D8
    FancyLedA217 = 0x82D9
    FancyLedA218 = 0x82DA
    FancyLedA219 = 0x82DB
    FancyLedA220 = 0x82DC
    FancyLedA221 = 0x82DD
    FancyLedA222 = 0x82DE
    FancyLedA223 = 0x82DF
    FancyLedA224 = 0x82E0
    FancyLedA225 = 0x82E1
    FancyLedA226 = 0x82E2
    FancyLedA227 = 0x82E3
    FancyLedA228 = 0x82E4
    FancyLedA229 = 0x82E5
    FancyLedA230 = 0x82E6
    FancyLedA231 = 0x82E7
    FancyLedA232 = 0x82E8
    FancyLedA233 = 0x82E9
    FancyLedA234 = 0x82EA
    FancyLedA235 = 0x82EB
    FancyLedA236 = 0x82EC
    FancyLedA237 = 0x82ED
    FancyLedA238 = 0x82EE
    FancyLedA239 = 0x82EF
    FancyLedA240 = 0x82F0
    FancyLedA241 = 0x82F1
    FancyLedA242 = 0x82F2
    FancyLedA243 = 0x82F3
    FancyLedA244 = 0x82F4
    FancyLedA245 = 0x82F5
    FancyLedA246 = 0x82F6
    FancyLedA247 = 0x82F7
    FancyLedA248 = 0x82F8
    FancyLedA249 = 0x82F9
    FancyLedA250 = 0x82FA
    FancyLedA251 = 0x82FB
    FancyLedA252 = 0x82FC
    FancyLedA253 = 0x82FD
    FancyLedA254 = 0x82FE
    FancyLedA255 = 0x82FF
    # FancyLedB List
    FancyLedB0 = 0x8300
    FancyLedB1 = 0x8301
    FancyLedB2 = 0x8302
    FancyLedB3 = 0x8303
    FancyLedB4 = 0x8304
    FancyLedB5 = 0x8305
    FancyLedB6 = 0x8306
    FancyLedB7 = 0x8307
    FancyLedB8 = 0x8308
    FancyLedB9 = 0x8309
    FancyLedB10 = 0x830A
    FancyLedB11 = 0x830B
    FancyLedB12 = 0x830C
    FancyLedB13 = 0x830D
    FancyLedB14 = 0x830E
    FancyLedB15 = 0x830F
    FancyLedB16 = 0x8310
    FancyLedB17 = 0x8311
    FancyLedB18 = 0x8312
    FancyLedB19 = 0x8313
    FancyLedB20 = 0x8314
    FancyLedB21 = 0x8315
    FancyLedB22 = 0x8316
    FancyLedB23 = 0x8317
    FancyLedB24 = 0x8318
    FancyLedB25 = 0x8319
    FancyLedB26 = 0x831A
    FancyLedB27 = 0x831B
    FancyLedB28 = 0x831C
    FancyLedB29 = 0x831D
    FancyLedB30 = 0x831E
    FancyLedB31 = 0x831F
    FancyLedB32 = 0x8320
    FancyLedB33 = 0x8321
    FancyLedB34 = 0x8322
    FancyLedB35 = 0x8323
    FancyLedB36 = 0x8324
    FancyLedB37 = 0x8325
    FancyLedB38 = 0x8326
    FancyLedB39 = 0x8327
    FancyLedB40 = 0x8328
    FancyLedB41 = 0x8329
    FancyLedB42 = 0x832A
    FancyLedB43 = 0x832B
    FancyLedB44 = 0x832C
    FancyLedB45 = 0x832D
    FancyLedB46 = 0x832E
    FancyLedB47 = 0x832F
    FancyLedB48 = 0x8330
    FancyLedB49 = 0x8331
    FancyLedB50 = 0x8332
    FancyLedB51 = 0x8333
    FancyLedB52 = 0x8334
    FancyLedB53 = 0x8335
    FancyLedB54 = 0x8336
    FancyLedB55 = 0x8337
    FancyLedB56 = 0x8338
    FancyLedB57 = 0x8339
    FancyLedB58 = 0x833A
    FancyLedB59 = 0x833B
    FancyLedB60 = 0x833C
    FancyLedB61 = 0x833D
    FancyLedB62 = 0x833E
    FancyLedB63 = 0x833F
    FancyLedB64 = 0x8340
    FancyLedB65 = 0x8341
    FancyLedB66 = 0x8342
    FancyLedB67 = 0x8343
    FancyLedB68 = 0x8344
    FancyLedB69 = 0x8345
    FancyLedB70 = 0x8346
    FancyLedB71 = 0x8347
    FancyLedB72 = 0x8348
    FancyLedB73 = 0x8349
    FancyLedB74 = 0x834A
    FancyLedB75 = 0x834B
    FancyLedB76 = 0x834C
    FancyLedB77 = 0x834D
    FancyLedB78 = 0x834E
    FancyLedB79 = 0x834F
    FancyLedB80 = 0x8350
    FancyLedB81 = 0x8351
    FancyLedB82 = 0x8352
    FancyLedB83 = 0x8353
    FancyLedB84 = 0x8354
    FancyLedB85 = 0x8355
    FancyLedB86 = 0x8356
    FancyLedB87 = 0x8357
    FancyLedB88 = 0x8358
    FancyLedB89 = 0x8359
    FancyLedB90 = 0x835A
    FancyLedB91 = 0x835B
    FancyLedB92 = 0x835C
    FancyLedB93 = 0x835D
    FancyLedB94 = 0x835E
    FancyLedB95 = 0x835F
    FancyLedB96 = 0x8360
    FancyLedB97 = 0x8361
    FancyLedB98 = 0x8362
    FancyLedB99 = 0x8363
    FancyLedB100 = 0x8364
    FancyLedB101 = 0x8365
    FancyLedB102 = 0x8366
    FancyLedB103 = 0x8367
    FancyLedB104 = 0x8368
    FancyLedB105 = 0x8369
    FancyLedB106 = 0x836A
    FancyLedB107 = 0x836B
    FancyLedB108 = 0x836C
    FancyLedB109 = 0x836D
    FancyLedB110 = 0x836E
    FancyLedB111 = 0x836F
    FancyLedB112 = 0x8370
    FancyLedB113 = 0x8371
    FancyLedB114 = 0x8372
    FancyLedB115 = 0x8373
    FancyLedB116 = 0x8374
    FancyLedB117 = 0x8375
    FancyLedB118 = 0x8376
    FancyLedB119 = 0x8377
    FancyLedB120 = 0x8378
    FancyLedB121 = 0x8379
    FancyLedB122 = 0x837A
    FancyLedB123 = 0x837B
    FancyLedB124 = 0x837C
    FancyLedB125 = 0x837D
    FancyLedB126 = 0x837E
    FancyLedB127 = 0x837F
    FancyLedB128 = 0x8380
    FancyLedB129 = 0x8381
    FancyLedB130 = 0x8382
    FancyLedB131 = 0x8383
    FancyLedB132 = 0x8384
    FancyLedB133 = 0x8385
    FancyLedB134 = 0x8386
    FancyLedB135 = 0x8387
    FancyLedB136 = 0x8388
    FancyLedB137 = 0x8389
    FancyLedB138 = 0x838A
    FancyLedB139 = 0x838B
    FancyLedB140 = 0x838C
    FancyLedB141 = 0x838D
    FancyLedB142 = 0x838E
    FancyLedB143 = 0x838F
    FancyLedB144 = 0x8390
    FancyLedB145 = 0x8391
    FancyLedB146 = 0x8392
    FancyLedB147 = 0x8393
    FancyLedB148 = 0x8394
    FancyLedB149 = 0x8395
    FancyLedB150 = 0x8396
    FancyLedB151 = 0x8397
    FancyLedB152 = 0x8398
    FancyLedB153 = 0x8399
    FancyLedB154 = 0x839A
    FancyLedB155 = 0x839B
    FancyLedB156 = 0x839C
    FancyLedB157 = 0x839D
    FancyLedB158 = 0x839E
    FancyLedB159 = 0x839F
    FancyLedB160 = 0x83A0
    FancyLedB161 = 0x83A1
    FancyLedB162 = 0x83A2
    FancyLedB163 = 0x83A3
    FancyLedB164 = 0x83A4
    FancyLedB165 = 0x83A5
    FancyLedB166 = 0x83A6
    FancyLedB167 = 0x83A7
    FancyLedB168 = 0x83A8
    FancyLedB169 = 0x83A9
    FancyLedB170 = 0x83AA
    FancyLedB171 = 0x83AB
    FancyLedB172 = 0x83AC
    FancyLedB173 = 0x83AD
    FancyLedB174 = 0x83AE
    FancyLedB175 = 0x83AF
    FancyLedB176 = 0x83B0
    FancyLedB177 = 0x83B1
    FancyLedB178 = 0x83B2
    FancyLedB179 = 0x83B3
    FancyLedB180 = 0x83B4
    FancyLedB181 = 0x83B5
    FancyLedB182 = 0x83B6
    FancyLedB183 = 0x83B7
    FancyLedB184 = 0x83B8
    FancyLedB185 = 0x83B9
    FancyLedB186 = 0x83BA
    FancyLedB187 = 0x83BB
    FancyLedB188 = 0x83BC
    FancyLedB189 = 0x83BD
    FancyLedB190 = 0x83BE
    FancyLedB191 = 0x83BF
    FancyLedB192 = 0x83C0
    FancyLedB193 = 0x83C1
    FancyLedB194 = 0x83C2
    FancyLedB195 = 0x83C3
    FancyLedB196 = 0x83C4
    FancyLedB197 = 0x83C5
    FancyLedB198 = 0x83C6
    FancyLedB199 = 0x83C7
    FancyLedB200 = 0x83C8
    FancyLedB201 = 0x83C9
    FancyLedB202 = 0x83CA
    FancyLedB203 = 0x83CB
    FancyLedB204 = 0x83CC
    FancyLedB205 = 0x83CD
    FancyLedB206 = 0x83CE
    FancyLedB207 = 0x83CF
    FancyLedB208 = 0x83D0
    FancyLedB209 = 0x83D1
    FancyLedB210 = 0x83D2
    FancyLedB211 = 0x83D3
    FancyLedB212 = 0x83D4
    FancyLedB213 = 0x83D5
    FancyLedB214 = 0x83D6
    FancyLedB215 = 0x83D7
    FancyLedB216 = 0x83D8
    FancyLedB217 = 0x83D9
    FancyLedB218 = 0x83DA
    FancyLedB219 = 0x83DB
    FancyLedB220 = 0x83DC
    FancyLedB221 = 0x83DD
    FancyLedB222 = 0x83DE
    FancyLedB223 = 0x83DF
    FancyLedB224 = 0x83E0
    FancyLedB225 = 0x83E1
    FancyLedB226 = 0x83E2
    FancyLedB227 = 0x83E3
    FancyLedB228 = 0x83E4
    FancyLedB229 = 0x83E5
    FancyLedB230 = 0x83E6
    FancyLedB231 = 0x83E7
    FancyLedB232 = 0x83E8
    FancyLedB233 = 0x83E9
    FancyLedB234 = 0x83EA
    FancyLedB235 = 0x83EB
    FancyLedB236 = 0x83EC
    FancyLedB237 = 0x83ED
    FancyLedB238 = 0x83EE
    FancyLedB239 = 0x83EF
    FancyLedB240 = 0x83F0
    FancyLedB241 = 0x83F1
    FancyLedB242 = 0x83F2
    FancyLedB243 = 0x83F3
    FancyLedB244 = 0x83F4
    FancyLedB245 = 0x83F5
    FancyLedB246 = 0x83F6
    FancyLedB247 = 0x83F7
    FancyLedB248 = 0x83F8
    FancyLedB249 = 0x83F9
    FancyLedB250 = 0x83FA
    FancyLedB251 = 0x83FB
    FancyLedB252 = 0x83FC
    FancyLedB253 = 0x83FD
    FancyLedB254 = 0x83FE
    FancyLedB255 = 0x83FF
    # FancyButtonA List
    FancyButtonA0 = 0xA000
    FancyButtonA1 = 0xA001
    FancyButtonA2 = 0xA002
    FancyButtonA3 = 0xA003
    FancyButtonA4 = 0xA004
    FancyButtonA5 = 0xA005
    FancyButtonA6 = 0xA006
    FancyButtonA7 = 0xA007
    FancyButtonA8 = 0xA008
    FancyButtonA9 = 0xA009
    FancyButtonA10 = 0xA00A
    FancyButtonA11 = 0xA00B
    FancyButtonA12 = 0xA00C
    FancyButtonA13 = 0xA00D
    FancyButtonA14 = 0xA00E
    FancyButtonA15 = 0xA00F
    FancyButtonA16 = 0xA010
    FancyButtonA17 = 0xA011
    FancyButtonA18 = 0xA012
    FancyButtonA19 = 0xA013
    FancyButtonA20 = 0xA014
    FancyButtonA21 = 0xA015
    FancyButtonA22 = 0xA016
    FancyButtonA23 = 0xA017
    FancyButtonA24 = 0xA018
    FancyButtonA25 = 0xA019
    FancyButtonA26 = 0xA01A
    FancyButtonA27 = 0xA01B
    FancyButtonA28 = 0xA01C
    FancyButtonA29 = 0xA01D
    FancyButtonA30 = 0xA01E
    FancyButtonA31 = 0xA01F
    FancyButtonA32 = 0xA020
    FancyButtonA33 = 0xA021
    FancyButtonA34 = 0xA022
    FancyButtonA35 = 0xA023
    FancyButtonA36 = 0xA024
    FancyButtonA37 = 0xA025
    FancyButtonA38 = 0xA026
    FancyButtonA39 = 0xA027
    FancyButtonA40 = 0xA028
    FancyButtonA41 = 0xA029
    FancyButtonA42 = 0xA02A
    FancyButtonA43 = 0xA02B
    FancyButtonA44 = 0xA02C
    FancyButtonA45 = 0xA02D
    FancyButtonA46 = 0xA02E
    FancyButtonA47 = 0xA02F
    FancyButtonA48 = 0xA030
    FancyButtonA49 = 0xA031
    FancyButtonA50 = 0xA032
    FancyButtonA51 = 0xA033
    FancyButtonA52 = 0xA034
    FancyButtonA53 = 0xA035
    FancyButtonA54 = 0xA036
    FancyButtonA55 = 0xA037
    FancyButtonA56 = 0xA038
    FancyButtonA57 = 0xA039
    FancyButtonA58 = 0xA03A
    FancyButtonA59 = 0xA03B
    FancyButtonA60 = 0xA03C
    FancyButtonA61 = 0xA03D
    FancyButtonA62 = 0xA03E
    FancyButtonA63 = 0xA03F
    FancyButtonA64 = 0xA040
    FancyButtonA65 = 0xA041
    FancyButtonA66 = 0xA042
    FancyButtonA67 = 0xA043
    FancyButtonA68 = 0xA044
    FancyButtonA69 = 0xA045
    FancyButtonA70 = 0xA046
    FancyButtonA71 = 0xA047
    FancyButtonA72 = 0xA048
    FancyButtonA73 = 0xA049
    FancyButtonA74 = 0xA04A
    FancyButtonA75 = 0xA04B
    FancyButtonA76 = 0xA04C
    FancyButtonA77 = 0xA04D
    FancyButtonA78 = 0xA04E
    FancyButtonA79 = 0xA04F
    FancyButtonA80 = 0xA050
    FancyButtonA81 = 0xA051
    FancyButtonA82 = 0xA052
    FancyButtonA83 = 0xA053
    FancyButtonA84 = 0xA054
    FancyButtonA85 = 0xA055
    FancyButtonA86 = 0xA056
    FancyButtonA87 = 0xA057
    FancyButtonA88 = 0xA058
    FancyButtonA89 = 0xA059
    FancyButtonA90 = 0xA05A
    FancyButtonA91 = 0xA05B
    FancyButtonA92 = 0xA05C
    FancyButtonA93 = 0xA05D
    FancyButtonA94 = 0xA05E
    FancyButtonA95 = 0xA05F
    FancyButtonA96 = 0xA060
    FancyButtonA97 = 0xA061
    FancyButtonA98 = 0xA062
    FancyButtonA99 = 0xA063
    FancyButtonA100 = 0xA064
    FancyButtonA101 = 0xA065
    FancyButtonA102 = 0xA066
    FancyButtonA103 = 0xA067
    FancyButtonA104 = 0xA068
    FancyButtonA105 = 0xA069
    FancyButtonA106 = 0xA06A
    FancyButtonA107 = 0xA06B
    FancyButtonA108 = 0xA06C
    FancyButtonA109 = 0xA06D
    FancyButtonA110 = 0xA06E
    FancyButtonA111 = 0xA06F
    FancyButtonA112 = 0xA070
    FancyButtonA113 = 0xA071
    FancyButtonA114 = 0xA072
    FancyButtonA115 = 0xA073
    FancyButtonA116 = 0xA074
    FancyButtonA117 = 0xA075
    FancyButtonA118 = 0xA076
    FancyButtonA119 = 0xA077
    FancyButtonA120 = 0xA078
    FancyButtonA121 = 0xA079
    FancyButtonA122 = 0xA07A
    FancyButtonA123 = 0xA07B
    FancyButtonA124 = 0xA07C
    FancyButtonA125 = 0xA07D
    FancyButtonA126 = 0xA07E
    FancyButtonA127 = 0xA07F
    FancyButtonA128 = 0xA080
    FancyButtonA129 = 0xA081
    FancyButtonA130 = 0xA082
    FancyButtonA131 = 0xA083
    FancyButtonA132 = 0xA084
    FancyButtonA133 = 0xA085
    FancyButtonA134 = 0xA086
    FancyButtonA135 = 0xA087
    FancyButtonA136 = 0xA088
    FancyButtonA137 = 0xA089
    FancyButtonA138 = 0xA08A
    FancyButtonA139 = 0xA08B
    FancyButtonA140 = 0xA08C
    FancyButtonA141 = 0xA08D
    FancyButtonA142 = 0xA08E
    FancyButtonA143 = 0xA08F
    FancyButtonA144 = 0xA090
    FancyButtonA145 = 0xA091
    FancyButtonA146 = 0xA092
    FancyButtonA147 = 0xA093
    FancyButtonA148 = 0xA094
    FancyButtonA149 = 0xA095
    FancyButtonA150 = 0xA096
    FancyButtonA151 = 0xA097
    FancyButtonA152 = 0xA098
    FancyButtonA153 = 0xA099
    FancyButtonA154 = 0xA09A
    FancyButtonA155 = 0xA09B
    FancyButtonA156 = 0xA09C
    FancyButtonA157 = 0xA09D
    FancyButtonA158 = 0xA09E
    FancyButtonA159 = 0xA09F
    FancyButtonA160 = 0xA0A0
    FancyButtonA161 = 0xA0A1
    FancyButtonA162 = 0xA0A2
    FancyButtonA163 = 0xA0A3
    FancyButtonA164 = 0xA0A4
    FancyButtonA165 = 0xA0A5
    FancyButtonA166 = 0xA0A6
    FancyButtonA167 = 0xA0A7
    FancyButtonA168 = 0xA0A8
    FancyButtonA169 = 0xA0A9
    FancyButtonA170 = 0xA0AA
    FancyButtonA171 = 0xA0AB
    FancyButtonA172 = 0xA0AC
    FancyButtonA173 = 0xA0AD
    FancyButtonA174 = 0xA0AE
    FancyButtonA175 = 0xA0AF
    FancyButtonA176 = 0xA0B0
    FancyButtonA177 = 0xA0B1
    FancyButtonA178 = 0xA0B2
    FancyButtonA179 = 0xA0B3
    FancyButtonA180 = 0xA0B4
    FancyButtonA181 = 0xA0B5
    FancyButtonA182 = 0xA0B6
    FancyButtonA183 = 0xA0B7
    FancyButtonA184 = 0xA0B8
    FancyButtonA185 = 0xA0B9
    FancyButtonA186 = 0xA0BA
    FancyButtonA187 = 0xA0BB
    FancyButtonA188 = 0xA0BC
    FancyButtonA189 = 0xA0BD
    FancyButtonA190 = 0xA0BE
    FancyButtonA191 = 0xA0BF
    FancyButtonA192 = 0xA0C0
    FancyButtonA193 = 0xA0C1
    FancyButtonA194 = 0xA0C2
    FancyButtonA195 = 0xA0C3
    FancyButtonA196 = 0xA0C4
    FancyButtonA197 = 0xA0C5
    FancyButtonA198 = 0xA0C6
    FancyButtonA199 = 0xA0C7
    FancyButtonA200 = 0xA0C8
    FancyButtonA201 = 0xA0C9
    FancyButtonA202 = 0xA0CA
    FancyButtonA203 = 0xA0CB
    FancyButtonA204 = 0xA0CC
    FancyButtonA205 = 0xA0CD
    FancyButtonA206 = 0xA0CE
    FancyButtonA207 = 0xA0CF
    FancyButtonA208 = 0xA0D0
    FancyButtonA209 = 0xA0D1
    FancyButtonA210 = 0xA0D2
    FancyButtonA211 = 0xA0D3
    FancyButtonA212 = 0xA0D4
    FancyButtonA213 = 0xA0D5
    FancyButtonA214 = 0xA0D6
    FancyButtonA215 = 0xA0D7
    FancyButtonA216 = 0xA0D8
    FancyButtonA217 = 0xA0D9
    FancyButtonA218 = 0xA0DA
    FancyButtonA219 = 0xA0DB
    FancyButtonA220 = 0xA0DC
    FancyButtonA221 = 0xA0DD
    FancyButtonA222 = 0xA0DE
    FancyButtonA223 = 0xA0DF
    FancyButtonA224 = 0xA0E0
    FancyButtonA225 = 0xA0E1
    FancyButtonA226 = 0xA0E2
    FancyButtonA227 = 0xA0E3
    FancyButtonA228 = 0xA0E4
    FancyButtonA229 = 0xA0E5
    FancyButtonA230 = 0xA0E6
    FancyButtonA231 = 0xA0E7
    FancyButtonA232 = 0xA0E8
    FancyButtonA233 = 0xA0E9
    FancyButtonA234 = 0xA0EA
    FancyButtonA235 = 0xA0EB
    FancyButtonA236 = 0xA0EC
    FancyButtonA237 = 0xA0ED
    FancyButtonA238 = 0xA0EE
    FancyButtonA239 = 0xA0EF
    FancyButtonA240 = 0xA0F0
    FancyButtonA241 = 0xA0F1
    FancyButtonA242 = 0xA0F2
    FancyButtonA243 = 0xA0F3
    FancyButtonA244 = 0xA0F4
    FancyButtonA245 = 0xA0F5
    FancyButtonA246 = 0xA0F6
    FancyButtonA247 = 0xA0F7
    FancyButtonA248 = 0xA0F8
    FancyButtonA249 = 0xA0F9
    FancyButtonA250 = 0xA0FA
    FancyButtonA251 = 0xA0FB
    FancyButtonA252 = 0xA0FC
    FancyButtonA253 = 0xA0FD
    FancyButtonA254 = 0xA0FE
    FancyButtonA255 = 0xA0FF
    # FancyButtonB List
    FancyButtonB0 = 0xA100
    FancyButtonB1 = 0xA101
    FancyButtonB2 = 0xA102
    FancyButtonB3 = 0xA103
    FancyButtonB4 = 0xA104
    FancyButtonB5 = 0xA105
    FancyButtonB6 = 0xA106
    FancyButtonB7 = 0xA107
    FancyButtonB8 = 0xA108
    FancyButtonB9 = 0xA109
    FancyButtonB10 = 0xA10A
    FancyButtonB11 = 0xA10B
    FancyButtonB12 = 0xA10C
    FancyButtonB13 = 0xA10D
    FancyButtonB14 = 0xA10E
    FancyButtonB15 = 0xA10F
    FancyButtonB16 = 0xA110
    FancyButtonB17 = 0xA111
    FancyButtonB18 = 0xA112
    FancyButtonB19 = 0xA113
    FancyButtonB20 = 0xA114
    FancyButtonB21 = 0xA115
    FancyButtonB22 = 0xA116
    FancyButtonB23 = 0xA117
    FancyButtonB24 = 0xA118
    FancyButtonB25 = 0xA119
    FancyButtonB26 = 0xA11A
    FancyButtonB27 = 0xA11B
    FancyButtonB28 = 0xA11C
    FancyButtonB29 = 0xA11D
    FancyButtonB30 = 0xA11E
    FancyButtonB31 = 0xA11F
    FancyButtonB32 = 0xA120
    FancyButtonB33 = 0xA121
    FancyButtonB34 = 0xA122
    FancyButtonB35 = 0xA123
    FancyButtonB36 = 0xA124
    FancyButtonB37 = 0xA125
    FancyButtonB38 = 0xA126
    FancyButtonB39 = 0xA127
    FancyButtonB40 = 0xA128
    FancyButtonB41 = 0xA129
    FancyButtonB42 = 0xA12A
    FancyButtonB43 = 0xA12B
    FancyButtonB44 = 0xA12C
    FancyButtonB45 = 0xA12D
    FancyButtonB46 = 0xA12E
    FancyButtonB47 = 0xA12F
    FancyButtonB48 = 0xA130
    FancyButtonB49 = 0xA131
    FancyButtonB50 = 0xA132
    FancyButtonB51 = 0xA133
    FancyButtonB52 = 0xA134
    FancyButtonB53 = 0xA135
    FancyButtonB54 = 0xA136
    FancyButtonB55 = 0xA137
    FancyButtonB56 = 0xA138
    FancyButtonB57 = 0xA139
    FancyButtonB58 = 0xA13A
    FancyButtonB59 = 0xA13B
    FancyButtonB60 = 0xA13C
    FancyButtonB61 = 0xA13D
    FancyButtonB62 = 0xA13E
    FancyButtonB63 = 0xA13F
    FancyButtonB64 = 0xA140
    FancyButtonB65 = 0xA141
    FancyButtonB66 = 0xA142
    FancyButtonB67 = 0xA143
    FancyButtonB68 = 0xA144
    FancyButtonB69 = 0xA145
    FancyButtonB70 = 0xA146
    FancyButtonB71 = 0xA147
    FancyButtonB72 = 0xA148
    FancyButtonB73 = 0xA149
    FancyButtonB74 = 0xA14A
    FancyButtonB75 = 0xA14B
    FancyButtonB76 = 0xA14C
    FancyButtonB77 = 0xA14D
    FancyButtonB78 = 0xA14E
    FancyButtonB79 = 0xA14F
    FancyButtonB80 = 0xA150
    FancyButtonB81 = 0xA151
    FancyButtonB82 = 0xA152
    FancyButtonB83 = 0xA153
    FancyButtonB84 = 0xA154
    FancyButtonB85 = 0xA155
    FancyButtonB86 = 0xA156
    FancyButtonB87 = 0xA157
    FancyButtonB88 = 0xA158
    FancyButtonB89 = 0xA159
    FancyButtonB90 = 0xA15A
    FancyButtonB91 = 0xA15B
    FancyButtonB92 = 0xA15C
    FancyButtonB93 = 0xA15D
    FancyButtonB94 = 0xA15E
    FancyButtonB95 = 0xA15F
    FancyButtonB96 = 0xA160
    FancyButtonB97 = 0xA161
    FancyButtonB98 = 0xA162
    FancyButtonB99 = 0xA163
    FancyButtonB100 = 0xA164
    FancyButtonB101 = 0xA165
    FancyButtonB102 = 0xA166
    FancyButtonB103 = 0xA167
    FancyButtonB104 = 0xA168
    FancyButtonB105 = 0xA169
    FancyButtonB106 = 0xA16A
    FancyButtonB107 = 0xA16B
    FancyButtonB108 = 0xA16C
    FancyButtonB109 = 0xA16D
    FancyButtonB110 = 0xA16E
    FancyButtonB111 = 0xA16F
    FancyButtonB112 = 0xA170
    FancyButtonB113 = 0xA171
    FancyButtonB114 = 0xA172
    FancyButtonB115 = 0xA173
    FancyButtonB116 = 0xA174
    FancyButtonB117 = 0xA175
    FancyButtonB118 = 0xA176
    FancyButtonB119 = 0xA177
    FancyButtonB120 = 0xA178
    FancyButtonB121 = 0xA179
    FancyButtonB122 = 0xA17A
    FancyButtonB123 = 0xA17B
    FancyButtonB124 = 0xA17C
    FancyButtonB125 = 0xA17D
    FancyButtonB126 = 0xA17E
    FancyButtonB127 = 0xA17F
    FancyButtonB128 = 0xA180
    FancyButtonB129 = 0xA181
    FancyButtonB130 = 0xA182
    FancyButtonB131 = 0xA183
    FancyButtonB132 = 0xA184
    FancyButtonB133 = 0xA185
    FancyButtonB134 = 0xA186
    FancyButtonB135 = 0xA187
    FancyButtonB136 = 0xA188
    FancyButtonB137 = 0xA189
    FancyButtonB138 = 0xA18A
    FancyButtonB139 = 0xA18B
    FancyButtonB140 = 0xA18C
    FancyButtonB141 = 0xA18D
    FancyButtonB142 = 0xA18E
    FancyButtonB143 = 0xA18F
    FancyButtonB144 = 0xA190
    FancyButtonB145 = 0xA191
    FancyButtonB146 = 0xA192
    FancyButtonB147 = 0xA193
    FancyButtonB148 = 0xA194
    FancyButtonB149 = 0xA195
    FancyButtonB150 = 0xA196
    FancyButtonB151 = 0xA197
    FancyButtonB152 = 0xA198
    FancyButtonB153 = 0xA199
    FancyButtonB154 = 0xA19A
    FancyButtonB155 = 0xA19B
    FancyButtonB156 = 0xA19C
    FancyButtonB157 = 0xA19D
    FancyButtonB158 = 0xA19E
    FancyButtonB159 = 0xA19F
    FancyButtonB160 = 0xA1A0
    FancyButtonB161 = 0xA1A1
    FancyButtonB162 = 0xA1A2
    FancyButtonB163 = 0xA1A3
    FancyButtonB164 = 0xA1A4
    FancyButtonB165 = 0xA1A5
    FancyButtonB166 = 0xA1A6
    FancyButtonB167 = 0xA1A7
    FancyButtonB168 = 0xA1A8
    FancyButtonB169 = 0xA1A9
    FancyButtonB170 = 0xA1AA
    FancyButtonB171 = 0xA1AB
    FancyButtonB172 = 0xA1AC
    FancyButtonB173 = 0xA1AD
    FancyButtonB174 = 0xA1AE
    FancyButtonB175 = 0xA1AF
    FancyButtonB176 = 0xA1B0
    FancyButtonB177 = 0xA1B1
    FancyButtonB178 = 0xA1B2
    FancyButtonB179 = 0xA1B3
    FancyButtonB180 = 0xA1B4
    FancyButtonB181 = 0xA1B5
    FancyButtonB182 = 0xA1B6
    FancyButtonB183 = 0xA1B7
    FancyButtonB184 = 0xA1B8
    FancyButtonB185 = 0xA1B9
    FancyButtonB186 = 0xA1BA
    FancyButtonB187 = 0xA1BB
    FancyButtonB188 = 0xA1BC
    FancyButtonB189 = 0xA1BD
    FancyButtonB190 = 0xA1BE
    FancyButtonB191 = 0xA1BF
    FancyButtonB192 = 0xA1C0
    FancyButtonB193 = 0xA1C1
    FancyButtonB194 = 0xA1C2
    FancyButtonB195 = 0xA1C3
    FancyButtonB196 = 0xA1C4
    FancyButtonB197 = 0xA1C5
    FancyButtonB198 = 0xA1C6
    FancyButtonB199 = 0xA1C7
    FancyButtonB200 = 0xA1C8
    FancyButtonB201 = 0xA1C9
    FancyButtonB202 = 0xA1CA
    FancyButtonB203 = 0xA1CB
    FancyButtonB204 = 0xA1CC
    FancyButtonB205 = 0xA1CD
    FancyButtonB206 = 0xA1CE
    FancyButtonB207 = 0xA1CF
    FancyButtonB208 = 0xA1D0
    FancyButtonB209 = 0xA1D1
    FancyButtonB210 = 0xA1D2
    FancyButtonB211 = 0xA1D3
    FancyButtonB212 = 0xA1D4
    FancyButtonB213 = 0xA1D5
    FancyButtonB214 = 0xA1D6
    FancyButtonB215 = 0xA1D7
    FancyButtonB216 = 0xA1D8
    FancyButtonB217 = 0xA1D9
    FancyButtonB218 = 0xA1DA
    FancyButtonB219 = 0xA1DB
    FancyButtonB220 = 0xA1DC
    FancyButtonB221 = 0xA1DD
    FancyButtonB222 = 0xA1DE
    FancyButtonB223 = 0xA1DF
    FancyButtonB224 = 0xA1E0
    FancyButtonB225 = 0xA1E1
    FancyButtonB226 = 0xA1E2
    FancyButtonB227 = 0xA1E3
    FancyButtonB228 = 0xA1E4
    FancyButtonB229 = 0xA1E5
    FancyButtonB230 = 0xA1E6
    FancyButtonB231 = 0xA1E7
    FancyButtonB232 = 0xA1E8
    FancyButtonB233 = 0xA1E9
    FancyButtonB234 = 0xA1EA
    FancyButtonB235 = 0xA1EB
    FancyButtonB236 = 0xA1EC
    FancyButtonB237 = 0xA1ED
    FancyButtonB238 = 0xA1EE
    FancyButtonB239 = 0xA1EF
    FancyButtonB240 = 0xA1F0
    FancyButtonB241 = 0xA1F1
    FancyButtonB242 = 0xA1F2
    FancyButtonB243 = 0xA1F3
    FancyButtonB244 = 0xA1F4
    FancyButtonB245 = 0xA1F5
    FancyButtonB246 = 0xA1F6
    FancyButtonB247 = 0xA1F7
    FancyButtonB248 = 0xA1F8
    FancyButtonB249 = 0xA1F9
    FancyButtonB250 = 0xA1FA
    FancyButtonB251 = 0xA1FB
    FancyButtonB252 = 0xA1FC
    FancyButtonB253 = 0xA1FD
    FancyButtonB254 = 0xA1FE
    FancyButtonB255 = 0xA1FF